gtstspct の解説

96/09/08 堀之内
97/02/01 堀之内 (ちょっと書き足す)

● 機能

空間(主に経度を想定)-時間 の2次元のスペクトルを求める。

※ 「空間」軸は等間隔グリッドであれば必ずしも経度でなくてよいが、以下
   の説明では簡単のため経度を想定し、「東進」、「西進」といった表現を
   使う。

● 旧版(gtstspct_old)との違い。

新しく実現した機能： 定常成分の出力(オプション steady=T)

なくなった機能： 「空間」軸を指定するオプション sdim を廃止し、
第１次元を空間軸と仮定

上記の機能廃止は、意図したものというより、SDIM が 1 以外である可能性を
残したままでのプログラムの改造が面倒くさかったからという消極的な理由に
よるものである。実際の使用にあたっては 空間軸＝経度 でばかり使っていた
ので、SDIM=1 しか必要なかった。

● 入力

入力は異なる時刻には異なるヘッダーがつく時系列(gtseqしていないもの)を
仮定する。「空間」軸にはデータの第一次元を用いる(※)。

  (※) 旧版 gtstspct_old ではオプション SDIM により「空間」軸を選べる。

計算に用いる FFT の都合上、空間軸時間軸ともグリッド数が 2,3,5 で因数分
解できる偶数でなければならない。

 

● 出力

出力されるファイルは

  スペクトル (デフォルト名はgtool.out)
  位相       (デフォルト名はgtoolph.out)
  波数軸ファイル (@WVNWE* : *には最大波数が入る)
  振動数軸ファイル (@FREQ*-? : *にはデータの個数が、?には何日分の時系列
                    からつくられたかが入る)

である。スペクトルと位相の定義は後述。位相及び軸ファイルは出力しないこ
ともできる(オプション -noph, -noax)。

波数軸は西進から東進へとならび (M=-MMAX,-MMAX+1,...,0,...,MMAX)、振動
数は低周波から高周波へと並ぶ。その際、定常成分（振動数＝０）を省略する
ことも可能である。

※ このコマンドを最初につくったときには定常成分を出力しないようにして
   いたが、後に出力できるよう改良した。その経緯からデフォルトでは出力
   しないようにしている(● オプション の steady の項を参照のこと)。ま
   た、定常成分を出力するかしないかでつくられる軸ファイルが違うのも無
   駄だと思うので統一するよう改めたい。

入力が３次元データ(の時系列)である場合、出力は４次元になってしまうが
gtool の都合上、３次元データの列にせざるを得ない。デフォルトでは振動数
の列として出力されるが、オプション seq により、別の軸をばらして列にす
ることもできる。各ヘッダーの ETTL に周期や本来の軸上の位置を書き込む。

※ バグ: SEQ=2または3の場合、軸の最初のグリッドは軸ファイル上の一番目
   の位置を仮定するので gtext したファイルを入力にした場合の ETTL は正
   しくない。

● オプション 

out[C]  出力ファイル名(スペクトル. デフォルトは $GTTMPDIR/gtool.out)
outp[C] 出力ファイル名(位相. デフォルトは $GTTMPDIR/gtoolph.out)
noax[L] T-> 軸ファイルを出力しない (デフォルトは F)
noph[L] T -> 位相を出力しない (デフォルトは F)
steady[L] T -> 定常成分(ω＝0)も出力する (デフォルトは F)
seq[I] (空間３次元データのスペクトルを求める場合にのみ有効)
       1-3 を指定すると、振動数を第3番目の軸として出力する代りに、
       もとのデータの seq 番目の軸をばらして列にする(seq=1なら波数を
       ばらす).
       デフォルトは 4. すなわち振動数をばらして列にする.
rstrd[L] T -> 空間FFTの前にリニアトレンドを引く(うまく行ってるかどう
         か確認してなかったかも知れない.  デフォルトは F.)
rttrd[L] T -> 時間FFTの前にリニアトレンドを引く (同上)
mis00[L] T -> s=ω=0成分を欠損値にする(これを指定すると強制的に
         steady=Tにする) デフォルトは F. このオプションは s=ω=0 成分
         が大きすぎてグラフを書く上でうっとうしい場合に用いるとよい.
log[L] ヘッダーの STYP を 2 にする
help[L], item[C], unit[C], title[C], dset[C], greset[L] 多くのコマンド
       と共通。unitは何も指定しなくても適当な書き換えが行われる。

● スペクトルと位相の定義。

ここでは振動数を０以上とする one-sided スペクトルを用いる。

空間・時間グリッド

  x=x_1,x_2,..,x_I, t=t_1,t_2,..,t_J  (等間隔)

上で与えられた f_{ij}≡f(x_i,t_j) は

  f_{ij}= \sum_{l=0}^{J/2} \sum_{k=-I/2}^{I/2}
             E_{kl} cos( ki - lj + φ_{kl} )

と表せる。k>0は東進、k<0が西進成分である。「位相」は φ_{kl} で定義し、
「スペクトル」は

  S_{kl} = ( E_{kl} )^2 / 2 (l≠0の場合)
           ( E_{kl} )^2     (l＝0の場合)

で定義する。すると

  (f_{ij})^2 の平均値 ＝ \sum_{l=0}^{J/2} \sum_{k=-I/2}^{I/2} S_{kl}  (*)

となる（パーセバルの等式）。なお、steady=F により定常成分を出さない場
合、左辺はもちろん f_{ij} から時間平均値を引いたものの二乗平均値になる。

S_{kl} の単位は f_{ij} のそれの二乗になる。


● 「パワースペクトル密度」を求めたいとき  (以下 97/02/01 に記す)

定数倍すればよい。以下では標準的な使用法である、経度・時間に関してフー
リエ変換した場合を例として、「定数」には何を用いれば良いかを述べる。

波数 s、振動数 f を独立変数とする場合、パワースペクトル密度 P_{kl} は 
(*) のかわりに

  (f_{ij})^2 の平均値 ＝ \sum_{l=0}^{J/2} \sum_{k=-I/2}^{I/2} P_{kl}ΔsΔf
                                                                     (**)
    Δs ＝ sの増分 ＝ 1
    Δf ＝ fの増分 ＝ 1/T (Tはデータの期間)

が成り立つようにすれば良い。よって、

   P_{kl} ＝ S_{kl}/(ΔsΔf) ＝ T・S_{kl}。

つまり T 倍すれば良い。

● 応用例 -- クロススペクトル

u.data と v.data という２つのデータのクロススペクトルを求める。

  % gtstspct u.data outp:u.phase                 # 位相 ＞ u.phase
                                                   スペクトル ＞ gtool.out
  % gtsqrt   out:u.amp                           # スペクトルのルート＞u.amp
  % gtstspct v.data outp:v.phase
  % gtsqrt   out:v.amp
  % gtsub u.phase v.phase
  % gtcos                                        # cos(位相差) ＞ gtool.out
  % gtmlt u.amp                                  # それに u.amp を掛け、
  % gtmlt v.amp  out:uv.cospect \
      unit:'m|2"s|-2"' title:'cospectrum(U,W)'   # v.amp を掛けて出来上がり。
                                                   u,w の単位＝m/sを仮定した

以上でコスペクトル(0 or π ずれ成分)が求まる。これを応用すると EP フラッ
クスの波数・振動数分布の計算といったことが出来る。

97/02/01 堀之内


時空間スペクトル解析ツール

● 各コマンドの簡単な説明

  gtstspct : 空間(主に経度を想定)-時間 の2次元のスペクトルを求める
	     位相の出力も可。

  gtstspct_old : gtstspct の旧版。

  gtstfilt : 時空間 Fourier 変換＆逆変換によるフィルター

● コンパイル上の注意

FFTライブラリー FTPACK (by 石岡＠東大・数理) の古いバージョンのリンク
が必要である。本ディレクトリー下に旧FTPACKのソース中のIMPLICIT文を書き
換えて、単精度にしたものを置く(ftpack_old)。先ずこれをコンパイルして適
当な場所にインストールし、それに応じて本ディレクトリーの Makefile を書
き換えること。

gtstfilt の解説

97/02/01 堀之内

● 機能

時空間 Fourier 変換＆逆変換によるフィルター

● オプション 

 以下で「東進」などの表現については README-gtstspct を参照のこと。

 sdim [I] sdim番目の軸をFourier変換を適用する「空間」軸とする(default=1)
 ewd  [L] T／F : 「東進」／「西進」成分を残す (default=T)
 mmin [I] 波数mmin(正値)以上を残す。0以下を与えると1を仮定 (default=-999)
 mmax [I] 波数mmax(正値)以下を残す。0以下を与えると最大波数-1を仮定(def.=-999)
      (注：Fourier変換の性質上 最大波数=IMAX/2 は東西進を区別できないので除外)
 fmin [I] 振動数fmin(正値)以上を残す。0以下を与えると1を仮定 (default=-999)
          (振動数も小さい方から何番目といった整数値で指定)
 fmax [I] 振動数mmax(正値)以下を残す。0以下だと最大振動数-1を仮定(def.=-999)
 m4 [I,4個]
 f4 [I,4個]
          波数振動数の範囲を4辺形で設定する。
          波数・振動数の４隅 (m4(i),f4(i)),i=1,..,4 は反時計回りになっ
          ていることを仮定する. すべての値に負でない値を与えたときのみ
          有効(defaultはすべて-999)。m4=2,10,10,2 などとコンマで区切っ
          て与える。
 help[L]  オプションの表示と簡単な説明。
 out,apnd,item,unit,title,dset,edit,ettl,greset: 他のgtoolコマンドと同様


● 備考

mmin,mmax,fmin,fmax による範囲指定と (m4(i),f4(i)) による範囲指定は同
時に行える。よって最大で8角形の切断が可能。

計算に用いる FFT の都合上、空間軸時間軸ともグリッド数が 2,3,5 で因数分
解できる偶数でなければならない。

● プログラマーズガイド

現状では波数ゼロ成分等、必ず削られる部分がある。これを残せるようにした
ほうが気分がいいかも知れない。

波数の指定が EWD と MMIN の二本立てになっているが、波数に負の値を許す
ようにすれば EWD は廃止できる。そうしたほうが使いやすいだろう。

*"表題 GTOOLファイルオープン GTOOL3(GFROPN)
*
*"履歴 90/08/16 沼口  敦
*"     90/09/06 沼口  敦
*"     92/09/19 沼口  敦 APPEND
*
*
*********************************************************************
*"         << ファイル読み込みオープン >>
*********************************************************************
      SUBROUTINE GFROPN
     M         ( IFILE ,
     I           HFILE  )
*
      INTEGER    IFILE                    !" 装置番号
      CHARACTER  HFILE*(*)                !" ファイル名
*
      IFILED = IFILE
      CALL       GFOPEN
     O         ( IFILE , IERR  ,
     I           HFILE , IFILED, 'READ' , 'UNFORMATTED'  )
*
      IF ( IERR .NE. 0 ) THEN
         CALL MSGDMP( 'E', 'GFROPN', 'FILE OPEN ERROR' )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << ファイル書き込みオープン >>
*********************************************************************
      SUBROUTINE GFWOPN
     M         ( IFILE ,
     I           HFILE  )
*
      INTEGER    IFILE                    !" 装置番号
      CHARACTER  HFILE*(*)                !" ファイル名
*
      IFILED = IFILE
      CALL       GFOPEN
     O         ( IFILE , IERR  ,
     I           HFILE , IFILED, 'WRITE' , 'UNFORMATTED'  )
*
      IF ( IERR .NE. 0 ) THEN
         CALL MSGDMP( 'E', 'GFWOPN', 'FILE OPEN ERROR' )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << ファイル追加書き込みオープン >>
*********************************************************************
      SUBROUTINE GFAOPN
     M         ( IFILE ,
     I           HFILE  )
*
      INTEGER    IFILE                    !" 装置番号
      CHARACTER  HFILE*(*)                !" ファイル名
*
      IFILED = IFILE
      CALL       GFOPEN
     O         ( IFILE , IERR  ,
     I           HFILE , IFILED, 'APPEND' , 'UNFORMATTED'  )
*
      IF ( IERR .NE. 0 ) THEN
         CALL MSGDMP( 'E', 'GFWOPN', 'FILE OPEN ERROR' )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << ファイル(追加)書き込みオープン >>
*********************************************************************
      SUBROUTINE GFOOPN
     M         ( IFILE ,
     I           HFILX , OAPPND  )
*
      INTEGER    IFILE                    !" 装置番号
      CHARACTER  HFILX*(*)                !" ファイル名
      LOGICAL    OAPPND                   !" 追加?
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      CHARACTER  HFILE *(NFILN)
      CHARACTER  HAPP  *(NCC)
*
      HFILE = HFILX
      CALL GTCGET ( 'APPENDC', HAPP )
      NAP = LENC( HAPP )
*
      IF ( HFILE(1:NAP) .EQ. HAPP ) THEN
         HFILE(1:NAP) = ' ' 
         CALL CLADJ( HFILE )
         CALL    GFAOPN
     O         ( IFILE , HFILE )
*
      ELSE IF ( OAPPND ) THEN
         CALL    GFAOPN
     M         ( IFILE ,
     I           HFILE  )
*
      ELSE
         CALL    GFWOPN
     M         ( IFILE ,
     I           HFILE  )
      ENDIF
*
      RETURN
      END

*"表題 第３次元に関する平均 GTOOL3(GPZAVG)
*
*"履歴 90/08/17 沼口  敦
*
*
*********************************************************************
*"         << 第３次元に関する平均 >>
*********************************************************************
      SUBROUTINE GPZAVG
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS         *(NCC)
      CHARACTER  HETTLD        *(NCC)
*
#ifdef SYS_IBMS
      INCLUDE   (GZIWRK)                     !" NW: 軸ワークの大きさ
#else
#include        "gziwrk.F"                   !" NW: 軸ワークの大きさ
#endif
      CHARACTER  HHEADZ ( NDC )*(NCC)
      REAL       AWGTZ  ( NW )
      REAL       WW     ( NW )
      LOGICAL    OSUBCK
*
      CALL GHCGET ( HHEAD, 'AITM3', HAXIS )
      IF ( HAXIS .EQ. ' ' ) THEN
         CALL       GPFSET
     I         ( HHEAD , GDATA ,
     I           ' '   , ' '   ,
     O           HHEADO, GDATAO   )
         RETURN
      ENDIF
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM )
*
*"         < 2. Δｚの取得 >
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HHEADZ  ,  NW     )
      CALL GUQAXV
     I            ( HHEAD , 3     , 'WGT'  ,
     O              HHEADZ, AWGTZ , IEOD     )
      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
*"         < 3. データ平均( 重みつき ) >
*
      CALL GUSZCZ ( NW    , IXDIM  )
*
      DO 3100 IY = 1, IYDIM
         CALL GUVINT( GDATAO( IXDIM*(IY-1)+1 ), WW, IXDIM )
         DO 3110 IZ = 1, IZDIM
            CALL GUVDIN( GDATAO( IXDIM*(IY-1)+1 ), WW, IXDIM, 1 ,
     &                   GDATA ( IXDIM*IYDIM*(IZ-1) + IXDIM*(IY-1)+1 ),
     &                   AWGTZ ( IZ )                                  )
 3110    CONTINUE
         CALL GUVOUT( GDATAO( IXDIM*(IY-1)+1 ), WW, IXDIM )
 3100 CONTINUE
*
*"         < 4. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHCSET ( HHEADO, 'AITM3', ' '   )
      CALL GHPSET ( HHEADO, 'ASTR3', 1     )
      CALL GHPSET ( HHEADO, 'AEND3', 1     )
*
      IF ( IZSTR .EQ. IZEND )                  RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GHCGET( HHEAD, 'AITM3', HAXIS )
         NH = LENC( HAXIS )
         HETTLD = HAXIS(1:NH)//'-mean'
         CALL GHEADD ( HHEADO, 'ZM' , HETTLD )
*
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL  )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第３次元に関する平均 >>
*********************************************************************
      SUBROUTINE GMZAVG
     M         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPZAVG
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 第３次元の部分切出し GTOOL3(GPZRDC)
*
*"履歴 90/08/18 沼口  敦
*
*
*********************************************************************
*"         << 第３次元の部分切出し >>
*********************************************************************
      SUBROUTINE GPZRDC
     I         ( HHEAD , GDATA , IZSEL1, IZSEL2,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO                 )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IZSEL1                  !" 切り出す第3次元の格子
      INTEGER    IZSEL2                  !" 切り出す第3次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS         *(NCC)
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
      LOGICAL    OCYCL                   !" サイクリックか？
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      IZDIMC = IZSEL2-IZSEL1+1
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIMC )
*
      CALL GHCGET( HHEAD, 'AITM3', HAXIS )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
*"         < 2. データ詰め替え >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
*
      DO 2100 IZ = IZSEL1, IZSEL2
         IF ( OCYCL ) THEN
            IZI = MOD( IZ-IZSTR, IADIM ) + 1
         ELSE
            IZI = IZ-IZSTR+1
         ENDIF
*
         IF ( ( 1.LE.IZI ).AND.( IZI.LE.IZDIM ) ) THEN
            CALL VRSET
     I         ( GDATA ( IXDIM*IYDIM*(IZI-1) +1 ),
     O           GDATAO( IXDIM*IYDIM*(IZ-IZSEL1)+1 ),
     I           IXDIM*IYDIM, 1     , 1                )
         ELSE
            CALL RSET
     O         ( GDATAO( IXDIM*IYDIM*(IZ-IZSEL1)+1 ),
     I           IXDIM*IYDIM, 1    , VMISS               )
         ENDIF
*
 2100 CONTINUE
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHPSET ( HHEADO, 'ASTR3', IZSEL1 )
      CALL GHPSET ( HHEADO, 'AEND3', IZSEL2 )
*
      IF ( ( IZSTR .EQ. IZSEL1 ).AND.( IZEND .EQ. IZSEL2 ) ) RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAXIS , 'ZR'   , '-reduce',
     I                 IZSEL1, IZSEL2 ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第３次元の部分切出し >>
*********************************************************************
      SUBROUTINE GMZRDC
     M         ( HHEAD , GDATA ,
     I           IZSEL1, IZSEL2,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IZSEL1                  !" 切り出す第3次元の格子
      INTEGER    IZSEL2                  !" 切り出す第3次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPZRDC
     I         ( HHEAD , GDATA , IZSEL1, IZSEL2,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW                 )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 第１次元の結合 GTOOL3(GPXCOM)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << 第１次元の結合 >>
*********************************************************************
      SUBROUTINE GPXCOM
     I         ( HHEAD , GDATA , IX    ,
     M           HHEADO, GDATAO         )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IX                      !" 入れるべき第1次元の格
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEADO )
*
      CALL GUQSIZ
     I         ( HHEADO,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
      IF ( ( IX .LT. IXSTR ) .OR. ( IX .GT. IXEND ) ) THEN
         CALL MSGDMP( 'E', 'GPXCOM', 'IX IS OUT OF RANGE.' )
      ENDIF
*
*"         < 2. データ詰め替え >
*
      CALL VRSET
     I      ( GDATA,
     O        GDATAO( IX-IXSTR+1 ),
     I        IYDIM*IZDIM, 1, IXDIM  )
*
      RETURN
      END
*********************************************************************
*"         << 第１次元の結合の準備 >>
*********************************************************************
      SUBROUTINE GPXCMI
     I         ( HHEAD , HAITMX, IXSTR , IXEND ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      CHARACTER  HAITMX      *(*)        !" 結合する第1次元の軸
      INTEGER    IXSTR                   !" 第1次元の軸の格子始め
      INTEGER    IXEND                   !" 第1次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      LOGICAL    OCYCL                   !" サイクリックか？
      CHARACTER  HAITM       *(NCC)
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
*
*"         < 1. 大きさの取得 >
*
      CALL GHCGET ( HHEAD , 'AITM1', HAITM  )
      IF ( HAITM .NE. ' ' ) THEN
         CALL GUQSIZ
     I         ( HHEAD ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM ,
     O           IDUMY1, IDUMY2, IDUMY3 )
      ELSE
         CALL GUQSIZ
     I         ( HHEAD ,
     O           IDUMY1, IDUMY2, IDUMY3,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM   )
      ENDIF
*
      IF ( ( IXSTR .EQ. 0 ) .AND. ( IXEND .EQ. 0 ) ) THEN
         CALL GUQAXD
     I         ( HAITMX,
     O           IADIM , OCYCL  )
         IXSTRZ = 1
         IXENDZ = IADIM
      ELSE
         IXSTRZ = IXSTR
         IXENDZ = IXEND
      ENDIF
*
      IXDIM = IXENDZ - IXSTRZ + 1
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 2. 欠損値を詰める >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
      CALL RSET   ( GDATAO, IXDIM*IYDIM*IZDIM, 1 , VMISS )
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
*
      CALL GHCGET ( HHEAD , 'AITM1', HAITM  )
      IF ( HAITM .NE. ' ' ) THEN
         CALL GHCGET ( HHEAD , 'AITM2', HAITM  )
         CALL GHCSET ( HHEADO, 'AITM3', HAITM  )
         CALL GHPSET ( HHEADO, 'ASTR3', IZSTR  )
         CALL GHPSET ( HHEADO, 'AEND3', IZEND  )
*
         CALL GHCGET ( HHEAD , 'AITM1', HAITM  )
         CALL GHCSET ( HHEADO, 'AITM2', HAITM  )
         CALL GHPSET ( HHEADO, 'ASTR2', IYSTR  )
         CALL GHPSET ( HHEADO, 'AEND2', IYEND  )
      ENDIF
*
      CALL GHCSET ( HHEADO, 'AITM1', HAITMX )
      CALL GHPSET ( HHEADO, 'ASTR1', IXSTRZ )
      CALL GHPSET ( HHEADO, 'AEND1', IXENDZ )
*
      IF ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAITMX, 'XC'   , '-combine',
     I                 IXSTRZ, IXENDZ ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END

*"表題 格子のサイズの参照 GTOOL3(GUQAXD)
*
*"履歴 90/09/14 沼口  敦
*
*
*********************************************************************
*"         << 格子のサイズの参照 >>
*********************************************************************
      SUBROUTINE GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
      CHARACTER  HAXIS      *(*)             !" 格子識別名称
      INTEGER    IADIM                       !" 格子のサイズ
      LOGICAL    OCYCL                       !" サイクリックか？
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      CHARACTER  HHEADZ( NDC )*(NCC)         !" ヘッダー
      CHARACTER  HAXD  *(NCC)
      CHARACTER  HAXF  *(NFILN)
      CHARACTER  HFILE *(NFILN)
      CHARACTER  HMSG  *100
      LOGICAL    OEXIST
*
      IF ( HAXIS .EQ. ' ' ) THEN
         IADIM = 1
         OCYCL = .FALSE.
                                        RETURN
      ENDIF
*
*"         < 1. 「内部ファイル」からの読み込み >
*
      CALL GUQIAH
     I         ( HAXIS ,
     O           HHEADZ, IEOD   )
*
      IF ( IEOD .NE. 0 ) THEN
*
         CALL GTPGET( 'WFILE', IFILW )
*
*"         < 2. カレントディレクトリからの読み込み >
*
         CALL GTCGET( 'FAXLOC1', HAXF  )
         NHF   = LENC( HAXF )
         HFILE = HAXF(1:NHF)//HAXIS
*
         INQUIRE ( FILE=HFILE, EXIST=OEXIST )
*
         IF ( OEXIST ) THEN
            CALL GFROPN
     M         ( IFILW ,
     I           HFILE   )
            CALL GFRDHD
     O         ( HHEADZ, IEOD  ,
     I           IFILW , 0      )
            CALL GFCLSE ( IFILW )
         ENDIF
      ENDIF
*
      IF ( IEOD .NE. 0 ) THEN
*
*"         < 3. デフォルトディレクトリからの読み込み >
*
         CALL GTCGET( 'FAXLOC', HAXF  )
         NHF   = LENC( HAXF )
         HFILE = HAXF(1:NHF)//HAXIS
*
         CALL GFROPN
     M         ( IFILW ,
     I           HFILE   )
         CALL GFRDHD
     O         ( HHEADZ, IEOD  ,
     I           IFILW , 0      )
         CALL GFCLSE ( IFILW )
      ENDIF
*
      IF ( IEOD .EQ. 0 ) THEN
         CALL GHPGET ( HHEADZ, 'AEND1', IADIM  )
         CALL GHCGET ( HHEADZ, 'DSET' , HAXD   )
         OCYCL = ( HAXD(1:1) .EQ. 'C' )
         IF ( OCYCL ) THEN
            IADIM  = IADIM - 1
         ENDIF
      ELSE
         NHP  = LENC(HAXIS)
         HMSG = 'AXIS '''//HAXIS(1:NHP)//''' IS NOT DEFINED.'
         CALL MSGDMP( 'E', 'GUQAXD', HMSG )
      ENDIF
*
      RETURN
      END

*=====================================================================
*      OPTARG for UNIX f77                        92/05/05 Numaguti.A.
*                                   for dcl-5.0 : 95/05/22 Takehiro.S. 
*                              for grph1 option : 95/10/27 Akahori.K. 
*                                               : 97/02/14 Takehiro S.
*=====================================================================
      SUBROUTINE OPTARG
     I         ( IOPUNT, HNMLST, HFLOPT,
     O           NOPT  , NFILE           )
*
      CHARACTER  HNMLST  *(*)
      CHARACTER  HFLOPT  *(*)
*     
*      get command line options
*
*      example:
*
*      CHARACTER GALA*16      / 'gala.gala.' /
*      CHARACTER HFILE(2)*128 / 'gala.out', ' '/
*      LOGICAL   HELP         / .FALSE. /
*      NAMELIST  /OPTION/ GALA, PEN, HFILE, HELP
*
*      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
*      READ  (91,OPTION,IOSTAT=IOS)
*      CLOSE (91)
*      IF ( IOS.NE.0 .OR. HELP ) THEN
*         WRITE (6,OPTION)
*         STOP
*      ENDIF
*
      PARAMETER (LENARG=256,LENNUM=3,LENNNM=20)
      CHARACTER  HOPARG  *(LENARG)
      CHARACTER  HFLNUM  *(LENNUM)
      CHARACTER  HNMNUM  *(LENNNM)
*
      OPEN  ( IOPUNT,STATUS='SCRATCH' ) 
      HNMNUM = ' &'//HNMLST
      WRITE ( IOPUNT,'(A)' ) HNMNUM(1:LENC(HNMNUM))
*
      NFILE = 0
      NARG  = IARGC()
*
      DO 1100 I = 1, NARG
         CALL OSGARG( I,HOPARG )
         CALL CLADJ( HOPARG )
         LENHOP = LENC( HOPARG )
         IF ((HOPARG(1:1).EQ.'-').AND.(HOPARG(4:4) .EQ.':')) GOTO 1100
*                                                  95/10/27 by Akahori.K
*                                     for grph1 option (ex.-sg:xxxx=xxxx)
*
         IF      ( INDEX( HOPARG,':' ).GT.1 ) THEN
	    IC = INDEX( HOPARG,':' )
	    WRITE ( IOPUNT,'(A)' )
     &         '  '//HOPARG(1:IC-1)//'='''
     &             //HOPARG(IC+1:LENHOP)//''''//','
         ELSE IF ( INDEX( HOPARG,'-' ).EQ.1 ) THEN
            WRITE ( IOPUNT,'(A)' ) '  '//HOPARG(2:LENHOP)//'=T'//','
         ELSE IF ( INDEX( HOPARG,'#' ).EQ.1 ) THEN
            WRITE ( IOPUNT,'(A)' ) '  '//HOPARG(2:LENHOP)//'=F'//','
         ELSE IF ( INDEX( HOPARG,'=' ).LE.0 ) THEN
            NFILE = NFILE+1
            HNMNUM = HFLOPT
            WRITE ( HFLNUM,'(I3)' ) NFILE
	    WRITE ( IOPUNT,'(A)' ) 
     &         '  '//HNMNUM(1:LENC(HNMNUM))//
     &          '('//HFLNUM(LENB(HFLNUM)+1:)//')='''
     &             //HOPARG(1:LENHOP)//''''//','
         ELSE
            WRITE ( IOPUNT,'(A)' ) '  '//HOPARG(1:LENHOP)//','
         ENDIF
 1100 CONTINUE
*
      WRITE ( IOPUNT, '(A)' ) '  &END'
      REWIND( IOPUNT )
*
      NOPT = NARG - NFILE
*
      RETURN
      END

*"表題 配列の大きさのチェック GTOOL3(GUSZCK)
*
*"履歴 90/09/21 沼口  敦
*
*
*********************************************************************
*"      << 配列の大きさのチェック >>
*********************************************************************
      SUBROUTINE GUSZCK
     I         ( HHEAD , ISIZEO  )
*
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      INTEGER    ISIZEO                      !" 出力の大きさ
*
      LOGICAL    OSUBCK                      !" チェックフラグ
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      IF ( .NOT. OSUBCK )                     RETURN
*
      CALL GHPGET ( HHEAD, 'SIZE', ISIZEA )
      CALL GUSZCZ ( ISIZEA, ISIZEO )
*
      RETURN
      END
*********************************************************************
*"      << 大きさのチェック >>
*********************************************************************
      SUBROUTINE GUSZCZ
     I         ( ISIZEA, ISIZEO )
*
      INTEGER    ISIZEA                      !" 領域の大きさ
      INTEGER    ISIZEO                      !" 出力の大きさ
*
      CHARACTER  HMSG *100
*
      IF ( ISIZEO .GT. ISIZEA ) THEN
         HMSG = 'INSUFFICIENT SPACE: OUT= '
         NH = LENC( HMSG )
         WRITE ( HMSG(NH+1:NH+8), '(I8)' ) ISIZEO
         HMSG(NH+9:100) = ',  ALLOC= '
         NH = LENC( HMSG )
         WRITE ( HMSG(NH+1:NH+8), '(I8)' ) ISIZEA
*
         CALL MSGDMP('E', 'GUSZCK', HMSG )
      ENDIF
*
      RETURN
      END

* PACKAGE  GTHYDRO !" T -> z hydrostatic
***********************************************************************
      PROGRAM GTHYDR
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEADT( NDC )*(NCC)
      REAL       GDATAT( IJKDIM )
      CHARACTER  HHEADQ( NDC )*(NCC)
      REAL       GDATAQ( IJKDIM )
      CHARACTER  HHEADZ( NDC )*(NCC)
      REAL       GDATAZ( IJKDIM )
      CHARACTER  HITEZ  *(NCC)
*
      DATA       IFILT / 50 /
      DATA       IFILQ / 51 /
      DATA       IFILZ / 52 /
      DATA       JFILE / 60 /
*
      DATA       GRAV  /  9.8 /
*
      CHARACTER  T      *(NFILN)
      DATA       T      / 'T' /
      CHARACTER  Q      *(NFILN)
      DATA       Q      / 'q' /
      CHARACTER  ZS     *(NFILN)
      DATA       ZS     / 'ZS' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM  / 'Z' /
      DATA       TITLE / 'G.P. Height' /
      DATA       UNIT  / 'm' /
      DATA       DSET, EDIT, ETTL / 3*' '/
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   CALGPH
*     
      NAMELIST  /OPTION/ T   , Q   , ZS   , OUT,  APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEADT, IJKDIM )
      CALL GTSIZE ( HHEADQ, IJKDIM )
      CALL GTSIZE ( HHEADZ, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( T,  OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( Q,  OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( ZS, OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILET, T    )
      CALL GFROPN ( IFILEQ, Q    )
      CALL GFROPN ( IFILEZ, ZS   )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      CALL   GFREAD
     O        ( HHEADZ, GDATAZ, IEODZ ,
     I          IFILEZ, 1               )
*
      IF ( IEODZ .NE. 0 ) THEN
         CALL MSGDMP('E','GTHYDRO','ZS FILE NOT FOUND' )
      ENDIF
*
      CALL GHCGET( HHEADZ, 'ITEM', HITEZ )
      IF ( HITEZ .EQ. 'GPHIS' ) THEN
         CALL GMFFCT
     I        ( HHEADZ, GDATAZ, 1./GRAV ,
     I          '  '  , '  '              )
      ENDIF
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEADT, GDATAT, IEODT ,
     I          IFILET, 1               )
         CALL   GFREAD
     O        ( HHEADQ, GDATAQ, IEODQ ,
     I          IFILEQ, 1               )
*
         IF ( MAX(IEODT,IEODQ) .EQ.0 ) THEN
            CALL GMCAL3
     I         ( CALGPH,
     M           HHEADT, GDATAT,
     I           HHEADQ, GDATAQ,
     I           HHEADZ, GDATAZ,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEADT, 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEADT )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEADT, GDATAT,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE CALGPH
     I         ( HT    , T     ,
     I           HQ    , Q     ,
     I           HZS   , ZS    ,
     O           HZGP  , ZGP   ,
     D           IMAX  , JMAX  , KMAX ,
     D           IMAX2 , JMAX2 , KMAX2,
     D           IMAX3 , JMAX3 , KMAX3  )
*
      CHARACTER  HT  ( * )*(*)
      REAL       T   ( IMAX, JMAX, KMAX )
      CHARACTER  HQ  ( * )*(*)
      REAL       Q   ( IMAX2, JMAX2, KMAX3 )
      CHARACTER  HZS ( * )*(*)
      REAL       ZS  ( IMAX3, JMAX3 )
      CHARACTER  HZGP( * )*(*)
      REAL       ZGP ( IMAX, JMAX, KMAX )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      CHARACTER  HHS ( NDC )*(NCC)
      PARAMETER  ( KMAXD = 100 )
      REAL       SIG   ( KMAXD )
      REAL       DSIG  ( KMAXD )
*
      IF ( KMAX .GT. KMAXD ) THEN
         CALL MSGDMP( 'E','CALGPH','WORK AREA TOO SMALL' )
      ENDIF
*
      CALL GTSIZE ( HHS  ,  KMAXD   )
      CALL GUQAXV
     I            ( HT    , 3     , 'LOC',
     O              HHS   , SIG   , IEOD  )
      CALL GUQAXV
     I            ( HT    , 3     , 'WGT',
     O              HHS   , DSIG  , IEOD  )
*
      CALL HYDRO
     O         ( ZGP   ,
     I           T     , Q     , ZS    ,
     I           SIG   , DSIG  , IMAX*JMAX, KMAX  )
*
      RETURN
      END
**********************************************************************
      SUBROUTINE HYDRO
     O         ( Z     ,
     I           T     , Q     , ZS    ,
     I           SIG   , DSIG  , IJMAX , KMAX  )
*
      REAL       Z     ( IJMAX, KMAX+1 )
      REAL       T     ( IJMAX, KMAX   )
      REAL       Q     ( IJMAX, KMAX   )
      REAL       ZS    ( IJMAX         )
      REAL       SIG   ( KMAX )
      REAL       DSIG  ( KMAX )
*
      DATA       CP   / 1004.6 /  
      DATA       RAIR / 287.04 /
      DATA       GRAV / 9.8 /
      DATA       RVAP / 461. /
*
      PARAMETER  ( KMAXD = 100 )
      REAL       SALPHA ( KMAXD )
      REAL       SBETA  ( KMAXD )
*
      IF ( KMAX .GT. KMAXD ) THEN
         CALL MSGDMP( 'E','HYDRO','WORK AREA TOO SMALL' )
      ENDIF
*
      AKAPPA = RAIR / CP
      EPSV   = RAIR / RVAP
      EPSVT  = 1.0/EPSV - 1.0
*
      DO 100 K = 1, KMAX
         SALPHA( K ) = -1. +    ( 1.+ DSIG(K)/SIG(K)/2.     )**AKAPPA
         SBETA ( K ) =  1. - MAX( 1.- DSIG(K)/SIG(K)/2., 0. )**AKAPPA
  100 CONTINUE
*
      DO 1100 IJ = 1, IJMAX
           Z ( IJ,1 ) = ZS( IJ )
     &                + CP/GRAV * SALPHA( 1   ) 
     &                  * T( IJ,1 ) * ( 1.+EPSVT* Q( IJ,1 ) )
 1100 CONTINUE 
*
      DO 2300 K = 2, KMAX
         DO 2310 IJ = 1, IJMAX
            Z( IJ,K ) = Z( IJ,K-1 )
     &                + CP/GRAV * SALPHA( K   )
     &                  * T( IJ,K   ) * ( 1.+EPSVT* Q( IJ,K   ) )
     &                + CP/GRAV * SBETA ( K-1 )
     &                  * T( IJ,K-1 ) * ( 1.+EPSVT* Q( IJ,K-1 ) )
 2310    CONTINUE
 2300 CONTINUE
*
      RETURN
      END

*"表題 第２次元の結合 GTOOL3(GPYCOM)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << 第２次元の結合 >>
*********************************************************************
      SUBROUTINE GPYCOM
     I         ( HHEAD , GDATA , IY    ,
     M           HHEADO, GDATAO         )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IY                      !" 入れるべき第2次元の格
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEADO )
*
      CALL GUQSIZ
     I         ( HHEADO,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
      IF ( ( IY .LT. IYSTR ) .OR. ( IY .GT. IYEND ) ) THEN
         CALL MSGDMP( 'E', 'GPYCOM', 'IY IS OUT OF RANGE.' )
      ENDIF
*
*"         < 2. データ詰め替え >
*
      DO 2100 IZ = 1, IZDIM
         CALL VRSET
     I      ( GDATA ( IXDIM*(IZ-1) + 1 ),
     O        GDATAO( IXDIM*IYDIM*(IZ-1) + IXDIM*(IY-IYSTR) + 1 ),
     I        IXDIM, 1     , 1                                     )
 2100 CONTINUE
*
      RETURN
      END
*********************************************************************
*"         << 第２次元の結合の準備 >>
*********************************************************************
      SUBROUTINE GPYCMI
     I         ( HHEAD , HAITMY, IYSTR , IYEND ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      CHARACTER  HAITMY      *(*)        !" 結合する第2次元の軸の
      INTEGER    IYSTR                   !" 第2次元の軸の格子始め
      INTEGER    IYEND                   !" 第2次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      LOGICAL    OCYCL                   !" サイクリックか？
      CHARACTER  HAITM       *(NCC)
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
*
*"         < 1. 大きさの取得 >
*
      CALL GHCGET ( HHEAD , 'AITM2', HAITM  )
      IF ( HAITM .NE. ' ' ) THEN
         CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IZSTR , IZEND , IZDIM ,
     O           IDUMY1, IDUMY2, IDUMY3 )
      ELSE
         CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IDUMY1, IDUMY2, IDUMY3,
     O           IZSTR , IZEND , IZDIM  )
      ENDIF
*
      IF ( ( IYSTR .EQ. 0 ) .AND. ( IYEND .EQ. 0 ) ) THEN
         CALL GUQAXD
     I         ( HAITMY,
     O           IADIM , OCYCL  )
         IYSTRZ = 1
         IYENDZ = IADIM
      ELSE
         IYSTRZ = IYSTR
         IYENDZ = IYEND
      ENDIF
*
      IYDIM = IYENDZ - IYSTRZ + 1
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 2. 欠損値を詰める >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
      CALL RSET   ( GDATAO, IXDIM*IYDIM*IZDIM, 1 , VMISS )
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHCGET ( HHEAD , 'AITM2', HAITM  )
      IF ( HAITM .NE. ' ' ) THEN
         CALL GHCGET ( HHEAD , 'AITM2', HAITM  )
         CALL GHCSET ( HHEADO, 'AITM3', HAITM  )
         CALL GHPSET ( HHEADO, 'ASTR3', IZSTR  )
         CALL GHPSET ( HHEADO, 'AEND3', IZEND  )
      ENDIF
*
      CALL GHCSET ( HHEADO, 'AITM2', HAITMY )
      CALL GHPSET ( HHEADO, 'ASTR2', IYSTRZ )
      CALL GHPSET ( HHEADO, 'AEND2', IYENDZ )
*
      IF ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAITMY, 'YC'   , '-combine',
     I                 IYSTRZ, IYENDZ ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END

* PACKAGE GTEXT    !" サイズの変更, 次元の追加
*********************************************************************
      PROGRAM GTEXT
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
      CHARACTER  HHEADR( NDC )*(NCC)
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      CHARACTER  HAXX  *(NCC), HAXXR  *(NCC)
      CHARACTER  HAXY  *(NCC), HAXYR  *(NCC)
      CHARACTER  HAXZ  *(NCC), HAXZR  *(NCC)
*
      CHARACTER  X *(NCC), Y *(NCC), Z *(NCC) 
      DATA       X, Y, Z  / 3*' ' /
      INTEGER    XSTR, XEND
      DATA       XSTR, XEND / 0,0 /
      INTEGER    YSTR, YEND
      DATA       YSTR, YEND / 0,0 /
      INTEGER    ZSTR, ZEND
      DATA       ZSTR, ZEND / 0,0 /
      CHARACTER  REF    *(NFILN)
      DATA       REF      / ' ' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ X, Y, Z,
     &                   XSTR, XEND, YSTR, YEND, ZSTR, ZEND,
     &                   REF , OUT, APND, HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GTSIZE ( HHEADR, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      IF ( REF .NE. ' ' ) THEN
         CALL GFROPN ( IFILE, REF )
         CALL GFRDHD 
     O         ( HHEADR, IEODR,
     I           IFILE , 1     )
         WRITE ( 6,* ) '** AS REFERENCE'
         IF ( IEODR .EQ. 0 ) THEN
            CALL GHCGET( HHEADR, 'AITM1', HAXXR )
            CALL GHCGET( HHEADR, 'AITM2', HAXYR )
            CALL GHCGET( HHEADR, 'AITM3', HAXZR )
            CALL GUQSIZ
     I         ( HHEADR,
     O           IXSTRR, IXENDR, IXDIMR,
     O           IYSTRR, IYENDR, IYDIMR,
     O           IZSTRR, IZENDR, IZDIMR )
         ELSE
            WRITE ( 6,* ) ' no reference file'
            STOP
         ENDIF
         CALL GFCLSE( IFILE )
      ENDIF
      CALL GFROPN ( IFILE, HFILE( 1 ) )
      CALL GFOOPN ( JFILE,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      II = 0
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD.EQ.0 ) THEN
*
            IF ( REF .NE. ' ' ) THEN
               CALL GHCGET( HHEAD , 'AITM1', HAXX  )
               CALL GHCGET( HHEAD , 'AITM2', HAXY  )
               CALL GHCGET( HHEAD , 'AITM3', HAXZ  )
               CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
               IERR = 0
               IF ( HAXZ .EQ. ' ' ) THEN
                  IF ( HAXY .EQ. ' ' ) THEN
                     IF ( HAXX .EQ. ' ' ) THEN
                        X = HAXXR
                        Y = HAXYR
                        Z = HAXZR
                     ELSE IF ( HAXX .EQ. HAXXR ) THEN
                        Y = HAXYR
                        Z = HAXZR
                     ELSE IF ( HAXX .EQ. HAXYR ) THEN
                        X = HAXXR
                        Z = HAXZR
                     ELSE IF ( HAXX .EQ. HAXZR ) THEN
                        X = HAXXR
                        Y = HAXYR
                     ELSE 
                        IERR = 1
                     ENDIF
                  ELSE IF ( HAXY .EQ. HAXYR ) THEN
                     IF ( HAXX .EQ. HAXXR ) THEN
                        Z = HAXZR
                     ELSE
                        IERR = 1
                     ENDIF
                  ELSE IF ( HAXY .EQ. HAXZR ) THEN                   
                     IF ( HAXX .EQ. HAXXR ) THEN
                        Y = HAXYR
                     ELSE IF ( HAXX .EQ. HAXYR ) THEN
                        X = HAXXR
                     ELSE
                        IERR = 1
                     ENDIF
                  ELSE
                     IERR = 1
                  ENDIF
               ELSE
                  IF ( HAXX .NE. HAXXR .OR.
     &                 HAXY .NE. HAXYR .OR.
     &                 HAXZ .NE. HAXZR       ) THEN
                      IERR = 1
                  ENDIF
               ENDIF
*
               IF ( IERR .NE. 0 ) THEN
                  WRITE (6,*) 'cannot extend as reference'
                  WRITE (6,*) HAXX//'-'//HAXY//'-'//HAXZ
                  WRITE (6,*) HAXXR//'-'//HAXYR//'-'//HAXZR
                  STOP
               ENDIF
*
            ENDIF
*            
            IF ( X .NE. ' ' ) THEN
               CALL GMXEXT
     M               ( HHEAD , GDATA ,
     I                 X     , XSTR  , XEND  ,
     I                 ' '   , ' '             )
            ELSE IF ( XSTR .EQ. 0 .AND. XEND .EQ. 0 ) THEN
               CALL GMXEXP
     M               ( HHEAD , GDATA ,
     I                 ' ' , ' '       )
            ELSE
               CALL GMXRDC
     M               ( HHEAD , GDATA ,
     I                 XSTR  , XEND  ,
     I                 ' '   , ' '     )
            ENDIF
*
            IF ( Y .NE. ' ' ) THEN
               CALL GMYEXT
     M               ( HHEAD , GDATA ,
     I                 Y     , YSTR  , YEND  ,
     I                 ' '   , ' '             )
            ELSE IF ( YSTR .EQ. 0 .AND. YEND .EQ. 0 ) THEN
               CALL GMYEXP
     M               ( HHEAD , GDATA ,
     I                 ' ' , ' '       )
            ELSE
               CALL GMYRDC
     M               ( HHEAD , GDATA ,
     I                 YSTR  , YEND  ,
     I                 ' '   , ' '     )
            ENDIF
*
            IF ( Z .NE. ' ' ) THEN
               CALL GMZEXT
     M               ( HHEAD , GDATA ,
     I                 Z     , ZSTR  , ZEND  ,
     I                 ' '   , ' '             )
            ELSE IF ( ZSTR .EQ. 0 .AND. ZEND .EQ. 0 ) THEN
               CALL GMZEXP
     M               ( HHEAD , GDATA ,
     I                 ' ' , ' '       )
            ELSE
               CALL GMZRDC
     M               ( HHEAD , GDATA ,
     I                 ZSTR  , ZEND  ,
     I                 ' '   , ' '     )
            ENDIF
*
            CALL  GFWRIT
     I               ( HHEAD , GDATA ,
     I                 JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END

*"    FST2S2, FST2P2 : 基本的に FST2SP, FST2PH と同じだが定常成分
*"    (振動数=0)も出力する
*
*     96/06/02 horinout < \
*        1993/11/17  horinout FST2SP:power spectrum FST2PH:phase
***********************************************************************
*
      SUBROUTINE  FST2S2 !"space-time fourier-->space-time power spect
     O   ( SP ,
     I     X  , N1 , NX , N3 , NT )
*
      IMPLICIT   REAL  (A-H,O-Z)
      DIMENSION  X(N1,NX,N3,NT)
      DIMENSION  SP(N1,NX+1,N3,0:NT/2)
*
      NX2 = NX/2
      NT2 = NT/2
      IF(NT2*2.NE.NT) CALL MSGDMP('E','FST2SP','INVALID ARRAY SIZE')
      IF(NX2*2 .NE.NX ) CALL MSGDMP('E','FST2SP','INVALID ARRAY size')
*
      DO 10 N = 0,NT2
      DO 10 J = 1,N3
      DO 10 K = 0,NX2
      DO 10 I = 1,N1
        IF(K.EQ.0 .AND. N.EQ.0) THEN
          P = X( I , 1 , J , 1 )
          Q = 0
          R = 0
          S = 0
        ELSE IF(K.EQ.0 .AND. N.LE.NT2-1) THEN
          P = X( I , 1 , J , 2*N+1 )
          Q =-X( I , 1 , J , 2*N+2 )
          R = 0
          S = 0
        ELSE IF(K.EQ.0 .AND. N.EQ.NT2) THEN
          P = X( I , 1 , J , 2 )
          Q = 0
          R = 0
          S = 0
        ELSE IF(K.LE.NX2-1 .AND. N.EQ.0) THEN
          P = X( I , 2*K+1 , J , 1 )
          Q = 0
          R =-X( I , 2*K+2 , J , 1 )
          S = 0
        ELSE IF(K.LE.NX2-1 .AND. N.LE.NT2-1) THEN
          P = X( I , 2*K+1 , J , 2*N+1 )
          Q =-X( I , 2*K+1 , J , 2*N+2 )
          R =-X( I , 2*K+2 , J , 2*N+1 )
          S = X( I , 2*K+2 , J , 2*N+2 )
        ELSE IF(K.LE.NX2-1 .AND. N.EQ.NT2) THEN
          P = X( I , 2*K+1 , J , 2 )
          Q = 0
          R =-X( I , 2*K+2 , J , 2 )
          S = 0
        ELSE IF(K.EQ.NX2 .AND. N.EQ.0) THEN
          P = X( I , 2 , J , 1 )
          Q = 0
          R = 0
          S = 0
        ELSE IF(K.EQ.NX2 .AND. N.LE.NT2-1) THEN
          P = X( I , 2 , J , 2*N+1 )
          Q =-X( I , 2 , J , 2*N+2 )
          R = 0
          S = 0
        ELSE IF(K.EQ.NX2 .AND. N.EQ.NT2) THEN
          P = X( I , 2 , J , 2 )
          Q = 0
          R = 0
          S = 0
        ENDIF
        IF (N.NE.0) THEN
          SP( I , NX2+1-K , J ,N) = 2 * ( (P-S)**2 + (Q+R)**2 )
          SP( I , NX2+1+K , J ,N) = 2 * ( (P+S)**2 + (Q-R)**2 )
        ELSE
          SP( I , NX2+1-K , J ,N) = P**2 + R**2
          SP( I , NX2+1+K , J ,N) = P**2 + R**2
        ENDIF
   10 CONTINUE
*
      RETURN
      END
***********************************************************************
*
      SUBROUTINE  FST2P2  !" space-time fourier --> space-time phase
     O   ( PH ,
     I     X  , N1 , NX , N3 , NT )
*
      IMPLICIT   REAL  (A-H,O-Z)
      DIMENSION  X(N1,NX,N3,NT)
      DIMENSION  PH(N1,NX+1,N3,0:NT/2)
*
      NX2 = NX/2
      NT2 = NT/2
      IF(NT2*2.NE.NT) CALL MSGDMP('E','FST2PH','INVALID ARRAY SIZE')
      IF(NX2*2 .NE.NX ) CALL MSGDMP('E','FST2PH','INVALID ARRAY size')
*
      DO 10 N = 1,NT2
      DO 10 J = 1,N3
      DO 10 K = 0,NX2
      DO 10 I = 1,N1
        IF(K.EQ.0 .AND. N.EQ.0) THEN
          P = X( I , 1 , J , 1 )
          Q = 0
          R = 0
          S = 0
        ELSE IF(K.EQ.0 .AND. N.LE.NT2-1) THEN
          P = X( I , 1 , J , 2*N+1 )
          Q =-X( I , 1 , J , 2*N+2 )
          R = 0
          S = 0
        ELSE IF(K.EQ.0 .AND. N.EQ.NT2) THEN
          P = X( I , 1 , J , 2 )
          Q = 0
          R = 0
          S = 0
        ELSE IF(K.LE.NX2-1 .AND. N.EQ.0) THEN
          P = X( I , 2*K+1 , J , 1 )
          Q = 0
          R =-X( I , 2*K+2 , J , 1 )
          S = 0
        ELSE IF(K.LE.NX2-1 .AND. N.LE.NT2-1) THEN
          P = X( I , 2*K+1 , J , 2*N+1 )
          Q =-X( I , 2*K+1 , J , 2*N+2 )
          R =-X( I , 2*K+2 , J , 2*N+1 )
          S = X( I , 2*K+2 , J , 2*N+2 )
        ELSE IF(K.LE.NX2-1 .AND. N.EQ.NT2) THEN
          P = X( I , 2*K+1 , J , 2 )
          Q = 0
          R =-X( I , 2*K+2 , J , 2 )
          S = 0
        ELSE IF(K.EQ.NX2 .AND. N.EQ.0) THEN
          P = X( I , 2 , J , 1 )
          Q = 0
          R = 0
          S = 0
        ELSE IF(K.EQ.NX2 .AND. N.LE.NT2-1) THEN
          P = X( I , 2 , J , 2*N+1 )
          Q =-X( I , 2 , J , 2*N+2 )
          R = 0
          S = 0
        ELSE IF(K.EQ.NX2 .AND. N.EQ.NT2) THEN
          P = X( I , 2 , J , 2 )
          Q = 0
          R = 0
          S = 0
        ENDIF
        IF ( (Q+R).NE.0 .OR. (P-S).NE.0 ) THEN
          PH( I , NX2+1-K , J ,N) = ATAN2( (Q+R) , (P-S) )
        ELSE
          PH( I , NX2+1-K , J ,N) = 0
        ENDIF
        IF ( (Q-R).NE.0 .OR. (P+S).NE.0 ) THEN
          PH( I , NX2+1+K , J ,N) = ATAN2( (Q-R) , (P+S) )
        ELSE
          PH( I , NX2+1+K , J ,N) = 0
        ENDIF
   10 CONTINUE
*
      RETURN
      END

*"表題 地図投影 : 座標の設定 GTOOL3(GGAXES)
*
*"履歴 90/08/16 沼口  敦
*"     95/05/26 竹広真一 for dcl-5.z.7
*"     95/05/31 竹広真一 極座標 tickmark をつける. 
*"     95/06/05 竹広真一 for dcl-5.z.13
*"     95/11/01 竹広真一 地図境界 clipping 
*"     96/01/10 竹広真一 minor 修正
*"     97/12/01 竹広真一 SET -> STX
*
*********************************************************************
*"         << 軸のセット 地図投影 >>
*********************************************************************
      SUBROUTINE GGAXES
     I         ( HHEAD )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
      INCLUDE    (GZIWRK)                !" NW: 軸ワークの大きさ
#else
#include         "gzsize.F"              !" NCC, NDC
#include         "gziwrk.F"              !" NW: 軸ワークの大きさ
#endif
      CHARACTER  HHEADX( NDC )*(NCC)     !" X 軸ファイルのヘッダー
      CHARACTER  HHEADY( NDC )*(NCC)     !" Y 軸ファイルのヘッダー
      REAL       AXISX ( NW )            !" X 座標値
      REAL       AXISY ( NW )            !" Y 座標値
      LOGICAL    OSUBCK
*
      REAL       XMIN, XMAX, YMIN, YMAX    !" 描画用変数
      REAL       RADI                      !" NC 上の地球半径
*
      INTEGER    IPRJ                      !" 投影法
      REAL       ALAT, ALON                !" 投影中心緯度傾度
      REAL       ROTA                      !" 回転
      REAL       SIMFAC                    !" 投影拡大率
      CHARACTER  HPOS*30, HLAT*8, HLON*8
*
*"         < 1. 軸ファイルの読み込み >
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HHEADX  ,  NW     )
      CALL GTSIZE ( HHEADY  ,  NW     )
      CALL GUQAXV
     I            ( HHEAD , 1     , 'LOC' ,
     O              HHEADX, AXISX , IEOD   )
      CALL GUQAXV
     I            ( HHEAD , 2     , 'LOC' ,
     O              HHEADY, AXISY , IEOD   )
      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
*"         < 2. 範囲 >
*
      CALL GHPGET ( HHEAD , 'ASTR1', IXSTR )
      CALL GHPGET ( HHEAD , 'AEND1', IXEND )
      CALL GHPGET ( HHEAD , 'ASTR2', IYSTR )
      CALL GHPGET ( HHEAD , 'AEND2', IYEND )
*
*"         < 3. 座標の設定 >
*
      CALL GGPGET( 'MAPPRJ', IPRJ )
*
      IF( IPRJ .EQ. 0 )THEN                     !" 地図投影しない <<X-Y>>
         CALL GGAXSZ
     I     ( HHEADX, AXISX , 'X'   )
         CALL GGAXSZ
     I     ( HHEADY, AXISY , 'Y'   )
      ENDIF
*
      CALL UWSGXA ( AXISX, IXEND-IXSTR+1 )
      CALL UWSGYA ( AXISY, IYEND-IYSTR+1 )
*
      IF( IPRJ .EQ. 0 ) RETURN                  !" 地図投影しない <<X-Y>>
*
*
*"         < 4. 地図描画設定 >
*
      CALL GGPGET( 'MAPLON', ALON )
      CALL GGPGET( 'MAPLAT', ALAT )
      CALL GGPGET( 'MAPROT', ROTA )
      CALL GGPGET( 'MAPFAC', SIMFAC )
*
      CALL GGPGET( 'VXMIN', XMIN )
      CALL GGPGET( 'VXMAX', XMAX )
      CALL GGPGET( 'VYMIN', YMIN )
      CALL GGPGET( 'VYMAX', YMAX )
*
      IF( ( 5 .LE. IPRJ ) .AND. ( IPRJ .LE. 6 ) )THEN
         CALL GHPGET ( HHEADX , 'DMAX' , RADW )          !" 動径最大値
         RADI = MIN( XMAX-XMIN, YMAX-YMIN ) / 2. * SIMFAC / RADW
      ENDIF
*
      CALL SGPSTX('LDEG',  .TRUE.)    !" 角度単位
      CALL SGPSTX('LLNINT',.TRUE.)
      CALL SGPSTX('LGCINT',.TRUE.)
      CALL SGPSTX('STLAT1', 45.0 )
      CALL SGPSTX('STLAT2', 30.0 )
*
      CALL SGSVPT( XMIN, XMAX, YMIN, YMAX )
*
      IF( ( 5 .LE. IPRJ ) .AND. ( IPRJ .LE. 6 ) )THEN
         CALL SGSSIM( RADI, 0., 0. )
         CALL SGSTRN(IPRJ)
         CALL SGSTRF
      ELSE IF( ( 10 .LE. IPRJ ) .AND. ( IPRJ .LE. 15 ) )THEN
         CALL GRSTRN(IPRJ)
         CALL UMSCNT( ALON, ALAT, ROT )
         CALL UMLSTX('LGLOBE', .TRUE. )
         CALL UMPFIT
         CALL GRSTRF
      ELSE IF( ( 20 .LE. IPRJ ) .AND. ( IPRJ .LE. 23 ) )THEN
         CALL GRSTRN(IPRJ)
         CALL UMSCNT( ALON, ALAT, ROT )
         CALL UMLSTX('LGLOBE', .TRUE. )
         CALL UMPFIT
         CALL GRSTRF
      ELSE IF( ( 30 .LE. IPRJ ) .AND. ( IPRJ .LE. 33 ) )THEN
         CALL GRSTRN(IPRJ)
         CALL UMSCNT( ALON, ALAT, ROT )
         CALL UMLSTX('LGLOBE', .TRUE. )
         CALL UMPFIT
         CALL GRSTRF
      ENDIF
*
*"         < 5. 投影中心位置の表示 > 
*
      CALL GGPGET( 'SEDIT' , SEDIT )
*
      CALL CHVAL( '(F6.1)', ALON, HLON )
      IHLON = LENC( HLON )
      CALL CHVAL( '(F5.1)', ALAT, HLAT )
      IHLAT = LENC( HLAT )
      HPOS = '(lon,lat)=(' // HLON(1:IHLON) // ', '
     &                              // HLAT(1:IHLAT) // ')'
      IHPOS = LENC(HPOS)
*
      XP = ( XMIN + XMAX ) / 2
      YP = YMIN - SEDIT * 1.2
      CALL SGTXZV( XP , YP , HPOS(1:IHPOS), SEDIT, 0, 0, 3 )
*
*"         < 6. 描画境界線 > 
*
      IF( ( 5 .LE. IPRJ ) .AND. ( IPRJ .LE. 6 ) )THEN
         CALL PORAXZ
     I          ( HHEADX , AXISX ,
     I            HHEADY , AXISY   )
      ELSE IF( ( 10 .LE. IPRJ ) .AND. ( IPRJ .LE. 33 ) )THEN
         CALL SGPSTX( 'LCLIP', .TRUE. )
         CALL UMPLIM
         CALL SGPSTX( 'LCLIP', .FALSE. )
      ENDIF
*
      RETURN
      END
**********************************************************************
      SUBROUTINE PORAXZ                  !" 外枠囲み(極座標)
     I             ( HHEADX , AXISX ,
     I               HHEADY , AXISY   )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
*
      CHARACTER  HHEADX( NDC )*(NCC)     !" 動径軸ヘッダーファイル
      CHARACTER  HHEADY( NDC )*(NCC)     !" 方位角軸ヘッダーファイル
      CHARACTER  HDSETY*(NCC)
*
      REAL       AXISX(*)                !" X 座標値
      REAL       AXISY(*)                !" Y 座標値
*
      REAL       RSIZE                   !" 座標目盛の長さ(V 座標)
*
      PARAMETER ( N = 5 )
      REAL  X(N) , Y(N)
*
      CALL GHPGET ( HHEADX, 'ASTR1', IXSTR )
      CALL GHPGET ( HHEADX, 'AEND1', IXEND )
      CALL GHPGET ( HHEADY, 'ASTR1', IYSTR )
      CALL GHPGET ( HHEADY, 'AEND1', IYEND )
*
      CALL GHPGET ( HHEADX , 'DMIN' , DMINX )
      CALL GHPGET ( HHEADX , 'DMAX' , DMAXX )
      CALL GHPGET ( HHEADY , 'DMIN' , DMINY )
      CALL GHPGET ( HHEADY , 'DMAX' , DMAXY )
*
      CALL GHCGET ( HHEADY , 'DSET' , HDSETY )
*
      CALL UZRGET('RSIZET1',RSIZE)
      CALL STFTRF( DMINX, DMINY, VX, VY )
      CALL STFTRF( DMINX+1.0, DMINY, VXP, VYP )
      RTICKX = 1.0 * ABS( RSIZE )/ SQRT( (VXP-VX)**2 + (VYP-VY)**2 )
      CALL STFTRF( DMINX, DMINY+1.0, VXP, VYP )
      RTICKY = 1.0 * ABS( RSIZE )/ SQRT( (VXP-VX)**2 + (VYP-VY)**2 )
*
      IF ( HDSETY(1:1) .EQ. 'C' )THEN
         DO 100 I = 1, N
            X(I) = DMINX
            Y(I) = ( DMAXY - DMINY ) / REAL(N-1) * (I-1)
 100     CONTINUE 
         CALL SGPLZU( N, X, Y, 1, 3 )
*     
         DO 110 I = 1, N
            X(I) = DMAXX
            Y(I) = ( DMAXY - DMINY ) / REAL(N-1) * (I-1)
 110     CONTINUE 
         CALL SGPLZU( N, X, Y, 1, 3 )
*
         DO 120 I=1, IYEND-IYSTR+1
            CALL SZLNZU(DMAXX,AXISY(I),DMAXX-RTICKX, AXISY(I) )
            CALL SZLNZU(DMINX,AXISY(I),DMINX+RTICKX, AXISY(I) )
 120     CONTINUE 
*
         DO 130 I=1, IXEND-IXSTR+1
            CALL SZLNZU(AXISX(I),DMINY,AXISX(I),DMINY+RTICKY)
 130     CONTINUE 
      ELSE
         X(1) = DMINX
         Y(1) = DMINY
*
         X(2) = DMINX
         Y(2) = DMAXY
*
         X(3) = DMAXX
         Y(3) = DMAXY
*
         X(4) = DMAXX
         Y(4) = DMINY
*
         X(5) = X(1)
         Y(5) = Y(1)
*
         CALL SGPLZU( N, X, Y, 1, 3 )

         DO 140 I=1, IYEND-IYSTR+1
            CALL SZLNZU(DMAXX,AXISY(I),DMAXX-RTICKX , AXISY(I) )
            CALL SZLNZU(DMINX,AXISY(I),DMINX+RTICKX , AXISY(I) )
 140     CONTINUE 
*
         RTICK = (DMAXY - DMINY) / (IYEND-IYSTR+1)
         DO 150 I=1, IXEND-IXSTR+1
            CALL SZLNZU(AXISX(I),DMAXY,AXISX(I),DMAXY-RTICKY)
            CALL SZLNZU(AXISX(I),DMINY,AXISX(I),DMINY+RTICKY)
 150     CONTINUE 
      ENDIF
*     
      RETURN
      END

*"表題 トーンスケール  GTOOL3(GGTONS)
*
*"履歴 90/10/01 沼口  敦
*"     92/07/08 沼口  敦
*"     95/05/26 竹広真一 for dcl-5.z.7
*"     96/01/10 竹広真一 for dcl-5.0
*"     97/12/01 竹広真一 SET -> STX
*
*********************************************************************
*"         << トーンスケール >>
*********************************************************************
      SUBROUTINE GGTONS
     I         ( HHEAD )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
*
      PARAMETER ( NHC=10, NTONL=10, NTONS=100 )
      CHARACTER  HL  (NTONL)*(NHC)
      REAL       UX2 (NTONL)
      REAL       UX1 (NTONS)
      REAL       UPX ( 4 )
      REAL       UPY ( 4 )
      CHARACTER  CSGI                    !" FUNCTION
*                                                 !" 正規化変換記憶用
      INTEGER    ITR                              !" 変換番号
      REAL       VXMIN , VXMAX , VYMIN , VYMAX    !" ビューポート
      REAL       UXMIN , UXMAX , UYMIN , UYMAX    !" 
      REAL       RADI  , VXOFF , VYOFF
      REAL       ALON  , ALAT  , ROT 
      REAL       ROFFXB                           !" 軸からのラベルの距離
*
*"         < 1. 正規化変換セーブ >
*
      CALL SGQTRN ( ITR )
      CALL SGQVPT ( VXMIN , VXMAX , VYMIN , VYMAX )
*
      IF ( ( 1. LE. ITR ) .AND. ( ITR .LE. 4 ) ) THEN
         CALL SGQWND ( UXMIN , UXMAX , UYMIN , UYMAX )
      ELSEIF ( ( 5. LE. ITR ) .AND. ( ITR .LE. 6 ) ) THEN
         CALL SGQSIM ( RADI , VXOFF , VYOFF )
      ELSEIF ( ( 10. LE. ITR ) .AND. ( ITR .LE. 33 ) ) THEN
         CALL SGQMPL ( ALON , ALAT , ROT )
      ENDIF
*
      CALL UZPGET ( 'ROFFXB', ROFFXB )
*
*"         < 2. トーンスケール用正規化変換設定 >
*
      CALL UEQNTL ( NTON )                            !" トーンレベル数
*
      CALL GGPGET ( 'TXSLOC', VXLOC )                 !" トーンスケールの位置(x)
      CALL GGPGET ( 'TYSLOC', VYLOC )                 !" トーンスケールの位置(y)
      CALL GGPGET ( 'TXSWDH', VXWDH )                 !" トーンスケールの幅(x)
      CALL GGPGET ( 'TYSWDH', VYWDH )                 !" トーンスケールの幅(y)
      CALL GGPGET ( 'TLNUM' , ITONL )                 !" トーンラベルの数
      IF ( ITONL .GT. NTONL ) THEN
         CALL MSGDMP( 'W', 'GGTONS', 'TONE LABEL NUMBER IS REDUCED.' )
         ITONL = NTONL
      ENDIF
      ITONL = MAX( ITONL, 1 )
*
      CALL SGSVPT ( VXLOC , VXLOC+VXWDH ,
     &              VYLOC , VYLOC+VYWDH   )
      CALL SGSWND ( 1.    , REAL(NTON+1), 0.    , 1.  )
      CALL SGSTRN ( 1 )
      CALL SGSTRF
*
      CALL UZPSTX ( 'ROFFXB', 0 )                     !" 座標軸からのラベルの距離
*
*"         < 3. スケール描画 >
*
      UPY ( 1 ) = 0.
      UPY ( 2 ) = 1.
      UPY ( 3 ) = 1.
      UPY ( 4 ) = 0.
      DO 3100 IT = 1, NTON
         UPX ( 1 ) = REAL( IT )
         UPX ( 2 ) = REAL( IT )
         UPX ( 3 ) = REAL( IT+1 )
         UPX ( 4 ) = REAL( IT+1 )
         CALL UEQTLV ( TLEV1, TLEV2, IPAT, IT )       !" トーンレベルの属性
         CALL SGTNZU ( 4, UPX, UPY,  IPAT )           !" 箱の塗りつぶし
 3100 CONTINUE
*
*"         < 4. スケール目盛 >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
      CALL GGPGET ( 'SREMK'  , SREMK )                !" 注記文字高さ
      CALL UZPSTX ( 'RSIZEL1', SREMK )                !" ラベル文字高さ設定
      CALL UZPSTX ( 'INNER'  , 1     )                !" 内向きに目盛を打つ
*
      IF ( (NTON+1) .GT. NTONS ) THEN
         CALL MSGDMP ( 'W', 'GGTONS', ' TOO MANY TONE LEVEL FOR SCALE' )
      ENDIF
      DO 4100 IT = 1, MIN( NTON+1, NTONS )
         UX1 ( IT ) = REAL ( IT )
 4100 CONTINUE
*
      UX2 (1) = 1.
      CALL UEQTLV ( TLEV1, TLEV2, IPAT, 1 )
      IF ( TLEV1 .NE. VMISS ) THEN
         CALL CHVAL  ( 'D', TLEV1, HL(1) )
      ELSE
         HL(1) = '-'//CSGI(189)                            !" -∞
      ENDIF
*
      IL = 1
      ITINT = NTON/ITONL + 1
      DO 4200 IT = ITINT+1, NTON-ITINT+1, ITINT
         IL = IL + 1
         UX2 ( IL ) = REAL( IT )
         CALL UEQTLV ( TLEV1, TLEV2, IPAT, IT )
         CALL CHVAL  ( 'D', TLEV1, HL(IL) )
 4200 CONTINUE
*
      IL = IL + 1
      UX2 ( IL ) = REAL( NTON+1 )
      CALL UEQTLV ( TLEV1, TLEV2, IPAT, NTON )
      IF ( TLEV2 .NE. VMISS ) THEN
         CALL CHVAL  ( 'D', TLEV2, HL(IL) )
      ELSE
         HL(IL) = CSGI(189)                                !" ∞
      ENDIF
*
      CALL UXAXLB( 'B', UX1, NTON+1, UX2, HL, NHC, IL )    !" 座標軸を描く
*
*"         < 5. 正規化変換を戻す >
*
      CALL SGSVPT ( VXMIN , VXMAX , VYMIN , VYMAX )
*
      IF ( ( 1. LE. ITR ) .AND. ( ITR .LE. 4 ) ) THEN
         CALL SGSWND ( UXMIN , UXMAX , UYMIN , UYMAX )
      ELSEIF ( ( 5. LE. ITR ) .AND. ( ITR .LE. 6 ) ) THEN
         CALL SGSSIM ( RADI , VXOFF , VYOFF )
      ELSEIF ( ( 10. LE. ITR ) .AND. ( ITR .LE. 33 ) ) THEN
         CALL SGSMPL ( ALON , ALAT , ROT )
      ENDIF
*
      CALL SGSTRN ( ITR )
      CALL SGSTRF
*
      CALL UZPSTX ( 'ROFFXB', ROFFXB )
*
      RETURN
      END

* PACKAGE GTCON   !" スカラー値セット
*********************************************************************
      PROGRAM GTCON
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE  / '$GTTMPDIR/gtool.out' /
      INTEGER    IFILE
      DATA       IFILE  / 50 /
      DATA       JFILE  / 60 /
*
      REAL       VAL
      DATA       VAL    / 1.0 /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET /4*' '/
*
      DATA       EDIT, ETTL /'CON','<gtcon>'/
*
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ VAL , OUT,  APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
      CALL GFOOPN ( JFILE,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
 1100 CONTINUE
*
         CALL   GFREAD
     O        ( HHEAD, GDATA, IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD .EQ. 0 ) THEN
*
           CALL GMFCON
     I        ( HHEAD , GDATA, VAL ,
     I          EDIT  , ETTL         )
*
           IF ( ITEM .NE. ' ' ) THEN
              CALL GHCSET( HHEAD, 'ITEM', ITEM )
           ENDIF
           IF ( UNIT .NE. ' ' ) THEN
              CALL GHCSET( HHEAD, 'UNIT', UNIT )
           ENDIF
           IF ( TITLE .NE. ' ' ) THEN
              CALL GHCSTS( HHEAD, 'TITL', TITLE )
           ENDIF
           IF ( DSET .NE. ' ' ) THEN
              CALL GHCSET( HHEAD, 'DSET', DSET )
           ENDIF
*
           IF ( GRESET ) THEN
              CALL GHRSGP( HHEAD )
           ENDIF
*
           CALL  GFWRIT
     I         ( HHEAD , GDATA ,
     I           JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END

* PACKAGE GTSKELTON   !" gtcreate ¤Īskelton
************************************************************************
      PROGRAM GTSKLT
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
*
      CHARACTER  HHEAD(NDC)*(NCC)
      CHARACTER  HHFLD*(NCC)
      CHARACTER  HDATE*(NCC)
      CHARACTER  HSIGN*(NCC)
      CHARACTER  HTITL*(NCC)
*
      CHARACTER  HFILE( 1 )        *(NFILN)
      DATA       HFILE / ' ' /
      DATA       IFILE / 50 /
      CHARACTER  HNUL *3
      PARAMETER  ( RUNDEF=-999., IUNDEF=-999, HNUL='NUL')
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL / 6*HNUL /
      REAL       DIVS , DIVL
      REAL       DMIN , DMAX
      REAL       DMISS, ROPTN
      DATA       DIVS , DIVL, DMIN, DMAX, DMISS, ROPTN / 6*RUNDEF /
      INTEGER    TIME
      INTEGER    TDUR
      DATA       TIME, TDUR  / 2*IUNDEF /
      CHARACTER  UTIM   *(NCC)
      CHARACTER  DATE   *(NCC)
      DATA       UTIM, DATE  / 2*HNUL /
      INTEGER    FNUM
      INTEGER    DNUM
      DATA       FNUM, DNUM  / 2*IUNDEF /
      CHARACTER  AITM1  *(NCC)
      CHARACTER  AITM2  *(NCC)
      CHARACTER  AITM3  *(NCC)
      DATA       AITM1, AITM2, AITM3 / 3*HNUL /
      INTEGER    ASTR1  
      INTEGER    ASTR2  
      INTEGER    ASTR3
      DATA       ASTR1, ASTR2, ASTR3 / 3*IUNDEF /
      INTEGER    AEND1  
      INTEGER    AEND2  
      INTEGER    AEND3
      DATA       AEND1, AEND2, AEND3 / 3*IUNDEF /
      INTEGER    STYP
      DATA       STYP  / IUNDEF /
      INTEGER    IOPTN 
      DATA       IOPTN / IUNDEF /
      CHARACTER  COPTN  *(NCC)
      DATA       COPTN / HNUL  /
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ ITEM, UNIT, TITLE, DSET, EDIT, ETTL,
     &                   DIVS, DIVL, DMIN, DMAX, DMISS, STYP,
     &                   TIME, TDUR, UTIM, DATE, FNUM, DNUM,
     &                   AITM1, AITM2, AITM3,
     &                   ASTR1, ASTR2, ASTR3,
     &                   AEND1, AEND2, AEND3,
     &                   ROPTN, IOPTN, COPTN, GRESET, HFILE, HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
*
      CALL GHPCLR ( HHEAD )
      CALL GTPGET ( 'MISS', VMISS )
      CALL GHPSET ( HHEAD, 'FNUM', 1     )
      CALL GHPSET ( HHEAD, 'DNUM', 1     )
      CALL GHCSET ( HHEAD, 'UTIM', 'DAY' )
      CALL GHPSET ( HHEAD, 'TDUR', 1     )
      CALL GHPSET ( HHEAD, 'ASTR1', 1    )      
      CALL GHPSET ( HHEAD, 'AEND1', 1    )      
      CALL GHPSET ( HHEAD, 'ASTR2', 1    )      
      CALL GHPSET ( HHEAD, 'AEND2', 1    )      
      CALL GHPSET ( HHEAD, 'ASTR3', 1    )      
      CALL GHPSET ( HHEAD, 'AEND3', 1    )      
      CALL GHPSET ( HHEAD, 'MISS', VMISS )
      CALL GHRSGP ( HHEAD  )
      CALL GHCSET ( HHEAD, 'DFMT', 'UR4' )
      CALL GUQNOW ( HDATE )
      CALL GTCGET ( 'MYSIGN', HSIGN )
      CALL GHCSET ( HHEAD , 'CDATE' , HDATE )
      CALL GHCSET ( HHEAD , 'CSIGN' , HSIGN )
*
      IF ( HFILE(1) .NE. ' ' ) THEN
         IF ( HFILE(1) .EQ. '-' ) THEN
            IFILE = 5
         ELSE
            OPEN ( IFILE, FILE=HFILE(1), 
     &           ACCESS='SEQUENTIAL',FORM='FORMATTED' )
         ENDIF
*
         CALL    RDTXT
     I         ( IFILE ,
     M           HHEAD  )
      ENDIF
*
      IF ( ITEM .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'ITEM', ITEM )
      ENDIF
      IF ( UNIT .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'UNIT', UNIT )
      ENDIF
      IF ( TITLE .NE. HNUL ) THEN
         CALL GHCSTS( HHEAD, 'TITL', TITLE )
      ENDIF
      IF ( DSET .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'DSET', DSET )
      ENDIF
      IF (  ( EDIT .NE. ' ' ).AND.( EDIT .NE. HNUL )  ) THEN
         CALL GHEADD ( HHEAD, EDIT, ETTL )
      ENDIF
      IF ( DIVS .NE. RUNDEF ) THEN
         CALL GHPSET( HHEAD, 'DIVS', DIVS )
      ENDIF
      IF ( DIVL .NE. RUNDEF ) THEN
         CALL GHPSET( HHEAD, 'DIVL', DIVL )
      ENDIF
      IF ( DMIN .NE. RUNDEF ) THEN
         CALL GHPSET( HHEAD, 'DMIN', DMIN )
      ENDIF
      IF ( DMAX .NE. RUNDEF ) THEN
         CALL GHPSET( HHEAD, 'DMAX', DMAX )
      ENDIF
      IF ( DMISS .NE. RUNDEF ) THEN
         CALL GHPSET( HHEAD, 'MISS', DMISS )
      ENDIF
      IF ( TIME  .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'TIME', TIME )
      ENDIF
      IF ( TDUR  .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'TDUR', TDUR )
      ENDIF
      IF ( UTIM  .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'UTIM', UTIM )
      ENDIF
      IF ( DATE  .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'DATE', DATE )
      ENDIF
      IF ( FNUM .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'FNUM', FNUM )
      ENDIF
      IF ( DNUM .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'DNUM', DNUM )
      ENDIF
      IF ( AITM1 .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'AITM1', AITM1 )
      ENDIF
      IF ( AITM2 .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'AITM2', AITM2 )
      ENDIF
      IF ( AITM3 .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'AITM3', AITM3 )
      ENDIF
      IF ( ASTR1 .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'ASTR1', ASTR1 )
      ENDIF
      IF ( ASTR2 .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'ASTR2', ASTR2 )
      ENDIF
      IF ( ASTR3 .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'ASTR3', ASTR3 )
      ENDIF
      IF ( AEND1 .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'AEND1', AEND1 )
      ENDIF
      IF ( AEND2 .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'AEND2', AEND2 )
      ENDIF
      IF ( AEND3 .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'AEND3', AEND3 )
      ENDIF
      IF ( ROPTN .NE. RUNDEF ) THEN
         CALL GHPSET( HHEAD, 'ROPTN', ROPTN )
      ENDIF
      IF ( STYP .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'STYP', STYP )
      ENDIF
      IF ( IOPTN .NE. IUNDEF ) THEN
         CALL GHPSET( HHEAD, 'IOPTN', IOPTN )
      ENDIF
      IF ( COPTN .NE. HNUL ) THEN
         CALL GHCSET( HHEAD, 'COPTN', COPTN )
      ENDIF
*
      DO 1200 IP = 1, NDC-1
         CALL GHNINQ( IP, HHFLD )
         IF ( HHFLD.EQ.'TITL1' ) THEN
            HTITL = HHEAD(IP)
         ELSE IF ( HHFLD.EQ.'TITL2' ) THEN
            HHFLD = 'TITLE'
            WRITE ( 6,1620 )  HHFLD, HTITL//HHEAD(IP)
         ELSE
            IF ( HHEAD(IP) .NE. ' ' ) THEN
               WRITE ( 6,1610 )  HHFLD, HHEAD(IP)
            ELSE
               WRITE ( 6,1600 )  HHFLD
            ENDIF
         ENDIF
 1600    FORMAT( ' ', A16, ': ' )
 1610    FORMAT( ' ', A16, ': ', A16 )
 1620    FORMAT( ' ', A16, ': ', A32 )
 1200 CONTINUE
*
      STOP
      END
***********************************************************************
      SUBROUTINE RDTXT
     I         ( IFILE ,
     M           HHEAD  )
*
      CHARACTER  HHEAD ( * )*(*)
*
      
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      PARAMETER (NBUF=255)
      CHARACTER  HBUF*(NBUF), HXX*(NBUF)
      CHARACTER  HP*(NCC), HX*(NCC)
      CHARACTER  HFMT*(NCC)
      LOGICAL    LCHRN
*
  100 CONTINUE 
      READ ( IFILE,'(A)',IOSTAT=IEOS ) HBUF
      IF ( IEOS .NE. 0 ) THEN
         RETURN
      ENDIF
      IF ( HBUF(1:1) .EQ. '#' ) THEN
         GOTO 100
      ENDIF
*
      IDX = 0
*
 1100 CONTINUE
*
         IL   = LENB(HBUF)
         LENH = LEN(HBUF)
         IF ( .NOT.LCHRN(HBUF(IL+1:IL+1)) ) THEN
*
            IC = INDEX(HBUF,':')
            IF ( IC.GT.IL .AND. IC.LT.LENH ) THEN
               HP  = HBUF(IL+1:IC-1)
               ILX = LENB(HBUF(IC+1:LENH))+IC
               HXX = HBUF(ILX+1:LENH)
               HX  = HXX
               IF ( HP .EQ. 'TITLE' ) THEN
                  CALL GHCSTS(HHEAD,'TITL',HXX)
               ELSE IF ( HP .NE. 'SIZE' ) THEN
                  CALL GHPINQ(HP,HFMT)
                  IF ( HFMT .NE. '(A)' ) THEN
                     CALL CRADJ(HX)
                  ENDIF
                  CALL GHCSET(HHEAD,HP,HX)
               ENDIF
            ENDIF
*
 1200       CONTINUE 
               READ ( IFILE,'(A)',END=9000 ) HBUF
            IF ( HBUF(1:1) .EQ. '#' ) THEN
               GOTO 1200
            ENDIF
*
      GOTO 1100
         ENDIF
*
 9000 CONTINUE
      RETURN
      END
********************************************************************
      LOGICAL FUNCTION   LCHRN(C)
      CHARACTER  C
      LOGICAL    LCHRD
*
      LCHRN = LCHRD(C) .OR. (C.EQ.'-') .OR. (C.EQ.'.')
*
      RETURN
      END

*"表題 ファイル入出力時間設定付 GTOOL3(GXRDTS)
*
*"履歴 90/10/13 沼口  敦
*
*
*********************************************************************
*"         << GTOOL3標準フォーマット入力時間取得 >>
*********************************************************************
      SUBROUTINE GFRDTS
     O         ( HHEAD , GDATA , IEOD  ,
     O           IT    , IDATE , IDNUM , ITDUR ,
     I           HPSEL , HSEL  , ISEL  ,
     I           IFILE , IOMODE                 )
*
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      REAL       GDATA ( * )                 !" データ
      INTEGER    IEOD                        !" データ有：０ 無：１
      INTEGER    IT                          !" 通し時間
      INTEGER    IDATE ( * )                 !" 時刻：年月日時分秒
      INTEGER    IDNUM                       !" データ番号
      INTEGER    ITDUR                       !" 代表時間
      CHARACTER  HPSEL *(*)                  !" 選択する欄
      CHARACTER  HSEL  *(*)                  !" 選択するデータ(文
*    (INTEGER)   ISEL                        !" 選択するデータ(数
      INTEGER    IFILE                       !" 入力ファイル番号
      INTEGER    JFILE                       !" 出力ファイル番号
      INTEGER    IOMODE                      !" 入出力モード
      INTEGER    NOEND                       !" ENDFILE間隔
*
#ifdef SYS_IBMS
      INCLUDE   (GZSIZE)                     !" 文字数
#else
#include        "gzsize.F"                   !" 文字数
#endif
      CHARACTER  HDATE         *(NCC)        !" 日付
*
*"         < 1. 読み込み >
*
      CALL GFRDSL
     O            ( HHEAD , GDATA  , IEOD  ,
     I              HPSEL , HSEL   , ISEL  ,
     I              IFILE , IOMODE          )
*
      IF ( IEOD .NE. 0 ) RETURN
*
*"         < 2. ヘッダーからの取得 >
*
      CALL GHPGET ( HHEAD, 'TIME', IT    )
      CALL GHCGET ( HHEAD, 'DATE', HDATE )
      CALL GHPGET ( HHEAD, 'DNUM', IDNUM )
      CALL GHPGET ( HHEAD, 'TDUR', ITDUR )
*
      CALL GUTUPC
     O            ( IDATE(1), IDATE(2), IDATE(3),
     O              IDATE(4), IDATE(5), IDATE(6),
     I              HDATE                        )
*
      RETURN
*=======================================================================
*"         << GTOOL3標準フォーマット時間設定出力 >>
*=======================================================================
      ENTRY      GFWTTS
     I         ( HHEAD , GDATA ,
     I           IT    , IDATE , IDNUM , ITDUR ,
     I           JFILE , IOMODE, NOEND           )
*
      CALL GUTPAC
     I            ( IDATE(1), IDATE(2), IDATE(3),
     I              IDATE(4), IDATE(5), IDATE(6),
     O              HDATE                        )
*
      CALL GHPSET ( HHEAD , 'TIME' , IT     )
      CALL GHCSET ( HHEAD , 'DATE' , HDATE  )
      CALL GHPSET ( HHEAD , 'DNUM' , IDNUM  )
      CALL GHPSET ( HHEAD , 'TDUR' , ITDUR  )
*
      CALL GFWRIT
     I            ( HHEAD , GDATA  ,
     I              JFILE , IOMODE , NOEND   )
*
      RETURN
      END

*"表題 第１次元と第２次元を交換 GTOOL3(GPEYXZ)
*
*"履歴 90/12/20 沼口  敦
*
*
*********************************************************************
*"         << 第１次元と第２次元を交換 >>
*********************************************************************
      SUBROUTINE GPEYXZ
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS1      *(NCC)      !" 軸名称
      CHARACTER  HAXIS2      *(NCC)      !" 軸名称
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 2. データ詰め替え >
*
      DO 2100 IZ = 1, IZDIM
         DO 2100 IY = 1, IYDIM
            CALL VRSET
     I         ( GDATA ( IXDIM*IYDIM*(IZ-1)+IXDIM*(IY-1)+1  ),
     O           GDATAO( IXDIM*IYDIM*(IZ-1)             +IY ),
     I           IXDIM, 1     , IYDIM                          )
 2100 CONTINUE
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHPSET ( HHEADO, 'ASTR1', IYSTR  )
      CALL GHPSET ( HHEADO, 'AEND1', IYEND  )
      CALL GHPSET ( HHEADO, 'ASTR2', IXSTR  )
      CALL GHPSET ( HHEADO, 'AEND2', IXEND  )
      CALL GHCGET ( HHEADO, 'AITM1', HAXIS1 )
      CALL GHCGET ( HHEADO, 'AITM2', HAXIS2 )
      CALL GHCSET ( HHEADO, 'AITM1', HAXIS2 )
      CALL GHCSET ( HHEADO, 'AITM2', HAXIS1 )
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第１次元と第２次元を交換 >>
*********************************************************************
      SUBROUTINE GMEYXZ
     M         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPEYXZ
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

* PACKAGE  GTTV  !" ²¾²¹ÅÙ
***********************************************************************
      PROGRAM GTTV
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEADQ( NDC )*(NCC)
      REAL       GDATAQ( IJKDIM )
      CHARACTER  HHEADT( NDC )*(NCC)
      REAL       GDATAT( IJKDIM )
*
      DATA       IFILT / 51 /
      DATA       IFILQ / 50 /
      DATA       JFILE / 60 /
*
      CHARACTER  T      *(NFILN)
      DATA       T      / 'T' /
      CHARACTER  Q      *(NFILN)
      DATA       Q      / 'q' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM   / 'TV' /
      DATA       UNIT   / 'K' /
      DATA       TITLE  / 'virtual temperature' /
      DATA       DSET, EDIT, ETTL /3*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /

      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   TVERT
*     
      NAMELIST  /OPTION/ T, Q, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEADT, IJKDIM )
      CALL GTSIZE ( HHEADQ, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( T, OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( Q, OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILET, T     )
      CALL GFROPN ( IFILEQ, Q     )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEADT, GDATAT, IEODT  ,
     I          IFILET , 1               )
         CALL   GFREAD
     O        ( HHEADQ, GDATAQ, IEODQ  ,
     I          IFILEQ, 1               )
*
         IF ( MAX(IEODQ,IEODT) .EQ.0 ) THEN
            CALL GMCAL2
     I         ( TVERT,
     M           HHEADT, GDATAT,
     I           HHEADQ, GDATAQ,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEADT, 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEADT  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEADT, GDATAT,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE TVERT
     I         ( HHEADT, T     ,
     I           HHEADQ, Q     ,
     O           HHEADV, TV    ,
     D           IXDIM , IYDIM , IZDIM ,
     D           IXDIM2, IYDIM2, IZDIM2 )
*
      CHARACTER  HHEADT ( * ) *(*)
      CHARACTER  HHEADQ ( * ) *(*)
      CHARACTER  HHEADV ( * ) *(*)
      REAL       T  ( IXDIM , IYDIM , IZDIM  )
      REAL       Q  ( IXDIM2, IYDIM2, IZDIM2 )
      REAL       TV ( IXDIM , IYDIM , IZDIM  )
*
      DATA       RAIR / 287.04 /
      DATA       RVAP / 461. /
*
      EPSV   = RAIR / RVAP
      EPSVT  = 1.0/EPSV - 1.0
*
      DO 1100 IZ = 1, IZDIM
         DO 1110 IY = 1, IYDIM
            DO 1120 IX = 1, IXDIM
               TV ( IX,IY,IZ ) = T ( IX,IY,IZ )
     &                         * ( 1.+ EPSVT * Q ( IX,IY,IZ ) )
 1120       CONTINUE
 1110    CONTINUE
 1100 CONTINUE
*
      RETURN
      END

* PACKAGE GTHBIN  !" HITAC VBS تر´¹
************************************************************************
      PROGRAM GTHBIN
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
*
*   [INTERNAL WORK] 
      INTEGER    II, IRTN, ISIZE
*
*   [EXTERNAL FUNC] 
      INTEGER    HOPEN, HCLOSE, HGNC, HGNF
*
*   [INTERNAL PARM] 
      CHARACTER  HFILE( 1 )        *(NFILN)
      DATA       HFILE / 'gtool.pln' /
      INTEGER    IFILE
      INTEGER    JFILE
      DATA       JFILE / 50 /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      LOGICAL    HELP
      DATA       HELP / .FALSE. /
*
      NAMELIST  /OPTION/ OUT, APND, HFILE, HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD , IJKDIM )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.plnin' )
*
      IFILE = HOPEN ( HFILE( 1 ) )
      CALL GFOOPN ( JFILE, OUT , APND )
*
      II = 0
 1100 CONTINUE
         II = II + 1
*
         IRTN = HGNC( IFILE,HHEAD,NDC*NCC )
*
         IF ( IRTN .GT. 0 ) THEN
            CALL GUQTSZ ( HHEAD, ISIZE )
            IRTN = HGNF( IFILE, GDATA, ISIZE )
*
            CALL GFWRIT
     I         ( HHEAD , GDATA ,
     I           JFILE , 1     , 0       )
      GOTO 1100            
         ENDIF
*
      IRTN = HCLOSE ( IFILE )
*
      STOP
      END

*"表題 ファイル読み込み GTOOL3(GFREAD)
*
*"履歴 90/08/15 沼口  敦
*"     92/06/18 沼口  敦               倍精度対応
*"     93/08/13 堀之内 武, 保坂 征宏   GFRDSL のバグフィックス
*"     96/09/03 竹広真一               GFREAD の倍精度対応
*"     97/02/04 竹広真一               GFREAD の倍精度対応ヘッダー変更
*"     97/02/14 竹広真一               GFREDZ を単/倍精度に分ける
*"     99/12/02 竹広真一               メッセージ出力番号を DCL より取得
*
**********************************************************************
*"      <<  GTOOL3標準フォーマットデータ読み込み >>
**********************************************************************
      SUBROUTINE GFREAD
     O         ( HHEAD , GDATA , IEOD  ,
     I           IFILE , MODE           )
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       GDATA ( * )             !" データ
      INTEGER    IEOD                    !" データ存在フラグ
      INTEGER    IFILE                   !" 装置番号
      INTEGER    MODE                    !" モード(1なら表示ON)
*
      CHARACTER  HDFMTI  *(NCC)              !" データフォーマット
*
      REAL * 8   DDATA ( IJKDIM )
      REAL * 4   SDATA ( IJKDIM )
      EQUIVALENCE (DDATA,SDATA)
*
      INTEGER    IUNIT
*
      CALL GLIGET( 'MSGUNIT', IUNIT )
*
      CALL       GFRDSL
     O         ( HHEAD , DDATA , IEOD  ,
     I           '###' , '###' , -1    ,
     I           IFILE , MODE           )
*
      IF ( IEOD .EQ. 0 ) THEN
*
*" << CNVDBL : 精度変換 >>
*
         CALL GHCGET ( HHEAD, 'DFMT',  HDFMTI )
         CALL GUQTSZ ( HHEAD, IJKSIZ )
*
         IF ( HDFMTI .EQ. 'UR8' ) THEN
            DO 1110 IJK = 1, IJKSIZ
                  GDATA( IJK ) = DDATA( IJK )
 1110       CONTINUE
            CALL MSGDMP('W','GFREAD','PRECISION MODIFIED INTO UR4')
            CALL GHCSET( HHEAD, 'DFMT', 'UR4' )
         ELSE
            DO 1120 IJK = 1, IJKSIZ
                  GDATA( IJK ) = SDATA( IJK )
*                            equiv DDATA
 1120       CONTINUE
         ENDIF
      ENDIF

      RETURN
      END
**********************************************************************
*"      <<  GTOOL3標準フォーマットデータ読み込み: 限定つき
**********************************************************************
      SUBROUTINE GFRDSL
     O         ( HHEAD , GDATA , IEOD  ,
     I           HPSEL , HSEL  , ISEL  ,
     I           IFILE , MODE           )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       GDATA ( * )             !" データ
      INTEGER    IEOD                    !" データ存在フラグ
      CHARACTER  HPSEL *(*)              !" 選択する欄
      CHARACTER  HSEL  *(*)              !" 選択するデータ(文字)
*"   (INTEGER)   ISEL                    ! 選択するデータ(数)
      INTEGER    IFILE                   !" ファイル番号
      INTEGER    MODE                    !" モード(1なら表示ON)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HITEM *(NCC)
      INTEGER    ITIME
      CHARACTER  HX    *(NCC)
      CHARACTER  HFMT  *(NCC)
      CHARACTER  HDFMT *(NCC)
*"   (INTEGER)   IX                       !" 堀之内 93/08/13   
      INTEGER    ISTR  , IEND  , JSTR  , JEND  , KSTR  , KEND
*
      INTEGER    IUNIT
      REAL       VMISS                    !" 欠損値
      INTEGER    ISDEF
      DATA       ISDEF / -1 /
*
*"         < 1. ファイルの番号 FTXXF0YY の配列 >
*
      INTEGER   NFIN( 99 )
      LOGICAL   OFIRST
      DATA      OFIRST / .TRUE. /
      SAVE      NFIN, OFIRST, IUNIT
*
      IF (OFIRST) THEN
         OFIRST=.FALSE.
         DO 1100 JF = 1, 99
            NFIN (JF) = 1
 1100    CONTINUE
         CALL GLIGET( 'MSGUNIT', IUNIT )
      ENDIF
*
      IEOD  = 0
      IEOF  = 0
      IOS   = 0
*
      IF (  ( IFILE.LT.1 ).OR.( IFILE.GT.99 )  ) THEN
        IEOD = 1
        RETURN
      ENDIF
*
 2100 CONTINUE
*"                                       <------< LOOP <-------<
*"         < 2. ヘッダーを読む >
*
         READ ( IFILE,IOSTAT=IOS ) ( HHEAD( II ), II=1, NDC-1 )
*
         IF ( IOS.EQ.0 ) THEN
*
            IEOF  = 0
*
            IF ( HPSEL .NE. '###' ) THEN
               CALL GHPINQ ( HPSEL , HFMT  )
               IF ( HFMT(2:2) .NE. 'A' ) THEN
                  CALL GHPGET ( HHEAD , HPSEL , IX    )
               ELSE
                  IX = ISDEF              !" 堀之内 93/08/13   
               ENDIF
               CALL GHCGET ( HHEAD , HPSEL , HX    )
            ELSE
               IX = ISDEF                 !" 堀之内 93/08/13   
               HX = '###'
            ENDIF
*
            IF (    ( HSEL .EQ. HX   )
     &          .OR.( (HFMT(2:2).NE.'A').AND.( ISEL .EQ. IX ) )
     &          .OR.( (HSEL .EQ. '###').AND.(ISEL .EQ. ISDEF) )
     &          .OR.( HPSEL .EQ. '###' )                         ) THEN
*
*"             < 3. 大きさ >
*
               CALL GUQSIZ
     I            ( HHEAD ,
     O              ISTR  , IEND  , IDIM ,
     O              JSTR  , JEND  , JDIM ,
     O              KSTR  , KEND  , KDIM   )
*
*"             < 4. データ読み込み >
*
               IF      ( MODE .GE. 1 )   THEN
                  CALL GHCGET ( HHEAD, 'ITEM', HITEM )
                  CALL GHPGET ( HHEAD, 'TIME', ITIME )
                  WRITE (IUNIT,*) '** READ ',HITEM, ' T = ',ITIME
               ENDIF
*
               CALL GHPGET ( HHEAD, 'MISS'  , VMISS )
               CALL RSET0  ( GDATA, IDIM*JDIM*KDIM, 1, VMISS )
*
               CALL GHCGET ( HHEAD, 'DFMT', HDFMT )
               IF ( HDFMT .EQ. 'UR8' ) THEN
                  CALL GUSZCK ( HHEAD, IDIM*JDIM*KDIM*2  )
                  CALL GFRDZD             !" 倍精度読み込み
     O            ( GDATA , IEOD  ,
     I              IFILE , IDIM*JDIM*KDIM )
               ELSE
                  CALL GUSZCK ( HHEAD, IDIM*JDIM*KDIM  )
                  CALL GFRDZR             !" 単精度読み込み
     O            ( GDATA , IEOD  ,
     I              IFILE , IDIM*JDIM*KDIM )
               ENDIF
*
            ELSE
*
*"             < 5. 読みとばし >
*
               IF      ( MODE .EQ. 1 )   THEN
                  CALL GHCGET ( HHEAD, 'ITEM', HITEM )
                  CALL GHPGET ( HHEAD, 'TIME', ITIME )
                  WRITE (IUNIT,*) '** SKIP ',HITEM, ' T = ',ITIME
               ENDIF
*
               READ ( IFILE )
               GOTO 2100
*"                                >------> 次のデータ >------>
            ENDIF
*
*"         < 6. ファイルの終りの処理 >
*
         ELSE IF ( IEOF .NE. 0 ) THEN
*
            IEOD  = 1
            RETURN
*"                                /////// end of data //////
         ELSE
*
            IEOF = 1
            WRITE (IUNIT,6100) IFILE, NFIN( IFILE )
 6100       FORMAT ('#### END OF INPUT FILE FT', I2.2, 'F', I3.3 )
*
            NFIN( IFILE ) = NFIN( IFILE ) + 1
            GOTO 2100
*"                                >------> 次のファイル >------>
         ENDIF
*
      RETURN
*=====================================================================
*"      <<  GTOOL3標準フォーマットヘッダー読み込み >>
*=====================================================================
      ENTRY      GFRDHD
     O         ( HHEAD , IEOD  ,
     I           IFILE , MODE   )
*
*"         < 7. ファイルの番号 FTXXF0YY の配列 >
*
      IF (OFIRST) THEN
         OFIRST=.FALSE.
         DO 7100 JF = 1, 99
            NFIN (JF) = 1
 7100    CONTINUE
         CALL GLIGET( 'MSGUNIT', IUNIT )
      ENDIF
*
      IEOD  = 0
      IEOF  = 0
      IOS   = 0
*
      IF (  ( IFILE.LT.1 ).OR.( IFILE.GT.99 )  ) THEN
        IEOD = 1
        RETURN
      ENDIF
*
 8100 CONTINUE
*"                                       <------< LOOP <-------<
*"         < 8. ヘッダーを読む >
*
         READ ( IFILE,IOSTAT=IOS ) ( HHEAD( II ), II=1, NDC-1 )
*
         IF ( IOS.EQ.0 ) THEN
*
            IEOF  = 0
*
               IF      ( MODE .EQ. 1 )   THEN
                  CALL GHCGET ( HHEAD, 'ITEM', HITEM )
                  CALL GHPGET ( HHEAD, 'TIME', ITIME )
                  WRITE (IUNIT,*) '******* ',HITEM, ' T = ',ITIME
               ENDIF
*
               READ ( IFILE )
*
         ELSE IF ( IEOF .NE. 0 ) THEN
*
            IEOD  = 1
            RETURN
*"                                /////// end of data //////
         ELSE
*
            IEOF = 1
            WRITE (IUNIT,9600) IFILE, NFIN( IFILE )
 9600       FORMAT ('#### END OF INPUT FILE FT', I2.2, 'F', I3.3 )
*
            NFIN( IFILE ) = NFIN( IFILE ) + 1
            GOTO 8100
*"                                >------> 次のファイル >------>
         ENDIF
*
      RETURN
      END
************************************************************************
*"         << データ読み込み >>
************************************************************************
      SUBROUTINE GFRDZR                        !" 単精度データ
     O         ( GDATA , IEOD  ,
     I           IFILE , IJKDIM )
*
      REAL       GDATA ( IJKDIM )              !" データ
      INTEGER    IFILE                         !" ファイル番号
*
      READ  ( IFILE, END=9000 ) GDATA
      RETURN
*
 9000 CONTINUE
      CALL MSGDMP( 'W', 'GFRDZR', 'UNEXPECTED EOF' )
      IEOD = 1
*
      END
************************************************************************
      SUBROUTINE GFRDZD                        !" 倍精度データ
     O         ( GDATA , IEOD  ,
     I           IFILE , IJKDIM )
*
      REAL*8     GDATA ( IJKDIM )              !" データ
      INTEGER    IFILE                         !" ファイル番号
*
      READ  ( IFILE, END=9000 ) GDATA
      RETURN
*
 9000 CONTINUE
      CALL MSGDMP( 'W', 'GFRDZD', 'UNEXPECTED EOF' )
      IEOD = 1
*
      END

*"表題 第1次元をサイクリックに GTOOL3(GPXCYC)
*
*"履歴 90/08/17 沼口  敦
*
*
*********************************************************************
*"         << 第1次元をサイクリックに >>
*********************************************************************
      SUBROUTINE GPXCYC
     I         ( HHEAD , GDATA ,
     O           HHEADO, GDATAO   )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS       *(NCC)      !" 軸名称
      LOGICAL    OCYCL                   !" サイクリックか？
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, (IXDIM+1)*IYDIM*IZDIM )
      CALL GHCOPY ( HHEAD, HHEADO )
*
      CALL GHCGET ( HHEAD, 'AITM1', HAXIS  )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
      IF ( OCYCL .AND. IXDIM .EQ. IADIM ) THEN
*
         II = 0
         IO = 0
         DO 1100 K = IZSTR, IZEND
            DO 1110 J = IYSTR, IYEND
*
               II0 = II + 1
               DO 1120 I = IXSTR, IXEND
                  II = II + 1
                  IO = IO + 1
                  GDATAO ( IO ) = GDATA ( II )
 1120          CONTINUE
*
               IO = IO + 1
               GDATAO ( IO ) = GDATA ( II0 )
*
 1110       CONTINUE
 1100    CONTINUE
*
         CALL GHPSET ( HHEADO, 'AEND1', IXEND+1 )
*
      ELSE
         DO 2100 I = 1, IXDIM*IYDIM*IZDIM
            GDATAO( I ) = GDATA( I )
 2100    CONTINUE
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第1次元をサイクリックに >>
*********************************************************************
      SUBROUTINE GMXCYC
     M         ( HHEAD , GDATA  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPXCYC
     I         ( HHEAD , GDATA ,
     O           HHEADW, GDATAW   )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 レイアウト GTOOL3(GGLAY3)
*
*"履歴 90/08/21 沼口  敦
*"履歴 95/05/29 竹広真一 for dcl-5.0
*"     97/12/01 竹広真一 SET -> STX
*
*********************************************************************
*"         << レイアウト, 題名表示 >>
*********************************************************************
      SUBROUTINE GGLAY3
     I         ( HHEAD )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HTITL   *(NCC*2)
      CHARACTER  HDSET   *(NCC)
      CHARACTER  HUNIT   *(NCC)
      CHARACTER  HITEM   *(NCC)
      CHARACTER  HUTIM   *4
      CHARACTER  HTIME   *(NCC)
      CHARACTER  HDATE   *(NCC)
      CHARACTER  HDATEX  *(NCC)
      CHARACTER  HDATIM  *(NCC*3)
      INTEGER    NHE  ( NED )
      CHARACTER  HFNUM   *(NCC)
      CHARACTER  HDNUM   *(NCC)
      CHARACTER  HAITM   *(NCC)
      CHARACTER  HS      *(NCC)
      CHARACTER  HE      *(NCC)
      CHARACTER  HRAN    *(NCC)
      CHARACTER  HEDS    *(100)
      CHARACTER  HP      *8
      DATA       NDESC  / 24 /
      DATA       VRATIO / 0.70 /
      DATA       VXMINI  / 0.10 /
      DATA       VXMAXI  / 0.949 /
      DATA       VYMINI  / 0.10 /
      DATA       VYMAXI  / 0.524 /
      DATA       STITL  / 0.015 / 
      DATA       SAXSL  / 0.01 / 
      DATA       SAXST  / 0.01 / 
      DATA       SREMK  / 0.01 / 
      DATA       SCONL  / 0.01 / 
      LOGICAL    LUNIT  / .TRUE. /             !" ユニットベクトル
      DATA       VXULOC  /0.06/                !"  〃 位置：ｘ
      DATA       VYULOC  /0.02/                !"  〃 位置：ｙ
      LOGICAL    LTONS  /.TRUE. /              !" トーンスケール
      DATA       TXSLOC  /0.05/                !"  〃 位置：ｘ
      DATA       TYSLOC  /0.02/                !"  〃 位置：ｙ
      DATA       TXSWDH  /0.25/                !"  〃 幅  ：ｘ
      DATA       TYSWDH  /0.02/                !"  〃 幅  ：ｙ
      INTEGER    TLNUM   /4/                   !"  〃 ラベルの数
      LOGICAL    LLINT   /.TRUE./              !" 線種コメント
      REAL       LTVX1   /0.22/                !"  〃 位置：ｘ(1)
      REAL       LTVX2   /0.55/                !"  〃 位置：ｘ(2)
      REAL       LTWDH   /0.08/                !"  〃 幅
      LOGICAL    OLCNTL
*
*"         < 1. 初期化 >
*
      CALL GRFRM
      CALL GGAXRS
      CALL GGLTRS
*
      CALL GGPSET ( 'VRATIO' , VRATIO )
      CALL GGPSET ( 'VXMIN'  , VXMINI )
      CALL GGPSET ( 'VXMAX'  , VXMAXI )
      CALL GGPSET ( 'VYMIN'  , VYMINI )
      CALL GGPSET ( 'VYMAX'  , VYMAXI )
      CALL GGPSET ( 'STITL'  , STITL  )
      CALL GGPSET ( 'SAXSL'  , SAXSL  )
      CALL GGPSET ( 'SAXST'  , SAXST  )
      CALL GGPSET ( 'SREMK'  , SREMK  )
      CALL GGPSET ( 'SCONL'  , SCONL  )
      CALL GGPSET ( 'LUNIT'  , LUNIT  )
      CALL GGPSET ( 'VXULOC' , VXULOC )
      CALL GGPSET ( 'VYULOC' , VYULOC )
      CALL GGPSET ( 'LTONS'  , LTONS  )
      CALL GGPSET ( 'TXSLOC' , TXSLOC )
      CALL GGPSET ( 'TYSLOC' , TYSLOC )
      CALL GGPSET ( 'TXSWDH' , TXSWDH )
      CALL GGPSET ( 'TYSWDH' , TYSWDH )
      CALL GGPSET ( 'TLNUM'  , TLNUM  )
      CALL GGPSET ( 'LLINT'  , LLINT  )    
      CALL GGPSET ( 'LTVX1'  , LTVX1  )
      CALL GGPSET ( 'LTVX2'  , LTVX2  )
      CALL GGPSET ( 'LTWDH'  , LTWDH  )
*
      CALL UZPGET( 'RSIZET2', RSIZT2 )
      CALL UZPGET( 'ROFFXT' , ROFFXT )
      IF ( ROFFXT .LT. RSIZT2 ) CALL UZPSTX( 'ROFFXT', RSIZT2 )
*
*"         < 2. ビューポート(仮座標)設定 >
*
      CALL SGSVPT ( VXMINI, VXMAXI , VYMINI , VYMAXI )
      CALL SGSWND ( 0.   , 1.    , 0.    , 1.  )
      CALL SGSTRN (1)
      CALL SGSTRF
*
      CALL SGPSTX ( 'IFONT', 2 )
*
      CALL GHCGTS ( HHEAD, 'TITL',  HTITL  )
      CALL GHCGET ( HHEAD, 'DSET',  HDSET  )
      CALL GHCGET ( HHEAD, 'UNIT',  HUNIT  )
*
      CALL GUQTIM ( HHEAD , RT    , HUTIM  )
      IF ( RT .GT. 9999900.0 ) THEN
         CALL CHVAL  ( 'D'      , RT    , HTIME  )
      ELSE
         CALL CHVAL  ( '(F10.1)', RT    , HTIME  )
      ENDIF
      NHT = LENC( HTIME )
*
      CALL GGPGET ( 'STITL'  , STITL )
      CALL UZPSTX ( 'RSIZEC2', STITL )
*
      CALL UZPGET ( 'ROFFXT', ROFF   )
      CALL UXMTTL ( 'T', HUNIT , -1. )
*
      HDATIM = HTIME(1:NHT)//HUTIM
      CALL GHCGET ( HHEAD, 'DATE',  HDATE  )
      IF ( HDATE .NE. ' ' ) THEN
         HDATEX        = ' ' 
         HDATEX(1:2)   = HDATE(3:4)
         HDATEX(3:3)   = '/'
         HDATEX(4:5)   = HDATE(5:6)
         HDATEX(6:6)   = '/'
         HDATEX(7:8)   = HDATE(7:8)
         HDATEX(9:9)   = '-'
         HDATEX(10:11) = HDATE(10:11)
         HDATEX(12:12)   = ':'
         HDATEX(13:14) = HDATE(12:13)
         NHT    = LENC( HDATIM )         
         HDATIM = HDATIM(1:NHT)//'   '//HDATEX
      ENDIF
      CALL UZPSTX ( 'ROFFXT', ROFF   )
      CALL UXMTTL ( 'T', HDATIM,  1. )
*
      CALL UZPGET ( 'ROFFXT', ROFF   )
      CALL UXMTTL ( 'T', HTITL , -1. )
      CALL UZPSTX ( 'ROFFXT', ROFF   )
      CALL SGPGET ( 'LCNTL', OLCNTL  )
      CALL SGPSTX ( 'LCNTL', .FALSE. )
      CALL UXMTTL ( 'T', HDSET ,  1. )
      CALL SGPSTX ( 'LCNTL', OLCNTL  )
*
      CALL UZPSTX ( 'ROFFXT' , 0. )
*
      RETURN
      END

*"表題 第２次元の部分切出し GTOOL3(GPYRDC)
*
*"履歴 90/08/18 沼口  敦
*
*
*********************************************************************
*"         << 第２次元の部分切出し >>
*********************************************************************
      SUBROUTINE GPYRDC
     I         ( HHEAD , GDATA , IYSEL1, IYSEL2,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO                  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IYSEL1                  !" 切り出す第2次元の格子
      INTEGER    IYSEL2                  !" 切り出す第2次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS       *(NCC)
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
      LOGICAL    OCYCL                   !" サイクリックか？
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      IYDIMC = IYSEL2-IYSEL1+1
      CALL GUSZCK ( HHEADO, IXDIM*IYDIMC*IZDIM )
*
      CALL GHCGET( HHEAD, 'AITM2', HAXIS )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
*"         < 2. データ詰め替え >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
*
      DO 2100 IY = IYSEL1, IYSEL2
         IF ( OCYCL ) THEN
            IYI = MOD( IY-IYSTR, IADIM ) + 1
         ELSE
            IYI = IY-IYSTR+1
         ENDIF
*
         IF ( ( 1.LE.IYI ).AND.( IYI.LE.IYDIM ) ) THEN
            DO 2110 IZ = 1, IZDIM
               CALL VRSET
     I            ( GDATA ( IXDIM*IYDIM*(IZ-1) + IXDIM*(IYI-1) +1 ),
     O              GDATAO( IXDIM*IYDIMC*(IZ-1)
     &                      + IXDIM*(IY-IYSEL1)+1 ),
     I              IXDIM , 1     , 1                               )
 2110       CONTINUE
         ELSE
            DO 2120 IZ = 1, IZDIM
               CALL RSET
     O            ( GDATAO( IXDIM*(IY-IYSEL1)+1 ),
     I              IXDIM , 1    , VMISS          )
 2120       CONTINUE
         ENDIF
*
 2100 CONTINUE
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHPSET ( HHEADO, 'ASTR2', IYSEL1 )
      CALL GHPSET ( HHEADO, 'AEND2', IYSEL2 )
*
      IF ( ( IYSTR .EQ. IYSEL1 ).AND.( IYEND .EQ. IYSEL2 ) ) RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAXIS , 'YR'   , '-reduce',
     I                 IYSEL1, IYSEL2 ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第２次元の部分切出し >>
*********************************************************************
      SUBROUTINE GMYRDC
     M         ( HHEAD , GDATA ,
     I           IYSEL1, IYSEL2,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IYSEL1                  !" 切り出す第2次元の格子
      INTEGER    IYSEL2                  !" 切り出す第2次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPYRDC
     I         ( HHEAD , GDATA , IYSEL1, IYSEL2,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW                  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 1つの軸を描き座標設定 GTOOL3(GGAXSZ)
*
*"履歴 90/08/18 沼口  敦
*"     95/06/05 竹広真一 for dcl-5.0
*"     95/11/08 竹広真一 異なる複数軸ファイルに対応
*"     97/12/01 竹広真一 SET -> STX
*
*********************************************************************
*"         << 1つの軸を描き座標設定 >>
*********************************************************************
      SUBROUTINE GGAXSZ
     I         ( HHEAD , AXISZ , HPOS  )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       AXISZ ( * )             !" 格子位置
      CHARACTER  HPOS *(*)               !" セットする軸 ('X' or 'Y')
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HTITL*(NCC)      
      CHARACTER  HTITLZ( 2 )*(NCC)
      CHARACTER  HSIDE *2, HSIDEL *2
      REAL       AZMINZ( 2 )
      REAL       AZMAXZ( 2 )
      LOGICAL    OSETZ ( 2 )
      SAVE       AZMINZ, AZMAXZ, OSETZ, HTITLZ
*
*"         < 1. すでに設定されていれば何もしない >
*
      IF      ( HPOS(1:1) .EQ. 'X' ) THEN
         IIZ = 1
      ELSE IF ( HPOS(1:1) .EQ. 'Y' ) THEN
         IIZ = 2
      ELSE
         CALL MSGDMP('E','GGAXSZ','INVALID AXIS SPECIFIER.' )
      ENDIF
*
      IF  ( OSETZ( IIZ ) ) THEN
         CALL GHCGET ( HHEAD, 'TITL1', HTITL ) !" 設定されている軸と
         CALL CLADJ( HTITL )                   !" 同じかどうか check
         IF( HTITL .NE. HTITLZ(IIZ) )THEN
            CALL MSGDMP('W','GGAXSZ','TITLE OF AXIS IS DIFFERENT' )
         ENDIF
                                             RETURN
      ELSE
            OSETZ( IIZ ) = .TRUE.
      ENDIF
*
*"         < 2. 文字の大きさ等 >
*
      CALL GGPGET ( 'SAXSL'  , SAXSL )
      CALL GGPGET ( 'SAXST'  , SAXST )
      CALL UZPSTX ( 'RSIZEL1', SAXSL )
      CALL UZPSTX ( 'RSIZEC1', SAXST )
*
*"         < 3. ウィンドウ範囲 >
*
      CALL GHPGET ( HHEAD, 'ASTR1', IZSTR )
      CALL GHPGET ( HHEAD, 'AEND1', IZEND )
      CALL GHCGET ( HHEAD, 'TITL1', HTITL )
      HTITLZ(IIZ) = HTITL
      CALL CLADJ( HTITLZ(IIZ) )
*
      CALL GHPGET ( HHEAD , 'MISS' , VMISZ )
      CALL GLPGET ( 'RUNDEF', RUNDEF )
*
      CALL GHPGET ( HHEAD , 'DMIN' , DMINZ )
      CALL GHPGET ( HHEAD , 'DMAX' , DMAXZ )
      CALL GHPGET ( HHEAD , 'DIVS' , DIVSZ )
      CALL GHPGET ( HHEAD , 'DIVL' , DIVLZ )
      IF ( DMINZ .EQ. VMISZ ) DMINZ = RUNDEF
      IF ( DMAXZ .EQ. VMISZ ) DMAXZ = RUNDEF
      IF ( DIVSZ .EQ. VMISZ ) DIVSZ = RUNDEF
      IF ( DIVLZ .EQ. VMISZ ) DIVLZ = RUNDEF
*
*"         < 4. 範囲のセット >
*
      CALL GUSMIS( HHEAD )
*
      IF ( HPOS(1:1) .EQ. 'X' ) THEN
         CALL USSPNT( IZEND-IZSTR+1, AXISZ, RUNDEF)
         CALL USRGET('XDTMIN', DMINQ)
         CALL USRGET('XDTMAX', DMAXQ)
      ELSE
         CALL USSPNT( IZEND-IZSTR+1, RUNDEF, AXISZ )
         CALL USRGET('YDTMIN', DMINQ)
         CALL USRGET('YDTMAX', DMAXQ)
      ENDIF
*
      CALL GHPGET ( HHEAD, 'STYP', ISTYP )
*
      IF ( DIVLZ .NE. RUNDEF ) THEN
         IF      ( DMINZ .NE. RUNDEF .AND.
     &             DMAXZ .NE. RUNDEF       ) THEN
            IF ( DMAXZ-DMINZ .LT. DIVLZ ) THEN
               DIVLZ = DMAXZ-DMINZ
            ENDIF
         ELSE IF ( DMINZ .NE. RUNDEF ) THEN
            IF ( DMAXQ .LT. DMINZ+DIVLZ ) THEN
               DMAXZ = DMINZ + DIVLZ
            ENDIF
         ELSE IF ( DMAXZ .NE. RUNDEF ) THEN
            IF ( DMINQ .GT. DMAXZ-DIVLZ ) THEN
               DMINZ = DMAXZ - DIVLZ
            ENDIF            
         ELSE
            DMINZ =  IGUS( DMINQ/DIVLZ )*DIVLZ
            DMAXZ = -IGUS(-DMAXQ/DIVLZ )*DIVLZ
         ENDIF
      ENDIF

      IF ( HPOS(1:1) .EQ. 'X' ) THEN
         IF ( ISTYP .GT. 0 ) THEN
            CALL USPSTX( 'LXINV', .FALSE. )
         ELSE
            CALL USPSTX( 'LXINV', .TRUE. )
         ENDIF
         CALL SGPSTX( 'UXMIN', DMINZ  )
         CALL SGPSTX( 'UXMAX', DMAXZ  )
         CALL USPSTX( 'DXT' , DIVSZ )
         CALL USPSTX( 'DXL' , DIVLZ )
      ELSE
         IF ( ISTYP .GT. 0 ) THEN
            CALL USPSTX( 'LYINV', .FALSE. )
         ELSE
            CALL USPSTX( 'LYINV', .TRUE. )
         ENDIF
         CALL SGPSTX( 'UYMIN', DMINZ  )
         CALL SGPSTX( 'UYMAX', DMAXZ  )
         CALL USPSTX( 'DYT' , DIVSZ )
         CALL USPSTX( 'DYL' , DIVLZ )
      ENDIF
*
*"         < 5. 座標設定 >
*
      IF ( ABS( ISTYP ) .LE. 2 ) THEN
         CALL SGPGET( 'ITR',ITR )
         IF ( HPOS(1:1) .EQ. 'X' ) THEN
            ITR = MOD(ITR-1,2)+1 + ( ABS( ISTYP )-1 )*2 
         ELSE
            ITR = ((ITR-1)/2) * 2 + ABS( ISTYP ) 
         ENDIF
         CALL SGPSTX( 'ITR',ITR )
      ELSE
         CALL MSGDMP('E','GGAXSZ','INVALID ISTYP.' )
      ENDIF
*
      CALL USPFIT
      CALL GRSTRF
*
*"         < 6. 座標軸を描く >
*
      IF ( HPOS(1:1) .EQ. 'X' ) THEN
         CALL GGAXLZ ( 'X' )

         CALL GGPGET ( 'INNER', INNER )
         CALL UZPSTX ( 'INNER', INNER )
         CALL GGCGET ( 'CXSIDE', HSIDE )
         NCS = LENZ(HSIDE)
         DO 6100 N=1, NCS
            CALL USXAXS(HSIDE(N:N))
 6100    CONTINUE

         CALL GGCGET ( 'CXSIDEL', HSIDEL )
         IF ( INDEX(HSIDEL,HSIDE(1:1)) .GE. 1 ) THEN
            IF (LENZ(HTITL).NE.0) CALL UXSTTL(HSIDE(1:1), HTITL, 0.)
         ENDIF

         CALL UZPSTX ( 'INNER', -INNER )
         CALL GGCGET ( 'CXSIDET', HSIDE )
         NCS = LENZ(HSIDE)
         DO 6110 N=1, NCS
            CALL UXPTMK(HSIDE(N:N),1,AXISZ,IZEND-IZSTR+1 )
 6110    CONTINUE
         CALL UZPSTX ( 'INNER', INNER )
*
      ELSE
         CALL GGAXLZ ( 'Y' )

         CALL GGPGET ( 'INNER', INNER )
         CALL UZPSTX ( 'INNER', INNER )
         CALL GGCGET ( 'CYSIDE', HSIDE )
         NCS = LENZ(HSIDE)
         DO 6200 N=1, NCS
            CALL USYAXS(HSIDE(N:N))
 6200    CONTINUE

         CALL GGCGET ( 'CYSIDEL', HSIDEL )
         IF ( INDEX(HSIDEL,HSIDE(1:1)) .GE. 1 ) THEN
            IF (LENZ(HTITL).NE.0) CALL UYSTTL(HSIDE(1:1), HTITL, 0.)
         ENDIF
*
         CALL UZPSTX ( 'INNER', -INNER )
         CALL GGCGET ( 'CYSIDET', HSIDE )
         NCS = LENZ(HSIDE)
         DO 6210 N=1, NCS
            CALL UYPTMK(HSIDE(N:N),1,AXISZ,IZEND-IZSTR+1 )
 6210    CONTINUE
         CALL UZPSTX ( 'INNER', INNER )
       ENDIF
*
      RETURN
*=====================================================================
*"         << 軸の座標範囲の設定 >>
*=====================================================================
      ENTRY      GGRANG
     I         ( HHEAD , AXISZ , HPOS  )
*
      CALL GHPGET ( HHEAD, 'ASTR1', IZSTR )
      CALL GHPGET ( HHEAD, 'AEND1', IZEND )
      CALL GLPGET ( 'RUNDEF', RUNDEF )
*
      CALL GUSMIS ( HHEAD )
*
      IF ( HPOS(1:1) .EQ. 'X' ) THEN
         CALL USSPNT( IZEND-IZSTR+1, AXISZ, RUNDEF)
      ELSE
         CALL USSPNT( IZEND-IZSTR+1, RUNDEF, AXISZ)
      ENDIF
*
      RETURN
*=====================================================================
*"         << X or Y 軸のリセット >>
*=====================================================================
      ENTRY      GGAXRR( HPOS )
*
      CALL GTPGET ( 'MISS', VMISD )
*
      IF      ( HPOS(1:1) .EQ. 'X' ) THEN
         IIZ = 1
         CALL SGPSTX( 'UXMIN', 0.  )
         CALL SGPSTX( 'UXMAX', 1.  )
      ELSE IF ( HPOS(1:1) .EQ. 'Y' ) THEN
         IIZ = 2
         CALL SGPSTX( 'UYMIN', 0.  )
         CALL SGPSTX( 'UYMAX', 1.  )
      ENDIF
*
      AZMINZ( IIZ ) = VMISD
      AZMAXZ( IIZ ) = VMISD
      OSETZ ( IIZ ) = .FALSE.
*
      RETURN
      END
*=====================================================================
*"         << 軸描画のリセット >>
*=====================================================================
      SUBROUTINE GGAXRS
*
      CALL GGAXRR( 'X' )
      CALL GGAXRR( 'Y' )
*
      RETURN
      END
*=====================================================================
*"         << 軸ラベルの描画フラグ >>
*=====================================================================
      SUBROUTINE GGAXLZ ( HPOS )
*
      CHARACTER  HPOS   * 1
      CHARACTER  HSIDEL * 2
*
      IF ( HPOS .EQ. 'X' ) THEN
         CALL GGCGET ( 'CXSIDEL', HSIDEL )
         IF ( INDEX( HSIDEL, 'B' ) .GE. 1 ) THEN
            CALL UZPSTX('LABELXB',.TRUE.)
         ELSE
            CALL UZPSTX('LABELXB',.FALSE.)            
         ENDIF
         IF ( INDEX( HSIDEL, 'T' ) .GE. 1 ) THEN
            CALL UZPSTX('LABELXT',.TRUE.)
         ELSE
            CALL UZPSTX('LABELXT',.FALSE.)            
         ENDIF
         IF ( INDEX( HSIDEL, 'U' ) .GE. 1 ) THEN
            CALL UZPSTX('LABELXU',.TRUE.)
         ELSE
            CALL UZPSTX('LABELXU',.FALSE.)            
         ENDIF
*
      ELSE IF ( HPOS .EQ. 'Y' ) THEN
         CALL GGCGET ( 'CYSIDEL', HSIDEL )
         IF ( INDEX( HSIDEL, 'L' ) .GE. 1 ) THEN
            CALL UZPSTX('LABELYL',.TRUE.)
         ELSE
            CALL UZPSTX('LABELYL',.FALSE.)            
         ENDIF
         IF ( INDEX( HSIDEL, 'R' ) .GE. 1 ) THEN
            CALL UZPSTX('LABELYR',.TRUE.)
         ELSE
            CALL UZPSTX('LABELYR',.FALSE.)            
         ENDIF
         IF ( INDEX( HSIDEL, 'U' ) .GE. 1 ) THEN
            CALL UZPSTX('LABELYU',.TRUE.)
         ELSE
            CALL UZPSTX('LABELYU',.FALSE.)            
         ENDIF
      ELSE
         CALL MSGDMP('E','GGAXLZ','INVALID AXIS SPECIFIER.' )
      ENDIF
*
      RETURN
      END

*"表題 ４引数外部手続き呼びだし GTOOL3(GPCAL4)
*
*"履歴   90/10/13 沼口  敦
*"     2002/06/20 竹広真一
*
*
*********************************************************************
*"         << ４引数外部手続き呼びだし >>
*********************************************************************
      SUBROUTINE GPCAL4
     I         ( GESUBR,
     I           HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     I           HHEAD3, GDATA3,
     I           HHEAD4, GDATA4,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      EXTERNAL   GESUBR                  ! 外部手続き名
      CHARACTER  HHEAD1 ( * )*(*)        !" ヘッダー(入力1)
      REAL       GDATA1 ( * )            !" データ(入力1)
      CHARACTER  HHEAD2 ( * )*(*)        !" ヘッダー(入力2)
      REAL       GDATA2 ( * )            !" データ(入力2)
      CHARACTER  HHEAD3 ( * )*(*)        !" ヘッダー(入力3)
      REAL       GDATA3 ( * )            !" データ(入力3)
      CHARACTER  HHEAD4 ( * )*(*)        !" ヘッダー(入力4)
      REAL       GDATA4 ( * )            !" データ(入力4)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD1 )
*
      CALL GUQSIZ
     I         ( HHEAD1,
     O           IXSTR1, IXEND1, IXDIM1,
     O           IYSTR1, IYEND1, IYDIM1,
     O           IZSTR1, IZEND1, IZDIM1 )
      CALL GUQSIZ
     I         ( HHEAD2,
     O           IXSTR2, IXEND2, IXDIM2,
     O           IYSTR2, IYEND2, IYDIM2,
     O           IZSTR2, IZEND2, IZDIM2 )
      CALL GUQSIZ
     I         ( HHEAD3,
     O           IXSTR3, IXEND3, IXDIM3,
     O           IYSTR3, IYEND3, IYDIM3,
     O           IZSTR3, IZEND3, IZDIM3 )
      CALL GUQSIZ
     I         ( HHEAD4,
     O           IXSTR4, IXEND4, IXDIM4,
     O           IYSTR4, IYEND4, IYDIM4,
     O           IZSTR4, IZEND4, IZDIM4 )
*
*"         < 2. ヘッダーコピー >
*
      CALL GHCOPY ( HHEAD1, HHEADO )
      CALL GHQENM ( HHEADO, IENUM  )
*
*"         < 3. 外部手続き呼びだし >
*
      CALL GESUBR
     I         ( HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     I           HHEAD3, GDATA3,
     I           HHEAD4, GDATA4,
     O           HHEADO, GDATAO,
     D           IXDIM1, IYDIM1, IZDIM1,
     D           IXDIM2, IYDIM2, IZDIM2,
     D           IXDIM3, IYDIM3, IZDIM3,
     D           IXDIM4, IYDIM4, IZDIM4 )
*
*"         < 4. ヘッダー変更 >
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHESET ( HHEADO, HEDIT  , HETTL , IENUM+1 )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << ４引数外部手続き呼びだし >>
*********************************************************************
      SUBROUTINE GMCAL4
     I         ( GESUBR,
     M           HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     I           HHEAD3, GDATA3,
     I           HHEAD4, GDATA4,
     I           HEDIT , HETTL  )
*
      EXTERNAL   GESUBR                  ! 外部手続き名
      CHARACTER  HHEAD1 ( * )*(*)        !" ヘッダー(入力1)
      REAL       GDATA1 ( * )            !" データ(入力1)
      CHARACTER  HHEAD2 ( * )*(*)        !" ヘッダー(入力2)
      REAL       GDATA2 ( * )            !" データ(入力2)
      CHARACTER  HHEAD3 ( * )*(*)        !" ヘッダー(入力3)
      REAL       GDATA3 ( * )            !" データ(入力3)
      CHARACTER  HHEAD4 ( * )*(*)        !" ヘッダー(入力4)
      REAL       GDATA4 ( * )            !" データ(入力4)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPCAL4
     I         ( GESUBR,
     I           HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     I           HHEAD3, GDATA3,
     I           HHEAD4, GDATA4,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD1, GDATA1  )
*
      RETURN
      END

*"表題 経度微分 GTOOL3(GPAXDF)
*
*"履歴 91/01/17 沼口  敦
*
*
*********************************************************************
*"         << 経度微分 >>
*"      [acosφ]^-1 d/dλ
*********************************************************************
      SUBROUTINE GPAXDF
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS         *(NCC)
      CHARACTER  HETTLD        *(NCC)
*
      PARAMETER  ( IDIM=3, JDIM=2, KDIM=1 )
#ifdef SYS_IBMS
      INCLUDE    (GPAINC)                !" /GPAWRK/
#else
#include         "gpainc.F"              !" /GPAWRK/
#endif
*"    COMMON /GPAWK?/ WDATA , ZDATA , ZWORK ,
*"                    PNM   , DPNM  , TRIGS , IFAX  ,
*"                    NMO   , GW    , COSLAT,
*"                    QPNM  , QDPNM , QGW   , QSINLA
*"    REAL ER / 6370.E3 /
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 2. 球関数の準備 >
*
      CALL GPASPS
     I         ( IXDIM , IYDIM , IZDIM , ER    ,
     O           PNM   , DPNM  , TRIGS , IFAX  ,
     O           NMO   , GW    , COSLAT,
     O           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           QPNM  , QDPNM , QGW   , QSINLA                 )
*
*"         < 3. スペクトルに >
*
      CALL SPG2W
     M         ( WDATA ,
     I           GDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  , GW    ,
     F           '    ', 'POS' ,
     D           IXDIM , IYDIM , IZDIM , IXDIM , IYDIM ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , ZWORK                                   )
*
*"         < 4. 微分して格子点値に戻す >
*
      CALL SPW2G
     M         ( GDATAO,
     I           WDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  ,
     F           'XGRA', 'POS' ,
     D           IXDIM , IYDIM , IZDIM , IXDIM , IYDIM ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , ZWORK                                   )
*
*"         < 5. ａcosφ で割る >
*
      DO 5100 K = 1, IZDIM
         DO 5110 J = 1, IYDIM
            DO 5120 I = 1, IXDIM
               IJK = I + (J-1)*IXDIM + (K-1)*IXDIM*IYDIM
               GDATAO( IJK ) = GDATAO( IJK ) / ER / COSLAT( J )
 5120       CONTINUE
 5110    CONTINUE
 5100 CONTINUE
*
*"         < 6. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GHCGET( HHEAD, 'AITM1', HAXIS )
         NH = LENC( HAXIS )
         HETTLD = HAXIS(1:NH)//'-diff'
         CALL GHEADD ( HHEADO, 'XDF' , HETTLD )
*
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL  )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 経度微分 >>
*"      [acosφ]^-1 d/dλ
*********************************************************************
      SUBROUTINE GMAXDF
     M         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPAXDF
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*" PACKAGE GTSTSPCT 時空間パワースペクトル、位相
*" [HIS]  93/11/25 堀之内 第一版（未完成部分多々あり）
*"        93/12/08 堀之内 今のところ"空間"軸(SDIM)が x方向であると仮定
*"                        して軸ファイルがつくられるようになっている。
*"                        オプション -TIMSQ は正常に働かない。
*"                     [未確認]：SDIM≠1 のときの動作
***********************************************************************
      PROGRAM GTSTSP
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
*
*" [PARAM] 必要な領域は約 (2*NDIM4+3*IJKDIM)*4 バイト. 確保可能か注意
**      PARAMETER (NDIM4 = 30E5 )   !" 読み込む全データ数の最大値
**      PARAMETER (IJKDIM= 15E4  )   !" 1レコードのデータ数の最大値
      PARAMETER (NDIM4 = 4.5E6 )   !" 読み込む全データ数の最大値
      PARAMETER (IJKDIM= 1E5  )   !" 1レコードのデータ数の最大値
**      PARAMETER (NDIM4 = 7536700 )   !" 読み込む全データ数の最大値
**      PARAMETER (IJKDIM= 94300  )   !" 1レコードのデータ数の最大値
*
      REAL       GDAT4( NDIM4 )
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      CHARACTER  HHEADS( NDC )*(NCC)
      CHARACTER  HHEADW( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
      DATA       JFILEP/ 61 /
*
      CHARACTER  OUT( 1 )    *(NFILN)
      DATA       OUT / '$GTTMPDIR/gtool.out' /
      CHARACTER  OUTP( 1 )    *(NFILN)
      DATA       OUTP/'$GTTMPDIR/gtoolph.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
*
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET /4*' '/
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
      LOGICAL    NOPH              !" T -> 位相を出力しない
      DATA       NOPH   / .FALSE. /
      INTEGER    SDIM       !" Fourier変換される空間次元は何次元目か
      DATA       SDIM   / 1 /
      LOGICAL    TIMSQ   !" T -> 入力データは既に時系列化されている
*"    但し、時系列データは、１レコードの最終次元が時間軸であると仮定する
      DATA       TIMSQ / .FALSE. /
      INTEGER    SEQ  !" 元が空間３次元データの場合、できた4次元データを
*                     !" 第 SEQ 次元以外の3次元データの列として出力する
      DATA       SEQ   / 4 /  !" デフォルトは、周波数毎のデータの列
      LOGICAL    RSTRD  !"  T -> 空間フーリエの前にリニアトレンドを引く
      DATA       RSTRD  / .FALSE. /
      LOGICAL    RTTRD  !"  T -> 時間フーリエの前にリニアトレンドを引く
      DATA       RTTRD  / .FALSE. /
      LOGICAL    LOG  !" T-> スペクトルのスケーリングタイプを log にする
      DATA       LOG    / .FALSE. /
      LOGICAL    NOAX   !"  T-> 軸ファイルを書かない
      DATA       NOAX   / .FALSE. /
      CHARACTER  UTIM   *4   !" 共通パラメター 'UTIM': 変えない方が無難
      DATA       UTIM   / 'DAY ' /
*
      NAMELIST  /OPTION/ OUT,  OUTP, APND,
     &                   ITEM, UNIT,  TITLE, DSET, GRESET,
     &                   HELP, HFILE, NOPH,  SDIM, TIMSQ,
     &                   SEQ,  RSTRD, RTTRD, LOG,  NOAX, UTIM
*
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       EDIT   / 'STPWSP' /
      DATA       ETTL   / 's-t power spectr' /
*
      CHARACTER  EDITP  *(NCC)
      CHARACTER  ETTLP  *(NCC)
      DATA       EDITP  / 'STPH' /
      DATA       ETTLP  / 's-t phase' /
*
      CHARACTER  AITMF  *(NCC)  !" 時間軸ファイル名
      DATA       AITMF  / '@FREQ' /  !" その頭の部分
      CHARACTER  AITMS  *(NCC)  !" 空間軸ファイル名
      DATA       AITMS  / '@WVNWE' /  !" その頭の部分
      INTEGER    ITIMD   !" 入力の何次元目が時間軸か。
      DATA       ITIMD  / 4 / 
      INTEGER    ISN
      DATA       ISN    / 1 /
      CHARACTER  HFTIME  *(NCC)
      CHARACTER  HFTIM1  *(NCC)
      LOGICAL    LFIRST
      DATA       LFIRST  /.TRUE./
      LOGICAL    LINIT
      DATA       LINIT  /.TRUE./
      CHARACTER  HAITM1*(NCC),HAITM2*(NCC),HAITM3*(NCC)
      CHARACTER  HAXSEQ*(NCC)
      CHARACTER  HAXSDM*(NCC)
      INTEGER    IXDIM,IYDIM,IZDIM,IWDIM !" ４次元データの各要素数
      INTEGER    IRDIM,ITDIM     !" 変換に使われる空間、時間の要素数
      INTEGER    IQDIM,ISDIM !" 時系列は(IQ,IR,IS,IT)DIM の４次元として扱われる
      INTEGER    ITIMDO    !"   出力の何次元目が時間軸か
      LOGICAL    LSEQ   !"  T -> 入力が空間３次元データの(時系)列である。
      DATA       LSEQ  /.FALSE./
*
*  [WORK]
      REAL       WX(IJKDIM),WT(IJKDIM)      !" work(consts) for FFT
      REAL       WY(NDIM4)                  !" work for FFT
      REAL       SP(NDIM4/2),PH(NDIM4/2)    !" power spectrum, phase
      EQUIVALENCE (WY(1),SP)
      EQUIVALENCE (WY(NDIM4/2+1),PH)
*
      INTEGER    IWT(5),IWX(5)
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
*
      CALL GURNTF ( HFILE( 1 ), OUT(1)  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( HFILE( 1 ), OUTP(1) , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFOOPN ( JFILE ,  OUT(1) , APND )
      CALL GUNENV( OUT(1),'.',.FALSE. )
      IL=LENC(OUT(1))
      WRITE (6,*) 'output='//OUT(1)(1:IL)
      IF(.NOT.NOPH) THEN
        CALL GFOOPN ( JFILEP,  OUTP(1) , APND )
        CALL GUNENV( OUTP(1),'.',.FALSE. )
        IL=LENC(OUTP(1))
        WRITE (6,*) 'output='//OUTP(1)(1:IL)
      ENDIF
*
      CALL GTCSET ( 'UTIM', UTIM )
*
*  < read data >
*
      IANUM = 0
 1100 CONTINUE
        CALL   GHCOPY( HHEAD,HHEADS)
        CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
        IF ( IEOD .EQ.0 ) THEN
          IANUM = IANUM + 1
          IF (LFIRST) THEN
            LFIRST = .FALSE.
            CALL GHCGET( HHEAD, 'TIME' , HFTIM1 )
            CALL GHCGET( HHEAD, 'AITM1', HAITM1 )
            CALL GHCGET( HHEAD, 'AITM2', HAITM2 )
            CALL GHCGET( HHEAD, 'AITM3', HAITM3 )
            IF  ( HAITM1 .EQ. ' ' ) 
     &          CALL MSGDMP( 'E',' MAIN ','ZERO SPACE DIMENSION' )
            CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
            IF (TIMSQ) THEN
              IF  ( HAITM2 .EQ. ' ' )
     &            CALL MSGDMP( 'E',' MAIN ','ZERO SPACE DIMENSION' )
              IF  ( HAITM3 .EQ. ' ' ) THEN
                ITIMD = 2
                ITIMDO= 2
                ITDIM = IYDIM
              ELSE
                ITIMD = 3
                ITIMDO= 3
                ITDIM = IZDIM
              ENDIF
              IF (.NOT.(SDIM.LT.ITIMDO))
     &            CALL MSGDMP( 'E',' MAIN ','INVALID SPACE DIM.NUM.' )
            ELSE
              IF(HAITM2.EQ.' ') THEN
                ITIMDO = 2
              ELSE IF(HAITM3.EQ.' ') THEN
                ITIMDO = 3
              ELSE 
                LSEQ = .TRUE.
                IF (SEQ.EQ.4) THEN
                  ITIMDO = 4
                ELSE
                  ITIMDO = 3
                ENDIF
              ENDIF
            ENDIF
          ENDIF
          IF ( IANUM*IXDIM*IYDIM*IZDIM .GT. NDIM4 )
     &         CALL MSGDMP('E',' MAIN ','TOO SMALL "NDIM4"')
          CALL COPY(GDAT4(1 + (IANUM-1)*IXDIM*IYDIM*IZDIM ),
     &              GDATA, IXDIM*IYDIM*IZDIM )
          IF (MOD(IANUM,2).EQ.0) CALL GHCGET( HHEAD, 'TIME' , HFTIME )
      GOTO 1100
        ENDIF
        CALL   GHCOPY( HHEADS,HHEAD)
        CALL   GHCOPY( HHEADS,HHEADW)
*
*  < set dimension >
*
      IWDIM = IANUM
      IF(.NOT.TIMSQ) THEN
        ITDIM = IWDIM
      ENDIF
*
      ITDIM = 2*(ITDIM/2)      !" 偶数に限る.
      IF ( .NOT.TIMSQ  ) CALL GHCSET(HHEAD, 'TIME', HFTIME)
*
      IF (SDIM.EQ.1) THEN
        IQDIM = 1
        IRDIM = IXDIM
        IF (ITIMD.EQ.2) THEN
          ISDIM = 1
        ELSE IF (ITIMD.EQ.3) THEN
          ISDIM = IYDIM
        ELSE
          ISDIM = IYDIM*IZDIM
        ENDIF
      ELSE IF (SDIM.EQ.2) THEN
        IQDIM = IXDIM
        IRDIM = IYDIM
        IF (ITIMD.EQ.3) THEN
          ISDIM = 1
        ELSE
          ISDIM = IZDIM
        ENDIF
      ELSE IF (SDIM.EQ.3) THEN
        IQDIM = IXDIM*IYDIM
        IRDIM = IZDIM
        ISDIM = 1
      ELSE
        CALL MSGDMP('E',' MAIN ','INVALID SPACE DIM.NUMBER' )
      ENDIF
*
*  < Fourier trans,  spectrum,phase > 
*
      WRITE(6,*) IXDIM,IYDIM,IZDIM,IWDIM
      WRITE(6,*) IQDIM,IRDIM,ISDIM,ITDIM
      IF (RSTRD) THEN   !" 空間リニアトレンドを引く
        CALL SUBTRD
     M      ( GDAT4,
     I        IQDIM, IRDIM, IRDIM, ISDIM*ITDIM )
      ENDIF
      CALL  AFFTRU      !" 空間 Fourier
     M      ( GDAT4, 
     W        WY,
     C        WX, IWX, 
     I        IQDIM, IRDIM, IRDIM, ISDIM*ITDIM,  ISN, LINIT )
*
      IF (RTTRD) THEN   !" 時間リニアトレンドを引く
        CALL SUBTRD
     M      ( GDAT4,
     I        IQDIM*IRDIM*ISDIM, ITDIM, ITDIM, 1 )
      ENDIF
      CALL  AFFTRU      !" 時間 Fourier
     M      ( GDAT4, 
     W        WY,
     C        WT, IWT, 
     I        IQDIM*IRDIM*ISDIM, ITDIM, ITDIM, 1,  ISN, LINIT )
      LINIT = .FALSE.
*
      CALL  FST2SP  !" space-time fourier --> space-time power spectrum
     O   ( SP    ,
     I     GDAT4 , IQDIM, IRDIM, ISDIM, ITDIM )
*
      IF (.NOT.NOPH) THEN
        IF ( IQDIM*(IRDIM+1)*ISDIM*ITDIM/2 .GT. NDIM4/2 )
     &       CALL MSGDMP('E',' MAIN ','TOO Small "NDIM4"')    
        CALL  FST2PH !" space-time fourier --> space-time fourier phase
     O   ( PH    ,
     I     GDAT4 , IQDIM, IRDIM, ISDIM, ITDIM )
      ENDIF
*
*  < header set >
*
      IF ( ITEM .NE. ' ' ) THEN
        CALL GHCSET( HHEAD , 'ITEM', ITEM )
      ENDIF
      IF ( UNIT .NE. ' ' ) THEN
        CALL GHCSET( HHEAD , 'UNIT', UNIT )
      ELSE
        CALL GHCGET( HHEAD , 'UNIT', UNIT )
        IL = LENZ(UNIT)
        IF (IL.NE.0) THEN
          UNIT = '('//UNIT(1:IL)//')|2"'
          CALL GHCSET( HHEAD , 'UNIT', UNIT )
        ENDIF
      ENDIF

      IF ( TITLE .NE. ' ' ) THEN
        CALL GHCSTS( HHEAD , 'TITL', TITLE )
      ELSE
        CALL GHCGTS( HHEAD , 'TITL', TITLE )
        IL = LENC(TITLE)
        TITLE = TITLE(1:IL)//' s-t pw.sp'
        CALL GHCSTS( HHEAD , 'TITL', TITLE )
      ENDIF
      IF ( DSET .NE. ' ' ) THEN
        CALL GHCSET( HHEAD , 'DSET', DSET )
      ENDIF
      IF ( GRESET ) THEN
        CALL GHRSGP( HHEAD  )
      ENDIF
*
      CALL GHEADD( HHEAD , EDIT , ETTL )
*
      IL = LENC(AITMS)
      CALL CHVAL( '(I8)', REAL(IRDIM/2) , AITMS(IL+1:NCC) )
*
      IF (SDIM.EQ.1) THEN
        CALL GHCGET( HHEAD, 'AITM1', HAXSDM) 
        IF (HAXSDM(1:4).EQ.'CSIG') THEN
          AITMS(5:6) = 'VT'
          HAXSDM(1:4) = 'CLNS'
          CALL GHCSET( HHEADW, 'AITM1', HAXSDM) 
        ENDIF
        CALL GHCSET( HHEAD, 'AITM1', AITMS) 
        CALL GHPSET( HHEAD, 'ASTR1', 1    ) 
        CALL GHPSET( HHEAD, 'AEND1', IRDIM+1) 
      ELSE IF (SDIM.EQ.2) THEN
        CALL GHCGET( HHEAD, 'AITM2', HAXSDM) 
        IF (HAXSDM(1:4).EQ.'CSIG') THEN
          AITMS(5:6) = 'VT'
          HAXSDM(1:4) = 'CLNS'
          CALL GHCSET( HHEADW, 'AITM2', HAXSDM) 
        ENDIF
        CALL GHCSET( HHEAD, 'AITM2', AITMS) 
        CALL GHPSET( HHEAD, 'ASTR2', 1    ) 
        CALL GHPSET( HHEAD, 'AEND2', IRDIM+1) 
      ELSE IF (SDIM.EQ.3) THEN
        CALL GHCGET( HHEAD, 'AITM2', HAXSDM) 
        IF (HAXSDM(1:4).EQ.'CSIG') THEN
          AITMS(5:6) = 'VT'
          HAXSDM(1:4) = 'CLNS'
          CALL GHCSET( HHEADW, 'AITM3', HAXSDM) 
        ENDIF
        CALL GHCSET( HHEAD, 'AITM3', AITMS) 
        CALL GHPSET( HHEAD, 'ASTR3', 1    ) 
        CALL GHPSET( HHEAD, 'AEND3', IRDIM+1) 
      ENDIF
*
      IL = LENC(AITMF)
      CALL CHVAL( '(I8)', REAL(ITDIM/2) , AITMF(IL+1:NCC) )
      CALL FFTTIM
     I           ( TIMSQ,  ITDIM, 
     I             HHEAD,  HFTIM1,
     I             ITIMDO,
     O             FTIM )
      IL = LENC(AITMF)
      AITMF(IL+1:IL+1) = '-'
      CALL CHVAL( '(I8)', REAL(FTIM) , AITMF(IL+2:NCC) )
*
      CALL HEDAXF
     M           ( HHEAD,
     O             HAXSEQ,
     I             AITMF, ITDIM, ITIMDO, SEQ ,LSEQ )
*
      CALL   GHCOPY( HHEAD,HHEADS)
      IF ( TITLE .NE. ' ' ) THEN
        CALL GHCSTS( HHEADS , 'TITL', TITLE )
      ELSE
        CALL GHCGTS( HHEADS , 'TITL', TITLE )
        IL = LENC(TITLE)
        TITLE = TITLE(1:IL)//' s-t phase'
        CALL GHCSTS( HHEADS , 'TITL', TITLE )
      ENDIF
      CALL GHEADD( HHEADS , EDITP , ETTLP )
      CALL GHCSET( HHEADS ,'UNIT', 'RAD')
*
      IF (LOG) THEN
        CALL GHPSET( HHEAD , 'STYP' , 2 )
      ENDIF
*
*  < output >
*
      IF (LSEQ) THEN
        IXDIMO = IXDIM
        IYDIMO = IYDIM
        IZDIMO = IZDIM
        IF(SDIM.EQ.1) IXDIMO = IXDIM + 1
        IF(SDIM.EQ.2) IYDIMO = IYDIM + 1
        IF(SDIM.EQ.3) IZDIMO = IZDIM + 1
        IF(SEQ.EQ.1) NSEQ=IXDIMO
        IF(SEQ.EQ.2) NSEQ=IYDIMO
        IF(SEQ.EQ.3) NSEQ=IZDIMO
        IF(SEQ.EQ.4) NSEQ=IWDIM/2
        DO 100 ISEQ = 1,NSEQ
          CALL COPY43(GDATA,SP,SEQ,ISEQ,IXDIMO,IYDIMO,IZDIMO,IWDIM/2)
          IF (SEQ.EQ.4) THEN
            CALL EADDPR
     M           ( HHEAD ,
     I             ISEQ, FTIM, AITMF )
          ELSE IF (SEQ.EQ.SDIM) THEN
            CALL EADDSX
     M           ( HHEAD,
     I             ISEQ, IRDIM  , AITMS )
          ELSE
            CALL EADDSQ
     M           ( HHEAD,
     I             HAXSEQ, SEQ, ISEQ ) 
          ENDIF
          CALL GFWRIT
     I         ( HHEAD , GDATA ,
     I         JFILE , 1     , 0      )
          IF (.NOT.NOPH) THEN
            CALL COPY43(GDATA,PH,SEQ,ISEQ,IXDIMO,IYDIMO,IZDIMO,IWDIM/2)
            IF (SEQ.EQ.4) THEN
              CALL EADDPR
     M             ( HHEADS ,
     I               ISEQ, FTIM, AITMF )
            ELSE IF (SEQ.EQ.SDIM) THEN
              CALL EADDSX
     M             ( HHEADS,
     I               ISEQ, IRDIM  , AITMS )
            ELSE
              CALL EADDSQ
     M             ( HHEADS,
     I               HAXSEQ, SEQ, ISEQ ) 
            ENDIF
            CALL GFWRIT
     I           ( HHEADS , GDATA ,
     I           JFILEP, 1     , 0      )
          ENDIF
  100   CONTINUE
      ELSE
        CALL COPY( GDAT4,SP,IQDIM*(IRDIM+1)*ISDIM*(ITDIM/2) )
        CALL GFWRIT
     I       ( HHEAD , GDAT4 ,
     I       JFILE , 1     , 0      )
        IF (.NOT.NOPH) THEN
          CALL COPY( GDAT4,PH,IQDIM*(IRDIM+1)*ISDIM*(ITDIM/2) )
          CALL GFWRIT
     I         ( HHEADS , GDAT4 ,
     I         JFILEP, 1     , 0      )
        ENDIF
      ENDIF
*
*  < make axis file >
*
      IF (.NOT.NOAX) THEN
        CALL JIKFRQ
     I      ( HHEAD,  AITMF, FTIM,
     I        ITDIM/2 )
        IF (HAXSDM(1:4).EQ.'GLON') THEN
          CALL JIKSPC
     I         ( HHEAD,  AITMS,
     I           IRDIM,  SDIM )
        ELSE IF(HAXSDM(1:4).EQ.'CLNS') THEN
          
          CALL JIKVRT
     I         ( HHEAD, HHEADW,  HAXSDM,
     I           IRDIM,  SDIM )
        ENDIF
      ENDIF
*
      STOP
      END
*********************************************************************
      SUBROUTINE COPY(X,Y,N)
      REAL    X(N),Y(N)
      DO 10 I=1,N
        X(I) = Y(I) 
   10 CONTINUE
      RETURN
      END
*********************************************************************
*  copy 4dim array --> 3dim array
      SUBROUTINE COPY43(X,Y,KD,ID,N1,N2,N3,N4)
      REAL    X(*),Y(*)
      IF (KD.EQ.1) THEN
        CALL COP431(X,Y,ID,N1,N2,N3,N4)
      ELSE IF (KD.EQ.2) THEN
        CALL COP432(X,Y,ID,N1,N2,N3,N4)
      ELSE IF (KD.EQ.3) THEN
        CALL COP433(X,Y,ID,N1,N2,N3,N4)
      ELSE IF (KD.EQ.4) THEN
        CALL COP434(X,Y,ID,N1,N2,N3,N4)
      ELSE
        CALL MSGDMP('E','COPY43','INVALID "KD"')
      ENDIF
      RETURN
      END
*********************************************************************
*  copy 4dim array --> 3dim array
      SUBROUTINE COP431(X,Y,ID,N1,N2,N3,N4)
      REAL    X(N2,N3,N4),Y(N1,N2,N3,N4)
      DO 10 I4 = 1,N4
      DO 10 I3 = 1,N3
      DO 10 I2 = 1,N2
        X(I2,I3,I4) = Y(ID,I2,I3,I4)
   10 CONTINUE
      RETURN
      END
*********************************************************************
*  copy 4dim array --> 3dim array
      SUBROUTINE COP432(X,Y,ID,N1,N2,N3,N4)
      REAL    X(N1,N3,N4),Y(N1,N2,N3,N4)
      DO 10 I4 = 1,N4
      DO 10 I3 = 1,N3
      DO 10 I1 = 1,N1
        X(I1,I3,I4) = Y(I1,ID,I3,I4)
   10 CONTINUE
      RETURN
      END
*********************************************************************
*  copy 4dim array --> 3dim array
      SUBROUTINE COP433(X,Y,ID,N1,N2,N3,N4)
      REAL    X(N1,N2,N4),Y(N1,N2,N3,N4)
      DO 10 I4 = 1,N4
      DO 10 I2 = 1,N2
      DO 10 I1 = 1,N1
        X(I1,I2,I4) = Y(I1,I2,ID,I4)
   10 CONTINUE
      RETURN
      END
*********************************************************************
*  copy 4dim array --> 3dim array
      SUBROUTINE COP434(X,Y,ID,N1,N2,N3,N4)
      REAL    X(N1,N2,N3),Y(N1,N2,N3,N4)
      DO 10 I3 = 1,N3
      DO 10 I2 = 1,N2
      DO 10 I1 = 1,N1
        X(I1,I2,I3) = Y(I1,I2,I3,ID)
   10 CONTINUE
      RETURN
      END
*********************************************************************
      SUBROUTINE JIKFRQ
     I      ( HHEAD,  AITMF,  FTIM,
     I        NF )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HHEAD ( NDC )*(NCC)
      CHARACTER  AITMF   *(NCC)
      CHARACTER  HUTIM   *4  !"共通パラメタ UTIM (default:'DAY')
      CHARACTER  HUNIT   *6
      PARAMETER  ( NAX=1024 )
      REAL       AX  ( NAX )
      REAL       DAX ( NAX )
      CHARACTER  HAX (NDC)*(NCC)
*
      CALL GTCGET ( 'UTIM', HUTIM )
      IL = LENC(HUTIM)
      HUNIT = '1/'//HUTIM(1:IL)
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
*
      DF = 1. / FTIM
      DO 10 I = 1,NF
        AX(I) = DF*I
        DAX(I) = 1.
   10 CONTINUE
*
      CALL GHCSET( HAX, 'AITM1', AITMF )
      CALL GHPSET( HAX, 'AEND1', NF )
*
      CALL    GHPACA
     O         ( HAX,
     I           'IAXLOC', AITMF,
     I           'frequency', HUNIT ,
     I           NF,
     I           'UR4' , VMISS ,
     I           VMISS , VMISS , VMISS , VMISS , 1 )
*
      CALL    GUSIAX
     I         ( HAX , AX , DAX ,
     I           1                )
*
      CALL  GUWIAX
     I         ( HAX )
*
      RETURN
      END
*********************************************************************
      SUBROUTINE JIKSPC
     I      ( HHEAD,  AITMS,
     I        NS , IAX )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HHEAD ( NDC )*(NCC)
      CHARACTER  AITMS   *(NCC)
      CHARACTER  HAITM   *(NCC)
      PARAMETER  ( NAX=1024 )
      REAL       AX  ( NAX )
      REAL       DAX ( NAX )
      CHARACTER  HAX (NDC)*(NCC)
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
      CALL GHPSET( HAX, 'AEND1', NS+1 )
*
      IF (IAX.EQ.1) THEN
        CALL GHCGET( HHEAD, 'AITM1', HAITM )
      ELSE IF (IAX.EQ.2) THEN
        CALL GHCGET( HHEAD, 'AITM2', HAITM )
      ELSE IF (IAX.EQ.3) THEN
        CALL GHCGET( HHEAD, 'AITM3', HAITM )
      ENDIF
*
        DO 10 I = -NS/2,NS/2
          AX(I+NS/2+1) = 1.*I
          DAX(I+NS/2+1) = 1.
   10   CONTINUE
*
        CALL    GHPACA
     O         ( HAX,
     I           'IAXLOC', AITMS,
     I           'wave number', ' ',
     I           NS+1,
     I           'UR4' , VMISS ,
     I           VMISS , VMISS , VMISS , VMISS , 1 )
*
        CALL    GUSIAX
     I         ( HAX , AX , DAX ,
     I           1                )
*
        CALL  GUWIAX
     I         ( HAX )
*
      RETURN
      END
*********************************************************************
      SUBROUTINE JIKVRT
     I      ( HHEAD,  HHEADW, HAXSDM,
     I        NS , IAX )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HHEAD ( NDC )*(NCC)
      CHARACTER  HAITM   *(NCC)
      CHARACTER  HAXSDM   *(NCC)
      PARAMETER  ( NAX=1024 )
      REAL       WGT ( NAX )
      REAL       AX  ( NAX )
      REAL       DAX ( NAX )
      CHARACTER  HAX (NDC)*(NCC)
      CHARACTER  HHEADO( NDC )*(NCC)
      LOGICAL    LREQ
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
      CALL GHPSET( HAX, 'AEND1', NS+1 )
*
      IF (IAX.EQ.1) THEN
        CALL GHCGET( HHEAD, 'AITM1', HAITM )
      ELSE IF (IAX.EQ.2) THEN
        CALL GHCGET( HHEAD, 'AITM2', HAITM )
      ELSE IF (IAX.EQ.3) THEN
        CALL GHCGET( HHEAD, 'AITM3', HAITM )
      ENDIF
*
      CALL GTSIZE ( HHEADO  ,  NAX  )
      CALL GUQAXV
     I     ( HHEADW, IAX, 'WGT' ,
     O       HHEADO,WGT, IEOD  )
*
      W = WGT(1)
      S = WGT(1)
      DO 5 I = 2,NS
        W2 = WGT(I)
        IF(.NOT.LREQ(W,W2)) 
     &       CALL MSGDMP('W','JIKVRT','AXIS IN NOT EQUALLY DIVDED')
        W = W2
        S = S + WGT(I)
    5 CONTINUE
*
      DS = -1 / S
*
      DO 10 I = -NS/2,NS/2
        AX(I+NS/2+1) = DS*I
        DAX(I+NS/2+1) = 1.
   10 CONTINUE
*
      CALL    GHPACA
     O         ( HAX,
     I           'IAXLOC', HAITM,
     I           'vertical wn', ' ',
     I           NS+1,
     I           'UR4' , VMISS ,
     I           VMISS , VMISS , VMISS , VMISS , 1 )
*
      CALL    GUSIAX
     I         ( HAX , AX , DAX ,
     I           1                )
*
      CALL  GUWIAX
     I         ( HAX )
*
      RETURN
      END
***********************************************************************
* GET TIME FOR TIME FFT
*
      SUBROUTINE FFTTIM
     I           ( LTIMSQ, ITDIM, 
     I             HHEAD,  HFTIM1,
     I             ITIMD,
     O             FTIM )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
*  [INPUT]
      LOGICAL    LTIMSQ   !"  T -> 入力データは既に時系列化されている。
      INTEGER    ITDIM    !" 変換に使われる時間の要素数
      CHARACTER  HHEAD ( NDC )*(NCC) !"          (for .NOT.LTMSQ)
      CHARACTER  HFTIM1  *(NCC)  !" 始めの時刻  (for .NOT.LTMSQ)
      INTEGER    ITIMD    !" 時間軸は何次元目か (for LTIMSQ)
*  [OUTPUT]
      REAL       FTIM     !" フーリエ変換に使われた時間 (単位 HUTIM)
*  [WORK]
      CHARACTER  HUTIM   *4  !"共通パラメタ UTIM (default:'DAY') となる
      CHARACTER  HUTIMF  *4  !" (for LTIMSQ)
      CHARACTER  HAW     *5  !" (for LTIMSQ)
      CHARACTER  HHEADW( NDC )*(NCC)
      PARAMETER  ( MAXAX = 1024 )
      REAL       AXIS(MAXAX)
*
      IF (.NOT.LTIMSQ) THEN
        CALL GUQTIM ( HHEAD , RTF , HUTIM ) !" 'DAY'?単位で時刻を読む
        CALL GHCOPY( HHEAD,HHEADW)
        CALL GHCSET(HHEADW, 'TIME', HFTIM1)
        CALL GUQTIM ( HHEADW , RTI , HUTIM ) !" 'DAY'?単位で時刻を読む
        FTIM = ( RTF - RTI ) * ITDIM / (ITDIM-1)
      ELSE
        IF (ITDIM.GT.MAXAX)
     &      CALL MSGDMP('E','FFTTIM','TOO LARGE TIME SEQUENCE')
        CALL GUQAXV
     I       ( HHEAD, ITIMD, 'LOC' ,
     O         HHEADW,AXIS , IEOD )
        HAW = 'ASTR#'
        WRITE(HAW(5:5),'(I1)') ITIMD
        CALL GHPGET(HHEAD,HAW,IASTR)
        RTI = AXIS(IASTR)
        RTF = AXIS(IASTR+ITDIM)
        FTIM = ( RTF - RTI ) * (ITDIM+1) / ITDIM
        CALL GHCGET ( HHEADW, 'UNIT',  HUTIMF )
        CALL GTCGET ( 'UTIM', HUTIM )
        IF ( HUTIMF(1:1) .NE. HUTIM(1:1)  ) THEN
          IT = FTIM
          CALL GUCT2R
     I            ( IT , HUTIMF, HUTIM , 1      ,
     O              FTIM                                )
        ENDIF
      ENDIF
*
      RETURN
      END
***********************************************************************
      SUBROUTINE HEDAXF
     M           ( HHEAD,
     O             HAXSEQ,
     I             AITMF, ITDIM, ITIMDO, ISEQ ,LSEQ )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
*  [MODIFY]
      CHARACTER  HHEAD ( NDC )*(NCC)
*  [OUTPUT]
      CHARACTER  HAXSEQ *(NCC)
*  [INPUT]
      CHARACTER  AITMF  *(NCC)  !" 時間軸ファイル名
      INTEGER    ITIMDO    !"   出力の何次元目が時間軸か
      INTEGER    ISEQ  !" 元が空間３次元データの場合、できた4次元データを
*                     !" 第 ISEQ 次元以外の3次元データの列として出力する。
      LOGICAL    LSEQ   !"  T -> 入力が空間３次元データの(時系)列である。
*  [WORK]
      CHARACTER*(NCC)  CAITM,CASTR,CAEND
      CHARACTER*(NCC)  HAITM,HASTR,HAEND
*
      CAITM = 'AITM#'
      CASTR = 'ASTR#'
      CAEND = 'AEND#'
*
      IF (ISEQ.NE.4) THEN
        WRITE(CAITM(5:5),'(I1)') ISEQ
        CALL GHCGET( HHEAD, CAITM, HAXSEQ )
      ENDIF
*
      IF (LSEQ .AND. ISEQ.LT.3) THEN
        DO 10 KS = ISEQ+1,3
          WRITE(CAITM(5:5),'(I1)') KS
          WRITE(CASTR(5:5),'(I1)') KS
          WRITE(CAEND(5:5),'(I1)') KS
          CALL GHCGET( HHEAD, CAITM, HAITM ) 
          CALL GHPGET( HHEAD, CASTR, HASTR ) 
          CALL GHPGET( HHEAD, CAEND, HAEND ) 
          WRITE(CAITM(5:5),'(I1)') KS-1
          WRITE(CASTR(5:5),'(I1)') KS-1
          WRITE(CAEND(5:5),'(I1)') KS-1
          CALL GHCSET( HHEAD, CAITM, HAITM ) 
          CALL GHPSET( HHEAD, CASTR, HASTR ) 
          CALL GHPSET( HHEAD, CAEND, HAEND ) 
   10   CONTINUE
      ENDIF
*
      WRITE(CAITM(5:5),'(I1)') ITIMDO
      WRITE(CASTR(5:5),'(I1)') ITIMDO
      WRITE(CAEND(5:5),'(I1)') ITIMDO
      IF (ITIMDO.NE.4) THEN
        CALL GHCSET( HHEAD, CAITM, AITMF  ) 
        CALL GHPSET( HHEAD, CASTR, 1      ) 
        CALL GHPSET( HHEAD, CAEND, ITDIM/2) 
      ENDIF
*
      RETURN
      END
*********************************************************************
*"    編集記述子追加 (周期)
      SUBROUTINE EADDPR
     M      ( HHEAD,
     I        IFRQ, FTIM, AITMF )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HHEAD ( NDC )*(NCC)
*
      INTEGER    IFRQ     !" 何番目か
      REAL       FTIM     !" フーリエ変換に使われた時間 (単位 'UTIM')
      CHARACTER  AITMF  *(NCC)  !" 時間軸ファイル名
*
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      CHARACTER  HUTIM   *4  !"共通パラメタ UTIM (default:'DAY') となる
      CHARACTER  HNUM   *(NCC)
      REAL       PERIOD
      INTEGER    IENUM
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       IENUM , OFIRST
*
      DF = 1. / FTIM
      FRQ = DF*IFRQ
      PERIOD = 1/FRQ
*
      EDIT = AITMF
*
      CALL GTCGET ( 'UTIM', HUTIM )
      CALL CHVAL( 'B' , PERIOD , HNUM )
      IL = LENC(HNUM)
      ETTL = 'PERIOD'//HNUM(1:IL)//HUTIM
*
      IF (OFIRST) THEN
        CALL GHQENM ( HHEAD, IENUM )
        OFIRST = .FALSE.
      ENDIF
      CALL GHESET( HHEAD , EDIT , ETTL , IENUM+1 )
*
      RETURN
      END
*********************************************************************
*"    編集記述子追加 (zonal w.n.)
      SUBROUTINE EADDSX
     M      ( HHEAD,
     I        ISX, IRDIM  , AITMS )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HHEAD ( NDC )*(NCC)
*
      INTEGER    ISX      !" 何番目か
      INTEGER    IRDIM    !" フーリエ変換に使われたデータ数
      CHARACTER  AITMS  *(NCC)  !" 軸ファイル名
*
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      CHARACTER  HNUM   *(NCC)
      REAL       WN
      INTEGER    IENUM
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       IENUM , OFIRST
*
      WN = -IRDIM/2 + (ISX-1)
*
      EDIT = AITMS
*
      CALL CHVAL( '(I8)' , WN , HNUM )
      ETTL = 'WVN'//HNUM
*
      IF (OFIRST) THEN
        CALL GHQENM ( HHEAD, IENUM )
        OFIRST = .FALSE.
      ENDIF
      CALL GHESET( HHEAD , EDIT , ETTL , IENUM+1 )
*
      RETURN
      END
***********************************************************************
*"    編集記述子追加
      SUBROUTINE EADDSQ
     M     ( HHEAD,
     I       HAXSEQ, KD,  IS )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HHEAD ( NDC )*(NCC)
*
      CHARACTER  HAXSEQ       *(NCC)
      INTEGER    KD      !" 何次元目か
      INTEGER    IS      !" 何番目か
*
      CHARACTER  HEDIT       *(NCC)        !" 編集略記号
      CHARACTER  HETTL       *(NCC)        !" 編集タイトル
      CHARACTER  HED         *2
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      INTEGER    IENUM
      SAVE       IENUM , OFIRST
*
      IF(KD.EQ.1) THEN
        HED = 'XS'
      ELSE IF(KD.EQ.2) THEN
        HED = 'YS'
      ELSE IF(KD.EQ.3) THEN
        HED = 'ZS'
      ELSE
        HED = 'SS'
      ENDIF
*
      CALL GUEAXN
     I               ( HAXSEQ, HED    , '-select',
     I                 IS    , IS     ,
     O                 HEDIT , HETTL           )
      IF (OFIRST) THEN
        CALL GHQENM ( HHEAD, IENUM )
        OFIRST = .FALSE.
      ENDIF
      CALL GHESET( HHEAD , HEDIT , HETTL , IENUM+1 )
*
      RETURN
      END

*"表題 トーン描画 GTOOL3(GGTONE)
*
*"履歴 90/08/17 沼口  敦
*"履歴 95/05/25 竹広真一  for dcl-5.0
*
*
*********************************************************************
*"         << トーン描画 >>
*********************************************************************
      SUBROUTINE GGTONE
     I         ( HHEAD , GDATA ,
     I           TONL  , ITON  , NTON  )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       GDATA ( * )             !" データ
      REAL       TONL  ( NTON+1 )        !" トーン境界値
      INTEGER    ITON  ( NTON )          !" トーン番号
*"    INTEGER    NTON                    ! トーンの数
*
      LOGICAL    OTONS
*
*"         < 1. サイズ >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GHPGET ( HHEAD, 'ASTR1', IXSTR )
      CALL GHPGET ( HHEAD, 'AEND1', IXEND )
      CALL GHPGET ( HHEAD, 'ASTR2', IYSTR )
      CALL GHPGET ( HHEAD, 'AEND2', IYEND )
      IXDIM = IXEND-IXSTR+1
      IYDIM = IYEND-IYSTR+1
*
*"         < 2. トーンレベル >
*
      CALL GGPGET ( 'TONESET', ITNSET )
      IF ( ITNSET .LE. 0 ) THEN
         CALL UEITLV                                    !" トーンレベルを無効
      ENDIF
*
      IF ( (ITNSET .NE. 1) .AND. (NTON .GE. 1) ) THEN
         CALL UESTLN ( TONL, ITON, NTON )               !" トーンレベルを設定
      ENDIF
*
      CALL UEQNTL ( NTONE )                             !" トーンレベルの数
      IF ( NTONE .LT. 1   ) RETURN
*
*"         < 3. トーン描画 >
*
c$$$      CALL GGPGET ( 'TONEPXL' , IPXLX )
c$$$      CALL GGPGET ( 'TONEPXL2', IPXLY )
c$$$      CALL UEPSET ( 'LINTER'  ,.FALSE.)
c$$$*
c$$$      CALL SGQTRN( ITR )
c$$$      IF ( ( 1 .LE. ITR ) .AND. ( ITR .LE. 4 ) ) THEN
c$$$         IF ( IPXLX .EQ. 0 ) THEN
c$$$            CALL VETONG ( GDATA ,
c$$$     I                    IXDIM , IXDIM , IYDIM )
c$$$         ELSE IF ( IPXLX .GT. 0 ) THEN
c$$$            IF ( IPXLY .LE. 0 ) IPXLY = IPXLX
c$$$            CALL VETONF ( GDATA ,
c$$$     I                    IXDIM , IXDIM , IYDIM , IPXLX, IPXLY )
c$$$         ELSE
c$$$            CALL UETONE ( GDATA ,
c$$$     I                    IXDIM , IXDIM , IYDIM )
c$$$         ENDIF
c$$$      ELSE
         CALL UETONE ( GDATA ,
     I                 IXDIM , IXDIM , IYDIM )          !" トーン描画
c$$$      ENDIF
*     
*"         < 4. トーンスケール >
*
      CALL GGPGET ( 'LTONS', OTONS )
      IF ( OTONS ) THEN
         CALL GGTONS                              
     I           ( HHEAD )                              !" トーンスケール描画
      ENDIF
*
      CALL GGPSET ( 'TONESET', 0 )
*
      RETURN
      END

*"表題 第1次元を拡張 GTOOL3(GPXEXP)
*
*"履歴 90/09/24 沼口  敦
*
*
*********************************************************************
*"         << 第1次元を拡張 >>
*********************************************************************
      SUBROUTINE GPXEXP
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO   )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS       *(NCC)      !" 軸名称
      LOGICAL    OCYCL                   !" サイクリックか？
*
      CALL GHCGET ( HHEAD, 'AITM1', HAXIS  )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
      CALL GPXRDC
     I         ( HHEAD , GDATA , 1      , IADIM  ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO                    )
*
      RETURN
*====================================================================
*"         << 第1次元をサイクリックに拡張 >>
*====================================================================
      ENTRY      GPXEXC
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO   )
*
      CALL GHCGET ( HHEAD, 'AITM1', HAXIS  )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
      IF ( OCYCL ) THEN
         IADIM = IADIM + 1
      ENDIF
*
      CALL GPXRDC
     I         ( HHEAD , GDATA , 1      , IADIM  ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO                    )
*
      RETURN
      END
*********************************************************************
*"         << 第1次元を拡張 >>
*********************************************************************
      SUBROUTINE GMXEXP
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPXEXP
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW   )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
*====================================================================
*"         << 第1次元をサイクリックに拡張 >>
*====================================================================
      ENTRY      GMXEXC
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPXEXC
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW   )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 トーン段彩 GTOOL3(GGSTON)
*
*"履歴 92/07/08 沼口  敦
*"     95/05/26 竹広真一 for dcl-5.0
*"     96/06/21 竹広真一 bug fixes 
*
*
*********************************************************************
*"         << トーン段彩 >>
*********************************************************************
      SUBROUTINE GGSTON
     I         ( HHEAD , GDATA  )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       GDATA ( * )             !" データ
*
*"         < 1. サイズ >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GHPGET ( HHEAD, 'ASTR1', IXSTR )
      CALL GHPGET ( HHEAD, 'AEND1', IXEND )
      CALL GHPGET ( HHEAD, 'ASTR2', IYSTR )
      CALL GHPGET ( HHEAD, 'AEND2', IYEND )
      IXDIM = IXEND-IXSTR+1
      IYDIM = IYEND-IYSTR+1
*
*"         < 2. トーンレベル >
*
      CALL GHPGET ( HHEAD, 'MISS' , VMISS )
      CALL GHPGET ( HHEAD, 'DMIN' , DMIN  )
      CALL GHPGET ( HHEAD, 'DMAX' , DMAX  )
      CALL GHPGET ( HHEAD, 'DIVS' , DIVS  )
*
      CALL GGPGET ( 'TONESET', ITNSET )
      IF ( ITNSET .LE. 0 ) THEN
         CALL UEITLV
      ENDIF
*
      CALL GGPGET ( 'NTONE',    NL    )
      CALL GGPGET ( 'TONEPAT',  IPAT1 ) 
      CALL GGPGET ( 'TONEINC',  IPINC ) 
*
      CALL GGPGET( 'CONRFCT', CONFAC )
      IF      ( (DMIN.EQ.VMISS) .AND. (DMAX.NE.VMISS) ) THEN
         CONFAC = 1.
      ELSE IF ( (DMIN.NE.VMISS) .AND. (DMAX.EQ.VMISS) ) THEN
         CONFAC = 0.
      ENDIF
*
      IF ( ITNSET .NE. 1 ) THEN
*
         GMIN = RMIN( GDATA, IXDIM*IYDIM, 1 )    !" データ最小値
         GMAX = RMAX( GDATA, IXDIM*IYDIM, 1 )    !" データ最大値
         IF (GMIN.EQ.GMAX) RETURN                !" 一定 -> トーンレベル設定せず
*
         IF       ( DMIN .EQ. VMISS  .AND. DMAX .EQ. VMISS ) THEN
            DMIN = GMIN
            DMAX = GMAX
         ELSE IF  ( DMIN .EQ. VMISS  .AND. DMAX .NE. VMISS ) THEN
            DMIN = GMIN
         ELSE IF  ( DMIN .NE. VMISS  .AND. DMAX .EQ. VMISS ) THEN
            DMAX = GMAX
         ENDIF
*
         IF  (DIVS .EQ. VMISS) THEN                  !" 目盛間隔(小)未設定時
            DIVS = RGNGE((DMAX-DMIN)/NL)
            ZMIN = IRLE(DMIN/DIVS)*DIVS      !" fixed by S.Takehiro(96/06/21)
            ZMAX = IRGE(DMAX/DIVS)*DIVS      !" fixed by S.Takehiro(96/06/21)
         ELSE                                     !" 目盛間隔(小)設定時
            ZMIN = IRLE(DMIN/DIVS)*DIVS      !" fixed by S.Takehiro(96/06/21)
            ZMAX = IRGE(DMAX/DIVS)*DIVS      !" fixed by S.Takehiro(96/06/21)
*     
            NUMTON = NINT( (ZMAX-ZMIN)/DIVS  ) + 1   !" トーンレベル数
            IF ( NUMTON .GT. NL ) THEN               !" NL までトーンレベルを設定
               RANGE = DIVS * NL             !" トーン描画範囲幅 
*                                            !" fixed by S.Takehiro(96/06/21)
               ZMIN  = ZMIN 
     &                + CONFAC*( ZMAX-ZMIN - RANGE ) !" CONFAC=0 : 大きい側を省略
               ZMAX  = ZMIN + RANGE                  !" CONFAC=1 : 小さい側を省略
            ELSE
               NL = NUMTON 
            ENDIF
         ENDIF
*
         DO 3100 I = 1, NL
            CALL UESTLV ( ZMIN+(I-1)*DIVS, ZMIN+I*DIVS, 
     &                    IPAT1+IPINC*(I-1) )
 3100    CONTINUE
*
         CALL GGPSET( 'TONESET', 2 )
*
      ENDIF
*
      RETURN
      END

*"表題 球面調和関数の領域 GTOOL3(GPAINC)
*
*"履歴 91/01/17 沼口  敦
*
*
**********************************************************************
*"      << 球面調和関数の領域 >>
**********************************************************************
      INTEGER MMAXC, LMAXC, NMAXC, MINTC, NMLC, NMDIMC
      PARAMETER
     & ( MMAXC = IDIM/3,
     &   LMAXC = MMAXC,
     &   NMAXC = MMAXC,
     &   MINTC = 1,
     &   NMLC  = NMAXC-LMAXC,
     &   NMDIMC= (MMAXC/MINTC+1)*(2*(NMAXC+1)-LMAXC)-NMLC*(NMLC+1) )
*
      COMMON /GPAWK1/ WDATA
      COMMON /GPAWK2/ ZDATA
      COMMON /GPAWK3/ ZWORK
      COMMON /GPAWK4/ PNM
      COMMON /GPAWK5/ DPNM
      COMMON /GPAWK6/ TRIGS
      COMMON /GPAWK7/ IFAX
      COMMON /GPAWK8/ NMO
      COMMON /GPAWK9/ GW
      COMMON /GPAWKA/ COSLAT
      COMMON /GPAWKB/ QPNM
      COMMON /GPAWKC/ QDPNM
      COMMON /GPAWKD/ QGW
      COMMON /GPAWKE/ QSINLA
*
      REAL       WDATA ( NMDIMC*KDIM    )    !" スペクトルデータ
      REAL       ZDATA ( IDIM*JDIM*KDIM )    !" 東西スペクトル
      REAL       ZWORK ( IDIM*JDIM*KDIM )    !" ワーク
*
      REAL       PNM   ( JDIM*NMDIMC/2 )     !" Ｐnm ルジャンドル
      REAL       DPNM  ( JDIM*NMDIMC/2 )     !" Ｐnm μ微分
      REAL       TRIGS ( 2*IDIM )            !" 三角関数表
      INTEGER    IFAX  ( 10 )                !" IMAX の因数分解
*
      INTEGER    NMO   ( 2*(MMAXC+1)*(LMAXC+1) ) !" 添字順番
      REAL       GW    ( JDIM )              !" ガウス荷重
      REAL       COSLAT( JDIM )              !" cos(緯度)
*
      REAL*8     QPNM  ( (NMAXC+2)*(MMAXC+1) ) !" Ｐnm ルジャンド
      REAL*8     QDPNM ( (NMAXC+2)*(MMAXC+1) ) !" Ｐnm μ微分
      REAL*8     QGW   ( JDIM )              !" ガウス荷重 ：倍精度
      REAL*8     QSINLA( JDIM )              !" sin(緯度) (倍精度
*
      REAL       ER                          !" 地球半径
      DATA       ER / 6370.E3 /
*

*"表題 球面調和関数の準備 GTOOL3(GPASPS)
*
*"履歴 91/01/17 沼口  敦
*"履歴 95/11/27 堀之内武 デバグ,判断基準改正
*
**********************************************************************
*"      << 球面調和関数の準備 >>
**********************************************************************
      SUBROUTINE GPASPS
     I         ( IMAX  , JMAX  , KMAX  , ER    ,
     O           PNM   , DPNM  , TRIGS , IFAX  ,
     O           NMO   , GW    , COSLAT,
     O           LMAX  , MMAX  , NMAX  , MINT  ,
     O           NMDIM , JMXHF ,
     W           QPNM  , QDPNM , QGW   , QSINLA          )
*
      INTEGER    IMAX
      INTEGER    JMAX
      REAL       ER                          !" 地球半径
*
      REAL       PNM   ( * )                 !" Ｐnm ルジャンドル
      REAL       DPNM  ( * )                 !" Ｐnm μ微分
      REAL       TRIGS ( * )                 !" 三角関数表
      INTEGER    IFAX  ( * )                 !" IMAX の因数分解
*
      INTEGER    NMO   ( * )                 !" スペクトルの添字順番
      REAL       GW    ( * )                 !" ガウス荷重
      REAL       COSLAT( * )                 !" cos(緯度)
*
      REAL*8     QPNM  ( * )                 !" Ｐnm ルジャンドル
      REAL*8     QDPNM ( * )                 !" Ｐnm μ微分
      REAL*8     QGW   ( * )                 !" ガウス荷重 ：倍精度
      REAL*8     QSINLA( * )                 !" sin(緯度) (倍精度
*
      INTEGER    IMAX0 , JMAX0               !" セット値
      DATA       IMAX0 , JMAX0 / 0, 0 /
*
      INTEGER    IMAXD , JMAXD, KMAXD        !" 領域の大きさ
      DATA       IMAXD , JMAXD, KMAXD / 0, 0, 0 /
      SAVE       IMAXD , JMAXD, KMAXD !" 堀之内 95/11/27 (追加)
      CHARACTER  HMSG *100
*
      IF ( ( IMAXD*JMAXD*KMAXD .NE. 0 ) !" 堀之内 95/11/27 (判断基準改正)
     &             .AND.
     &     ( ( IMAX .GT. IMAXD ) .OR. ( JMAX .GT. JMAXD )
     &       .OR. ( IMAX*JMAX*KMAX .GT. IMAXD*JMAXD*KMAXD ) ) ) THEN
*
         HMSG = 'INSUFFICIENT SPACE: IMAX= '
         NH = LENC( HMSG )
         WRITE ( HMSG(NH+1:NH+9), '(I4,1X,I4)' ) IMAX,IMAXD
         HMSG(NH+10:100) = ', JMAX= '
         NH = LENC( HMSG )
         WRITE ( HMSG(NH+1:NH+9), '(I4,1X,I4)' ) JMAX,JMAXD
         HMSG(NH+10:100) = ', KMAX= '
         NH = LENC( HMSG )
         WRITE ( HMSG(NH+1:NH+9), '(I4,1X,I4)' ) KMAX,KMAXD
*
         CALL MSGDMP('E', 'GPASPS', HMSG )
      ENDIF
*
*"         < 1. 波数：三角形切断の場合のみ！ >
*
      MMAX00 = IMAX / 3
      IF ( MMAX00 .EQ. 0 ) THEN
         MMAX  = IMAX     / 2
         LMAX  = (JMAX*2) / 2
         NMAX  = MAX( MMAX, LMAX )
         MINT  = 1
         NML   = NMAX-LMAX
         NMDIM = LMAX+1
      ELSE
         MMAX  = IMAX     / 3 !" /2にしても x微分以外はうまく行く。/2だと密な
         LMAX  = (JMAX*2) / 3 !" Fourier係数になるのでMMAX/2成分の場所が問題
         NMAX  = MAX( MMAX, LMAX )
         MINT  = 1
         NML   = NMAX-LMAX
         NMDIM = (MMAX/MINT+1)*(2*(NMAX+1)-LMAX)-NML*(NML+1)
      ENDIF
      JMXHF = JMAX/2+1
*
      IF ( ( IMAX .NE. IMAX0 ) .OR. ( JMAX .NE. JMAX0 ) ) THEN
*
         IMAX0 = IMAX
         JMAX0 = JMAX
*
*"         < 2. FFTの準備 >
*
         IF ( IMAX .GE. 2 ) THEN
            CALL RFFTIM
     I            ( IMAX  ,
     O              TRIGS , IFAX )
         ENDIF
*
*"         < 3. ルジャンドル関数の計算 >
*
         IF ( JMAX .GE. 2 ) THEN
*
            CALL GAUSS
     O         ( QSINLA , QGW   ,
     I           JMAX            )
*
            CALL SETPNM
     O         ( PNM   , DPNM  , NMO   ,
     I           QSINLA,
     D           JMAX  , MMAX  , LMAX  , NMAX  , MINT  ,
     D           NMDIM , JMXHF ,
     W           QPNM  , QDPNM                                  )
*
*"         < 4. ガウス荷重 >
*
            DO 4100 J = 1, JMAX
               GW    ( J ) = QGW( J )
               COSLAT( J ) = SQRT( 1.D0 - QSINLA(J)**2 )
 4100       CONTINUE
*
         ENDIF
*
      ENDIF
*
      RETURN
*=====================================================================
*"    << 球面調和関数領域の大きさ指定 >>
*=====================================================================
      ENTRY      GPASPW
     I         ( IMAXDW, JMAXDW, KMAXDW )
*
      IMAXD = IMAXDW
      JMAXD = JMAXDW
      KMAXD = KMAXDW
*
      END

*" σ面上で PV (ちゃんと 3 次元)を求める     96/09/02 akahori
*********************************************************************
      PROGRAM GTPV2
      IMPLICIT NONE
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
*"[入出力データの領域確保]
      CHARACTER  HTHETA ( NDC )*(NCC)  !" θ
      REAL       GTHETA ( IJKDIM )
      CHARACTER  HU ( NDC )*(NCC)      !" ｕ
      REAL       GU ( IJKDIM )
      CHARACTER  HV ( NDC )*(NCC)      !" ｖ
      REAL       GV ( IJKDIM )
      CHARACTER  HPS ( NDC )*(NCC)     !" Ps
      REAL       GPS ( IJKDIM )
      CHARACTER  HPV ( NDC )*(NCC)     !" Ps
      REAL       GPV ( IJKDIM )
*
*"[途中の計算に必要なワーク領域]
      CHARACTER  HUS ( NDC )*(NCC)     !" ∂ｕ∂σ
      REAL       GUS ( IJKDIM )
      CHARACTER  HVS ( NDC )*(NCC)     !" ∂ｖ/∂σ
      REAL       GVS ( IJKDIM )
      CHARACTER  HVOR ( NDC )*(NCC)    !" ∂ζ/∂σ
      REAL       GVOR ( IJKDIM )
      CHARACTER  HTHETAX ( NDC )*(NCC)   !" ∂θ/∂ｘ
      REAL       GTHETAX ( IJKDIM )
      CHARACTER  HTHETAY ( NDC )*(NCC)   !" ∂θ/∂ｙ
      REAL       GTHETAY ( IJKDIM )
      CHARACTER  HTHETAS ( NDC )*(NCC)   !" ∂θ/∂σ
      REAL       GTHETAS ( IJKDIM )
*
*"[データに初期値を与える]
      INTEGER ITHETA, IU, IV, IPS, JPV
      DATA       ITHETA / 50 /
      DATA       IU     / 52 /
      DATA       IV     / 54 /
      DATA       IPS    / 56 /
      DATA       JPV    / 64 /
*
      CHARACTER  THT    *(NFILN)
      DATA       THT    / '$GTTMPDIR/THETA' /
      CHARACTER  U      *(NFILN)
      DATA       U      / '$GTTMPDIR/U' /
      CHARACTER  V      *(NFILN)
      DATA       V      / '$GTTMPDIR/V' /
      CHARACTER  PS     *(NFILN)
      DATA       PS     / '$GTTMPDIR/PS' /
      CHARACTER  PV     *(NFILN)
      DATA       PV     / '$GTTMPDIR/PV' /
*
*"[球面調和関数による微分のための定義]
      LOGICAL    DX  !" T: x 微分 (DY=Tの方が優先される)
      LOGICAL    DY  !" T: y 微分
      LOGICAL    A   !" T: 地球半径で割る
      INTEGER    WB !"(cosφ)**WB の重みを微分前に掛ける   (x微分の場合WBと
      INTEGER    WA !"(cosφ)**WA の重みを微分後に掛ける    WAは同じ働き)
      LOGICAL    ZONAL !" T: 一番目の軸を y 軸とみなす(波数０成分を仮定)
*
      CHARACTER  ITEM   *(NCC)
      DATA       ITEM   / 'PV' /
      CHARACTER  UNIT   *(NCC)
      DATA       UNIT   / 'PVU' /
      CHARACTER  TITLE  *(NCC*2)
      DATA       TITLE  / 'PV' /
      CHARACTER  DSET   *(NCC)
      DATA       DSET   / ' ' /
      CHARACTER  EDIT   *(NCC)
      DATA       EDIT   / ' ' /
      CHARACTER  ETTL   *(NCC)
      DATA       ETTL   / ' ' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   GSPLIN2, CORIOL, DSPHE, U2VOR, PTLVOR
*
      INTEGER NFILE, NOPT, IOS, IAX, IEOTHT, IEOU, IEOPS, NDIF,
     &        IXDIM, IXSTR, IXEND,
     &        IYDIM, IYSTR, IYEND,
     &        IZDIM, IZSTR, IZEND, 
     &        IEOV

      NAMELIST  /OPTION/
     &     THT, U, V, PS,                    !" 入力ファイル名
     &     PV,                               !" 出力ファイル名
     &     ITEM, UNIT, TITLE, DSET, EDIT, ETTL, 
     &     APND ,GRESET, HELP
*"[オプション]
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*"[gtool をはじめるよ]
      CALL GTOPEN
*"[データ入力のための前処理]
      CALL GTSIZE ( HTHETA , IJKDIM )
      CALL GTSIZE ( HU     , IJKDIM )
      CALL GTSIZE ( HV     , IJKDIM )
      CALL GTSIZE ( HPS    , IJKDIM )
      CALL GTSIZE ( HPV    , IJKDIM )
      CALL GTSIZE ( HUS    , IJKDIM )
      CALL GTSIZE ( HVS    , IJKDIM )
      CALL GTSIZE ( HVOR   , IJKDIM )
      CALL GTSIZE ( HTHETAX, IJKDIM )
      CALL GTSIZE ( HTHETAY, IJKDIM )
      CALL GTSIZE ( HTHETAS, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*"[データ入力]
      CALL GFROPN ( ITHETA , THT )
      CALL GFROPN ( IU     , U   )
      CALL GFROPN ( IV     , V   )
      CALL GFROPN ( IPS    , PS  )
      CALL GFOOPN ( JPV    , PV  , APND )
*"[鉛直補間のためのパラメータ設定]
      IAX=3                    !" 3 番目の軸を補間
      CALL SETPAR2 ( IAX )
*
 1100 CONTINUE
*
*"[データ入力]
         CALL   GFREAD                      !" θ 入力
     O        ( HTHETA , GTHETA , IEOTHT ,
     I          ITHETA , 1                )
*
         CALL   GFREAD                      !" Ｕ 入力
     O        ( HU     , GU     , IEOU   ,
     I          IU     , 1                )
*
         CALL   GFREAD                      !" Ｖ 入力
     O        ( HV     , GV     , IEOV   ,
     I          IV     , 1                )
*
         CALL   GFREAD                      !" Ps 入力
     O        ( HPS    , GPS    , IEOPS  ,
     I          IPS    , 1               )
*
         IF (      ( IEOTHT .EQ. 0 ) .AND. ( IEOU  .EQ. 0 )
     +       .AND. ( IEOV   .EQ. 0 ) .AND. ( IEOPS .EQ. 0 ) ) THEN
*
*"[θの鉛直微分]
           CALL GPFSET
     +          ( HTHETA , GTHETA ,
     +             '   ' , '   '  ,
     +            HTHETAS, GTHETAS )
            NDIF=1                       !" 一階微分
            CALL SETDIF ( NDIF )
            CALL GMCAL1                  !" dθ/dσ を求める
     I         ( GSPLIN2,
     I           HTHETAS, GTHETAS,
     I           '   ' , '   ' )
*"[uの鉛直微分]
           CALL GPFSET
     +          ( HU     , GU     ,
     +             '   ' , '   '  ,
     +            HUS    , GUS     )
            NDIF=1                       !" 一階微分
            CALL SETDIF ( NDIF )
            CALL GMCAL1                  !" dｕ/dσ を求める
     I         ( GSPLIN2,
     I           HUS   , GUS     ,
     I           '   ' , '   ' )
*"[vの鉛直微分]
           CALL GPFSET
     +          ( HV     , GV     ,
     +             '   ' , '   '  ,
     +            HVS    , GVS     )
            NDIF=1                       !" 一階微分
            CALL SETDIF ( NDIF )
            CALL GMCAL1                  !" dｖ/dσ を求める
     I         ( GSPLIN2,
     I           HVS   , GVS     ,
     I           '   ' , '   ' )
*"[θの X 微分]
           CALL GPFSET
     +          ( HTHETA , GTHETA ,
     +           '   '   ,'   '  ,
     +            HTHETAX, GTHETAX )
           DX=.TRUE.
           DY=.FALSE.
           ZONAL=.FALSE.
           WB=0
           WA=-1
           A=.TRUE.
           CALL EDSPHE(DX,DY,WA,WB,A,ZONAL)
           CALL GMCAL1
     I         ( DSPHE  ,
     M           HTHETAX, GTHETAX,
     I           '  '   , '  '   )
*"[θの Y 微分]
           CALL GPFSET
     +          ( HTHETA , GTHETA ,
     +           '   '   ,'   '  ,
     +            HTHETAY, GTHETAY )
           DX=.FALSE.
           DY=.TRUE.
           ZONAL=.FALSE.
           WB=0
           WA=0
           A=.TRUE.
           CALL EDSPHE(DX,DY,WA,WB,A,ZONAL)
           CALL GMCAL1
     I         ( DSPHE  ,
     M           HTHETAY, GTHETAY,
     I           '  '   , '  '   )
*"[相対渦度の鉛直成分]
           CALL GPFSET
     +          ( HU     , GU    ,
     +           '   '   ,'   '  ,
     +            HVOR   , GVOR   )
           CALL GMCAL2
     I          ( U2VOR,
     M            HVOR , GVOR,    !" input U ; output VOR
     I            HV   , GV  ,
     I            '  ' , '  ' )
*"[相対渦度-->絶対渦度]
           CALL GMCAL1            !" 絶対渦度を求める
     I          ( CORIOL,
     M            HVOR  , GVOR,
     I            '   ' , '   ' )
*"[合体]
           CALL GUQSIZ
     I          ( HVOR  ,
     O            IXSTR , IXEND, IXDIM,
     O            IYSTR , IYEND, IYDIM,
     O            IZSTR , IZEND, IZDIM  )
           CALL GHCOPY ( HVOR  , HPV )
           CALL PTLVOR
     I          ( GPS    ,
     I            GUS    ,
     I            GVS    ,
     I            GVOR   ,
     I            GTHETAS,
     I            GTHETAX,
     I            GTHETAY,
     O            GPV    ,
     I            IXDIM, IYDIM, IZDIM )
*"[ PV データ出力]
                  IF ( ITEM .NE. ' ' ) THEN
                     CALL GHCSET( HPV , 'ITEM', ITEM )
                  ENDIF
                  IF ( UNIT .NE. ' ' ) THEN
                     CALL GHCSET( HPV , 'UNIT', UNIT )
                  ENDIF
                  IF ( TITLE .NE. ' ' ) THEN
                     CALL GHCSTS( HPV , 'TITL', TITLE )
                  ENDIF
                  IF ( DSET .NE. ' ' ) THEN
                     CALL GHCSET( HPV , 'DSET', DSET )
                  ENDIF
                  IF ( GRESET ) THEN
                     CALL GHRSGP( HPV  )
                  ENDIF

              IF ( GRESET ) CALL GHRSGP( HPV )
              CALL GFWRIT
     I             ( HPV , GPV   ,
     I               JPV , 1     , 0       )
*
      GOTO 1100
         ENDIF
* commented out by toyoda
*     CALL GTCLSE
      STOP
      END



********************************************************************
*" (旧 95/01/16 horinout  CUBIC SPLINE INTERPOLATIO)
*" 改良している
*" 補間か微分かを決める NDIF は ENTRY 文で代入
*===================================================================
      SUBROUTINE GSPLIN2
     I         ( HHEAD1, GDATA1,
     O           HHEADO, GDATAO,
     D           IDIM1 , JDIM1 , KDIM1 )
      IMPLICIT NONE
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
*
      INTEGER    IDIM1, JDIM1, KDIM1
      CHARACTER  HHEAD1 ( * )*(*)
      REAL       GDATA1 ( IDIM1,JDIM1,KDIM1 )
      CHARACTER  HHEADO ( * )*(*)
      REAL       GDATAO ( * )
* internal work
      CHARACTER  HAX1 ( NDC )*(NCC)
      INTEGER NAXD
      PARAMETER  (NAXD=2048)
      REAL       AX1(NAXD)
      REAL       X(NAXD),Y(NAXD),Y2(NAXD)
*
      INTEGER   IAX, NDIF,  IAXE, NDIFE
      SAVE  IAX, NDIF
      INTEGER I, J, IJKDO, N, K, IJK, IEOD1
      REAL VMISS, AX, YB
*
* / read axis /
*
      CALL GTSIZE(HAX1,NAXD)

      CALL GUQAXV   !" original axis
     I       ( HHEAD1, IAX, 'LOC' ,
     O         HAX1, AX1 , IEOD1 )      
*
*  / header /
*
      CALL GHPGET( HHEAD1,'MISS',VMISS )
*
      IJKDO=IDIM1*JDIM1*KDIM1
      CALL GTSIZE( HHEADO,IJKDO )
*
* / cubic spline interpolation /
*
        DO 1300 J=1,JDIM1
        DO 1300 I=1,IDIM1
          N=0
          DO 1310 K=1,KDIM1
            IF(GDATA1(I,J,K).NE.VMISS) THEN
              N=N+1
              X(N)=AX1(K)
              Y(N)=GDATA1(I,J,K)
            ENDIF
 1310     CONTINUE
          CALL SPLINE(X,Y,N,1E31,1E31,Y2)
          DO 1320 K=1,KDIM1
            IJK=I+IDIM1*(J-1)+IDIM1*JDIM1*(K-1)
            AX=AX1(K)
            CALL SPLINT(X,Y,Y2,N,AX,NDIF,YB)
            GDATAO(IJK)=YB
 1320     CONTINUE
 1300   CONTINUE
*
      RETURN
*===========
      ENTRY SETPAR2(IAXE)
      IAX  = IAXE
      RETURN
*===========
      ENTRY SETDIF (NDIFE)
      NDIF=NDIFE
      RETURN
      END




************************************************************************
*(Original Source Location: /home/horinout/src/numrecipes/splin.f)
*
* NUMERICAL  RECIPES
*
*" 3.3  3次スプライン補間
*" subroutines  SPLINE  準備 ( Y2 = y" )
*"              SPLINT  補間  仮定: X(1)<X(2)<..<X(N) or X(1)>X(2)>..>X(N)
*" 95/02/01  Ver.3 一、二階微分値の計算ができる(NDIF で指定)。
*" [注意]  SPLINT の引数は Ver.1, Ver.2 と違う. (入力 NDIF を追加)
************************************************************************
      SUBROUTINE SPLINE
     I            ( X,Y,N,YP1,YPN,
     O              Y2 )
      IMPLICIT  REAL  (A-H,O-Z)
      PARAMETER (NMAX=200)
      DIMENSION X(N),Y(N), Y2(N), U(NMAX)
*
      IF(N.GT.NMAX) THEN
        WRITE(6,*) '***(SPLINE)*** NOT ENOUGH WORKING AREA SIZE NMAX'
        STOP
      ENDIF
*
      IF (YP1 .GT. .99E30) THEN !" the lower b.c. is set either to be "natural"
        Y2(1)=0.
        U(1)=0.
      ELSE
        Y2(1)=-0.5
        U(1)=(3./(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
      ENDIF
      DO 11 I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.
        Y2(I)=(SIG-1.)/P
        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     &       /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
   11 CONTINUE
      IF (YPN .GT. .99E30) THEN !" the upper b.c. is set either to be "natural"
        QN=0.
        UN=0.
      ELSE
        QN=0.5
        UN=(3./(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      ENDIF
      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)
      DO 12 K=N-1,1,-1
        Y2(K)=Y2(K)*Y2(K+1)+U(K)
   12 CONTINUE
      RETURN
      END
************************************************************************
* NDIF=0:simple interpolation, NDIF=1,2:d(YA)/d(XA),d^2(YA)/d(XA)^2
*
      SUBROUTINE SPLINT
     I            ( XA,YA,Y2A,N,X, NDIF,
     O              Y )
      IMPLICIT  REAL  (A-H,O-Z)
      DIMENSION XA(N),YA(N),Y2A(N)
*
      KLO=1
      KHI=N
    1  IF (KHI-KLO.GT.1) THEN
         K=(KHI+KLO)/2
         IF((XA(N).GT.XA(1)).EQV.(XA(K).GT.X)) THEN
           KHI=K
         ELSE
           KLO=K
         ENDIF
      GOTO 1
       ENDIF
      H=XA(KHI)-XA(KLO)
      IF (H.EQ.0.) THEN
        WRITE(6,*) '***(SPLINT)*** Bad XA input.'
        STOP
      ENDIF
      A=(XA(KHI)-X)/H
      B=(X-XA(KLO))/H
      IF (NDIF.NE.1 .AND. NDIF.NE.2) THEN
        Y=A*YA(KLO)+B*YA(KHI)+
     &     ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.
      ELSE IF (NDIF.EQ.1) THEN  !" 1st derivative
        Y=(YA(KHI)-YA(KLO))/H 
     &      - (3.*A*A-1.)/6.*H*Y2A(KLO) + (3.*B*B-1.)/6.*H*Y2A(KHI)
      ELSE IF (NDIF.EQ.2) THEN  !" 2nd derivative
        Y=A*Y2A(KLO)+B*Y2A(KHI)
      ENDIF
      RETURN
      END



**************************************************************
* 相対渦度 ---> 絶対渦度
**************************************************************
      SUBROUTINE CORIOL
     I         ( HHEAD , GDATA ,
     O           HHEADS, GDATAS,
     D           IXDIM , IYDIM , IZDIM )
*
      IMPLICIT NONE
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)           !" NCC, NDC, NED, NFILN
#else
#include         "gzsize.F"
#endif
*
      INTEGER    IXDIM, IYDIM, IZDIM
      CHARACTER  HHEAD  ( * ) *(*)
      CHARACTER  HHEADS ( * ) *(*)
      REAL       GDATA  ( IXDIM, IYDIM, IZDIM )
      REAL       GDATAS ( IXDIM, IYDIM, IZDIM )
      REAL       VMISS
*
      CHARACTER  HHEADA ( NDC ) * ( NCC )
      INTEGER    JMAX
      PARAMETER  ( JMAX=200 )
      REAL       AXIS ( JMAX )
      REAL       F    ( JMAX )

      INTEGER IEOD, J, K, I
      REAL    PI, OMEGA
*
      IF(IYDIM.GT.JMAX) THEN
        CALL MSGDMP('E','CORIOL','ARRAY IS TOO SMALL')
      ENDIF
*
      CALL GTSIZE(HHEADA, JMAX)
      CALL GUQAXV
     I     ( HHEAD , 2    , 'LOC' ,
     O       HHEADA, AXIS , IEOD   )
*
      PI     = ATAN ( 1. )*4.
      OMEGA  = 2. *PI / 86400.
      DO 2000 J=1, IYDIM
        F(J) = 2.*OMEGA*SIN(AXIS(J)*PI/180.) !" コリオリパラメータ
 2000 CONTINUE
*
      CALL GHPGET( HHEAD, 'MISS', VMISS )
*
      DO 6100 K=1,IZDIM
        DO 6200 J=1,IYDIM
          DO 6300 I=1,IXDIM
            IF ( GDATA( I, J, K ).NE.VMISS ) THEN
              GDATAS( I, J, K ) = GDATA( I, J, K ) + F ( J )
            ELSE 
              GDATAS( I, J, K ) = VMISS
            ENDIF
 6300     CONTINUE
 6200   CONTINUE
 6100 CONTINUE
*
      RETURN
      END


*********************************************************************
*" cp from gtdsph
*" ただし地球半径で割る部分を改良した。
*********************************************************************
      SUBROUTINE DSPHE
     I         ( HH    , GDATA , 
     O           HHF   , GDATAF,
     I           IDIMI , JDIMI , KDIMI )
*
      IMPLICIT NONE
      INTEGER    IDIMI, JDIMI, KDIMI
      CHARACTER  HH    ( * )*(*)             !" ヘッダー(入力)
      REAL       GDATA ( IDIMI*JDIMI*KDIMI )  !" データ(入力)
      CHARACTER  HHF   ( * )*(*)             !" ヘッダー(出力)
      REAL       GDATAF( IDIMI*JDIMI*KDIMI )  !" データ(出力)
*
      LOGICAL    LDX,DX  !" T: x 微分 (DY=Tの方が優先される)
      LOGICAL    LDY,DY  !" T: y 微分
      INTEGER    IWB,WB !"(cosφ)**WB の重みを微分前に掛ける
      INTEGER    IWA,WA !"(cosφ)**WA の重みを微分後に掛ける
      LOGICAL    LA,A  !" T: 地球半径で割る
      LOGICAL    LZONAL,ZONAL  !" T: 一番目の軸を y 軸とみなす(波数０成分用)
      SAVE       LDX,LDY,IWB,IWA,LA,LZONAL
*
      REAL       VMISS
      CHARACTER  HGRAD*4
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (gpainc)              !" /GPAWRK/
#else
#include         "gtsinc.F"
#include         "gpainc.F"
#endif
*"    COMMON /GPAWK?/ WDATA , ZDATA , ZWORK ,
*"                    PNM   , DPNM  , TRIGS , IFAX  ,
*"                    NMO   , GW    , COSLAT,
*"                    QPNM  , QDPNM , QGW   , QSINLA
*"    REAL ER / 6370.E3 /
*
*"         < 配列の次元 (incl.どこが y 軸 ?) >
*
      INTEGER IDIMS, JDIMS, KDIMS, IMAXS, JMAXS, KMAXS, JMXHF,
     &        LMAX, MINT, MMAX, NMAX, NMDIM,
     &        I, J, K, IJK

      IF(.NOT.LZONAL) THEN
        IDIMS=IDIMI
        JDIMS=JDIMI
        KDIMS=KDIMI
        IMAXS=2*(IDIMI/2) !" IDIMI が奇数なら IMAX=IDIMI-1 と仮定する
        JMAXS=JDIMI
        KMAXS=KDIMI
      ELSE
        IDIMS=1
        JDIMS=IDIMI
        KDIMS=JDIMI
        IMAXS=1
        JMAXS=IDIMI
        KMAXS=JDIMI
        IF(KDIMI.GT.1) CALL MSGDMP('E','DSPHE',
     +       '3D DATA CANNOT BE PROCESSED IF -ZONAL')
      ENDIF
*
*"         < 球関数の準備 >
*
      CALL GPASPW !" 作業配列の大きさを GPASPS に知らせる
     I         ( IDIM,JDIM,KDIM )
*
      CALL GPASPS !" 三角形切断しか扱えない！
     I         ( IMAXS , JMAXS , KMAXS , ER    ,
     O           PNM   , DPNM  , TRIGS , IFAX  ,
     O           NMO   , GW    , COSLAT,
     O           LMAX  , MMAX  , NMAX  , MINT  ,
     O           NMDIM , JMXHF ,
     W           QPNM  , QDPNM , QGW   , QSINLA         )
*
*"         < 微分前後の重み掛けなど >
*
**      IF (LA) THEN  !" 地球半径で割る   !" commented out by akahori
**        DO 100 J=1,JMAXS
**          GW(J)=GW(J)/ER
**  100   CONTINUE
**      ENDIF
**
      CALL GHPGET( HH,'MISS',VMISS )
      IF(IWB.NE.0) THEN
        DO 200 K=1,KDIMS
        DO 200 J=1,JDIMS
        DO 200 I=1,IDIMS
          IJK = I + (J-1)*IDIMS + (K-1)*IDIMS*JDIMS
          IF( GDATA(IJK).NE.VMISS ) THEN
            GDATA(IJK) = COSLAT(J)**(IWB) * GDATA(IJK)
          ENDIF
  200   CONTINUE
      ENDIF
*
*"         < 微分フラッグ >
*
      IF(LDY) THEN
        HGRAD='YGRA'
      ELSE IF(LDX) THEN
        HGRAD='XGRA'
      ELSE
        HGRAD='    '
      ENDIF
*
*"         < スペクトルに (微分も) >
*
      IF(.NOT.LZONAL) THEN
        CALL SPG2W
     M         ( WDATA ,
     I           GDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  , GW    ,
     F           '    ','POSO' ,
     D           IMAXS , JMAXS , KMAXS , IDIMS , JDIMS ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , ZWORK                                   )
      ELSE
        CALL SPG2WM
     M         ( WDATA ,
     I           GDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  , GW    ,
     F           '    ','POSO' ,
     D           IMAXS , JMAXS , KMAXS , IDIMS , JDIMS ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , ZWORK  ) !" in this subroutine ZDATA is dummy
      ENDIF
*
*"         < 格子点値に戻す >
*
      IF(.NOT.LZONAL) THEN
        IF(.NOT.LDY) THEN
          CALL SPW2G
     M         ( GDATAF,
     I           WDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  ,
     F           HGRAD , 'POS' ,
     D           IMAXS , JMAXS , KMAXS , IDIMS , JDIMS ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF , 
     W           ZDATA , ZWORK                                   )
        ELSE
          CALL SPW2G
     M         ( GDATAF,
     I           WDATA ,
     C           DPNM  , NMO   , TRIGS , IFAX  ,
     F           HGRAD , 'POSO' ,
     D           IMAXS , JMAXS , KMAXS , IDIMS , JDIMS ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF , 
     W           ZDATA , ZWORK                                   )
        ENDIF
      ELSE
        IF(.NOT.LDY) THEN
          CALL SPW2GM
     M         ( GDATAF,
     I           WDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  ,
     F           HGRAD , 'POS' ,
     D           IMAXS , JMAXS , KMAXS , IDIMS , JDIMS ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF , 
     W           ZDATA , ZWORK                                   )
        ELSE
          CALL SPW2GM
     M         ( GDATAF,
     I           WDATA ,
     C           DPNM  , NMO   , TRIGS , IFAX  ,
     F           HGRAD , 'POSO' ,
     D           IMAXS , JMAXS , KMAXS , IDIMS , JDIMS ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF , 
     W           ZDATA , ZWORK                                   )
        ENDIF
      ENDIF
*
      IF(LDY) THEN
        DO 400 K=1,KDIMS !"微分後の重み掛け
        DO 400 J=1,JDIMS
        DO 400 I=1,IDIMS
          IJK = I + (J-1)*IDIMS + (K-1)*IDIMS*JDIMS
          IF( GDATA(IJK).NE.VMISS ) THEN
            GDATAF(IJK) = COSLAT(J)**(IWA-1) * GDATAF(IJK)
          ENDIF
  400   CONTINUE
      ELSE
        DO 500 K=1,KDIMS !"微分後の重み掛け
        DO 500 J=1,JDIMS
        DO 500 I=1,IDIMS
          IJK = I + (J-1)*IDIMS + (K-1)*IDIMS*JDIMS
          IF( GDATA(IJK).NE.VMISS ) THEN
            GDATAF(IJK) = COSLAT(J)**(IWA) * GDATAF(IJK)
          ENDIF
  500   CONTINUE
      ENDIF

      IF (LA) THEN   !" 地球半径で割る   !" moved by akahori
        DO 1000 K=1,KDIMS
        DO 1000 J=1,JDIMS
        DO 1000 I=1,IDIMS
          IJK = I + (J-1)*IDIMS + (K-1)*IDIMS*JDIMS
          IF( GDATA(IJK).NE.VMISS ) THEN
            GDATAF(IJK) = GDATAF(IJK)/ER
          ENDIF
 1000   CONTINUE
      ENDIF

      RETURN
*===========
      ENTRY EDSPHE(DX,DY,WA,WB,A,ZONAL)
      LDX=DX
      LDY=DY
      IWA=WA
      IWB=WB
      LA=A
      LZONAL=ZONAL
*
      RETURN
      END



*********************************************************************
*" cp from gtu2vor
*********************************************************************
      SUBROUTINE U2VOR
     I         ( HU    , GDU,
     I           HV    , GDV,
     O           HVOR  , GDVOR,
     I           IMAX  , JMAX  , KMAX,
     I           IMAX2  , JMAX2  , KMAX2  )
*
      IMPLICIT NONE
      INTEGER    IMAX, JMAX, KMAX
      INTEGER    IMAX2, JMAX2, KMAX2
      CHARACTER  HU     ( * )*(*)        !" ヘッダー(入力)
      REAL       GDU    ( * )            !" データ(入力)
      CHARACTER  HV     ( * )*(*)        !" ヘッダー(入力)
      REAL       GDV    ( * )            !" データ(入力)
      CHARACTER  HVOR   ( * )*(*)        !" ヘッダー(出力)
      REAL       GDVOR  ( * )            !" データ(出力)
*
#include         "gzsize.F"
#include         "gtsinc.F"
#include         "gpainc.F"
*
      REAL  UVFACT ( IDIM*JDIM )
      REAL  WDVOR  ( NMDIMC*KDIM    )       !" スペクトルデータ
      REAL  GWDEL  ( JDIM )              !" 微分用のガウス荷重

      INTEGER JMXHF, LMAX, MINT, MMAX, NMAX, NMDIM,
     &        I, J, IJ, K, IJK 

*
*"         < 球関数の準備 >
*
      CALL GPASPW !" 作業配列の大きさを GPASPS に知らせる
     I         ( IDIM,JDIM,KDIM )
      CALL GPASPS
     I         ( IMAX  , JMAX  , KMAX  , ER    ,
     O           PNM   , DPNM  , TRIGS , IFAX  ,
     O           NMO   , GW    , COSLAT,
     O           LMAX  , MMAX  , NMAX  , MINT  ,
     O           NMDIM , JMXHF ,
     W           QPNM  , QDPNM , QGW   , QSINLA         )
*
*"         < Uファクター >
*
      DO 3210 J = 1, JMAX
        DO 3200 I = 1, IMAX
          IJ=IMAX*(J-1)+I
          UVFACT ( IJ ) = COSLAT(J)
 3200   CONTINUE
 3210 CONTINUE
*
*"         < 微分用のガウス荷重 >
*
      DO 3100 J = 1, JMAX
         GWDEL( J ) = QGW( J ) / ER / ( 1. - QSINLA(J)**2 )
 3100 CONTINUE
*
*"         < 1. ζ のスペクトル >
*
      DO 1100 K = 1, KMAX
         DO 1100 IJ = 1, IMAX*JMAX
           IJK=IMAX*JMAX*(K-1)+IJ
            GDU ( IJK ) = GDU ( IJK ) * UVFACT( IJ )
            GDV ( IJK ) = GDV ( IJK ) * UVFACT( IJ )
 1100 CONTINUE
*
      CALL SPG2W
     M         ( WDVOR ,
     I           GDU   ,
     C           DPNM  , NMO   , TRIGS , IFAX  , GWDEL ,
     F          'YGRA', 'POS ' ,
     D           IMAX  , JMAX  , KMAX  , IMAX  , JMAX  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , ZWORK                                   )
*
      IF ( MMAX .GE. 1 ) THEN
      CALL SPG2W
     M         ( WDVOR ,
     I           GDV   ,
     C           PNM   , NMO   , TRIGS , IFAX  , GWDEL ,
     F          'XGRA', 'ADD ' ,
     D           IMAX  , JMAX  , KMAX  , IMAX  , JMAX  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , ZWORK                                   )
      ENDIF
*
*"         < 格子点値に戻す >
*
      CALL SPW2G
     M         ( GDVOR ,
     I           WDVOR ,
     C           PNM   , NMO   , TRIGS , IFAX  ,
     F          '    ' , 'POS ',
     D           IMAX  , JMAX  , KMAX  , IMAX  , JMAX  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF , 
     W           ZDATA , ZWORK                                   )
*
      RETURN
      END






*******************************************************************
*"    Potential Vorticity 
*"  = - (g/Ps) * { - ∂ｖ/∂σ     * 1/(a cosφ) ∂θ/∂λ
*"                 + ∂ｕ/∂σ     * 1/a ∂θ/∂φ
*"                 + ( f + rotｖ ) * ∂θ/∂σ             }
*"      rot ｖ ≡ 1/(a cosφ){∂ｖ/∂λ - ∂(cosφ ｕ)/∂λ}
*"      単位は PVU = 10^{-6} m^2 K / ( kg s )
*******************************************************************
           SUBROUTINE PTLVOR
     I          ( GPS    ,
     I            GUS    ,
     I            GVS    ,
     I            GVOR   ,
     I            GTHETAS,
     I            GTHETAX,
     I            GTHETAY,
     O            GPV    ,
     I            IMAX, JMAX, KMAX )
      IMPLICIT NONE
*
      INTEGER    IMAX, JMAX, KMAX
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
*"[入出力データの領域確保]
      REAL  GPS     (IMAX*JMAX)
      REAL  GUS     (IMAX*JMAX, KMAX)
      REAL  GVS     (IMAX*JMAX, KMAX)
      REAL  GVOR    (IMAX*JMAX, KMAX)
      REAL  GTHETAS (IMAX*JMAX, KMAX)
      REAL  GTHETAX (IMAX*JMAX, KMAX)
      REAL  GTHETAY (IMAX*JMAX, KMAX)
      REAL  GPV     (IMAX*JMAX, KMAX)
*
      REAL PVX, PVY, PVZ
      REAL  G
      DATA  G / 9.8 /
*
      INTEGER IJ, K

      DO 10 K  = 1, KMAX
      DO 10 IJ = 1, IMAX*JMAX
        PVX = - GVS(IJ,K) * GTHETAX(IJ,K)
        PVY =   GUS(IJ,K) * GTHETAY(IJ,K)
        PVZ =   GVOR(IJ,K)* GTHETAS(IJ,K)
        GPV(IJ,K) = - G / ( GPS(IJ) * 1E2 ) * ( PVX+PVY+PVZ ) * 1E6
   10 CONTINUE
*
      RETURN
      END

*"表題 第２次元の格子選択 GTOOL3(GPYSEL)
*
*"履歴 90/08/17 沼口  敦
*
*
*********************************************************************
*"         << 第２次元の格子選択 >>
*********************************************************************
      SUBROUTINE GPYSEL
     I         ( HHEAD , GDATA , IYSEL  ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO          )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IYSEL                   !" 選択する第2次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HITM        *(NCC)
      CHARACTER  HAXIS       *(NCC)
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
      LOGICAL    OCYCL                   !" サイクリックか？
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IZDIM )
*
      CALL GHCGET( HHEAD, 'AITM2', HAXIS )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
*"         < 2. データ詰め替え >
*
      IF ( OCYCL ) THEN
         IYI = MOD( IYSEL-IYSTR, IADIM ) + 1
      ELSE
         IYI = IYSEL-IYSTR+1
      ENDIF
*
      IF ( ( 1.LE.IYI ).AND.( IYI.LE.IYDIM ) ) THEN
         DO 2100 IZ = 1, IZDIM
            CALL VRSET
     I       ( GDATA ( IXDIM*IYDIM*(IZ-1) + IXDIM*(IYI-1) + 1 ),
     O         GDATAO( IXDIM*(IZ-1) + 1 ),
     I         IXDIM  , 1    , 1                                 )
 2100    CONTINUE
      ELSE
         CALL GHPGET( HHEAD , 'MISS', VMISS )
         CALL RSET  ( GDATAO, IXDIM*IZDIM, VMISS )
      ENDIF
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHCGET ( HHEAD , 'AITM3', HITM  )
      CALL GHCSET ( HHEADO, 'AITM2', HITM  )
      CALL GHPSET ( HHEADO, 'ASTR2', IZSTR )
      CALL GHPSET ( HHEADO, 'AEND2', IZEND )
      CALL GHCSET ( HHEADO, 'AITM3', ' '   )
      CALL GHPSET ( HHEADO, 'ASTR3', 1     )
      CALL GHPSET ( HHEADO, 'AEND3', 1     )
*
      IF ( ( IYSTR .EQ. IYSEL ).AND.( IYEND .EQ. IYSEL ) ) RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAXIS , 'YS'   , '-select',
     I                 IYSEL , IYSEL  ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第２次元の格子選択 >>
*********************************************************************
      SUBROUTINE GMYSEL
     M         ( HHEAD , GDATA ,
     I           IYSEL ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IYSEL                   !" 選択する第2次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPYSEL
     I         ( HHEAD , GDATA , IYSEL  ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW          )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

* PACKAGE USPHEZ  !" 球面調和関数変換 (南北1次元) GCM5(USPHEZ)
*
*"  [HIS] !" 90/08/31(numaguti)
*
**********************************************************************
      SUBROUTINE SPW2GM    !" 球面調和関数変換 (スペクトル→格子)
     M         ( GDATA ,
     I           WDATA ,
     C           PNM   , NMO   , TRIGS , IFAX ,
     F           HGRAD , HFUNC ,
     D           IMAX  , JMAX  , KMAX  , IDIM  , JDIM  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , WORK                                    )
*
*   [PARAM] 
      INTEGER    IMAX
      INTEGER    JMAX
      INTEGER    KMAX
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    LMAX
      INTEGER    MMAX
      INTEGER    NMAX
      INTEGER    MINT
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [MODIFY] 
      REAL       GDATA ( IDIM*JDIM, KMAX )    !" 格子点データ
*
*   [INPUT] 
      REAL       WDATA ( NMDIM, KMAX     )    !" スペクトルデータ
*
      REAL       PNM   ( NMDIM, JMXHF )       !" ルジャンドル関数
      INTEGER    NMO   ( 2, 0:MMAX , 0:LMAX ) !" スペクトルの添字順番
      REAL       TRIGS ( * )                  !" 三角関数表
      INTEGER    IFAX  ( * )                  !" IMAX の因数分解
*
      CHARACTER  HGRAD*4                      !" 微分フラグ
      CHARACTER  HFUNC*4                      !" 符号フラグ
*
*   [WORK] 
      REAL       ZDATA ( IDIM*JDIM, KMAX )    !" 東西スペクトル
      REAL       WORK  ( IDIM*JDIM, KMAX )    !" ワーク
*
*   [INTERNAL WORK] 
      LOGICAL    LDPNM                        !" ｙ微分フラグ
      LOGICAL    LOFFS                        !" オフセットフラグ
      INTEGER    KMAXD
      PARAMETER (KMAXD=100)
      REAL       DOFFS ( KMAXD )              !" オフセット値
      INTEGER    J, K
*
*
      IF ( IMAX .NE. 1 ) THEN
         CALL MSGDMP( 'E','SPW2G','THIS ROUTINE IS FOR AXSYMMETRIC')
      ENDIF
*
      IF ( HFUNC(4:4) .EQ. 'O' ) THEN
         LOFFS = .TRUE.
         IF ( KMAXD .LT. KMAX ) THEN
            CALL MSGDMP( 'E','SPW2G','INSUFFICIENT WORK STRAGE')
         ENDIF
      ELSE
         LOFFS = .FALSE.
      ENDIF
*
      IF ( HGRAD(1:1) .EQ. 'X' ) THEN
*
*"         < 1. ｘ微分 = 0 >
*
          CALL RESET ( WORK , IDIM*JDIM*KMAX )
          LOFFS = .FALSE.
*
      ELSE
*
*"         < 2. LDPNM : ｙ微分のフラグ >
*
         IF ( HGRAD(1:1) .EQ. 'Y' ) THEN
            LDPNM = .TRUE.
            LOFFS = .FALSE.
         ELSE
            LDPNM = .FALSE.
         ENDIF
*
*"         < 3. スペクトル → [ zonal mean ] value >
*
*
         IF ( LOFFS ) THEN
            DO 3000 K = 1, KMAX
               DOFFS( K ) = WDATA( NMO(1,0,0), K )
               WDATA( NMO(1,0,0), K ) = 0.  
 3000       CONTINUE
         ENDIF
*
         CALL SPW2ZM
     O           ( WORK  ,
     I             WDATA ,
     C             PNM   , NMO   ,
     F             LDPNM ,
     D             JMAX  , KMAX  , JDIM  ,
     D             LMAX  , NMAX  , NMDIM , JMXHF ,
     W             ZDATA                           )
*
      ENDIF
*
      IF ( LOFFS ) THEN
         DO 3100 K = 1, KMAX
            WDATA( NMO(1,0,0), K ) = DOFFS( K )
 3100    CONTINUE
*
         DO 3200 K = 1, KMAX
#ifdef SYS_SX3
*vdir noloopchg
#endif
            DO 3200 J = 1, JDIM
               WORK ( J,K ) = WORK ( J,K ) + DOFFS( K )
 3200    CONTINUE
      ENDIF
*
*"         < 5. 出力データ >
*
      IF      ( HFUNC(1:1) .EQ. 'A' ) THEN
*
*"                               ( add )
        DO 5000 K = 1, KMAX
           DO 5000 J = 1, JDIM
                  GDATA ( J,K ) = GDATA( J,K ) + WORK( J,K )
 5000   CONTINUE
*
      ELSE IF ( HFUNC(1:1) .EQ. 'S' ) THEN
*
*"                               ( sub )
        DO 5100 K = 1, KMAX
          DO 5100 J = 1, JDIM
                  GDATA ( J,K ) = GDATA( J,K ) - WORK( J,K )
 5100   CONTINUE
*
      ELSE IF ( HFUNC(1:1) .EQ. 'N' ) THEN
*
*"                               ( negative )
        DO 5200 K = 1, KMAX
          DO 5200 J = 1, JDIM
                  GDATA ( J,K ) = - WORK( J,K )
 5200   CONTINUE
*
      ELSE
*"                               ( positive )
        DO 5300 K = 1, KMAX
          DO 5300 J = 1, JDIM
                  GDATA ( J,K ) = WORK( J,K )
 5300   CONTINUE
*
      ENDIF
*
      RETURN
      END
**********************************************************************
      SUBROUTINE SPG2WM    !" 球面調和関数変換 (格子→スペクトル)
     M         ( WDATA ,
     I           GDATA ,
     C           PNM   , NMO   , TRIGS , IFAX , GW   ,
     F           HGRAD , HFUNC ,
     D           IMAX  , JMAX  , KMAX  , IDIM  , JDIM  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , WORK                                   )
*
*   [PARAM] 
      INTEGER    IMAX
      INTEGER    JMAX
      INTEGER    KMAX
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    LMAX
      INTEGER    MMAX
      INTEGER    NMAX
      INTEGER    MINT
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [MODIFY] 
      REAL       WDATA ( NMDIM, KMAX     )    !" スペクトルデータ
*
*   [INPUT] 
      REAL       GDATA ( IDIM*JDIM, KMAX )    !" 格子点データ
*
      REAL       PNM   ( NMDIM, JMXHF )       !" ルジャンドル関数
      INTEGER    NMO   ( 2, 0:MMAX , 0:LMAX ) !" スペクトルの添字順番
      REAL       GW    ( JDIM )               !" ガウス荷重
      REAL       TRIGS ( * )                  !" 三角関数表
      INTEGER    IFAX  ( * )                  !" IMAX の因数分解
*
      CHARACTER  HGRAD*4                      !" 微分フラグ
      CHARACTER  HFUNC*4                      !" 符号フラグ
*
*   [WORK] 
      REAL       ZDATA ( IDIM*JDIM, KMAX )    !" 東西スペクトル
      REAL       WORK  ( IDIM*JDIM, KMAX )    !" ワーク
*
*   [INTERNAL WORK] 
      LOGICAL    LDPNM                        !" ｙ微分フラグ
      LOGICAL    LOFFS                        !" オフセットフラグ
      INTEGER    KMAXD
      PARAMETER (KMAXD=100)
      REAL       DOFFS ( KMAXD )              !" オフセット値
      INTEGER    J, K
*
      IF ( IMAX .NE. 1 ) THEN
         CALL MSGDMP( 'E','SPG2W','THIS ROUTINE IS FOR AXSYMMETRIC')
      ENDIF
*
      IF ( HFUNC(4:4) .EQ. 'O' ) THEN
         LOFFS = .TRUE.
         IF ( KMAXD .LT. KMAX ) THEN
            CALL MSGDMP( 'E','SPG2W','INSUFFICIENT WORK STRAGE')
         ENDIF
      ELSE
         LOFFS = .FALSE.
      ENDIF
*
      IF ( HGRAD(1:1) .EQ. 'X' ) THEN
*
*"         < 1. ｘ微分 = 0 >
*
         IF (      ( HFUNC(1:1) .NE. 'A' )
     &        .AND.( HFUNC(1:1) .NE. 'S' )    ) THEN
            CALL RESET ( WDATA , NMDIM*KMAX )
*
         ENDIF
*
      ELSE
*
*"         < 2. LDPNM : ｙ微分のフラグ >
*
         IF ( HGRAD(1:1) .EQ. 'Y' ) THEN
            LDPNM = .TRUE.
            LOFFS = .FALSE.
         ELSE
            LDPNM = .FALSE.
         ENDIF
*
*
*"         < 3. [ zonal mean ] wave → スペクトル >
*
         IF ( LOFFS ) THEN
            DO 3000 K = 1, KMAX
               DOFFS ( K ) = GDATA( 1,K )
#ifdef SYS_SX3
*vdir noloopchg
#endif
               DO 3020 J = 1, JDIM
                  GDATA( J,K ) = GDATA( J,K ) - DOFFS( K )
 3020          CONTINUE
 3000       CONTINUE
         ENDIF
*
         CALL SPZ2WM
     M           ( WDATA ,
     I             GDATA ,
     C             PNM   , NMO   , GW    ,
     F             LDPNM , HFUNC ,
     D             JMAX  , KMAX  , JDIM  ,
     D             LMAX  , NMAX  , NMDIM , JMXHF ,
     W             WORK                            )
*
         IF ( LOFFS ) THEN
            IF (      ( HFUNC(1:1) .EQ. 'N' )
     &           .OR. ( HFUNC(1:1) .EQ. 'S' )    ) THEN
               DO 3100 K = 1, KMAX
                  WDATA( NMO(1,0,0),K ) = WDATA( NMO(1,0,0),K )
     &                                  - DOFFS( K )
 3100          CONTINUE
            ELSE
               DO 3200 K = 1, KMAX
                  WDATA( NMO(1,0,0),K ) = WDATA( NMO(1,0,0),K )
     &                                  + DOFFS( K )
 3200          CONTINUE
            ENDIF
*
            DO 3300 K = 1, KMAX
               DO 3300 J = 1, JDIM
                  GDATA( J,K ) = GDATA( J,K ) + DOFFS( K )
 3300       CONTINUE
         ENDIF
*
      ENDIF
*
      RETURN
      END
**********************************************************************
      SUBROUTINE SPW2ZM    !" ルジャンドル変換 (スペクトル→格子)
     O         ( ZDATA   ,
     I           WDATA ,
     C           PNM   , NMO   ,
     F           LDPNM ,
     D           JMAX  , KMAX  , JDIM  ,
     D           LMAX  , NMAX  , NMDIM , JMXHF ,
     W           ZDW                            )
*
*   [PARAM] 
      INTEGER    JMAX
      INTEGER    KMAX
      INTEGER    JDIM
      INTEGER    LMAX
      INTEGER    NMAX
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [OUTPUT] 
      REAL       ZDATA ( JDIM, KMAX    )      !" 東西スペクトル
*
*   [INPUT] 
      REAL       WDATA ( NMDIM, KMAX   )      !" スペクトル
*
      REAL       PNM   ( NMDIM, JMXHF )       !" ルジャンドル関数
      INTEGER    NMO   ( 2, 0:LMAX )          !" スペクトルの添字順番
*
      LOGICAL    LDPNM                        !" ｙ微分フラグ
*
*   [WORK] 
      REAL       ZDW   ( JDIM, KMAX )         !" ワーク
*
*   [INTERNAL ONCE] 
      INTEGER    NMDIMD
      PARAMETER (NMDIMD=500)
      INTEGER    JLIST ( NMDIMD )             !" リストベクトル
      LOGICAL    OLSET
      DATA       OLSET / .FALSE. /
      SAVE       JLIST, OLSET
*
*   [INTERNAL WORK] 
      INTEGER    NM, K, L, LEND
      INTEGER    J, JP, JN, JS, JE, JO
*
*"         < 0. リストベクトル作成 >
*
*   [ONCE] 
      IF ( .NOT. OLSET ) THEN
        OLSET = .TRUE.
*
        IF ( NMDIMD .LT. NMDIM ) THEN
            CALL MSGDMP( 'E','SPW2ZM','INSUFFICIENT WORK STRAGE')
        ENDIF
*
        LEND = MIN ( LMAX, NMAX )
*
        DO 100 L = 0, LEND
*
          IF ( MOD( L,2 ) .EQ. 0 ) THEN
            JLIST (  NMO ( 1,L )  ) = 0
          ELSE
            JLIST (  NMO ( 1,L )  ) = JMAX / 2
          ENDIF
*
  100   CONTINUE
*
      ENDIF
*
*"         < 1. 作業領域リセット >
*
      CALL RESET ( ZDW  , JDIM*KMAX )
      CALL RESET ( ZDATA, JDIM*KMAX )
*
*"         < 2.  ルジャンドル変換 >
*
      DO 2300 NM = 1 , NMDIM
         DO 2200 K = 1 , KMAX
#ifdef SYS_HITAC
*VOPTION INDEP(ZDW)
#endif
#ifdef SYS_SX3
*vdir nodep(ZDW)
#endif
            DO 2100 J = 1 , JMAX/2
               JP = JLIST( NM ) + J
*
               ZDW( JP,K ) = ZDW( JP,K  )
     &                        +  PNM  ( NM,J  )
     &                         * WDATA( NM,K  )
 2100       CONTINUE
 2200    CONTINUE
 2300 CONTINUE
*
*"         < 3. 対称・反対称成分 → 通常の並び >
*
      DO 3200 J = 1 , JMAX/2
        JN = J
        JS = JMAX+1 - J
        IF ( .NOT. LDPNM ) THEN
*"                                (  PNM を用いる場合 )
          JE = J
          JO = JMAX/2 + J
        ELSE
*"                                ( DPNM を用いる場合 )
          JE = JMAX/2 + J
          JO = J
        ENDIF
*
        DO 3100 K = 1 , KMAX
          ZDATA( JN,K ) = ZDW( JE,K ) + ZDW( JO,K )
          ZDATA( JS,K ) = ZDW( JE,K ) - ZDW( JO,K )
 3100   CONTINUE
 3200 CONTINUE
*
*
      RETURN
      END
**********************************************************************
      SUBROUTINE SPZ2WM    !" ルジャンドル変換 (格子→スペクトル)
     M         ( WDATA ,
     I           ZDATA   ,
     C           PNM   , NMO   , GW    ,
     F           LDPNM , HFUNC ,
     D           JMAX  , KMAX  , JDIM  ,
     D           LMAX  , NMAX  , NMDIM , JMXHF ,
     W           ZDW                             )
*
*   [PARAM] 
      INTEGER    JMAX
      INTEGER    KMAX
      INTEGER    JDIM
      INTEGER    LMAX
      INTEGER    NMAX
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [MODIFY] 
      REAL       WDATA ( NMDIM, KMAX   )      !" スペクトル
*
*   [INPUT] 
      REAL       ZDATA ( JDIM, KMAX    )      !" 東西スペクトル
*
      REAL       PNM   ( NMDIM, JMXHF )       !" ルジャンドル関数
      INTEGER    NMO   ( 2, 0:LMAX )          !" スペクトルの添字順番
      REAL       GW    ( JDIM )               !" ガウス荷重
*
      LOGICAL    LDPNM                        !" ｙ微分フラグ
      CHARACTER  HFUNC*4                      !" 符号フラグ
*
*   [WORK] 
      REAL       ZDW   ( JDIM, KMAX )         !" ワーク
*
*   [INTERNAL ONCE] 
      INTEGER    NMDIMD
      PARAMETER (NMDIMD=4000)
      INTEGER    JLIST ( NMDIMD )             !" リストベクトル
      LOGICAL    OLSET
      DATA       OLSET / .FALSE. /
      SAVE       JLIST, OLSET
*
*   [INTERNAL WORK] 
      INTEGER    NM, K, L, LEND
      INTEGER    J, JP, JN, JS, JE, JO
*
*"         < 0. リストベクトル作成 >
*
*   [ONCE] 
      IF ( .NOT. OLSET ) THEN
        OLSET = .TRUE.
*
        IF ( NMDIMD .LT. NMDIM ) THEN
           CALL MSGDMP( 'E','SPZ2WM','INSUFFICIENT WORK STRAGE')
        ENDIF
*
        LEND = MIN ( LMAX, NMAX )
*
        DO 100 L = 0, LEND
*
          IF ( MOD( L,2 ) .EQ. 0 ) THEN
            JLIST (  NMO ( 1,L )  ) = 0
          ELSE
            JLIST (  NMO ( 1,L )  ) = JMAX / 2
          ENDIF
*
  100   CONTINUE
*
      ENDIF
*
*
      IF (      ( HFUNC(1:1) .NE. 'A' )
     &     .AND.( HFUNC(1:1) .NE. 'S' )    ) THEN
*
*"                 < 1. 和差をとらないときリセット >
*
        CALL RESET ( WDATA, NMDIM*KMAX )
      ENDIF
*
*"         < 2. ガウス荷重をかける >
*"              ( 通常の並び → 対称・反対称成分 )
*
      DO 2200 J = 1 , JMAX/2
*
        JN = J
        JS = JMAX+1 - J
        IF ( .NOT. LDPNM ) THEN
*"                                (  PNM を用いる場合 )
          JE = J
          JO = JMAX/2 + J
        ELSE
*"                                ( DPNM を用いる場合 )
          JE = JMAX/2 + J
          JO = J
        ENDIF
*
        DO 2100 K = 1 , KMAX
          ZDW( JE,K ) = GW ( J ) *
     &                      ( ZDATA( JN,K ) + ZDATA( JS,K ) )
          ZDW( JO,K ) = GW ( J ) *
     &                      ( ZDATA( JN,K ) - ZDATA( JS,K ) )
 2100   CONTINUE
 2200 CONTINUE
*
*
      IF (      ( HFUNC(1:1) .EQ. 'N' )
     &     .OR. ( HFUNC(1:1) .EQ. 'S' )    ) THEN
*
*"         < 3. ルジャンドル変換−負のとき   >
*
        DO 3300 J = 1 , JMAX/2
          DO 3200 K = 1 , KMAX
            DO 3100 NM = 1 , NMDIM
*
              JP = JLIST( NM ) + J
*
              WDATA( NM,K )  = WDATA( NM,K   )
     &                       -  PNM ( NM,J   )
     &                           * ZDW( JP,K )
 3100       CONTINUE
 3200     CONTINUE
 3300   CONTINUE
*
      ELSE
*
*"         < 4. ルジャンドル変換−正のとき   >
*
        DO 4300 J = 1 , JMAX/2
          DO 4200 K = 1 , KMAX
            DO 4100 NM = 1 , NMDIM
*
              JP = JLIST( NM ) + J
*
              WDATA( NM,K )  = WDATA( NM,K   )
     &                       +  PNM ( NM,J   )
     &                           * ZDW( JP,K )
 4100       CONTINUE
 4200     CONTINUE
 4300   CONTINUE
*
      ENDIF
*
      RETURN
      END

*"表題 データ同士の差 GTOOL3(GPFSUB)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << データ同士の差 >>
*********************************************************************
      SUBROUTINE GPFSUB
     I         ( HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD1 ( * )*(*)        !" ヘッダー(入力1)
      REAL       GDATA1 ( * )            !" データ(入力1)
      CHARACTER  HHEAD2 ( * )*(*)        !" ヘッダー(入力2)
      REAL       GDATA2 ( * )            !" データ(入力2)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 軸のチェック >
*
      CALL GUSMIS ( HHEAD1 )
*
      CALL GUAXCK
     I         ( HHEAD1, HHEAD2,
     O           ICHK            )
      IF ( ICHK .NE. 0 ) THEN
         CALL MSGDMP('W', 'GPFSUB', 'AXES DO NOT AGREE.' )
      ENDIF
*
*"         < 2. 大きさの取得 >
*
      CALL GUCSIZ
     I         ( HHEAD1, HHEAD2,
     O           IXSTR1, IXDIM1, IXSTR2, IXDIM2,
     O           IYSTR1, IYDIM1, IYSTR2, IYDIM2,
     O           IZSTR1, IZDIM1, IZSTR2, IZDIM2,
     O           IXSTRC, IXENDC, IXDIMC,
     O           IYSTRC, IYENDC, IYDIMC,
     O           IZSTRC, IZENDC, IZDIMC          )
*
      CALL GUSZCK ( HHEADO, IXDIM1*IYDIM1*IZDIM1 )
*
*"         < 3. データ演算 >
*
      CALL GHPGET ( HHEAD1, 'MISS', VMISS )
      CALL RSET   ( GDATAO, IXDIM1*IYDIM1*IZDIM1, 1, VMISS )
*
      DO 3100 IZ = IZSTRC, IZENDC
         DO 3110 IY = IYSTRC, IYENDC
            CALL VRSUB
     I     ( GDATA1( IXDIM1*IYDIM1*(IZ-IZSTR1)
     I                    + IXDIM1*(IY-IYSTR1) + IXSTRC-IXSTR1+1 ),
     I       GDATA2( IXDIM2*IYDIM2*(IZ-IZSTR2)
     I                    + IXDIM2*(IY-IYSTR2) + IXSTRC-IXSTR2+1 ),
     O       GDATAO( IXDIM1*IYDIM1*(IZ-IZSTR1)
     O                    + IXDIM1*(IY-IYSTR1) + IXSTRC-IXSTR1+1 ),
     I       IXDIMC, 1  , 1  , 1                                   )
 3110    CONTINUE
 3100 CONTINUE
*
*"         < 4. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD1, HHEADO )
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << データ同士の差 >>
*********************************************************************
      SUBROUTINE GMFSUB
     M         ( HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD1 ( * )*(*)        !" ヘッダー(入力1)
      REAL       GDATA1 ( * )            !" データ(入力1)
      CHARACTER  HHEAD2 ( * )*(*)        !" ヘッダー(入力2)
      REAL       GDATA2 ( * )            !" データ(入力2)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPFSUB
     I         ( HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD1, GDATA1  )
*
      RETURN
      END

*"表題 時間平均 GTOOL3(GPTAVG)
*
*"履歴 90/09/15 沼口  敦
*
*
*********************************************************************
*"         << 時間平均への足し込み >>
*********************************************************************
      SUBROUTINE GPTAVG
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     M           HHEADW, WDATA ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADW ( * )*(*)        !" ヘッダー(ワーク)
      REAL       WDATA  ( * )            !" ウェイトカウンター
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HUTIM       *(NCC)
      CHARACTER  HTIME       *(NCC)
      CHARACTER  HETTLD      *(NCC)
      CHARACTER  HRSMRK      *(NCC)
      CHARACTER  HITEM       *(NCC)
*
      DATA       HRSMRK / '%%RESET:GPTAVG%%' /
      SAVE       HRSMRK
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADW, IXDIM*IYDIM*IZDIM )
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 2. 初期設定 >
*
      CALL GHCGET ( HHEADO, 'ITEM', HITEM )
      IF ( HITEM .EQ. HRSMRK ) THEN
         CALL GUVINT( GDATAO, WDATA, IXDIM*IYDIM*IZDIM )
*
         CALL GHCOPY ( HHEAD, HHEADO )
*
         CALL GUQTIM ( HHEAD , RT    , HUTIM  )
         NHU = LENC( HUTIM )
         CALL CHVAL  ( 'D'   , RT    , HTIME  )
         NHT = LENC( HTIME )
         HETTLD = HTIME(1:NHT)//HUTIM(1:NHU)//'-'
*
         IF      ( HEDIT .EQ. ' ' ) THEN
            CALL GHEADD ( HHEADO, 'TM' , HETTLD )
         ELSE IF ( HEDIT .NE. 'NUL' ) THEN
            CALL GHEADD ( HHEADO, HEDIT, HETTL  )
         ENDIF
      ENDIF
*
*"         < 3. データを入れる >
*
      CALL GHPGET( HHEAD, 'TDUR', ITDUR  )
*
      CALL  GUVDIN
     M    ( GDATAO, WDATA ,
     I      IXDIM*IYDIM*IZDIM, 1   ,
     I      GDATA , REAL(ITDUR)     )
*
      CALL GHPGET( HHEAD , 'TIME' , ITIME )
      CALL GHPSET( HHEADO, 'TIME' , ITIME )
      CALL GHCGET( HHEAD , 'DATE' , HTIME )
      CALL GHCSET( HHEADO, 'DATE' , HTIME )
*
      RETURN
*====================================================================
*"         << 時間平均のリセット >>
*====================================================================
      ENTRY       GPTAVR
     O          ( HHEADO )
*
      CALL GHCSET( HHEADO, 'ITEM' , HRSMRK )
*
      RETURN
      END
*********************************************************************
*"         << 時間平均の算出 >>
*********************************************************************
      SUBROUTINE GPTAVO
     I         ( HHEADW, WDATA  ,
     M           HHEADO, GDATAO  )
*
      CHARACTER  HHEADW ( * )*(*)        !" ヘッダー(ワーク)
      REAL       WDATA  ( * )            !" ウェイトカウンター
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEADO )
*
      CALL GUQSIZ
     I         ( HHEADO,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
*"         < 2. 平均算出 >
*
      CALL GUVOUT
     M     ( GDATAO,
     I       WDATA , IXDIM*IYDIM*IZDIM )
*
*"         < 3. ヘッダー書き換え >
*
      TDUR = RMAX( WDATA , IXDIM*IYDIM*IZDIM, 1 )
      CALL GHPSET( HHEADO, 'TDUR', INT(TDUR)  )
*
      RETURN
      END

* PACKAGE GTEDY   !" eddy
**************************************************************************
      PROGRAM GTEDY
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      PARAMETER  ( RUNDEF=-999., IUNDEF=-999 )
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       IFILP / 51 /
      DATA       JFILE / 60 /
*
      LOGICAL    X, Y, Z
      DATA       X, Y, Z / .TRUE.,.FALSE.,.FALSE. /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ X, Y, Z, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, 
     &                   GRESET, HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
      CALL GFOOPN ( JFILE,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      II = 0
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD.EQ.0 ) THEN
*
               II = II + 1
*
                  IF ( Z ) THEN
                     CALL GMZEDY
     M               ( HHEAD , GDATA ,
     I                 EDIT  , ETTL  )
                  ENDIF
                  IF ( Y ) THEN
                     CALL GMYEDY
     M               ( HHEAD , GDATA ,
     I                 EDIT  , ETTL  )
                  ENDIF
                  IF ( X  ) THEN
                     CALL GMXEDY
     I               ( HHEAD , GDATA ,
     I                 EDIT  , ETTL  )
                  ENDIF
*
                  IF ( ITEM .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'ITEM', ITEM )
                  ENDIF
                  IF ( UNIT .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'UNIT', UNIT )
                  ENDIF
                  IF ( TITLE .NE. ' ' ) THEN
                     CALL GHCSTS( HHEAD , 'TITL', TITLE )
                  ENDIF
                  IF ( DSET .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'DSET', DSET )
                  ENDIF
                  IF ( GRESET ) THEN
                     CALL GHRSGP( HHEAD  )
                  ENDIF
*
                  CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END

*"表題 第３次元の格子選択 GTOOL3(GPZSEL)
*
*"履歴 90/08/17 沼口  敦
*
*
*********************************************************************
*"         << 第３次元の格子選択 >>
*********************************************************************
      SUBROUTINE GPZSEL
     I         ( HHEAD , GDATA , IZSEL  ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO          )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IZSEL                   !" 選択する第3次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS       *(NCC)
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
      LOGICAL    OCYCL                   !" サイクリックか？
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM )
*
      CALL GHCGET( HHEAD, 'AITM3', HAXIS )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
*"         < 2. データ詰め替え >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
*
      IF ( OCYCL ) THEN
         IZI = MOD( IZSEL-IZSTR, IADIM ) + 1
      ELSE
         IZI = IZSEL-IZSTR+1
      ENDIF
*
      IF ( ( 1.LE.IZI ).AND.( IZI.LE.IZDIM ) ) THEN
         CALL VRSET
     I      ( GDATA ( IXDIM*IYDIM*(IZI-1) + 1 ),
     O        GDATAO ,
     I        IXDIM*IYDIM  , 1    , 1                 )
      ELSE
         CALL GHPGET( HHEAD , 'MISS', VMISS )
         CALL RSET  ( GDATAO, IXDIM*IYDIM, VMISS )
      ENDIF
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHCSET ( HHEADO, 'AITM3', ' '    )
      CALL GHPSET ( HHEADO, 'ASTR3', 1      )
      CALL GHPSET ( HHEADO, 'AEND3', 1      )
*
      IF ( ( IZSTR .EQ. IZSEL ).AND.( IZEND .EQ. IZSEL ) ) RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAXIS , 'ZS'   , '-select',
     I                 IZSEL , IZSEL  ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第３次元の格子選択 >>
*********************************************************************
      SUBROUTINE GMZSEL
     M         ( HHEAD , GDATA ,
     I           IZSEL ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IZSEL                   !" 選択する第3次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPZSEL
     I         ( HHEAD , GDATA , IZSEL  ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW          )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 第１次元の平均を引く GTOOL3(GPXEDY)
*
*"履歴 90/09/06 沼口  敦
*"     92/08/28 竹広真一
*"     96/10/14 石渡正樹
*
*********************************************************************
*"         << 第１次元の平均を引く >>
*********************************************************************
      SUBROUTINE GPXEDY
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS         *(NCC)
      CHARACTER  HETTLD        *(NCC)
*
#ifdef SYS_IBMS
      INCLUDE   (GZIWRK)                     !" NW: 軸ワークの大きさ
#else
#include        "gziwrk.F"                   !" NW: 軸ワークの大きさ
#endif
      CHARACTER  HHEADX ( NDC )*(NCC)
      REAL       AWGTX  ( NW )
      REAL       WW     ( NW )
      LOGICAL    OSUBCK
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 2. Δｘの取得 >
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HHEADX  ,  NW     )
      CALL GUQAXV
     I            ( HHEAD , 1     , 'WGT'  ,
     O              HHEADX, AWGTX , IEOD     )
      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
*"         < 3. データ平均( 重みつき ) >
*
      CALL GUSZCZ ( NW    , IYDIM  )
*
      DO 3100 IZ = 1, IZDIM
*
         CALL GUVINT( GDATAO( IXDIM*IYDIM*(IZ-1)+1 ), WW, IYDIM )
         DO 3110 IX = 1, IXDIM
            CALL GUVDIN( GDATAO( IXDIM*IYDIM*(IZ-1)+1 ), WW, 
     &                   IYDIM, IXDIM,
     &                   GDATA ( IX+IXDIM*IYDIM*(IZ-1) ),
     &                   AWGTX ( IX )                               )
 3110    CONTINUE
         CALL GUVOUT( GDATAO( IXDIM*IYDIM*(IZ-1)+1 ), WW, IYDIM )
*
         CALL VRSET0( GDATAO( IXDIM*IYDIM*(IZ-1)+1 ), WW, IYDIM, 1, 1 )
         DO 3120 IX = 1, IXDIM
            CALL VRSUB ( GDATA ( IX+IXDIM*IYDIM*(IZ-1) ),
     &                   WW,
     &                   GDATAO( IX+IXDIM*IYDIM*(IZ-1) ),
     &                   IYDIM, IXDIM, 1, IXDIM          )
 3120    CONTINUE
*
 3100 CONTINUE
*
*"         < 4. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GHCGET( HHEAD, 'AITM1', HAXIS )
         NH = LENC( HAXIS )
         HETTLD = HAXIS(1:NH)//'-eddy'
         CALL GHEADD ( HHEADO, 'XE' , HETTLD )
*
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL  )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第１次元の平均を引く >>
*********************************************************************
      SUBROUTINE GMXEDY
     M         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPXEDY
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 データとスカラーの積 GTOOL3(GPFFCT)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << データとスカラーの積 >>
*********************************************************************
      SUBROUTINE GPFFCT
     I         ( HHEAD , GDATA , VAL   ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      REAL       VAL                     !" スカラー値
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 3. データ演算 >
*
      CALL VRFCT
     I     ( GDATA ,
     O       GDATAO,
     I       IXDIM*IYDIM*IZDIM, 1 , 1 , VAL )
*
*"         < 4. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << データとスカラーの積 >>
*********************************************************************
      SUBROUTINE GMFFCT
     M         ( HHEAD , GDATA ,
     I           VAL   ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      REAL       VAL                     !" スカラー値
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPFFCT
     I         ( HHEAD , GDATA , VAL   ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 線種タイトル GTOOL3(GGLINT)
*
*"履歴 90/10/12 沼口  敦
*"     97/12/01 竹広真一 SET -> STX
*
*********************************************************************
*"         << 線種タイトル表示 >>
*********************************************************************
      SUBROUTINE GGLINT
     I         ( HHEAD , HTYPE )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      CHARACTER  HTYPE      *(*)         !" 種類(CURV/MARK)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HLINT      *(NCC)       !" 線種タイトル
      CHARACTER  HLTITM     *8           !" 線種タイトル識別子名
      REAL       VPX ( 2 ), VPY ( 2 )
*
      DATA       VPOFF /  2. /
      DATA       IROTA /  0  /
      DATA       ICENT / -1  /
      DATA       ILINZ /  0  /
      SAVE       VPOFF, IROTA, ICENT, ILINZ
*
      CALL GGPGET ( 'SREMK' , SREMK  )
      CALL GGCGET ( 'LTITEM', HLTITM )
      CALL GGPGET ( 'LTVX1' , VXL1   )
      CALL GGPGET ( 'LTVX2' , VXL2   )
      CALL GGPGET ( 'LTWDH' , VXW    )
*
      CALL GHCGET ( HHEAD, HLTITM, HLINT )
*
      CALL UZPGET ( 'ROFFXB' , ROFFX )
      CALL UZPGET ( 'PAD1'   , PAD   )
      CALL UZPGET ( 'INDEXL2', INDEX )
c$$$      CALL SUQVPT ( VXMIN, VXMAX, VYMIN, VYMAX )
      CALL SGQVPT ( VXMIN, VXMAX, VYMIN, VYMAX )
*
      ILINZ = ILINZ + 1
      IF (  ( VXL1.EQ.VXL2 ) .OR. ( MOD(ILINZ,2).EQ.1 )  ) THEN
         ROFFX = ROFFX - SREMK*(PAD+1.)
         CALL UZPSTX ( 'ROFFXB' , ROFFX )
         VPX(1) = VXL1
      ELSE
         VPX(1) = VXL2
      ENDIF
      VPX(2) =  VPX(1) + VXW
      VX     =  VPX(2) + SREMK*VPOFF
*
      VPY(1) =  VYMIN + ROFFX
      VPY(2) =  VPY(1)
      VY     =  VPY(1)
*
      IF ( HTYPE(1:1) .EQ. 'C' ) THEN
         CALL SGPLV  ( 2, VPX, VPY )
      ELSE
         CALL SGPMV  ( 1, VPX(2), VPY(2) )
      ENDIF
      CALL SGTXZV ( VX, VY, HLINT, SREMK, IROTA, ICENT, INDEX )
*
      RETURN
*=====================================================================
*"         << 線種タイトル表示リセット >>
*=====================================================================
      ENTRY      GGLTRS
*
      ILINZ = 0
*
      RETURN
      END

*"表題 第２次元の平均を引く GTOOL3(GPYEDY)
*
*"履歴 90/09/06 沼口  敦
*
*
*********************************************************************
*"         << 第２次元の平均を引く >>
*********************************************************************
      SUBROUTINE GPYEDY
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS         *(NCC)
      CHARACTER  HETTLD        *(NCC)
*
#ifdef SYS_IBMS
      INCLUDE   (GZIWRK)                     !" NW: 軸ワークの大きさ
#else
#include        "gziwrk.F"                   !" NW: 軸ワークの大きさ
#endif
      CHARACTER  HHEADY ( NDC )*(NCC)
      REAL       AWGTY  ( NW )
      REAL       WW     ( NW )
      LOGICAL    OSUBCK
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IZDIM )
*
*"         < 2. Δｙの取得 >
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HHEADY  ,  NW     )
      CALL GHPSET ( HHEADY, 'SIZE', NW    )
      CALL GUQAXV
     I            ( HHEAD , 2     , 'WGT'  ,
     O              HHEADY, AWGTY , IEOD     )
      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
*"         < 3. データ平均( 重みつき ) >
*
      CALL GUSZCZ ( NW    , IXDIM  )
*
      DO 3100 IZ = 1, IZDIM
*
         CALL GUVINT( GDATAO( IXDIM*(IZ-1)+1 ), WW, IXDIM )
         DO 3110 IY = 1, IYDIM
            CALL GUVDIN( GDATAO( IXDIM*(IZ-1)+1 ), WW, IXDIM, 1 ,
     &                   GDATA ( IXDIM*(IY-1)+IXDIM*IYDIM*(IZ-1)+1 ),
     &                   AWGTY ( IY )                                 )
 3110    CONTINUE
         CALL GUVOUT( GDATAO( IXDIM*(IZ-1)+1 ), WW, IXDIM )
*
         CALL VRSET0( GDATAO( IXDIM*(IZ-1)+1 ), WW, IXDIM, 1, 1 )
         DO 3120 IY = 1, IYDIM
            CALL VRSUB ( GDATA ( IXDIM*(IY-1)+IXDIM*IYDIM*(IZ-1)+1 ),
     &                   WW,
     &                   GDATAO( IXDIM*(IY-1)+IXDIM*IYDIM*(IZ-1)+1 ),
     &                   IXDIM, 1, 1, 1                              )
 3120    CONTINUE
*
 3100 CONTINUE
*
*"         < 4. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
*
      IF ( IYSTR .EQ. IYEND )                  RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GHCGET( HHEAD, 'AITM2', HAXIS )
         NH = LENC( HAXIS )
         HETTLD = HAXIS(1:NH)//'-eddy'
         CALL GHEADD ( HHEADO, 'YE' , HETTLD )
*
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL  )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第２次元の平均を引く >>
*********************************************************************
      SUBROUTINE GMYEDY
     M         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPYEDY
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 第１次元に関する平均 GTOOL3(GPXAVG)
*
*"履歴 90/08/17 沼口  敦
*"履歴 90/09/13 沼口  敦
*
*
*********************************************************************
*"         << 第１次元に関する平均 >>
*********************************************************************
      SUBROUTINE GPXAVG
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HITM          *(NCC)
      CHARACTER  HAXIS         *(NCC)
      CHARACTER  HETTLD        *(NCC)
*
#ifdef SYS_IBMS
      INCLUDE   (GZIWRK)                     !" NW: 軸ワークの大きさ
#else
#include        "gziwrk.F"                   !" NW: 軸ワークの大きさ
#endif
      CHARACTER  HHEADX ( NDC )*(NCC)
      REAL       AWGTX  ( NW )
      REAL       WW     ( NW )
      LOGICAL    OSUBCK
*
      CALL GHCGET ( HHEAD, 'AITM1', HAXIS )
      IF ( HAXIS .EQ. ' ' ) THEN
         CALL       GPFSET
     I         ( HHEAD , GDATA ,
     I           ' '   , ' '   ,
     O           HHEADO, GDATAO   )
         RETURN
      ENDIF
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IYDIM*IZDIM )
*
*"         < 2. Δｘの取得 >
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HHEADX  ,  NW     )
      CALL GUQAXV
     I            ( HHEAD , 1     , 'WGT'  ,
     O              HHEADX, AWGTX , IEOD     )
      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
*"         < 3. データ平均( 重みつき ) >
*
      CALL GUSZCZ ( NW    , IYDIM  )
*
      DO 3100 IZ = 1, IZDIM
         CALL GUVINT( GDATAO( IYDIM*(IZ-1)+1 ), WW, IYDIM )
         DO 3110 IX = 1, IXDIM
            CALL GUVDIN( GDATAO( IYDIM*(IZ-1)+1 ), WW, IYDIM, IXDIM,
     &                   GDATA ( IX+IXDIM*IYDIM*(IZ-1) ),
     &                   AWGTX ( IX )                               )
 3110    CONTINUE
         CALL GUVOUT( GDATAO( IYDIM*(IZ-1)+1 ), WW, IYDIM )
 3100 CONTINUE
*
*"         < 4. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHCGET ( HHEAD , 'AITM2', HITM  )
      CALL GHCSET ( HHEADO, 'AITM1', HITM  )
      CALL GHCGET ( HHEAD , 'AITM3', HITM  )
      CALL GHCSET ( HHEADO, 'AITM2', HITM  )
      CALL GHPSET ( HHEADO, 'ASTR2', IZSTR )
      CALL GHPSET ( HHEADO, 'AEND2', IZEND )
      CALL GHPSET ( HHEADO, 'ASTR1', IYSTR )
      CALL GHPSET ( HHEADO, 'AEND1', IYEND )
      CALL GHCSET ( HHEADO, 'AITM3', ' '   )
      CALL GHPSET ( HHEADO, 'ASTR3', 1     )
      CALL GHPSET ( HHEADO, 'AEND3', 1     )
*
      IF ( IXSTR .EQ. IXEND )                  RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GHCGET( HHEAD, 'AITM1', HAXIS )
         NH = LENC( HAXIS )
         HETTLD = HAXIS(1:NH)//'-mean'
         CALL GHEADD ( HHEADO, 'XM' , HETTLD )
*
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL  )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第１次元に関する平均 >>
*********************************************************************
      SUBROUTINE GMXAVG
     M         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPXAVG
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

* PACKAGE GTBPF   !" band-pass filter (M.Murakami)
**************************************************************************
      PROGRAM GTBPF
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      LOGICAL    X, Y, Z
      DATA       X, Y, Z / .FALSE.,.FALSE.,.FALSE. /
      REAL       PERI( 2 )
      DATA       PERI    / 2.1, 1000. /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      CHARACTER  ITEM   *(NCC)
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ X, Y, Z, PERI, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, 
     &                   GRESET, HELP, HFILE
*
      EXTERNAL   BNDPS1
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      IF       ( X .AND.(.NOT.Y).AND.(.NOT.Z) ) THEN
         CALL SETBPF( 'X', PERI(1), PERI(2) )         
      ELSE IF  ( Y .AND.(.NOT.X).AND.(.NOT.Z) ) THEN
         CALL SETBPF( 'Y', PERI(1), PERI(2) )         
      ELSE IF  ( Z .AND.(.NOT.X).AND.(.NOT.Y) ) THEN
         CALL SETBPF( 'Z', PERI(1), PERI(2) )         
      ELSE
         CALL MSGDMP( 'E','GTBPF',
     &                'ONE OF -x OR -y OR -z MUST BE SPECIFIED' )
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
      CALL GFOOPN ( JFILE,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      II = 0
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD.EQ.0 ) THEN
*
                  II = II + 1
*
                  CALL GMCAL1
     I            ( BNDPS1,
     M              HHEAD , GDATA ,
     I              EDIT  , ETTL   )
*
                  IF ( ITEM .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'ITEM', ITEM )
                  ENDIF
                  IF ( UNIT .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'UNIT', UNIT )
                  ENDIF
                  IF ( TITLE .NE. ' ' ) THEN
                     CALL GHCSTS( HHEAD , 'TITL', TITLE )
                  ENDIF
                  IF ( DSET .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'DSET', DSET )
                  ENDIF
                  IF ( GRESET ) THEN
                     CALL GHRSGP( HHEAD  )
                  ENDIF
*
                  CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE BNDPS1
     I         ( HHEAD , GDATA ,
     O           HHEADF, GDATAF,
     D           IXDIM , IYDIM , IZDIM )
*
      CHARACTER  HHEAD  ( * ) *(*)
      CHARACTER  HHEADF ( * ) *(*)
      REAL       GDATA  ( * )
      REAL       GDATAF ( * )
      CHARACTER  HBPFZ*1, HBPF*1
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      CHARACTER  HEDIT   *(NCC)
      CHARACTER  HETTL1 *(NCC)
      CHARACTER  HETTL2 *(NCC)
      SAVE
*
      IF      ( ( HBPF .EQ. 'X' ).OR.( HBPF .EQ. 'x' ) ) THEN
         CALL BNDPAS
     O      ( GDATAF,
     I        GDATA , PERI1, PERI2, 1, IXDIM, IYDIM*IZDIM )
      ELSE IF ( ( HBPF .EQ. 'Y' ).OR.( HBPF .EQ. 'y' ) ) THEN
         CALL BNDPAS
     O      ( GDATAF,
     I        GDATA , PERI1, PERI2, IXDIM, IYDIM, IZDIM )
      ELSE IF ( ( HBPF .EQ. 'Z' ).OR.( HBPF .EQ. 'z' ) ) THEN
         CALL BNDPAS
     O      ( GDATAF,
     I        GDATA , PERI1, PERI2, IXDIM*IYDIM, IZDIM, 1 )
      ELSE
         CALL MSGDMP( 'E', 'BNDPS1','INVALID BPF SPECIFICATION' )
      ENDIF
*
      HEDIT   = HBPF//'BPF'
      HETTL1  = HBPF//'cut='
      WRITE ( HETTL1(5:13),'(1PE9.2)' ) PERI1
      HETTL2 = HBPF//'cut='
      WRITE ( HETTL2(5:13),'(1PE9.2)' ) PERI2
      CALL GHEADD ( HHEADF, HEDIT, HETTL1 )
      CALL GHEADD ( HHEADF, HEDIT, HETTL2 )
*
      RETURN
*=====================================================================
      ENTRY      SETBPF
     I         ( HBPFZ , PERIZ1, PERIZ2 )
*
      HBPF  = HBPFZ 
      PERI1 = PERIZ1
      PERI2 = PERIZ2
*      
      END
********************************************************************
      SUBROUTINE BNDPAS
     O      ( FD    ,
     I        D     , PERI1 , PERI2 , 
     D        IMAX  , JMAX  , KMAX   )
*
      REAL       FD  ( IMAX, JMAX, KMAX )
      REAL       D   ( IMAX, JMAX, KMAX )
      REAL       PERI1, PERI2
*
      LOGICAL    OMISS
*
      CALL GLPGET( 'RMISS', VMISS )
*
      IF ( MIN( PERI1, PERI2 ) .LE. 2. ) THEN
         CALL MSGDMP( 'E','BNDPAS','PERIOD MUST BE > 2.0' )
      ENDIF
*
      PI = ATAN( 1.) *4.
      AV1 = 2.*PI/ PERI1
      AV2 = 2.*PI/ PERI2
*
      DOM = 2.* ABS( SIN(AV1)/(1.+COS(AV1)) - SIN(AV2)/(1.+COS(AV2)) )
      OM2 = 4.* SIN(AV1)*SIN(AV2)/(1.+COS(AV1))/(1.+COS(AV2))
*
      A0  = 2.*DOM           /( 4.+2.*DOM+OM2 )
      B1  = 2.*(OM2-4.)      /( 4.+2.*DOM+OM2 )
      B2  = ( 4.-2.*DOM+OM2 )/( 4.+2.*DOM+OM2 )
*
      DO 4000 K = 1, KMAX
*
         DO 1100 I = 1, IMAX 
            FD( I,1,K ) = 0.
            FD( I,2,K ) = 0.
 1100    CONTINUE 
*
         DO 1200 J = 3, JMAX
            DO 1210 I = 1, IMAX 
               FD( I,J,K ) = A0*( D( I,J,K ) - D( I,J-2,K ) )
     &                     - B1* FD( I,J-1,K ) - B2* FD( I,J-2,K )
 1210       CONTINUE 
 1200    CONTINUE 
*
         DO 2100 J = JMAX-2, 1, -1
            DO 2110 I = 1, IMAX
               FD( I,J,K ) = A0*( D( I,J,K ) - D( I,J+2,K ) )
     &                     - B1* FD( I,J+1,K ) - B2* FD( I,J+2,K )
 2110       CONTINUE 
 2100    CONTINUE 
*
         DO 3100 I = 1, IMAX
            OMISS = .FALSE.
            DO 3110 J = 1, JMAX
               IF ( D( I,J,K ) .EQ. VMISS ) THEN
                  OMISS = .TRUE.
               ENDIF
 3110       CONTINUE 
            IF ( OMISS ) THEN
               DO 3120 J = 1, JMAX
                  FD( I,J,K ) = VMISS
 3120          CONTINUE 
            ENDIF
 3100    CONTINUE 
*
 4000 CONTINUE 
*        
      RETURN
      END

*"表題 第１次元の格子選択 GTOOL3(GPXSEL)
*
*"履歴 90/08/17 沼口  敦
*
*
*********************************************************************
*"         << 第１次元の格子選択 >>
*********************************************************************
      SUBROUTINE GPXSEL
     I         ( HHEAD , GDATA , IXSEL  ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO          )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IXSEL                   !" 選択する第1次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HITM        *(NCC)
      CHARACTER  HAXIS       *(NCC)
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
      LOGICAL    OCYCL                   !" サイクリックか？
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IYDIM*IZDIM )
*
      CALL GHCGET( HHEAD, 'AITM1', HAXIS )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
*"         < 2. データ詰め替え >
*
      IF ( OCYCL ) THEN
         IXI = MOD( IXSEL-IXSTR, IADIM ) + 1
      ELSE
         IXI = IXSEL-IXSTR+1
      ENDIF
*
      IF ( ( 1.LE.IXI ).AND.( IXI.LE.IXDIM ) ) THEN
         CALL VRSET
     I        ( GDATA ( IXI ),
     O          GDATAO ,
     I          IYDIM*IZDIM  , IXDIM   , 1    )
      ELSE
         CALL GHPGET( HHEAD , 'MISS', VMISS )
         CALL RSET  ( GDATAO, IYDIM*IZDIM, VMISS )
      ENDIF
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHCGET ( HHEAD , 'AITM2', HITM  )
      CALL GHCSET ( HHEADO, 'AITM1', HITM  )
      CALL GHCGET ( HHEAD , 'AITM3', HITM  )
      CALL GHCSET ( HHEADO, 'AITM2', HITM  )
      CALL GHPSET ( HHEADO, 'ASTR2', IZSTR )
      CALL GHPSET ( HHEADO, 'AEND2', IZEND )
      CALL GHPSET ( HHEADO, 'ASTR1', IYSTR )
      CALL GHPSET ( HHEADO, 'AEND1', IYEND )
      CALL GHCSET ( HHEADO, 'AITM3', ' '   )
      CALL GHPSET ( HHEADO, 'ASTR3', 1     )
      CALL GHPSET ( HHEADO, 'AEND3', 1     )
*
      IF ( ( IXSTR .EQ. IXSEL ).AND.( IXEND .EQ. IXSEL ) ) RETURN
*
*"         < 4. 編集記述を設定  >
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAXIS , 'XS'   , '-select',
     I                 IXSEL , IXSEL  ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第１次元の格子選択 >>
*********************************************************************
      SUBROUTINE GMXSEL
     M         ( HHEAD , GDATA ,
     I           IXSEL ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IXSEL                   !" 選択する第1次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPXSEL
     I         ( HHEAD , GDATA , IXSEL  ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW          )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 ヘッダーパック GTOOL3(GHPACK)
*
*"履歴 90/08/21 沼口  敦
*
*
***********************************************************************
*"         << 識別記述子のパック >>
**********************************************************************
      SUBROUTINE GHPACK
     O         ( HHEAD ,
     I           HDSET , HITEM , IFNUM , IDNUM ,
     I           HTITL , HUNIT ,
     I           ITIME , HDATE , HUTIM , ITDUR ,
     I           HAITM1, IASTR1, IAEND1,
     I           HAITM2, IASTR2, IAEND2,
     I           HAITM3, IASTR3, IAEND3,
     I           HDFMT , VMISS ,
     I           DMIN  , DMAX  , DIVS  , DIVL  , ISTYP ,
     I           HCDATE, HCSIGN                         )
*
      CHARACTER  HHEAD ( * )*(*)
*
      CHARACTER  HDSET  *(*)             !" データセット名
      CHARACTER  HITEM  *(*)             !" 識別名称
      INTEGER    IFNUM                   !" ファイル番号
      INTEGER    IDNUM                   !" データ番号
*
      CHARACTER  HTITL  *(*)             !" タイトル
      CHARACTER  HUNIT  *(*)             !" 単位
*
      INTEGER    ITIME                   !" 時刻(通し)
      CHARACTER  HDATE  *(*)             !" 時刻(yyyymmddhhmmss)
      CHARACTER  HUTIM  *(*)             !" 時刻単位
      INTEGER    ITDUR                   !" 代表する時間
*
      CHARACTER  HAITM1 *(*)             !" 軸1の格子名称
      INTEGER    IASTR1                  !" 軸1の格子始め
      INTEGER    IAEND1                  !" 軸1の格子終り
      CHARACTER  HAITM2 *(*)             !" 軸2の格子名称
      INTEGER    IASTR2                  !" 軸2の格子始め
      INTEGER    IAEND2                  !" 軸2の格子終り
      CHARACTER  HAITM3 *(*)             !" 軸3の格子名称
      INTEGER    IASTR3                  !" 軸3の格子始め
      INTEGER    IAEND3                  !" 軸3の格子終り
*
      CHARACTER  HDFMT  *(*)             !" データフォーマット
      REAL       VMISS                   !" 欠損値の値
*
      REAL       DMIN                    !" レンジ(最小)
      REAL       DMAX                    !" レンジ(最大)
      REAL       DIVS                    !" 間隔(小)
      REAL       DIVL                    !" 間隔(大)
      INTEGER    ISTYP                   !" スケーリングタイプ
*
      CHARACTER  HCDATE *(*)             !" データ作成日付
      CHARACTER  HCSIGN *(*)             !" データ作成者
*
      CHARACTER  HMDATE *(*)             !" データ変更日付
      CHARACTER  HMSIGN *(*)             !" データ変更者
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HDDSET *(NCC)
      CHARACTER  HDATEZ *(NCC)
      CHARACTER  HSIGNZ *(NCC)
*
*"         < 1. 全てパック >
*
      DO 1100 II = 1, NDC-1
         HHEAD( II ) = ' '
 1100 CONTINUE
*
      CALL GHPSET ( HHEAD , 'IDFM    ' , 0      )
*
      IF ( HDSET .NE. ' ' ) THEN
         CALL GHCSET ( HHEAD , 'DSET    ' , HDSET  )
      ELSE
         CALL GTCGET ('DDSET', HDDSET )
         CALL GHCSET ( HHEAD , 'DSET    ' , HDDSET )
      ENDIF
*
      CALL GHCSET ( HHEAD , 'ITEM    ' , HITEM  )
      CALL GHPSET ( HHEAD , 'FNUM    ' , IFNUM  )
      CALL GHPSET ( HHEAD , 'DNUM    ' , IDNUM  )
*
      CALL GHCSTS ( HHEAD , 'TITL    ' , HTITL  )
      CALL GHCSET ( HHEAD , 'UNIT    ' , HUNIT  )
*
      CALL GHPSET ( HHEAD , 'TIME    ' , ITIME  )
      CALL GHCSET ( HHEAD , 'DATE    ' , HDATE  )
      CALL GHCSET ( HHEAD , 'UTIM    ' , HUTIM  )
      CALL GHPSET ( HHEAD , 'TDUR    ' , ITDUR  )
*
      CALL GHCSET ( HHEAD , 'AITM1   ' , HAITM1 )
      CALL GHPSET ( HHEAD , 'ASTR1   ' , IASTR1 )
      CALL GHPSET ( HHEAD , 'AEND1   ' , IAEND1 )
*
      CALL GHCSET ( HHEAD , 'AITM2   ' , HAITM2 )
      CALL GHPSET ( HHEAD , 'ASTR2   ' , IASTR2 )
      CALL GHPSET ( HHEAD , 'AEND2   ' , IAEND2 )
*
      CALL GHCSET ( HHEAD , 'AITM3   ' , HAITM3 )
      CALL GHPSET ( HHEAD , 'ASTR3   ' , IASTR3 )
      CALL GHPSET ( HHEAD , 'AEND3   ' , IAEND3 )
*
      CALL GHCSET ( HHEAD , 'DFMT    ' , HDFMT  )
      CALL GHPSET ( HHEAD , 'MISS    ' , VMISS  )
*
      CALL GHPSET ( HHEAD , 'DMIN    ' , DMIN   )
      CALL GHPSET ( HHEAD , 'DMAX    ' , DMAX   )
      CALL GHPSET ( HHEAD , 'DIVS    ' , DIVS   )
      CALL GHPSET ( HHEAD , 'DIVL    ' , DIVL   )
      CALL GHPSET ( HHEAD , 'STYP    ' , ISTYP  )
*
      CALL GUQNOW ( HDATEZ )
      CALL GTCGET ( 'MYSIGN', HSIGNZ )
*
      IF ( HCDATE .EQ. ' ' ) THEN
         CALL GHCSET ( HHEAD , 'CDATE   ' , HDATEZ )
      ELSE
         CALL GHCSET ( HHEAD , 'CDATE   ' , HCDATE )
      ENDIF
*
      IF ( HCSIGN .EQ. ' ' ) THEN
         CALL GHCSET ( HHEAD , 'CSIGN   ' , HSIGNZ  )
      ELSE
         CALL GHCSET ( HHEAD , 'CSIGN   ' , HCSIGN )
      ENDIF
      CALL GHCSET ( HHEAD , 'MDATE   ' , HDATEZ  )
      CALL GHCSET ( HHEAD , 'MSIGN   ' , HSIGNZ  )
*
      RETURN
*=====================================================================
*"         << 識別記述子のアンパック >>
*====================================================================
      ENTRY      GHUPAC
     I         ( HHEAD ,
     O           HDSET , HITEM , IFNUM , IDNUM ,
     O           HTITL , HUNIT ,
     O           ITIME , HDATE , HUTIM , ITDUR ,
     O           HAITM1, IASTR1, IAEND1,
     O           HAITM2, IASTR2, IAEND2,
     O           HAITM3, IASTR3, IAEND3,
     O           HDFMT , VMISS ,
     O           DMIN  , DMAX  , DIVS  , DIVL  , ISTYP ,
     O           HCDATE, HCSIGN, HMDATE, HMSIGN         )
*
*"         < 2. 全てアンパック >
*
      CALL GHCGET ( HHEAD , 'DSET    ' , HDSET  )
      CALL GHCGET ( HHEAD , 'ITEM    ' , HITEM  )
      CALL GHPGET ( HHEAD , 'FNUM    ' , IFNUM  )
      CALL GHPGET ( HHEAD , 'DNUM    ' , IDNUM  )
*
      CALL GHCGTS ( HHEAD , 'TITL    ' , HTITL  )
      CALL GHCGET ( HHEAD , 'UNIT    ' , HUNIT  )
*
      CALL GHPGET ( HHEAD , 'TIME    ' , ITIME  )
      CALL GHCGET ( HHEAD , 'DATE    ' , HDATE  )
      CALL GHCGET ( HHEAD , 'UTIM    ' , HUTIM  )
      CALL GHPGET ( HHEAD , 'TDUR    ' , ITDUR  )
*
      CALL GHCGET ( HHEAD , 'AITM1   ' , HAITM1 )
      CALL GHPGET ( HHEAD , 'ASTR1   ' , IASTR1 )
      CALL GHPGET ( HHEAD , 'AEND1   ' , IAEND1 )
*
      CALL GHCGET ( HHEAD , 'AITM2   ' , HAITM2 )
      CALL GHPGET ( HHEAD , 'ASTR2   ' , IASTR2 )
      CALL GHPGET ( HHEAD , 'AEND2   ' , IAEND2 )
*
      CALL GHCGET ( HHEAD , 'AITM3   ' , HAITM3 )
      CALL GHPGET ( HHEAD , 'ASTR3   ' , IASTR3 )
      CALL GHPGET ( HHEAD , 'AEND3   ' , IAEND3 )
*
      CALL GHCGET ( HHEAD , 'DFMT    ' , HDFMT  )
      CALL GHPGET ( HHEAD , 'MISS    ' , VMISS  )
*
      CALL GHPGET ( HHEAD , 'DMIN    ' , DMIN   )
      CALL GHPGET ( HHEAD , 'DMAX    ' , DMAX   )
      CALL GHPGET ( HHEAD , 'DIVS    ' , DIVS   )
      CALL GHPGET ( HHEAD , 'DIVL    ' , DILV   )
      CALL GHPGET ( HHEAD , 'STYP    ' , ISTYP  )
*
      CALL GHCGET ( HHEAD , 'CDATE   ' , HCDATE )
      CALL GHCGET ( HHEAD , 'CSIGN   ' , HCSIGN )
*
      CALL GHCGET ( HHEAD , 'MDATE   ' , HMDATE )
      CALL GHCGET ( HHEAD , 'MSIGN   ' , HMSIGN )
*
      RETURN
      END

* PACKAGE GTINT2   !" int 2 ->gtool3
************************************************************************
      PROGRAM GTINT2
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
      CHARACTER  HFNAME *(NCC)
*
      CHARACTER  HFILE( 1 )        *(NFILN)
      DATA       HFILE / '-' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      REAL       FACT
      DATA       FACT / 1. /
      LOGICAL    HELP
      DATA       HELP  / .FALSE. /
*
      NAMELIST  /OPTION/ OUT, APND, FACT, HFILE, HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GMSIZE ( IJKDIM  )
      CALL GHPCLR ( HHEAD )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.txt' )
*
      IF ( HFILE(1) .EQ. '-' ) THEN
         IFILE = 5
      ELSE
         OPEN ( IFILE, FILE=HFILE(1), 
     &          ACCESS='SEQUENTIAL',FORM='FORMATTED' )
      ENDIF
      CALL GFOOPN ( JFILE, OUT , APND )
*
      II = 0
 1100 CONTINUE
         II = II + 1
*
         CALL RDTXTH
     I            ( IFILE ,
     M              HHEAD ,
     O              IEOD  )
*
         IF ( IEOD .EQ. 0 ) THEN
            CALL GUQSIZ 
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*     
            CALL GHCGET ( HHEAD, 'ETTL1', HFNAME )
*         
            CALL RDINT2
     O         ( GDATA ,
     I           IXDIM , IYDIM , IZDIM  ,
     I           HFNAME                   )
*
           IF ( FACT .NE. 1.0 ) THEN
              CALL GMFFCT
     I        ( HHEAD , GDATA , FACT  ,
     I          '  '  , '  '           )
           ENDIF
*     
            CALL GFWRIT
     I         ( HHEAD , GDATA ,
     I           JFILE , 1     , 0       )
*
            GOTO 1100            
         ENDIF
*
 1900 CONTINUE
*
      STOP
      END
***********************************************************************
      SUBROUTINE RDTXTH
     I         ( IFILE ,
     M           HHEAD ,
     O           IEOD  )
*
      CHARACTER  HHEAD ( * )*(*)
*
      
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      PARAMETER (NBUF=255)
      CHARACTER  HBUF*(NBUF), HXX*(NBUF)
      CHARACTER  HP*(NCC), HX*(NCC)
      CHARACTER  HFMT*(NCC)
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      LOGICAL    LCHRN
*
  100 CONTINUE 
      READ ( IFILE,'(A)',IOSTAT=IEOS ) HBUF
      IF ( IEOS .NE. 0 ) THEN
         IEOD = 1
         RETURN
      ENDIF
      IF ( HBUF(1:1) .EQ. '#' ) THEN
         GOTO 100
      ENDIF
*
      IDX = 0
*
 1100 CONTINUE
*
         IL   = LENB(HBUF)
         LENH = LEN(HBUF)
         IF ( .NOT.LCHRN(HBUF(IL+1:IL+1)) ) THEN
*
            IC = INDEX(HBUF,':')
            IF ( IC.GT.IL .AND. IC.LT.LENH ) THEN
               HP  = HBUF(IL+1:IC-1)
               ILX = LENB(HBUF(IC+1:LENH))+IC
               HXX = HBUF(ILX+1:LENH)
               HX  = HXX
               IF ( HP .EQ. 'TITLE' ) THEN
                  CALL GHCSTS(HHEAD,'TITL',HXX)
               ELSE IF ( HP .NE. 'SIZE' ) THEN
                  CALL GHPINQ(HP,HFMT)
                  IF ( HFMT .NE. '(A)' ) THEN
                     CALL CRADJ(HX)
                  ENDIF
                  CALL GHCSET(HHEAD,HP,HX)
               ENDIF
            ENDIF
*
 1200       CONTINUE 
               READ ( IFILE,'(A)',END=9000 ) HBUF
            IF ( HBUF(1:1) .EQ. '#' ) THEN
               GOTO 1200
            ENDIF
*
      GOTO 1100
         ENDIF
*
 9000 CONTINUE 
*
      CALL GUQTSZ( HHEAD,ISIZE )
      CALL GHPSET( HHEAD, 'SIZE', ISIZE )
      IEOD = 0
*
      RETURN
      END
********************************************************************
      LOGICAL FUNCTION   LCHRN(C)
      CHARACTER  C
      LOGICAL    LCHRD
*
      LCHRN = LCHRD(C) .OR. (C.EQ.'-') .OR. (C.EQ.'.')
*
      RETURN
      END
********************************************************************
      SUBROUTINE RDINT2
     O         ( GDATA ,
     I           NLO   , NLA   , KDIM  ,
     I           HFNAME                   )
*
      PARAMETER   (NLOMX=1025)
      INTEGER*2    IDATA(NLOMX)
      REAL         GDATA(NLO,NLA)
      CHARACTER    HFNAME *(*)
*
      IF ( NLO .GT. NLOMX ) CALL MSGDMP('E','RDINT2','NLO TOO LARGE')
*
      OPEN (UNIT=1,FILE=HFNAME,STATUS='OLD',
     &      ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NLO*2)
*
      DO 1000 K = 1, KDIM
         DO 1000 LA = 1, NLA
            READ(1,REC=LA) (IDATA(LO),LO=1,NLO)
            DO 800 LO = 1, NLO
               GDATA(LO,LA) = IDATA(LO)
  800       CONTINUE
 1000 CONTINUE
*
      RETURN
      END

*"表題 第１次元の部分切出し GTOOL3(GPXRDC)
*
*"履歴 90/08/18 沼口  敦
*
*
*********************************************************************
*"         << 第１次元の部分切出し >>
*********************************************************************
      SUBROUTINE GPXRDC
     I         ( HHEAD , GDATA , IXSEL1 , IXSEL2 ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO                    )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IXSEL1                  !" 切り出す第1次元の格子
      INTEGER    IXSEL2                  !" 切り出す第1次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS       *(NCC)      !" 軸名称
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
      LOGICAL    OCYCL                   !" サイクリックか？
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      IXDIMC = IXSEL2-IXSEL1+1
      CALL GUSZCK ( HHEADO, IXDIMC*IYDIM*IZDIM )
*
      CALL GHCGET ( HHEAD, 'AITM1 ', HAXIS  )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
*"         < 2. データ詰め替え >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
*
      DO 2100 IX = IXSEL1, IXSEL2
         IF ( OCYCL ) THEN
            IXI = MOD( IX-IXSTR, IADIM ) + 1
         ELSE
            IXI = IX-IXSTR+1
         ENDIF
*
         IF ( ( 1.LE.IXI ).AND.( IXI.LE.IXDIM ) ) THEN
            CALL VRSET
     I         ( GDATA ( IXI         ),
     O           GDATAO( IX-IXSEL1+1 ),
     I           IYDIM*IZDIM, IXDIM , IXDIMC )
         ELSE
           CALL RSET
     O        ( GDATAO( IX-IXSEL1+1 ),
     I          IYDIM*IZDIM , IXDIMC, VMISS )
         ENDIF
*
 2100 CONTINUE
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHPSET ( HHEADO, 'ASTR1', IXSEL1 )
      CALL GHPSET ( HHEADO, 'AEND1', IXSEL2 )
*
      IF ( ( IXSTR .EQ. IXSEL1 ).AND.( IXEND .EQ. IXSEL2 ) ) RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAXIS , 'XR'   , '-reduce',
     I                 IXSEL1, IXSEL2 ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第１次元の部分切出し >>
*********************************************************************
      SUBROUTINE GMXRDC
     I         ( HHEAD , GDATA ,
     I           IXSEL1, IXSEL2,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IXSEL1                  !" 切り出す第1次元の格子
      INTEGER    IXSEL2                  !" 切り出す第1次元の格子
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPXRDC
     I         ( HHEAD , GDATA , IXSEL1 , IXSEL2 ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW                    )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 マーク描画 GTOOL3(GGMARK)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << マーク描画 >>
*********************************************************************
      SUBROUTINE GGMARK
     I         ( HHEAD , GDATA , HPOS  )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       GDATA ( * )             !" データ
      CHARACTER  HPOS       *(*)         !" データ軸 ('X' or 'Y')
*
#ifdef SYS_IBMS
      INCLUDE    (GZIWRK)                !" NW: 軸ワークの大きさ
#else
#include         "gziwrk.F"              !" NW: 軸ワークの大きさ
#endif
      REAL       ZDATA ( NW )
      LOGICAL    OLINT                   !" 線種コメントを描く？
*
      CALL GUSMIS ( HHEAD )
*
*"         < 1. 軸描画, 座標設定 >
*
      CALL GGAXSZ
     I     ( HHEAD , GDATA , HPOS   )
*
*"         < 2. 範囲 >
*
      CALL GHPGET ( HHEAD, 'ASTR1', IZSTR )
      CALL GHPGET ( HHEAD, 'AEND1', IZEND )
      IZDIM = IZEND-IZSTR+1
      CALL GUSZCZ ( NW   , IZDIM )
*
*"         < 3. 折れ線描画 >
*
      CALL UWQGXA ( ZDATA, IZDIMZ )
      IF ( IZDIM .NE. IZDIMZ ) THEN
         CALL MSGDMP( 'W', 'GGMARK', 'ARRAY SIZE DO NOT AGREE.' )
      ENDIF
*
      IF ( HPOS(1:1) .EQ. 'X' ) THEN
         CALL SGPMU  ( IZDIM, GDATA, ZDATA )
      ELSE
         CALL SGPMU  ( IZDIM, ZDATA, GDATA )
      ENDIF
*
*"         < 4. 線種コメント >
*
      CALL GGPGET ( 'LLINT', OLINT )
      IF ( OLINT ) THEN
         CALL GGLINT ( HHEAD, 'MARK' )
      ENDIF
*
      RETURN
      END

* PACKAGE GTCURV    !"  折れ線図                      A.Numaguti
*"                             for dcl-5.0 : 95/05/31 S.Takehiro 
*"                  異なる軸ファイルに対応 : 95/11/07 S.Takehiro 
*"                             miner bugfix: 96/09/06 S.Takehiro
*******************************************************************
      PROGRAM    GTCURV
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      PARAMETER  ( NFILE=10, NIDX=24 )
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
*
      INTEGER    IFILE( NFILE )
      DATA       IFILE / 50,51,52,53,54,55,56,57,58,59 /
      PARAMETER  (NFM1=NFILE-1)
      CHARACTER  HFILE( NFILE ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out',NFM1*' ' /
*
      INTEGER    X, Y, Z
      DATA       X, Y, Z / 3*-1 /
      INTEGER    OVERLAY
      DATA       OVERLAY / 1 /
      CHARACTER  LTITEM  *(NCC)
      DATA       LTITEM / 'ITEM' /
      LOGICAL    LINT
      DATA       LINT  / .TRUE. /
      REAL       DIV ( 2 )
      DATA       DIV   / -999.,-999. /
      REAL       RANGE ( 2 )
      DATA       RANGE / -999.,-999. /

      PARAMETER  (NIDM1=NIDX-1,NIDM4=NIDX-4)
      INTEGER    LIDX( NIDX ), LTYPE( NIDX )
      DATA       LIDX  / 2,NIDM1*-1 / 
      DATA       LTYPE / 1,2,3,4,NIDM4*-1 /
      REAL       BITLEN
      DATA       BITLEN / -1. /
      INTEGER    LAY
      DATA       LAY / 1 /
      INTEGER    WSN
      DATA       WSN / 0 /
      LOGICAL    MONO, PRINT
      DATA       MONO, PRINT / 2*.FALSE. /
      CHARACTER  PS   *(NFILN)
      DATA       PS  / '$GTTMPDIR/sgks.ps' /
      LOGICAL    TICK , ATTL
      DATA       TICK , ATTL / 2*.TRUE. /
      INTEGER    STR, END, STEP
      DATA       STR, END, STEP / 1, 999999, 1 /
      LOGICAL    EXCH
      DATA       EXCH  /.FALSE./
      INTEGER    STYPE
      DATA       STYPE / 0 /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST /OPTION/  X, Y, Z, DIV, RANGE,
     &                   OVERLAY, LIDX, LTYPE, BITLEN, LTITEM, LINT,
     &                   LAY , WSN,  MONO, PRINT, PS, TICK, ATTL,
     &                   STR, END, STEP, EXCH , STYPE,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILES )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      IF ( WSN .LE. 0 ) THEN
         IF ( PRINT ) THEN
            WSN = 2
            IF ( PS .NE. ' ' ) THEN
               CALL GUNENV( PS, '.', .FALSE. )
               CALL SWCSET( 'PSFILE', PS     )
               IP=LENC(PS)
               WRITE (6,*) 'ps='//PS(1:IP)
            ENDIF
         ELSE
            WSN = 1
         ENDIF
      ENDIF
      CALL GGOPEN ( WSN )
*
      NFL = 1
      IF ( NFILES .EQ. 0 ) NFILES = 1
      DO 300 IFL = 1, NFILES
         IF ( HFILE(IFL) .NE. ' ' ) THEN
            CALL GFROPN ( IFILE(IFL), HFILE(IFL) )
            NFL = IFL
         ENDIF
 300  CONTINUE
*
      IF ( Z .GE. 0 ) THEN
         IF ( X.LT.0  .AND. Y.LT.0 ) X = 0
      ELSE IF ( Y .GE. 0 ) THEN
         IF ( X.LT.0  .AND. Z.LT.0 ) Z = 0
      ELSE IF ( X .GE. 0 ) THEN
         IF ( Y.LT.0  .AND. Z.LT.0 ) Z = 0
      ELSE
         X = 0
         Z = 0
      ENDIF
*
      OVERLAY = MAX( OVERLAY, NFL )
      STEP    = MAX( STEP, 1 )
*
      NLIDX  = 1
      NLTYPE = 1
      DO 500 ID = 1, NIDX
         IF ( LIDX(ID)  .NE. -1 ) NLIDX  = ID
         IF ( LTYPE(ID) .NE. -1 ) NLTYPE = ID
 500  CONTINUE
*
      IF ( BITLEN .GT. 0 ) THEN
         CALL SGPSET( 'BITLEN', BITLEN )
      ENDIF
      CALL CUPPER( LTITEM )
      CALL GGCSET( 'LTITEM', LTITEM )
      CALL GGPSET( 'LLINT', LINT )
*
      II  = 0
      IID = 0
 1100 CONTINUE
         IFILEX = IFILE( MOD(II,NFL)+1 )
         CALL GFREAD
     O            ( HHEAD , GDATA , IEOD  ,
     I              IFILEX, 1               )
*
         IF ( IEOD .EQ. 0 ) THEN
*
            II = II + 1
            IF ( ( II.GE.STR ).AND.( II.LE.END ).AND.
     &           ( MOD( II-STR,STEP ).EQ.0 )          ) THEN         
               IID = IID + 1
*
               IF ( Z .EQ. 0 ) THEN
                  CALL GMZAVG
     M               ( HHEAD , GDATA ,
     I                 'ZM'  , 'vert mean'  )
               ELSE IF ( Z .GT. 0 ) THEN 
                  CALL GMZSEL
     M               ( HHEAD , GDATA , Z ,
     I                 '  '  , '  '        )
               ENDIF
               IF ( Y .EQ. 0 ) THEN
                  CALL GMYAVG
     M               ( HHEAD , GDATA ,
     I                 'YM'  , 'merid mean' )
               ELSE IF ( Y .GT. 0 ) THEN 
                  CALL GMYSEL
     M               ( HHEAD , GDATA , Y ,
     I                 '  '  , '  '         )
               ENDIF
               IF ( X .EQ. 0 ) THEN
                  CALL GMXAVG
     I               ( HHEAD , GDATA ,
     I                 'XM'  , 'zonal mean' )
               ELSE IF ( X .GT. 0 ) THEN 
                  CALL GMXSEL
     I               ( HHEAD , GDATA , X ,
     I                 '  '  , '  '        )
               ENDIF
*
               IF ( ITEM .NE. ' ' ) THEN
                  CALL GHCSET( HHEAD , 'ITEM', ITEM )
               ENDIF
               IF ( UNIT .NE. ' ' ) THEN
                  CALL GHCSET( HHEAD , 'UNIT', UNIT )
               ENDIF
               IF ( TITLE .NE. ' ' ) THEN
                  CALL GHCSTS( HHEAD , 'TITL', TITLE )
               ENDIF
               IF ( DSET .NE. ' ' ) THEN
                  CALL GHCSET( HHEAD , 'DSET', DSET )
               ENDIF
               IF ( GRESET ) THEN
                  CALL GHRSGP( HHEAD  )
               ENDIF
               IF ( STYPE .NE. 0 ) THEN
                  CALL GHPSET ( HHEAD, 'STYP', STYPE )
               ENDIF
*     
               IF ( DIV( 1 ) .GT. 0. ) THEN
                  CALL GHPSET( HHEAD, 'DIVS', DIV( 1 ) )
               ENDIF
               IF ( DIV( 2 ) .GT. 0. ) THEN
                  CALL GHPSET( HHEAD, 'DIVL', DIV( 2 ) )
               ENDIF
               IF ( RANGE(1) .NE. -999. ) THEN
                  CALL GHPSET( HHEAD, 'DMIN', RANGE(1) )
               ENDIF
               IF ( RANGE(2) .NE. -999. ) THEN
                  CALL GHPSET( HHEAD, 'DMAX', RANGE(2) )
               ENDIF
*
               IF ( MOD(IID-1,OVERLAY) .EQ. 0 ) THEN
                  IF      ( LAY .EQ. 2 ) THEN
                     CALL GGLAY2  ( HHEAD )
                  ELSE IF ( LAY .EQ. 3 ) THEN
                     CALL GGLAY3  ( HHEAD )
                  ELSE
                     CALL GGLAY1  ( HHEAD )
                  ENDIF
               ENDIF
*
               IF ( .NOT. EXCH ) THEN
                  CALL GGAXIS  ( HHEAD , 'X' )
               ELSE
                  CALL GGAXIS  ( HHEAD , 'Y' )
               ENDIF
*
               LI = MOD( IID-1,OVERLAY )+1
               LIDXS  = LIDX ( MOD( LI-1,NLIDX  )+1 )
               LTYPES = LTYPE( MOD( LI-1,NLTYPE )+1 )
               IF ( LIDXS .GT. 0 ) THEN
                  CALL SGSPLI  ( LIDXS )
                  CALL SGSPLT  ( LTYPES )
                  IF ( .NOT. EXCH ) THEN
                     IF ( .NOT. TICK ) CALL GGCSET( 'CYSIDET', ' ' )
                     IF ( .NOT. ATTL ) CALL GGCSET( 'CYSIDEL', ' ' )
                     CALL GGCURV  ( HHEAD , GDATA , 'Y' )
                  ELSE
                     IF ( .NOT. TICK ) CALL GGCSET( 'CXSIDET', ' ' )
                     IF ( .NOT. ATTL ) CALL GGCSET( 'CXSIDEL', ' ' )
                     CALL GGCURV  ( HHEAD , GDATA , 'X' )
                  ENDIF
               ENDIF
*
            ENDIF
            IF ( II .LT. END ) GOTO 1100
         ENDIF
*
      CALL GGCLSE
*
      STOP
      END

*"表題 格子名称のチェック GTOOL3(GUAXCK)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << 格子名称のチェック >>
*********************************************************************
      SUBROUTINE GUAXCK
     I         ( HHEAD1, HHEAD2,
     O           ICHK            )
*
      CHARACTER  HHEAD1 ( * )*(*)        !" ヘッダー1
      CHARACTER  HHEAD2 ( * )*(*)        !" ヘッダー1
      INTEGER    ICHK                    !" 軸が合致していれば0
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAITM1      *(NCC)
      CHARACTER  HAITM2      *(NCC)
*
      ICHK = 0
*
      CALL GHCGET ( HHEAD1, 'AITM1', HAITM1 )
      CALL GHCGET ( HHEAD2, 'AITM1', HAITM2 )
      IF ( HAITM1 .NE. HAITM2 ) THEN
         ICHK = ICHK + 1
      ENDIF
*
      CALL GHCGET ( HHEAD1, 'AITM2', HAITM1 )
      CALL GHCGET ( HHEAD2, 'AITM2', HAITM2 )
      IF ( HAITM1 .NE. HAITM2 ) THEN
         ICHK = ICHK + 2
      ENDIF
*
      CALL GHCGET ( HHEAD1, 'AITM3', HAITM1 )
      CALL GHCGET ( HHEAD2, 'AITM3', HAITM2 )
      IF ( HAITM1 .NE. HAITM2 ) THEN
         ICHK = ICHK + 4
      ENDIF
*
      RETURN
      END

*"表題 軸ヘッダーパック GTOOL3(GHPACA)
*
*"履歴 90/09/21 沼口  敦
*
*
***********************************************************************
*"         << 格子情報ヘッダーパック >>
**********************************************************************
      SUBROUTINE GHPACA
     O         ( HHEADA,
     I           HKIND , HITEM ,
     I           HTITL , HUNIT ,
     I           IXDIM ,
     I           HDFMT , VMISS ,
     I           DMIN  , DMAX  , DIVS  , DIVL  , ISTYP  )
*
      CHARACTER  HHEADA ( * )*(*)        !" ヘッダー
      CHARACTER  HKIND       *(*)        !" 格子情報の種類
      CHARACTER  HITEM       *(*)        !" 格子識別名称
      CHARACTER  HTITL       *(*)        !" 軸タイトル
      CHARACTER  HUNIT       *(*)        !" 単位
      INTEGER    IXDIM                   !" 格子数
      CHARACTER  HDFMT       *(*)        !" データフォーマット
      REAL       VMISS                   !" 欠損値の値
      REAL       DMIN                    !" レンジ(最小)
      REAL       DMAX                    !" レンジ(最大)
      REAL       DIVS                    !" 間隔(小)
      REAL       DIVL                    !" 間隔(大)
      INTEGER    ISTYP                   !" スケーリングタイプ
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HTIME       *(NCC)
      CHARACTER  HSIGN       *(NCC)      !" データ作成者
*
      CALL    GUQNOW ( HTIME )
      CALL    GTCGET ( 'MYSIGN', HSIGN  )
*
      IF ( HKIND(1:1) .EQ. 'C' ) THEN
         IXDIMD = IXDIM + 1
      ELSE
         IXDIMD = IXDIM
      ENDIF
*
      CALL    GHPACK
     O         ( HHEADA,
     I           HKIND , HITEM , 1     , 1    ,
     I           HTITL , HUNIT ,
     I           0     , HTIME , 'SEC' , 1    ,
     I           HITEM , 1     , IXDIMD,
     I           ' '   , 1     , 1     ,
     I           ' '   , 1     , 1     ,
     I           HDFMT , VMISS ,
     I           DMIN  , DMAX  , DIVS  , DIVL  , ISTYP ,
     I           HTIME , HSIGN                           )
*
      RETURN
      END

* PACKAGE UFFTR  !" ＦＦＴ( Numerical Recipes ２**ｎのみ )
*
*"  [HIS] 90/08/31(numaguti)
*
**********************************************************************
      SUBROUTINE FFT99X      !" FFT を呼ぶ
     M         ( G     ,
     M           Z     ,
     C           WTBL  , IFAC  ,
     C           INC   , JUMP  , N     , LOT  , ISIGN  )
*
*   [MODIFY] 
      REAL       G ( * )                     !" 格子データ
      REAL       Z ( * )                     !" スペクトル
*
*   [INPUT] 
      REAL       WTBL  ( * )                 !" 三角関数表
      INTEGER    IFAC  ( * )                 !" 因数分解(ダミー)
      INTEGER    INC                         !" 配列のつめかた
      INTEGER    JUMP
      INTEGER    N
      INTEGER    LOT
      INTEGER    ISIGN                       !" 0 :正変換 1: 逆
*
*   [INTERNAL WORK] 
      INTEGER    INCN, LB, LA
      INTEGER    I, K
*
*
      IF ( JUMP .GT. INC ) THEN
         INCN = ( LOT*JUMP ) / N
      ELSE
         INCN = INC
      ENDIF
      IF ( MOD( INCN,16 ) .EQ. 0 ) INCN = INCN-1
      INCN = MAX ( INCN, LOT )
*
      IF ( ISIGN .EQ. 0 ) THEN
*
*"         < 1. 格子 → スペクトル >
*
         IF ( N .EQ. 1 ) THEN
            DO 1000 K = 1, LOT
               Z ( K ) = G ( K )
 1000       CONTINUE
            RETURN
         ENDIF
*
         DO 1100 I = 1, N
            LA = (I-1)*INC  + 1
            LB = (I-1)*INCN + 1
            DO 1110 K = 1, LOT
               Z ( LB ) = G ( LA )
               LA = LA + JUMP
               LB = LB + 1
 1110       CONTINUE
 1100    CONTINUE
*
         CALL   RFOURT
     O         ( G     ,
     M           Z     ,
     F           1     ,
     F           WTBL  ,
     D           N     , LOT   , INCN )
*
*"                            ( K,2,0 ) <= 0.
         DO 1200 K = 1, LOT
            G ( K+INCN ) = 0.D0
 1200    CONTINUE
*
         DO 1300 I = 1, N
            LA = (I-1)*INC  + 1
            LB = (I-1)*INCN + 1
            DO 1310 K = 1, LOT
               Z ( LA ) = G ( LB )
               LA = LA + JUMP
               LB = LB + 1
 1310       CONTINUE
 1300    CONTINUE
*
      ELSE
*
*"         < 2. スペクトル → 格子 >
*
         IF ( N .EQ. 1 ) THEN
            DO 2000 K = 1, LOT
               G ( K ) = Z ( K )
 2000       CONTINUE
            RETURN
         ENDIF
*
         DO 2100 I = 1, N
            LA = (I-1)*INC  + 1
            LB = (I-1)*INCN + 1
            DO 2110 K = 1, LOT
               G ( LB ) = Z ( LA )
               LA = LA + JUMP
               LB = LB + 1
 2110       CONTINUE
 2100    CONTINUE
*
          CALL   RFOURT
     O         ( Z     ,
     M           G     ,
     F           -1    ,
     F           WTBL  ,
     D           N     , LOT   , INCN )
*
         DO 2300 I = 1, N
            LA = (I-1)*INC  + 1
            LB = (I-1)*INCN + 1
            DO 2310 K = 1, LOT
               G ( LA ) = Z ( LB )
               LA = LA + JUMP
               LB = LB + 1
 2310       CONTINUE
 2300    CONTINUE
*
      ENDIF
*
      RETURN
      END
************************************************************************
      SUBROUTINE RFFTIM     !" FFT 3角関数表作成
     I         ( N     ,
     O           WTBL  , IFAC  )
*
*   [PARAM] 
      INTEGER    N
*
*   [OUTPUT] 
      REAL       WTBL ( 2, N )               !" 三角関数表
      INTEGER    IFAC ( * )                  !" 因数分解(ダミー)
*
*   [INTERNAL WORK] 
      REAL       PI, THETA
      INTEGER    L, M, MM
*
      PI    = ATAN2 ( 0. , -1. )
*
      L  = 1
      MM = 0
 1100 CONTINUE
        IF ( L .LT. N ) THEN
          THETA =  2. * PI / REAL( 2*L )
*
          DO 1110 M = 0, L-1
             MM = MM + 1
             WTBL ( 1, MM ) =   COS( THETA*M )
             WTBL ( 2, MM ) = - SIN( THETA*M )
 1110     CONTINUE
*
          L = L * 2
          GOTO 1100
*"    Repeat
        ENDIF
*
      RETURN
      END
***********************************************************************
      SUBROUTINE RFOURT    !" FFT 実数, 基数 2
     O         ( DATAO ,
     M           DATAI ,
     F           ISIGN ,
     F           WTBL  ,
     D           N     , KMAX  , KDIM )
*
*   [PARAM] 
      INTEGER    N
      INTEGER    KMAX
      INTEGER    KDIM
*
*   [INPUT] 
      REAL       DATAO ( KDIM, 2, 0:N/2-1 )  !" 出力データ
      REAL       DATAI ( KDIM, 2, 0:N/2-1 )  !" 入力データ
      INTEGER    ISIGN                       !" 1: 正変換 -1: 逆
      REAL       WTBL  ( 2, N )              !" 三角関数表
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      REAL       C1, C2, WR, WI
      REAL       H1R, H2R, H3R
      REAL       H1I, H2I, H3I
*
*
      IF ( ISIGN .EQ.  1 ) THEN
        C1  =  1. / N
        C2  = -1. / N
        CALL CFOURT
     M         ( DATAI ,
     F           1     ,
     I           WTBL  ,
     D           N/2   , KMAX  , KDIM )
      ELSE
        C1  = 0.5  
        C2  = 0.5  
      ENDIF
*
      DO 2100 I = 1, N/4
        J  = N/2 - I
        WR = WTBL ( 1,I+N/2 )
        WI = WTBL ( 2,I+N/2 ) * ISIGN
*
        DO 2110 K = 1, KMAX
           H1R            =  C1*( DATAI( K,1,I ) + DATAI( K,1,J ) )
           H1I            =  C1*( DATAI( K,2,I ) - DATAI( K,2,J ) )
           H2R            = -C2*( DATAI( K,2,I ) + DATAI( K,2,J ) )
           H2I            =  C2*( DATAI( K,1,I ) - DATAI( K,1,J ) )
           H3R            =  WR*H2R - WI*H2I
           H3I            =  WR*H2I + WI*H2R
           DATAO( K,1,I ) =  H1R + H3R
           DATAO( K,2,I ) =  H1I + H3I
           DATAO( K,1,J ) =  H1R - H3R
           DATAO( K,2,J ) = -H1I + H3I
 2110   CONTINUE
 2100 CONTINUE
*
      IF ( ISIGN .EQ.  1 ) THEN
        DO 3100 K = 1, KMAX
           H1R            = DATAI( K,1,0 )
           DATAO( K,1,0 ) = C1*( H1R + DATAI( K,2,0 ) )
           DATAO( K,2,0 ) = C1*( H1R - DATAI( K,2,0 ) )
 3100   CONTINUE
      ELSE
        DO 3200 K = 1, KMAX
           H1R            = DATAI( K,1,0 )
           DATAO( K,1,0 ) = H1R + DATAI( K,2,0 )
           DATAO( K,2,0 ) = H1R - DATAI( K,2,0 )
 3200   CONTINUE
*
        CALL CFOURT
     M         ( DATAO ,
     F           -1    ,
     F           WTBL  ,
     D           N/2   , KMAX  , KDIM )
      ENDIF
*
      RETURN
      END
************************************************************************
      SUBROUTINE CFOURT   !" FFT 複素数, 基数 2
     M         ( DATA  ,
     F           ISIGN ,
     I           WTBL  ,
     D           N     , KMAX  , KDIM )
*
*   [PARAM] 
      INTEGER    N
      INTEGER    KMAX
      INTEGER    KDIM
*
*   [MODIFY] 
      REAL       DATA( KDIM, 2, 0:N-1 )      !" データ
*
*   [INPUT] 
      INTEGER    ISIGN                       !" 1: 正変換 -1: 逆
      REAL       WTBL  ( 2, N )              !" 三角関数表
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K, L, M, MM
      REAL       TEMPR, TEMPI, WR, WI
*
*
      J = 0
      DO 1100 I = 0, N-1
*
        IF ( J .GT. I )THEN
          DO 1110 K = 1, KMAX
             TEMPR         = DATA( K,1,J )
             TEMPI         = DATA( K,2,J )
             DATA( K,1,J ) = DATA( K,1,I )
             DATA( K,2,J ) = DATA( K,2,I )
             DATA( K,1,I ) = TEMPR
             DATA( K,2,I ) = TEMPI
 1110     CONTINUE
        ENDIF
*
        M = N/2
 1120   CONTINUE
           IF ( ( M .GT. 1 ) .AND. ( J .GE. M ) ) THEN
              J = J - M
              M = M / 2
              GO TO 1120
*"      Repeat
           ENDIF
*
        J = J + M
*
 1100 CONTINUE
*
      L  = 1
      MM = 0
 2100 CONTINUE
        IF ( L .LT. N ) THEN
          DO 2110 M = 0, L-1
            MM = MM + 1
            WR = WTBL ( 1,MM )
            WI = WTBL ( 2,MM ) * ISIGN
*
            DO 2120 I = M, N-L-1, L*2
              J = I + L
              DO 2130 K = 1, KMAX
                TEMPR         = WR * DATA( K,1,J )
     &                        - WI * DATA( K,2,J )
                TEMPI         = WR * DATA( K,2,J )
     &                        + WI * DATA( K,1,J )
                DATA( K,1,J ) = DATA( K,1,I ) - TEMPR
                DATA( K,2,J ) = DATA( K,2,I ) - TEMPI
                DATA( K,1,I ) = DATA( K,1,I ) + TEMPR
                DATA( K,2,I ) = DATA( K,2,I ) + TEMPI
2130          CONTINUE
2120        CONTINUE
2110      CONTINUE
*
          L = L * 2
          GO TO 2100
*"    Loop
        ENDIF
*
      RETURN
      END

*"表題 格子名配置子の変更  GTOOL3(GUCACF)
*
*"履歴 91/01/21 沼口  敦
*
*
*********************************************************************
*"         << 格子名配置子の変更 >>
*********************************************************************
      SUBROUTINE GUCACF
     I         ( HHEAD, ID    , HCFG  ,
     M           HHEADO                )
*
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      INTEGER    ID                          !" 何次元目の軸か
      CHARACTER  HCFG       *(*)             !" 配置子
      CHARACTER  HHEADO( * )*(*)             !" ヘッダー（出力）
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      CHARACTER  HAITM *(NCC)                !" 格子識別名称
      CHARACTER  HAITMO*(NCC)                !" 格子識別名称
      CHARACTER  HP    *(NCC)
*
      IF ( ( ID .LT. 1 ) .OR. ( ID .GT. 3 ) ) THEN
         CALL MSGDMP( 'E', 'GUCACF', 'IRREGAL ID' )
      ENDIF
*
      HP      = 'AITM'
      WRITE ( HP(5:5), '(I1)' ) ID
*
      CALL GHCGET ( HHEAD , HP   , HAITM )
      CALL GUTACF
     I            ( HAITM , HCFG  ,
     O              HAITMO          )
      CALL GHCSET ( HHEADO, HP   , HAITMO )
*
      RETURN
      END
*********************************************************************
*"         << 格子名配置子の変換 >>
*********************************************************************
      SUBROUTINE GUTACF
     I         ( HAITM , HCFG  ,
     O           HAITMO          )
*
      CHARACTER  HAITM      *(*)                !" 格子識別名称
      CHARACTER  HCFG       *(*)                !" 配置子
      CHARACTER  HAITMO     *(*)                !" 格子識別名称

      HAITMO = ' '
      LENH   = LEN( HAITMO )
*
      INDP = INDEX( HAITM, '.' )
      IF ( INDP .GE. 1 ) THEN
         HAITMO = HAITM(1:INDP)
      ELSE
         INDP = LENZ( HAITM ) + 1
         IF ( INDP .EQ. 1 ) THEN
            CALL MSGDMP( 'W', 'GUTACF', 'NULL AXIS-ITEM' )
            HAITMO = '.'
         ELSE
            HAITMO = HAITM(1:INDP-1)//'.'
         ENDIF
      ENDIF
*
      IF ( INDP .LT. LENH ) THEN
         HAITMO(INDP+1:INDP+1) = HCFG(1:1)
      ELSE
         CALL MSGDMP( 'W', 'GUTACF', 'CHARACTER LENGTH OVER' )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 格子名配置子の参照 >>
*********************************************************************
      SUBROUTINE GUQACF
     I         ( HHEAD, ID    ,
     M           HCFG                  )
*
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      INTEGER    ID                          !" 何次元目の軸か
      CHARACTER  HCFG       *(*)             !" 配置子
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      CHARACTER  HAITM *(NCC)                !" 格子識別名称
      CHARACTER  HP    *(NCC)
*
      IF ( ( ID .LT. 1 ) .OR. ( ID .GT. 3 ) ) THEN
         CALL MSGDMP( 'E', 'GUQACF', 'IRREGAL ID' )
      ENDIF
*
      HP      = 'AITM'
      WRITE ( HP(5:5), '(I1)' ) ID
*
      CALL GHCGET ( HHEAD , HP   , HAITM )
*
      INDP = INDEX( HAITM, '.' )
      IF ( (INDP .GE. 1) .AND. (INDP .LT. NCC ) ) THEN
         HCFG = HAITM(INDP+1:INDP+1)
      ELSE
         HCFG = ' '
      ENDIF
*
      RETURN
      END

* PACKAGE  GTQSAT !" Qsat
***********************************************************************
      PROGRAM GTQSAT
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      CHARACTER  HHEADT( NDC )*(NCC)
      REAL       GDATAT( IJKDIM )
      CHARACTER  HHEADP( NDC )*(NCC)
      REAL       GDATAP( IJKDIM )
      CHARACTER  HHEADQ( NDC )*(NCC)
      REAL       GDATAQ( IJKDIM )
*
      DATA       IFILT / 51 /
      DATA       IFILP / 52 /
      DATA       JFILE / 60 /
*
      CHARACTER  T      *(NFILN)
      DATA       T      / 'T' /
      CHARACTER  PS     *(NFILN)
      DATA       PS     / 'Ps' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM   / 'QSAT' /
      DATA       UNIT   / ' ' /
      DATA       TITLE  / 'saturation humidity' /
      DATA       DSET, EDIT, ETTL /3*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   QSATUM
*     
      NAMELIST  /OPTION/ T, PS, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEADT, IJKDIM )
      CALL GTSIZE ( HHEADP, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( T , OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( PS, OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILET, T     )
      CALL GFROPN ( IFILEP, PS    )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEADT, GDATAT, IEODT  ,
     I          IFILET , 1               )
         CALL   GFREAD
     O        ( HHEADP, GDATAP, IEODP ,
     I          IFILEP, 1               )
*
         IF ( MAX(IEODT,IEODP) .EQ.0 ) THEN
            CALL GPCAL2
     I         ( QSATUM,
     I           HHEADT, GDATAT,
     I           HHEADP, GDATAP,
     I           EDIT  , ETTL  ,
     O           HHEADQ, GDATAQ  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEADQ, 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEADQ, 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEADQ, 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEADQ, 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEADQ  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEADQ, GDATAQ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE QSATUM
     I         ( HHEADT, TT    ,
     I           HHEADP, PS    ,
     O           HHEADQ, QQS   ,
     D           IXDIM , IYDIM , IZDIM ,
     D           IXDIM2, IYDIM2, IZDIM2 )
*
      CHARACTER  HHEADT ( * ) *(*)
      CHARACTER  HHEADP ( * ) *(*)
      CHARACTER  HHEADQ ( * ) *(*)
      REAL       TT ( IXDIM , IYDIM , IZDIM  )
      REAL       PS ( IXDIM2, IYDIM2         )
      REAL       QQS( IXDIM , IYDIM , IZDIM  )
*
      PARAMETER  ( NCC=16, NDC=64 )
      PARAMETER  ( KDIMD=20 )
      CHARACTER  HHEADS ( NDC ) *(NCC)
      REAL       SIG ( KDIMD )
*
* PACKAGE ZQSAT     !" Clausis-Clapeyron の式(文関数)
*
*"    QSAT:  saturation water vapour mixing ratio
*"    DQSAT: d(QSAT)/d(T)
*
      REAL       FQSAT
      REAL       FDQSAT
      REAL       T, P, QS
*
      FQSAT ( T,P )    = EPSV * ES0
     &                   * EXP( EL/RVAP *( 1./273. - 1./T ) )
     &                   / P
      FDQSAT( T,QS )   = EL * QS / ( RVAP * T*T )
*
      EL   = 2.5E6
      RVAP = 461.
      EPSV = 0.622
      ES0  = 6.11
      CALL GTSIZE ( HHEADS, KDIMD )
*
      CALL GUQAXV
     I         ( HHEADT, 3     , 'LOC' ,
     O           HHEADS, SIG   , IEOD   )
*
      DO 1100 IZ = 1, IZDIM
         DO 1110 IY = 1, IYDIM
            DO 1120 IX = 1, IXDIM
               QQS ( IX,IY,IZ ) 
     &            = FQSAT( TT(IX,IY,IZ), PS(IX,IY)*SIG(IZ) )
 1120       CONTINUE
 1110    CONTINUE
 1100 CONTINUE
*
      CALL GHCSET ( HHEADQ, 'ITEM', 'QSAT' )
      CALL GHCSTS ( HHEADQ, 'TITL', 'saturation humidity' )
      CALL GHCSET ( HHEADQ, 'UNIT', ' '  )
      CALL GHRSGP ( HHEADQ  )
*
      RETURN
      END

*"    等間隔データのリニアトレンドの除去 ( 回帰直線を引き去る )
*
*"    93/11/16 horinout
*"      ( SAISHE -- hasegawa )
*"    電脳 MATH1 使用（欠損値処理）
***********************************************************************
      SUBROUTINE SUBTRD(X,K,LD,L,M)
*
      IMPLICIT  REAL (A-H,O-Z)
*  [MODIFTY]
      DIMENSION  X(K,LD,M) !" 第２次元整合寸法 LD, 計算には L 個のみ使う
*
      LOGICAL    LFIRST
      DATA       LFIRST/ .TRUE. /
      SAVE       LFIRST
      REAL*4     RMISS
*
      IF(LFIRST) THEN
        LFIRST = .FALSE.
        CALL GLPGET('RMISS',RMISS)
      ENDIF
*
      DO 10 J=1,M
      DO 10 I=1,K
        CALL SAISHE(X(I,1,J),L,K,A,B,RMISS)
*
        DO 30 N=1,L
          IF( X(K,N,J).NE.RMISS ) THEN
            XTRD = A*N + B
            X(K,N,J) = X(K,N,J) - XTRD    !" トレンドを引く
          ENDIF
   30   CONTINUE
   10 CONTINUE
*
      RETURN
      END
C######################################################
      SUBROUTINE SAISHE(Y,ND,KI,A,B,RMISS)
C######################################################

C     saishou 2jouhou de liner trend wo motomeru
C     Y :data
C     ND:data number, KI:data interval
C     A ------- katamuki
C     B ------- seppen  

C     originary made by Hasegawa,F. reformed by horinout

      IMPLICIT  REAL (A-H,O-Z)
      DIMENSION Y(*)
      REAL*4    RMISS
      SX1=0
      SX2=0
      SY1=0
      SXY=0
      N=0
      
      DO 10 I=1,ND*KI,KI
        IF (Y(I).NE.RMISS) THEN
          X = I
          SX1=SX1+X
          SX2=SX2+X**2
          SY1=SY1+Y(I)
          SXY=SXY+X*Y(I)
          N=N+1
          ENDIF
   10 CONTINUE

      IF (N.LE.1) THEN
        A=RMISS
        B=RMISS
      ELSE 
        A=( N*SXY-SX1*SY1 ) / ( N*SX2-SX1**2 )
        B=( SX2*SY1-SX1*SXY ) / ( N*SX2-SX1**2 )
      ENDIF

      RETURN
      END

* PACKAGE GTXPWSPCT x 軸パワースペクトル                 A.Numaguti
*"                                    bug fix : 97/02/04 S.Takehiro
*********************************************************************
      PROGRAM GTXPSP
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   XPWSPC
*     
      NAMELIST  /OPTION/ OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GTSIZE ( HHEADP, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
C         IF ( MAX(IEOD,IEODP) .EQ.0 ) THEN
         IF ( IEOD.EQ.0 ) THEN
            CALL GMCAL1
     I         ( XPWSPC,
     M           HHEAD , GDATA ,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEAD , 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEAD  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE XPWSPC
     I         ( HDT   , DT    ,
     O           HPW   , PW    ,
     D           IDIM  , JDIM  , KDIM  )
*
      CHARACTER  HDT ( * )*(*)
      REAL       DT  ( IDIM, JDIM, KDIM )
      CHARACTER  HPW ( * )*(*)
      REAL       PW  ( IDIM/2-1, JDIM, KDIM )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      PARAMETER  ( NW=512 )
      REAL       WN  ( NW )
      REAL       DWN ( NW )
      CHARACTER  HWN ( NDC )*(NCC)
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
*
      IF ( IDIM .GE. NW*2 ) THEN
         CALL MSGDMP( 'E','XPWSPC','WORK AREA TOO SMALL' )
      ENDIF
*
      CALL       GTSIZE( HWN, NW )
*
      DO 1100 K = 1, KDIM
         DO 1100 J = 1, JDIM
            CALL RFFTI( IDIM, PW )
            CALL RFFTF(IDIM,DT(1,J,K),PW )
 1100 CONTINUE
*
      DO 2100 K = 1, KDIM
         DO 2100 J = 1, JDIM
            DO 2100 I = 1, IDIM/2-1
               PW( I,J,K ) = ( DT(I*2,J,K) **2 + DT(I*2+1,J,K) **2 )
     &                     / REAL(IDIM) **2
 2100 CONTINUE
*
      CALL GHCSET( HPW, 'AITM1', '@WVN01' )
      CALL GHPSET( HPW, 'AEND1', IDIM/2-1 )
*
*"       < 波数空間軸の生成 >
*
      IF( OFIRST ) THEN
         OFIRST = .FALSE.
*
         IF ( IDIM/2-1 .GT. NW ) THEN
            CALL MSGDMP('E','XPWSPC','WORK SPACE NOT ENOUGH')
         ENDIF
         DO 3100 I = 1, IDIM/2-1
            WN ( I ) = REAL(I)
            DWN( I ) = 1.
 3100    CONTINUE
*
         CALL    GHPGET ( HDT, 'MISS', VMISS )
         CALL    GHPACA
     O         ( HWN,
     I           'IAXLOC', '@WVN01',
     I           'wave number', ' ',
     I           IDIM/2-1,
     I           'UR4' , VMISS ,
     I           VMISS , VMISS , VMISS , VMISS , 1 )
*
         CALL    GUSIAX
     I         ( HWN , WN , DWN ,
     I           1                )
*
         CALL  GUWIAX
     I         ( HPW )
      ENDIF
*
      RETURN
      END

*"表題 描画属性記述子のリセット GTOOL3(GHRSGP)
*
*"履歴 90/10/13 沼口  敦
*
*
*********************************************************************
*"         << 描画属性記述子のリセット >>
*********************************************************************
      SUBROUTINE GHRSGP
     I         ( HHEAD )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
*
      DATA       ISTYP / 1 /
*
      CALL GHPGET( HHEAD, 'MISS', VMISS )
*
      CALL GHPSET( HHEAD, 'DMIN', VMISS )
      CALL GHPSET( HHEAD, 'DMAX', VMISS )
      CALL GHPSET( HHEAD, 'DIVS', VMISS )
      CALL GHPSET( HHEAD, 'DIVL', VMISS )
      CALL GHPSET( HHEAD, 'STYP', ISTYP )
*
      RETURN
      END

*"表題 GTOOLファイル名取得オープン GTOOL3(GFROPQ)
*
*"履歴 90/10/13 沼口  敦
*"     92/09/19 沼口  敦 APPEND
*"     99/12/02 竹広真一  メッセージ出力番号を DCL より取得
*
*********************************************************************
*"         << ファイル名取得＆読み込みオープン >>
*********************************************************************
      SUBROUTINE GFROPQ
     O         ( IFILE ,
     I           HINQ   )
*
      INTEGER    IFILE                    !" 装置番号
      CHARACTER  HINQ  *(*)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      INTEGER    IUNIT
      CHARACTER  HFILE *(NFILN)           !" ファイル名
      CHARACTER  HMSG  *100
      DATA       IFILED / 50 /
*
      CALL GLIGET( 'MSGUNIT', IUNIT )
*
      IFILE  = IFILED
      HMSG   = ' INPUT  FILE NAME for '//HINQ//' ? '
      WRITE ( IUNIT,* )     HMSG
      READ  ( 5,'(A)' ) HFILE
*
      CALL       GFROPN
     O         ( IFILE , HFILE )
*
      RETURN
*====================================================================
*"         << ファイル名取得＆書き込みオープン >>
*====================================================================
      ENTRY      GFWOPQ
     O         ( IFILE ,
     I           HINQ   )
*
      IFILE  = IFILED
      HMSG   = ' OUTPUT FILE NAME for '//HINQ//' ? '
      CALL GLIGET( 'MSGUNIT', IUNIT )
      WRITE ( IUNIT,* )     HMSG
      READ  ( 5,'(A)' ) HFILE
*
      CALL       GFWOPN
     O         ( IFILE , HFILE )
*
      RETURN
*====================================================================
*"         << ファイル名取得＆追加書き込みオープン >>
*====================================================================
      ENTRY      GFAOPQ
     O         ( IFILE ,
     I           HINQ   )
*
      IFILE  = IFILED
      HMSG   = ' APPEND OUT FILE NAME for '//HINQ//' ? '
      CALL GLIGET( 'MSGUNIT', IUNIT )
      WRITE ( IUNIT,* )     HMSG
      READ  ( 5,'(A)' ) HFILE
*
      CALL       GFAOPN
     O         ( IFILE , HFILE )
*
      RETURN
*====================================================================
*"         << ファイル名取得＆(追加)書き込みオープン >>
*====================================================================
      ENTRY      GFOOPQ
     M         ( IFILE ,
     I           HINQ    )
*
      IFILE  = IFILED
      HMSG   = ' OUTPUT FILE NAME for '//HINQ//' ? '
      CALL GLIGET( 'MSGUNIT', IUNIT )
      WRITE ( IUNIT,* )     HMSG
      READ  ( 5,'(A)' ) HFILE
*
      CALL    GFOOPN
     O         ( IFILE , HFILE, .FALSE. )
*
      RETURN
      END

*"表題 ベクトル描画 GTOOL3(GGVECT)
*
*"履歴 90/08/17 沼口  敦
*"     90/10/17 沼口  敦
*"     95/05/31 竹広真一 for dcl-5.0
*"     97/12/01 竹広真一 UGPSET -> UGPSTX
*
*********************************************************************
*"         << ベクトル描画 >>
*********************************************************************
      SUBROUTINE GGVECT
     I         ( HHEADU, GDATAU,
     I           HHEADV, GDATAV )
*
      CHARACTER  HHEADU ( * )*(*)        !" ヘッダー(u成分)
      CHARACTER  HHEADV ( * )*(*)        !" ヘッダー(v成分)
      REAL       GDATAU ( * )            !" データ(u成分)
      REAL       GDATAV ( * )            !" データ(v成分)
*
      LOGICAL    OUNIT
      LOGICAL    OEQRAT
*
      CALL GUSMIS ( HHEADU )
*
      CALL GUQSIZ
     I         ( HHEADU,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GHPGET ( HHEADU, 'MISS' , UMISS  )
      CALL GHPGET ( HHEADU, 'DMIN' , UMIN   )
      CALL GHPGET ( HHEADU, 'DMAX' , UMAX   )
      CALL GHPGET ( HHEADU, 'STYP' , ISTYPU )
*
      CALL GHPGET ( HHEADV, 'MISS' , VMISS  )
      CALL GHPGET ( HHEADV, 'DMIN' , VMIN   )
      CALL GHPGET ( HHEADV, 'DMAX' , VMAX   )
      CALL GHPGET ( HHEADV, 'STYP' , ISTYPV )
*
      CALL GGPGET ( 'VXINT'  , IXINT )
      CALL GGPGET ( 'VYINT'  , IYINT )
      CALL UGPSTX ( 'IXINT'  , IXINT )
      CALL UGPSTX ( 'IYINT'  , IYINT )
*
      CALL GGPGET ( 'LUNIT'  , OUNIT   )
      CALL UGPSTX ( 'LUNIT'  , OUNIT   )
      CALL GGPGET ( 'VXULOC' , VXULOC  )
      CALL GGPGET ( 'VYULOC' , VYULOC  )
      CALL UGPSTX ( 'VXULOC' , VXULOC  )
      CALL UGPSTX ( 'VYULOC' , VYULOC  )
      CALL GGPGET ( 'SREMK'  , SREMK   )
      CALL UGPSTX ( 'RSIZET' , SREMK   )
      CALL UGPSTX ( 'RSIZEUT', SREMK   )
*
      CALL GGPGET ( 'LEQRAT' , OEQRAT  )
      CALL UGPSTX ( 'LEQRAT' , OEQRAT  )
      CALL UGPSTX ( 'LNRMAL' , .FALSE. )
*
      CALL GGPGET ( 'VECFCT' , VECFCT )
*
      CALL SGQVPT ( VXMIN , VXMAX , VYMIN , VYMAX )
*
      IF ( UMIN .EQ. UMISS ) UMIN = RMIN( GDATAU, IXDIM*IYDIM, 1 )
      IF ( UMAX .EQ. UMISS ) UMAX = RMAX( GDATAU, IXDIM*IYDIM, 1 )
      AUMAX = MAX( ABS( UMIN ), ABS( UMAX ) )
      XFACT = VECFCT/AUMAX
     &        * ( VXMAX-VXMIN )/MAX( 1,IXDIM-1 ) * IXINT
      XFACT = RGNLE ( XFACT )
*
      IF ( VMIN .EQ. VMISS ) VMIN = RMIN( GDATAV, IXDIM*IYDIM, 1 )
      IF ( VMAX .EQ. VMISS ) VMAX = RMAX( GDATAV, IXDIM*IYDIM, 1 )
      AVMAX = MAX( ABS( VMIN ), ABS( VMAX ) )
      YFACT = VECFCT/AVMAX
     &        * ( VYMAX-VYMIN )/MAX( 1,IYDIM-1 ) * IYINT
      YFACT = RGNLE ( YFACT )
*
      IF ( OEQRAT ) THEN
         XFACT = MIN( XFACT, YFACT )
         YFACT = XFACT
      ENDIF
      IF ( ISTYPU .LT. 0 ) XFACT = - XFACT
      IF ( ISTYPV .LT. 0 ) YFACT = - YFACT
*
      CALL UGPSTX ( 'XFACT1', XFACT )
      CALL UGPSTX ( 'YFACT1', YFACT )
*
      CALL UGVECT ( GDATAU, IXEND-IXSTR+1,
     &              GDATAV, IXEND-IXSTR+1,
     &              IXEND-IXSTR+1, IYEND-IYSTR+1 )
*
      RETURN
      END

*"表題 共通パラメーター管理 GTOOL3(GTPGET)
*
*"履歴 90/09/21 沼口  敦
*
*
*********************************************************************
*"         << 共通パラメータ（数）を参照 >>
*********************************************************************
      SUBROUTINE GTPGET
     I         ( HP,
     O           IPARA )
*
      CHARACTER HP   *(*)                !" パラメーターの名前
*"   (INTEGER)  IPARA                    ! パラメーターの内容：数字
*
      CHARACTER HPARA*(*)                !" パラメーターの内容：文字
*
      PARAMETER ( NPP=4, NPC=10 )
*
      REAL      RX( NPP )
      INTEGER   IX( NPP )
      LOGICAL   LX( NPP )
      EQUIVALENCE ( RX,IX,LX )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC, NFILN
#else
#include         "gzsize.F"                  !" NCC, NDC, NFILN
#endif
      CHARACTER HPP  ( NPP )*8
      CHARACTER HPC  ( NPC )*8
      CHARACTER HX   ( NPC )*(NFILN)
      CHARACTER CMSG*80
*
      SAVE  IX, HPP, HX, HPC
*
      DATA      HPP( 1)/'MISS    '/, RX( 1)/-999./   !" 欠損値
      DATA      HPP( 2)/'SUBCHK  '/, LX( 2)/.FALSE./ !" チェック
      DATA      HPP( 3)/'WFILE   '/, IX( 3)/91/      !" 作業ファイル
      DATA      HPP( 4)/'STYTSQ  '/, IX( 4)/1/       !" 時間軸方向
*
      DATA      HPC( 1)/'FAXLOC  '/, HX( 1)/           !" 格子位置
     & GTAXLOC /
      DATA      HPC( 2)/'FAXWGT  '/, HX( 2)/           !" 格子重み
     & GTAXWGT /
      DATA      HPC( 3)/'FAXLOC1 '/, HX( 3)/'GTAXLOC.'/!" 格子位置
      DATA      HPC( 4)/'FAXWGT1 '/, HX( 4)/'GTAXWGT.'/!" 格子重み
      DATA      HPC( 5)/'UTIM    '/, HX( 5)/'DAY '/  !" 時間表示単位
      DATA      HPC( 6)/'MYSIGN  '/, HX( 6)/'GTOOL3'/!" あなたの名前
      DATA      HPC( 7)/'DDSET   '/, HX( 7)/'TEST'  /!" デフォルトDS
      DATA      HPC( 8)/'ITEMSEQ '/, HX( 8)/'TIME'  /!" 系列ITEM
      DATA      HPC( 9)/'AXISSEQ '/, HX( 9)/'@EXTAX'/!" 系列軸名
      DATA      HPC(10)/'APPENDC '/, HX(10)/'+'/     !" APPENDモード
*
      DO 1100 N = 1, NPP
        IF ( HP .EQ. HPP  (N) ) THEN
          IPARA = IX(N)
          RETURN
        END IF
 1100 CONTINUE
*
      NHP  = LENC(HP)
      CMSG = 'PARAMETER '''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP( 'E', 'GTPGET', CMSG )
*
      RETURN
*=======================================================================
*"         << 共通パラメータ（数）を設定 >>
*=======================================================================
      ENTRY GTPSET
     I         ( HP, IPARA )
*
      DO 2100 N = 1, NPP
        IF ( HP .EQ. HPP  (N) ) THEN
          IX( N ) = IPARA
          RETURN
        END IF
 2100 CONTINUE
*
      NHP = LENC(HP)
      CMSG = 'PARAMETER '''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP( 'E', 'GTPSET', CMSG )
*
      RETURN
*=======================================================================
*"         << 共通パラメータ（文字）を参照 >>
*=======================================================================
      ENTRY GTCGET
     I         ( HP,
     O           HPARA )
*
      DO 3100 N = 1, NPC
        IF ( HP .EQ. HPC(N) ) THEN
          HPARA = HX( N )
          RETURN
        END IF
 3100 CONTINUE
*
      NHP = LENC(HP)
      CMSG = 'PARAMETER '''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP( 'E', 'GTCGET', CMSG )
*
      RETURN
*=======================================================================
*"         << 共通パラメーター（文字）を設定 >>
*=======================================================================
      ENTRY GTCSET
     I         ( HP, HPARA )
*
      DO 4100 N = 1, NPC
        IF ( HP .EQ. HPC(N) ) THEN
          HX( N ) = HPARA
          RETURN
        END IF
 4100 CONTINUE
*
      NHP = LENC(HP)
      CMSG = 'PARAMETER '''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP( 'E', 'GTCSET', CMSG )
*
      RETURN
      END

*"表題 コンター描画 GTOOL3(GGCNTR)
*
*"履歴 90/08/17 沼口  敦
*"     97/12/01 竹広真一 SET -> STX
*
*********************************************************************
*"         << コンター描画 >>
*********************************************************************
      SUBROUTINE GGCNTR
     I         ( HHEAD, GDATA )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       GDATA ( * )             !" データ
*
      PARAMETER (NBR3=3000*3)
      INTEGER   IBR ( NBR3 )
*
      CALL GUSMIS ( HHEAD )
*
      CALL GHPGET ( HHEAD, 'ASTR1', IXSTR )
      CALL GHPGET ( HHEAD, 'AEND1', IXEND )
      CALL GHPGET ( HHEAD, 'ASTR2', IYSTR )
      CALL GHPGET ( HHEAD, 'AEND2', IYEND )
      IXDIM = IXEND-IXSTR+1
      IYDIM = IYEND-IYSTR+1
*
      CALL GHPGET ( HHEAD, 'MISS' , VMISS )
      CALL GHPGET ( HHEAD, 'DMIN' , DMIN  )
      CALL GHPGET ( HHEAD, 'DMAX' , DMAX  )
      CALL GHPGET ( HHEAD, 'DIVS' , DIVS  )
      CALL GHPGET ( HHEAD, 'DIVL' , DIVL  )
*
      CALL GGPGET ( 'SREMK' , SREMK )
      CALL UDPSTX ( 'RSIZET', SREMK )
      CALL GGPGET ( 'SCONL' , SCONL )
      CALL UDPSTX ( 'RSIZEL', SCONL )
*
      CALL GGPGET ( 'ICYCLE', ICYCLE )
      CALL UDPSTX ( 'ICYCLE', ICYCLE )
*
      CALL GGPGET ( 'CONTSET', ICNSET )
      IF ( ICNSET .LE. 0 ) THEN
         CALL UDICLV
      ENDIF
*
      IF ( (ICNSET .NE. 1) .AND. (DIVS .NE. VMISS) ) THEN
*
         IF ( DIVL .NE. VMISS ) THEN
            ICYCLE = NINT( DIVL/DIVS )
            CALL UDPSTX( 'ICYCLE', ICYCLE )
         ENDIF
*
         CALL GGPGET( 'CONRFCT', CONFAC )
         IF      ( (DMIN.EQ.VMISS) .AND. (DMAX.NE.VMISS) ) THEN
            CONFAC = 1.
         ELSE IF ( (DMIN.NE.VMISS) .AND. (DMAX.EQ.VMISS) ) THEN
            CONFAC = 0.
         ENDIF
*
         IF ( DMIN .EQ. VMISS ) THEN
            DMIN = RMIN( GDATA, IXDIM*IYDIM, 1 )
         ENDIF
         IF ( DMAX .EQ. VMISS ) THEN
            DMAX = RMAX( GDATA, IXDIM*IYDIM, 1 )
         ENDIF
*
         CALL GGPGET( 'NCONMAX', NCONMX )
         NUMCON = INT( (DMAX-DMIN)/DIVS  ) + 1
         IF ( NUMCON .GT. NCONMX ) THEN
            RANGE = DIVS * ( NCONMX-1 )
            DMIN  = DMIN + CONFAC*( DMAX-DMIN - RANGE )
            DMAX  = DMIN + RANGE
         ENDIF
*
         CALL UDGCLA ( DMIN, DMAX, DIVS )
*
      ENDIF
*
      CALL UDCNTZ ( GDATA,
     &              IXDIM, IXDIM, IYDIM,
     &              IBR  , NBR3          )
*
      RETURN
      END

*"表題 レイアウト GTOOL3(GGLAY1)
*
*"履歴 90/08/21 沼口  敦
*"履歴 95/05/25 竹広真一  for dcl-5.0
*"     97/12/01 竹広真一 SET -> STX
*
*********************************************************************
*"         << レイアウト, 題名表示 >>
*********************************************************************
      SUBROUTINE GGLAY1
     I         ( HHEAD )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HTITL   *(NCC*2)
      CHARACTER  HDSET   *(NCC)
      CHARACTER  HUNIT   *(NCC)
      CHARACTER  HITEM   *(NCC)
      CHARACTER  HUTIM   *4
      CHARACTER  HTIME   *(NCC)
      CHARACTER  HDATE   *(NCC)
      CHARACTER  HDATEX  *(NCC)
      CHARACTER  HDATIM  *(NCC*3)
      CHARACTER  HEDIT( NED )*(NCC)
      INTEGER    NHE  ( NED )
      CHARACTER  HFNUM   *(NCC)
      CHARACTER  HDNUM   *(NCC)
      CHARACTER  HAITM   *(NCC)
      CHARACTER  HS      *(NCC)
      CHARACTER  HE      *(NCC)
      CHARACTER  HRAN    *(NCC)
      CHARACTER  HEDS    *(100)
      CHARACTER  HP      *8
      LOGICAL    OLCNTL
      DATA       NDESC / 24 /            !" 横に出力する情報の数
*
*"         < 1. 初期化 >
*
      CALL GRFRM
      CALL GGAXRS
      CALL GGLTRS
*
      CALL UZPGET( 'RSIZET2', RSIZT2 )
      CALL UZPGET( 'ROFFXT' , ROFFXT )
      IF ( ROFFXT .LT. RSIZT2 ) CALL UZPSTX( 'ROFFXT', RSIZT2 )
*
*"         < 2. ビューポート(仮座標)設定 >
*
      CALL GGPGET ( 'VRATIO' , VRATIO )
      CALL GGPGET ( 'VXMIN'  , VXMIN  )
      CALL GGPGET ( 'VXMAX'  , VXMAX  )
      CALL GGPGET ( 'VYMIN'  , VYMIN  )
      CALL GGPGET ( 'VYMAX'  , VYMAX  )
*
      CALL SGSVPT ( VXMIN, VXMAX , VYMIN , VYMAX )
      CALL SGSWND ( 0.   , 1.    , 0.    , 1.  )
      CALL SGSTRN (1)
      CALL SGSTRF
*
*"         < 3. 編集タイトル >
*
      CALL GHCGET ( HHEAD, 'ITEM',  HITEM    )
      CALL GHCGET ( HHEAD, 'EDIT1', HEDIT(1) )
      CALL GHCGET ( HHEAD, 'EDIT2', HEDIT(2) )
      CALL GHCGET ( HHEAD, 'EDIT3', HEDIT(3) )
      CALL GHCGET ( HHEAD, 'EDIT4', HEDIT(4) )
      CALL GHCGET ( HHEAD, 'EDIT5', HEDIT(5) )
      CALL GHCGET ( HHEAD, 'EDIT6', HEDIT(6) )
      CALL GHCGET ( HHEAD, 'EDIT7', HEDIT(7) )
      CALL GHCGET ( HHEAD, 'EDIT8', HEDIT(8) )
      NHI = LENC( HITEM )
      DO 2100 II = 1, 8
         NHE ( II ) = LENC( HEDIT( II ) )
 2100 CONTINUE
      CALL GHCGET ( HHEAD, 'FNUM', HFNUM    )
      NHFL = LENB( HFNUM )
      NHF  = LENC( HFNUM )
      CALL GHCGET ( HHEAD, 'DNUM', HDNUM    )
      NHDL = LENB( HDNUM )
      NHD  = LENC( HDNUM )
*
      HEDS  =       HITEM(1:NHI)
     &       //' '//HEDIT(1)(1:NHE(1))
     &       //' '//HEDIT(2)(1:NHE(2))
     &       //' '//HEDIT(3)(1:NHE(3))
     &       //' '//HEDIT(4)(1:NHE(4))
     &       //' '//HEDIT(5)(1:NHE(5))
     &       //' '//HEDIT(6)(1:NHE(6))
     &       //' '//HEDIT(7)(1:NHE(7))
     &       //' '//HEDIT(8)(1:NHE(8))
     &       //'#'//HFNUM(NHFL+1:NHF)
     &       //'-'//HDNUM(NHDL+1:NHD)
*
      CALL GGPGET ( 'SEDIT'  , SEDIT )
      CALL UZPSTX ( 'RSIZEC2', SEDIT )
*
      CALL SGPGET ( 'LCNTL', OLCNTL  )
      CALL SGPSTX ( 'LCNTL', .FALSE. )
      CALL UXMTTL ( 'T', HEDS  , -1. )
      CALL SGPSTX ( 'LCNTL', OLCNTL  )
*
*"         < 4. タイトル等 >
*
      CALL GHCGTS ( HHEAD, 'TITL',  HTITL  )
      CALL GHCGET ( HHEAD, 'DSET',  HDSET  )
      CALL GHCGET ( HHEAD, 'UNIT',  HUNIT  )
*
      CALL GUQTIM ( HHEAD , RT    , HUTIM  )
      IF ( RT .GT. 9999900.0 ) THEN
         CALL CHVAL  ( 'D'      , RT    , HTIME  )
      ELSE
         CALL CHVAL  ( '(F10.1)', RT    , HTIME  )
      ENDIF
      NHT = LENC( HTIME )
*
      CALL GGPGET ( 'STITL'  , STITL )
      CALL UZPSTX ( 'RSIZEC2', STITL )
*
      CALL UZPGET ( 'ROFFXT', ROFF   )
      CALL UXMTTL ( 'T', HUNIT , -1. )
*
      HDATIM = HTIME(1:NHT)//HUTIM
      CALL GHCGET ( HHEAD, 'DATE',  HDATE  )
      IF ( HDATE .NE. ' ' ) THEN
         HDATEX        = ' ' 
         HDATEX(1:2)   = HDATE(3:4)
         HDATEX(3:3)   = '/'
         HDATEX(4:5)   = HDATE(5:6)
         HDATEX(6:6)   = '/'
         HDATEX(7:8)   = HDATE(7:8)
         NHT    = LENC( HDATIM )         
         HDATIM = HDATIM(1:NHT)//' '//HDATEX
      ENDIF
      CALL UZPSTX ( 'ROFFXT', ROFF   )
      CALL UXMTTL ( 'T', HDATIM,  1. )
*
      CALL UZPGET ( 'ROFFXT', ROFF   )
      CALL UXMTTL ( 'T', HTITL , -1. )
      CALL UZPSTX ( 'ROFFXT', ROFF   )
      CALL SGPGET ( 'LCNTL', OLCNTL  )
      CALL SGPSTX ( 'LCNTL', .FALSE. )
      CALL UXMTTL ( 'T', HDSET ,  1. )
      CALL SGPSTX ( 'LCNTL', OLCNTL  )
*
      CALL UZPSTX ( 'ROFFXT' , 0. )
*
*"         < 5. その他の情報を出力 >
*
      VX    = VXMAX + ( 1.-VXMAX ) *0.1         !" 出力位置(x)
      VY    = VYMAX                             !" 出力位置(y)
      DVY   = - ( VYMAX - 0.0 ) / NDESC         !" 出力間隔(y)
*
      CALL GGPGET ( 'SDESC'  , SDESC )
      IF ( SDESC .LE. 0. ) RETURN
*
      CALL SGSTXS ( SDESC )
      CALL SGSTXC ( -1 )
      CALL SGSTXI ( 1 )
*
      HP = 'ETTL'
      DO 5100 II = 1, 8
         WRITE ( HP(5:5), '(I1)' ) II
         CALL GGCDSC ( HHEAD, HP, VX, VY )
         VY = VY + DVY
 5100 CONTINUE
*
      CALL GGCDSC ( HHEAD, 'DATE', VX, VY )
      VY = VY + DVY
*
      DO 5200 II = 1, 2
         HP = 'AITM'
         WRITE ( HP(5:5), '(I1)' ) II
         CALL GHCGET ( HHEAD, HP, HAITM  )
         CALL SGTXV  ( VX, VY, HAITM  )
         VY = VY + DVY
         IF ( HAITM .NE. ' ' ) THEN
            HP(1:4) = 'ASTR'
            CALL GHCGET ( HHEAD, HP, HS  )
            HP(1:4) = 'AEND'
            CALL GHCGET ( HHEAD, HP, HE  )
            NHSB = LENB( HS )
            NHSC = LENC( HS )
            NHEB = LENB( HE )
            NHEC = LENC( HE )
            HRAN = '('//HS(NHSB+1:NHSC)//','//HE(NHEB+1:NHEC)//')'
            CALL SGTXV  ( VX , VY, HRAN  )
         ENDIF
         VY = VY + DVY
 5200 CONTINUE
*
      CALL GGPDSC ( HHEAD, 'DMIN', VX   , VY  )
      VY = VY + DVY
      CALL GGPDSC ( HHEAD, 'DMAX', VX   , VY  )
      VY = VY + DVY
      CALL GGPDSC ( HHEAD, 'DIVS', VX   , VY  )
      VY = VY + DVY
      CALL GGPDSC ( HHEAD, 'DIVL', VX   , VY  )
      VY = VY + DVY
*
      CALL GGCDSC ( HHEAD, 'MDATE', VX   , VY  )
      VY = VY + DVY
      CALL GGCDSC ( HHEAD, 'MSIGN', VX   , VY  )
      VY = VY + DVY
*
      RETURN
      END

*"表題 サイズの比較 GTOOL3(GUCSIZ)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << データサイズの比較 >>
*********************************************************************
      SUBROUTINE GUCSIZ
     I         ( HHEAD1, HHEAD2,
     O           IXSTR1, IXDIM1, IXSTR2, IXDIM2,
     O           IYSTR1, IYDIM1, IYSTR2, IYDIM2,
     O           IZSTR1, IZDIM1, IZSTR2, IZDIM2,
     O           IXSTRC, IXENDC, IXDIMC,
     O           IYSTRC, IYENDC, IYDIMC,
     O           IZSTRC, IZENDC, IZDIMC         )
*
      CHARACTER  HHEAD1 ( * )*(*)        !" ヘッダー１
      CHARACTER  HHEAD2 ( * )*(*)        !" ヘッダー２
      INTEGER    IXSTR1, IXDIM1          !" 軸１の始めと大きさ
      INTEGER    IXSTR2, IXDIM2          !"  〃 （ヘッダー２）
      INTEGER    IYSTR1, IYDIM1          !" 軸２の始めと大きさ
      INTEGER    IYSTR2, IYDIM2          !"  〃 （ヘッダー２）
      INTEGER    IZSTR1, IZDIM1          !" 軸３の始めと大きさ
      INTEGER    IZSTR2, IZDIM2          !"  〃 （ヘッダー２）
      INTEGER    IXSTRC, IXENDC, IXDIMC  !" 軸１の共通部分
      INTEGER    IYSTRC, IYENDC, IYDIMC  !" 軸２の共通部分
      INTEGER    IZSTRC, IZENDC, IZDIMC  !" 軸３の共通部分
*
*"         < 1. サイズを調べる >
*
      CALL GUQSIZ
     I         ( HHEAD1,
     O           IXSTR1, IXEND1, IXDIM1,
     O           IYSTR1, IYEND1, IYDIM1,
     O           IZSTR1, IZEND1, IZDIM1 )
      CALL GUQSIZ
     I         ( HHEAD2,
     O           IXSTR2, IXEND2, IXDIM2,
     O           IYSTR2, IYEND2, IYDIM2,
     O           IZSTR2, IZEND2, IZDIM2 )
*
*"         < 2. 共通部分 >
*
      IXSTRC = MAX( IXSTR1, IXSTR2 )
      IYSTRC = MAX( IYSTR1, IYSTR2 )
      IZSTRC = MAX( IZSTR1, IZSTR2 )
      IXENDC = MIN( IXEND1, IXEND2 )
      IYENDC = MIN( IYEND1, IYEND2 )
      IZENDC = MIN( IZEND1, IZEND2 )
*
*"         < 3. 共通部分の大きさ >
*
      IXDIMC = IXENDC - IXSTRC + 1
      IYDIMC = IYENDC - IYSTRC + 1
      IZDIMC = IZENDC - IZSTRC + 1
*
      RETURN
      END

*"表題 ヘッダー読み書き GTOOL3(GHPGET)
*
*"履歴 90/08/21 沼口  敦
*"     99/12/02 竹広真一  メッセージ出力番号を DCL より取得
*
*
**********************************************************************
*"         << 記述子（数）の参照 >>
**********************************************************************
      SUBROUTINE GHPGET
     I         ( HHEAD , HP    ,
     I           IX              )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEAD (NDC)*(NCC)       !" ヘッダー
      CHARACTER  HP         *(*)         !" ヘッダーの記述子指定
*"   (INTEGER)   IX                      ! 記述子の内容：数
*
      CHARACTER  HX         *(*)         !" 記述子の内容：文字
      CHARACTER  HFM        *(*)         !" 記述子の書式
*
      CHARACTER  HPARA ( NDC )*8
      CHARACTER  HFMT  ( NDC )*8
*
      REAL       AY
      INTEGER    IY
      EQUIVALENCE (AY,IY)
*
      CHARACTER  HMSG*50
      INTEGER    NHP
*
      INTEGER    IDFM0                   !" フォーマットid
      DATA       IDFM0 /9010/
*
      INTEGER    NPARA
      DATA       NPARA / 64 /
*
      DATA       HPARA(  1 )/'IDFM    '/, HFMT(  1 )/'(I16)'/
      DATA       HPARA(  2 )/'DSET    '/, HFMT(  2 )/'(A)'/
      DATA       HPARA(  3 )/'ITEM    '/, HFMT(  3 )/'(A)'/
      DATA       HPARA(  4 )/'EDIT1   '/, HFMT(  4 )/'(A)'/
      DATA       HPARA(  5 )/'EDIT2   '/, HFMT(  5 )/'(A)'/
      DATA       HPARA(  6 )/'EDIT3   '/, HFMT(  6 )/'(A)'/
      DATA       HPARA(  7 )/'EDIT4   '/, HFMT(  7 )/'(A)'/
      DATA       HPARA(  8 )/'EDIT5   '/, HFMT(  8 )/'(A)'/
      DATA       HPARA(  9 )/'EDIT6   '/, HFMT(  9 )/'(A)'/
      DATA       HPARA( 10 )/'EDIT7   '/, HFMT( 10 )/'(A)'/
      DATA       HPARA( 11 )/'EDIT8   '/, HFMT( 11 )/'(A)'/
      DATA       HPARA( 12 )/'FNUM    '/, HFMT( 12 )/'(I16)'/
      DATA       HPARA( 13 )/'DNUM    '/, HFMT( 13 )/'(I16)'/
      DATA       HPARA( 14 )/'TITL1   '/, HFMT( 14 )/'(A)'/
      DATA       HPARA( 15 )/'TITL2   '/, HFMT( 15 )/'(A)'/
      DATA       HPARA( 16 )/'UNIT    '/, HFMT( 16 )/'(A)'/
      DATA       HPARA( 17 )/'ETTL1   '/, HFMT( 17 )/'(A)'/
      DATA       HPARA( 18 )/'ETTL2   '/, HFMT( 18 )/'(A)'/
      DATA       HPARA( 19 )/'ETTL3   '/, HFMT( 19 )/'(A)'/
      DATA       HPARA( 20 )/'ETTL4   '/, HFMT( 20 )/'(A)'/
      DATA       HPARA( 21 )/'ETTL5   '/, HFMT( 21 )/'(A)'/
      DATA       HPARA( 22 )/'ETTL6   '/, HFMT( 22 )/'(A)'/
      DATA       HPARA( 23 )/'ETTL7   '/, HFMT( 23 )/'(A)'/
      DATA       HPARA( 24 )/'ETTL8   '/, HFMT( 24 )/'(A)'/
      DATA       HPARA( 25 )/'TIME    '/, HFMT( 25 )/'(I16)'/
      DATA       HPARA( 26 )/'UTIM    '/, HFMT( 26 )/'(A)'/
      DATA       HPARA( 27 )/'DATE    '/, HFMT( 27 )/'(A)'/
      DATA       HPARA( 28 )/'TDUR    '/, HFMT( 28 )/'(I16)'/
      DATA       HPARA( 29 )/'AITM1   '/, HFMT( 29 )/'(A)'/
      DATA       HPARA( 30 )/'ASTR1   '/, HFMT( 30 )/'(I16)'/
      DATA       HPARA( 31 )/'AEND1   '/, HFMT( 31 )/'(I16)'/
      DATA       HPARA( 32 )/'AITM2   '/, HFMT( 32 )/'(A)'/
      DATA       HPARA( 33 )/'ASTR2   '/, HFMT( 33 )/'(I16)'/
      DATA       HPARA( 34 )/'AEND2   '/, HFMT( 34 )/'(I16)'/
      DATA       HPARA( 35 )/'AITM3   '/, HFMT( 35 )/'(A)'/
      DATA       HPARA( 36 )/'ASTR3   '/, HFMT( 36 )/'(I16)'/
      DATA       HPARA( 37 )/'AEND3   '/, HFMT( 37 )/'(I16)'/
      DATA       HPARA( 38 )/'DFMT    '/, HFMT( 38 )/'(A)'/
      DATA       HPARA( 39 )/'MISS    '/, HFMT( 39 )/'(E16.7)'/
      DATA       HPARA( 40 )/'DMIN    '/, HFMT( 40 )/'(E16.7)'/
      DATA       HPARA( 41 )/'DMAX    '/, HFMT( 41 )/'(E16.7)'/
      DATA       HPARA( 42 )/'DIVS    '/, HFMT( 42 )/'(E16.7)'/
      DATA       HPARA( 43 )/'DIVL    '/, HFMT( 43 )/'(E16.7)'/
      DATA       HPARA( 44 )/'STYP    '/, HFMT( 44 )/'(I16)'/
      DATA       HPARA( 45 )/'COPTN   '/, HFMT( 45 )/'(A)'/
      DATA       HPARA( 46 )/'IOPTN   '/, HFMT( 46 )/'(I16)'/
      DATA       HPARA( 47 )/'ROPTN   '/, HFMT( 47 )/'(E16.7)'/
      DATA       HPARA( 48 )/'TIME2   '/, HFMT( 48 )/'(I16)'/
      DATA       HPARA( 49 )/'UTIM2   '/, HFMT( 49 )/'(A)'/
      DATA       HPARA( 50 )/'MEMO1   '/, HFMT( 50 )/'(A)'/
      DATA       HPARA( 51 )/'MEMO2   '/, HFMT( 51 )/'(A)'/
      DATA       HPARA( 52 )/'MEMO3   '/, HFMT( 52 )/'(A)'/
      DATA       HPARA( 53 )/'MEMO4   '/, HFMT( 53 )/'(A)'/
      DATA       HPARA( 54 )/'MEMO5   '/, HFMT( 54 )/'(A)'/
      DATA       HPARA( 55 )/'MEMO6   '/, HFMT( 55 )/'(A)'/
      DATA       HPARA( 56 )/'MEMO7   '/, HFMT( 56 )/'(A)'/
      DATA       HPARA( 57 )/'MEMO8   '/, HFMT( 57 )/'(A)'/
      DATA       HPARA( 58 )/'MEMO9   '/, HFMT( 58 )/'(A)'/
      DATA       HPARA( 59 )/'MEMO10  '/, HFMT( 59 )/'(A)'/
      DATA       HPARA( 60 )/'CDATE   '/, HFMT( 60 )/'(A)'/
      DATA       HPARA( 61 )/'CSIGN   '/, HFMT( 61 )/'(A)'/
      DATA       HPARA( 62 )/'MDATE   '/, HFMT( 62 )/'(A)'/
      DATA       HPARA( 63 )/'MSIGN   '/, HFMT( 63 )/'(A)'/
      DATA       HPARA( 64 )/'SIZE    '/, HFMT( 64 )/'(I16)'/
      DATA       IMISS / 39 /
*
      INTEGER    IUNIT
*
*"         < 1. フォーマットの検査 >
*
      READ ( HHEAD( 1 ), HFMT( 1 ), IOSTAT=IOS ) IDFM
      IF ( ( IDFM .NE. IDFM0 ).OR.( IOS .NE. 0 ) ) THEN
         NFMT = LENC ( HHEAD( 1 ) )
         HMSG = 'FORMAT'//HHEAD( 1 )(1:NFMT)//' IS NOT MATCH.'
         CALL MSGDMP('W', 'GHPGET', HMSG )
         CALL GLIGET( 'MSGUNIT', IUNIT )
         WRITE ( IUNIT,* ) HHEAD
*
         IY = -1
      ENDIF
*
*"         < 2. 表から探して読む >
*
      CALL GTPGET( 'MISS', VMISS )
*
      DO 2100 IP = 1, NPARA
         IF ( HP .EQ. HPARA( IP ) ) THEN
*
            IF      ( HFMT( IP )(2:2) .EQ. 'I' ) THEN
               READ ( HHEAD( IP ), HFMT( IP ), IOSTAT=IOS  ) IY
               IF ( IOS .NE. 0 ) IY = 0
            ELSE IF ( HFMT( IP )(2:2) .EQ. 'E' ) THEN
               READ ( HHEAD( IP ), HFMT( IP ), IOSTAT=IOS  ) AY
               IF ( IOS .NE. 0 ) THEN
                 READ ( HHEAD(IMISS),HFMT(IMISS),IOSTAT=IOS ) AY
               ENDIF
            ELSE
               NHP  = LENC ( HP )
               HMSG = 'PARAMETER'''//HP(1:NHP)//''' IS NOT FOR NUMBER.'
               CALL MSGDMP('W', 'GHPGET', HMSG )
               IY = -1
            ENDIF
*
            IX = IY
*
            RETURN
        ENDIF
 2100 CONTINUE
*
*"         < 3. 表にないとき >
*
      NHP  = LENC ( HP )
      HMSG = 'PARAMETER'''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP('W', 'GHPGET', HMSG )
*
      RETURN
*=====================================================================
*"         << 記述子（数）の設定 >>
*=====================================================================
      ENTRY GHPSET
     M         ( HHEAD ,
     I           HP    , IX     )
*
*"         < 4. 表から探して書く >
*
      IF ( HP .EQ. HPARA( 1 ) ) THEN
         WRITE ( HHEAD( 1 ), HFMT( 1 ) ) IDFM0
         RETURN
      ENDIF
*
      DO 4100 IP = 2, NPARA
         IF ( HP .EQ. HPARA( IP ) ) THEN
*
            IY = IX
            IF       ( HFMT( IP )(2:2) .EQ. 'I' ) THEN
               WRITE ( HHEAD( IP ), HFMT( IP ) ) IY
            ELSE  IF ( HFMT( IP )(2:2) .EQ. 'E' ) THEN
               WRITE ( HHEAD( IP ), HFMT( IP ) ) AY
            ELSE
               NHP  = LENC ( HP )
               HMSG = 'PARAMETER'''//HP(1:NHP)//''' IS NOT FOR NUMBER.'
               CALL MSGDMP('W', 'GHPSET', HMSG )
            ENDIF
*
            RETURN
         ENDIF
 4100 CONTINUE
*
*"         < 5. 表にないとき >
*
      NHP  = LENC ( HP )
      HMSG = 'PARAMETER'''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP('W', 'GHPSET', HMSG )
*
      RETURN
*=====================================================================
*"         << 記述子（文字）の参照 >>
*=====================================================================
      ENTRY      GHCGET
     I         ( HHEAD , HP    ,
     I           HX              )
*
*"         < 6. フォーマットの検査 >
*
      READ ( HHEAD( 1 ), HFMT( 1 ), IOSTAT=IOS ) IDFM
      IF ( ( IDFM .NE. IDFM0 ).OR.( IOS .NE. 0 ) ) THEN
         NFMT = LENC ( HHEAD( 1 ) )
         HMSG = 'FORMAT'//HHEAD( 1 )(1:NFMT)//' IS NOT MATCH.'
         CALL MSGDMP('W', 'GHCGET', HMSG )
         CALL GLIGET( 'MSGUNIT', IUNIT )
         WRITE ( IUNIT,* ) HHEAD
*
         HX = ' '
      ENDIF
*
*"         < 7. 表から探して読む >
*
      DO 7100 IP = 1, NPARA
         IF ( HP .EQ. HPARA( IP ) ) THEN
            HX = HHEAD( IP )
            RETURN
        ENDIF
 7100 CONTINUE
*
*"         < 8. 表にないとき >
*
      NHP  = LENC ( HP )
      HMSG = 'PARAMETER'''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP('W', 'GHCGET', HMSG )
*
      RETURN
*=====================================================================
*"         << 記述子（文字）の設定 >>
*=====================================================================
      ENTRY GHCSET
     M         ( HHEAD ,
     I           HP    , HX     )
*
*"         < 9. 表から探して書く >
*
      DO 9100 IP = 1, NPARA
         IF ( HP .EQ. HPARA( IP ) ) THEN
            HHEAD( IP ) = HX
            RETURN
         ENDIF
 9100 CONTINUE
*
*"         < 10. 表にないとき >
*
      NHP  = LENC ( HP )
      HMSG = 'PARAMETER'''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP('W', 'GHCSET', HMSG )
*
      RETURN
*=====================================================================
*"         << 記述子の書式参照 >>
*=====================================================================
      ENTRY GHPINQ
     I         ( HP    ,
     O           HFM    )
*
      DO 9600 IP = 1, NPARA
         IF ( HP .EQ. HPARA( IP ) ) THEN
            HFM = HFMT( IP )
            RETURN
        ENDIF
 9600 CONTINUE
*
      HFM = ' '
      RETURN
*=====================================================================
*"         << 記述子のクリアー >>
*=====================================================================
      ENTRY GHPCLR
     O         ( HHEAD  )
*
      WRITE ( HHEAD( 1 ), HFMT( 1 ) ) IDFM0
*
      DO 9700 IP = 2, NPARA
         IF       ( HFMT( IP )(2:2) .EQ. 'I' ) THEN
            WRITE ( HHEAD( IP ), HFMT( IP ) ) 0
         ELSE  IF ( HFMT( IP )(2:2) .EQ. 'E' ) THEN
            WRITE ( HHEAD( IP ), HFMT( IP ) ) 0.
         ELSE
            HHEAD( IP ) = ' '
         ENDIF
 9700 CONTINUE
*
      RETURN
*=====================================================================
*"         << 記述子名参照 >>
*=====================================================================
      ENTRY GHNINQ
     I         ( IZ    ,
     O           HP      )
*
      IF ( IZ .GE. 1 .AND. IZ .LE. NPARA ) THEN
         HP = HPARA ( IZ )
      ELSE
         HP = ' '
      ENDIF
*
      RETURN
      END

*"表題 格子情報ファイルの読み込み  GTOOL3(GUQAXS)
*
*"履歴 90/09/14 沼口  敦
*
*
*********************************************************************
*"         << 格子情報ファイルの読み込み >>
*********************************************************************
      SUBROUTINE GUQAXS
     I         ( HAXIS , HKIND ,
     O           HHEAD , AXIS  , IEOD  )
*
      CHARACTER  HAXIS *(*)                  !" 格子識別名称
      CHARACTER  HKIND *(*)                  !" LOC/WGT
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      REAL       AXIS  ( * )                 !" 位置/重み
      INTEGER    IEOD                        !" データなしフラグ
      LOGICAL    OEXIST
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      CHARACTER  HAXF  *(NFILN)
      CHARACTER  HFILE *(NFILN)
*
      IF ( HAXIS .EQ. ' ' ) THEN
         IEOD = 1
                                        RETURN
      ENDIF
*
*"        < 1. 「内部ファイル」からの読み込み >
*
      CALL GUQIAX
     I         ( HAXIS , HKIND ,
     O           HHEAD , AXIS  , IEOD   )
*
      IF ( IEOD .NE. 0  ) THEN
*
         CALL GTPGET( 'WFILE', IFILW )
*
*"         < 2. カレントディレクトリからの読み込み >
*
         IF      ( HKIND(1:1).EQ.'L' ) THEN
            CALL GTCGET( 'FAXLOC1', HAXF  )
         ELSE IF ( HKIND(1:1).EQ.'W' ) THEN
            CALL GTCGET( 'FAXWGT1', HAXF  )
         ELSE
            CALL MSGDMP( 'W','GUQAXS','IRREGAL HKIND: <LOC> ASSUMED.' )
            CALL GTCGET( 'FAXLOC1', HAXF  )
         ENDIF
         NHF   = LENC( HAXF )
         HFILE = HAXF(1:NHF)//HAXIS
*
         INQUIRE ( FILE=HFILE, EXIST=OEXIST )
*
         IF ( OEXIST ) THEN
            CALL GFROPN
     M         ( IFILW ,
     I           HFILE   )
            CALL GFREAD
     O         ( HHEAD , AXIS  , IEOD  ,
     I           IFILW , 0              )
            CALL GFCLSE ( IFILW )
         ENDIF
      ENDIF
*
*"         < 3. デフォルトディレクトリからの読み込み >
*
      IF ( IEOD .NE. 0 ) THEN 
         IF      ( HKIND(1:1).EQ.'L' ) THEN
            CALL GTCGET( 'FAXLOC', HAXF  )
         ELSE IF ( HKIND(1:1).EQ.'W' ) THEN
            CALL GTCGET( 'FAXWGT', HAXF  )
         ELSE
            CALL GTCGET( 'FAXLOC', HAXF  )
         ENDIF
         NHF   = LENC( HAXF )
         HFILE = HAXF(1:NHF)//HAXIS
*
         CALL GFROPN
     M         ( IFILW ,
     I           HFILE   )
         CALL GFREAD
     O         ( HHEAD , AXIS  , IEOD  ,
     I           IFILW , 0              )
         CALL GFCLSE ( IFILW )
*
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 格子情報ファイルの読み込み >>
*********************************************************************
      SUBROUTINE GUQAXC
     I         ( HAXIS , HKIND ,
     O           HHEAD , AXIS  , ACYCLE, IAMAX , IEOD  )
*
      CHARACTER  HAXIS *(*)                  !" 格子識別名称
      CHARACTER  HKIND *(*)                  !" LOC/WGT
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      REAL       AXIS  ( * )                 !" 位置/重み
      REAL       ACYCLE                      !" サイクリック値
      INTEGER    IAMAX                       !" 格子点数:非サイクリック
      INTEGER    IEOD                        !" データなしフラグ
      LOGICAL    OCYCL                       !" 周期境界軸スイッチ
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      CHARACTER  HAXD *(NCC)
*
      CALL       GUQAXS
     I         ( HAXIS , HKIND ,
     O           HHEAD , AXIS  , IEOD  )
*
      IF ( IEOD .EQ. 0 ) THEN
         CALL GHPGET ( HHEAD, 'AEND1', IAMAX  )
         CALL GHCGET ( HHEAD, 'DSET' , HAXD   )
         OCYCL = ( HAXD(1:1) .EQ. 'C' )
         IF ( OCYCL ) THEN
            IAMAX  = IAMAX - 1
            IF      ( HKIND(1:1).EQ.'L' ) THEN
               ACYCLE = AXIS( IAMAX+1 ) - AXIS( 1 )
            ELSE IF ( HKIND(1:1).EQ.'W' ) THEN
               ACYCLE = 0.
            ELSE
               CALL MSGDMP
     &              ( 'W','GUQAXC','IRREGAL HKIND: <LOC> ASSUMED.' )
               ACYCLE = AXIS( IAMAX+1 ) - AXIS( 1 )
            ENDIF
         ELSE
            ACYCLE = 0.
         ENDIF
      ELSE
         AXIS(1) = 1.
         ACYCLE  = 0.
         IAMAX   = 1
      ENDIF
*
      RETURN
      END

*"表題 散布図描画 GTOOL3(GGSCAT)
*
*"履歴 93/01/25 沼口  敦
*
*
*********************************************************************
*"         << 散布図描画 >>
*********************************************************************
      SUBROUTINE GGSCAT
     I         ( HHEADX, GDATAX,
     I           HHEADY, GDATAY, HPOS   )
*
      CHARACTER  HHEADX( * )*(*)         !" ヘッダー
      REAL       GDATAX( * )             !" データ
      CHARACTER  HHEADY( * )*(*)         !" ヘッダー
      REAL       GDATAY( * )             !" データ
      CHARACTER  HPOS       *(*)         !" データ軸 ('X' or 'Y')
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHX( NDC )*(NCC)
      CHARACTER  HHY( NDC )*(NCC)
*
      LOGICAL    OLINT                   !" 線種コメントを描く？
*
      CALL GUSMIS ( HHEADX )
*
*"        < 1. 範囲 >
*
      CALL GUQTSZ ( HHEADX, ISIZEX )
      CALL GUQTSZ ( HHEADY, ISIZEY )
      CALL GHCOPY ( HHEADX, HHX )
      CALL GHCOPY ( HHEADY, HHY )
      CALL GHPSET ( HHX, 'ASTR1', 1 )
      CALL GHPSET ( HHX, 'AEND1', ISIZEX )
      CALL GHPSET ( HHX, 'ASTR2', 1 )
      CALL GHPSET ( HHX, 'AEND2', 1 )
      CALL GHPSET ( HHX, 'ASTR3', 1 )
      CALL GHPSET ( HHX, 'AEND3', 1 )
      CALL GHPSET ( HHY, 'ASTR1', 1 )
      CALL GHPSET ( HHY, 'AEND1', ISIZEY )
      CALL GHPSET ( HHY, 'ASTR2', 1 )
      CALL GHPSET ( HHY, 'AEND2', 1 )
      CALL GHPSET ( HHY, 'ASTR3', 1 )
      CALL GHPSET ( HHY, 'AEND3', 1 )
*
*"         < 2. 軸描画, 座標設定 >
*
      CALL GGAXSZ
     I     ( HHX, GDATAX, 'X'  )
      CALL GGAXSZ
     I     ( HHY, GDATAY, 'Y'  )
*
*"         < 3. 折れ線描画 >
*
      IF ( ISIZEX .NE. ISIZEY ) THEN
         CALL MSGDMP( 'W', 'GGSCAT', 'ARRAY SIZE DO NOT AGREE.' )
      ENDIF
*
      CALL SGPMU  ( ISIZEX, GDATAX, GDATAY )
*
*"         < 4. 線種コメント >
*
      CALL GGPGET ( 'LLINT', OLINT )
      IF ( OLINT ) THEN
         IF ( HPOS .EQ. 'X' ) THEN
            CALL GGLINT ( HHX, 'CURV' )
         ELSE
            CALL GGLINT ( HHY, 'CURV' )
         ENDIF
      ENDIF
*
      RETURN
      END

* PACKAGE GTADD   !" ΟΒ
*********************************************************************
      PROGRAM GTADD
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD1( NDC )*(NCC)
      REAL       GDATA1( IJKDIM )
      CHARACTER  HHEAD2( NDC )*(NCC)
      REAL       GDATA2( IJKDIM )
      CHARACTER  HFILE( 2 ) *(NFILN)
      DATA       HFILE  / '$GTTMPDIR/gtool.out',
     &                    '$GTTMPDIR/gtool.out' /
      INTEGER    IFILE( 2 ) 
      DATA       IFILE  / 50, 51 /
      DATA       JFILE  / 60 /
*
      REAL       OFS1,  OFS2
      DATA       OFS1,  OFS2  / 0.0, 0.0 /
      REAL       FACT1, FACT2
      DATA       FACT1, FACT2 / 1.0, 1.0 /
      REAL       VAL
      DATA       VAL    / 1.0 /
      REAL       OFS , FACT
      DATA       OFS , FACT   / 0.0, 1.0 /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET /4*' '/
*
      DATA       EDIT, ETTL /'ADD','<gtadd>'/
*
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ OFS1, OFS2, FACT1, FACT2, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE

*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD1, IJKDIM )
      CALL GTSIZE ( HHEAD2, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( HFILE( 2 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE( 1 ), HFILE( 1 ) )
      IF ( HFILE( 1 ) .NE. HFILE( 2 ) ) THEN
         CALL GFROPN ( IFILE( 2 ), HFILE( 2 ) )
      ENDIF
      CALL GFOOPN ( JFILE, OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
 1100 CONTINUE
*
         CALL   GFREAD
     O        ( HHEAD1, GDATA1, IEOD1 ,
     I          IFILE( 1 ), 1               )
*
         IEOD2 = 0
         IF ( HFILE( 1 ) .NE. HFILE( 2 ) ) THEN
            CALL   GFREAD
     O        ( HHEAD2, GDATA2, IEOD2 ,
     I          IFILE( 2 ), 1               )
         ELSE
            CALL   GPFSET
     I        ( HHEAD1, GDATA1,
     I          '  '  , '  '  ,
     O          HHEAD2, GDATA2  )
            WRITE (6,*) '** DUPLEX'
         ENDIF
*
         IF ( MAX( IEOD1,IEOD2 ) .EQ. 0 ) THEN
*
           IF ( OFS1 .NE. 0.0 ) THEN
              CALL GMFINC
     I        ( HHEAD1, GDATA1, OFS1 ,
     I          '  '  , '  '           )
           ENDIF
           IF ( FACT1 .NE. 1.0 ) THEN
              CALL GMFFCT
     I        ( HHEAD1, GDATA1, FACT1   ,
     I          '  '  , '  '           )
           ENDIF
*
           IF ( OFS2 .NE. 0.0 ) THEN
              CALL GMFINC
     I        ( HHEAD2, GDATA2, OFS2 ,
     I          '  '  , '  '           )
           ENDIF
           IF ( FACT2 .NE. 1.0 ) THEN
              CALL GMFFCT
     I        ( HHEAD2, GDATA2, FACT2 ,
     I          '  '  , '  '           )
           ENDIF
*
           CALL GMFADD
     I        ( HHEAD1, GDATA1,
     I          HHEAD2, GDATA2,
     I          EDIT  , ETTL   )
*
           IF ( ITEM .NE. ' ' ) THEN
              CALL GHCSET( HHEAD1, 'ITEM', ITEM )
           ENDIF
           IF ( UNIT .NE. ' ' ) THEN
              CALL GHCSET( HHEAD1, 'UNIT', UNIT )
           ENDIF
           IF ( TITLE .NE. ' ' ) THEN
              CALL GHCSTS( HHEAD1, 'TITL', TITLE )
           ENDIF
           IF ( DSET .NE. ' ' ) THEN
              CALL GHCSET( HHEAD1, 'DSET', DSET )
           ENDIF
*
           IF ( GRESET ) THEN
              CALL GHRSGP( HHEAD1 )
           ENDIF
*
           CALL  GFWRIT
     I         ( HHEAD1, GDATA1,
     I           JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END

* PACKAGE GTSINC  !" ワーク領域の大きさ(IJKDIMのみ意味あり)
*****************************************************************
      INTEGER IDIM, JDIM, KDIM, IJKDIM
      PARAMETER  ( IDIM=256 )
      PARAMETER  ( JDIM=128 )
      PARAMETER  ( KDIM=33  )
      PARAMETER  ( IJKDIM=IDIM*JDIM*KDIM )
      

*"表題 第3次元を拡張 GTOOL3(GPZEXP)
*
*"履歴 90/09/24 沼口  敦
*
*
*********************************************************************
*"         << 第3次元を拡張 >>
*********************************************************************
      SUBROUTINE GPZEXP
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO   )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS       *(NCC)      !" 軸名称
      LOGICAL    OCYCL                   !" サイクリックか？
*
      CALL GHCGET ( HHEAD, 'AITM3', HAXIS  )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
      CALL GPZRDC
     I         ( HHEAD , GDATA , 1      , IADIM  ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO                    )
*
      RETURN
*====================================================================
*"         << 第3次元をサイクリックに拡張 >>
*====================================================================
      ENTRY      GPZEXC
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO   )
*
      CALL GHCGET ( HHEAD, 'AITM3 ', HAXIS  )
      CALL GUQAXD
     I         ( HAXIS ,
     O           IADIM , OCYCL  )
*
      IF ( OCYCL ) THEN
         IADIM = IADIM + 1
      ENDIF
*
      CALL GPZRDC
     I         ( HHEAD , GDATA , 1      , IADIM  ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO                    )
*
      RETURN
      END
*********************************************************************
*"         << 第3次元を拡張 >>
*********************************************************************
      SUBROUTINE GMZEXP
     M         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPZEXP
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW   )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
*====================================================================
*"         << 第3次元をサイクリックに拡張 >>
*====================================================================
      ENTRY      GMZEXC
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPZEXC
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW   )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

* PACKAGE GTCREATE   !" ½ñ¼°¤Ä¤­->gtool3
************************************************************************
      PROGRAM GTCRET
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
      CHARACTER  HDATE*(NCC)
      CHARACTER  HSIGN*(NCC)
*
      CHARACTER  HFILE( 1 )        *(NFILN)
      DATA       HFILE / '-' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
      LOGICAL    LOC
      DATA       LOC    / .FALSE. /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ LOC, OUT, APND, HFILE, HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GHPCLR ( HHEAD )
      CALL GTPGET ( 'MISS', VMISS )
      CALL GHPSET ( HHEAD, 'FNUM', 1     )
      CALL GHPSET ( HHEAD, 'DNUM', 1     )
      CALL GHCSET ( HHEAD, 'UTIM', 'DAY' )
      CALL GHPSET ( HHEAD, 'TDUR', 1     )
      CALL GHPSET ( HHEAD, 'ASTR1', 0    )      
      CALL GHPSET ( HHEAD, 'AEND1', 0    )      
      CALL GHPSET ( HHEAD, 'ASTR2', 0    )      
      CALL GHPSET ( HHEAD, 'AEND2', 0    )      
      CALL GHPSET ( HHEAD, 'ASTR3', 0    )      
      CALL GHPSET ( HHEAD, 'AEND3', 0    )      
      CALL GHPSET ( HHEAD, 'MISS', VMISS )
      CALL GHPSET ( HHEAD, 'DMIN', VMISS )
      CALL GHPSET ( HHEAD, 'DMAX', VMISS )
      CALL GHPSET ( HHEAD, 'DIVS', VMISS )
      CALL GHPSET ( HHEAD, 'DIVL', VMISS )
      CALL GHPSET ( HHEAD, 'STYP', 1     )
      CALL GHCSET ( HHEAD, 'DFMT', 'UR4' )
      CALL GUQNOW ( HDATE )
      CALL GTCGET ( 'MYSIGN', HSIGN )
      CALL GHCSET ( HHEAD , 'CDATE' , HDATE )
      CALL GHCSET ( HHEAD , 'CSIGN' , HSIGN )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      IF ( HFILE(1) .EQ. '-' ) THEN
         IFILE = 5
      ELSE
         OPEN ( IFILE, FILE=HFILE(1), 
     &          ACCESS='SEQUENTIAL',FORM='FORMATTED' )
      ENDIF
      CALL GFOOPN ( JFILE, OUT , APND )
*
      II = 0
 2100 CONTINUE
         II = II + 1
*
         IF ( LOC ) THEN
            CALL RDTXTL
     I            ( IFILE ,
     M              HHEAD ,
     O              GDATA , IEOD  )
         ELSE
            CALL RDTXT
     I            ( IFILE ,
     M              HHEAD ,
     O              GDATA , IEOD  )
         ENDIF
*
         IF ( IEOD .EQ. 0 ) THEN
            CALL GFWRIT
     I            ( HHEAD , GDATA ,
     I              JFILE , 1     , 0       )
      GOTO 2100            
         ENDIF
*
      STOP
      END
***********************************************************************
      SUBROUTINE RDTXT
     I         ( IFILE ,
     M           HHEAD ,
     O           GDATA, IEOD  )
*
      CHARACTER  HHEAD ( * )*(*)
      REAL       GDATA ( * )
*
      
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      PARAMETER (NBUF=255)
      CHARACTER  HBUF*(NBUF), HXX*(NBUF)
      CHARACTER  HP*(NCC), HX*(NCC)
      CHARACTER  HFMT*(NCC)
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      LOGICAL    LCHRN
*
  100 CONTINUE 
      READ ( IFILE,'(A)',IOSTAT=IEOS ) HBUF
      IF ( IEOS .NE. 0 ) THEN
         IEOD = 1
         RETURN
      ENDIF
      IF ( HBUF(1:1) .EQ. '#' ) THEN
         GOTO 100
      ENDIF
*
      IDX = 0
*
 1100 CONTINUE
*
         IL   = LENB(HBUF)
         LENH = LEN(HBUF)
         IF ( .NOT.LCHRN(HBUF(IL+1:IL+1)) ) THEN
*
            IC = INDEX(HBUF,':')
            IF ( IC.GT.IL .AND. IC.LT.LENH ) THEN
               HP  = HBUF(IL+1:IC-1)
               ILX = LENB(HBUF(IC+1:LENH))+IC
               HXX = HBUF(ILX+1:LENH)
               HX  = HXX
               IF ( HP .EQ. 'TITLE' ) THEN
                  CALL GHCSTS(HHEAD,'TITL',HXX)
               ELSE IF ( HP .NE. 'SIZE' ) THEN
                  CALL GHPINQ(HP,HFMT)
                  IF ( HFMT .NE. '(A)' ) THEN
                     CALL CRADJ(HX)
                  ENDIF
                  CALL GHCSET(HHEAD,HP,HX)
               ENDIF
            ENDIF
*
 1200       CONTINUE 
               READ ( IFILE,'(A)',END=9000 ) HBUF
            IF ( HBUF(1:1) .EQ. '#' ) THEN
               GOTO 1200
            ENDIF
*
      GOTO 1100
         ENDIF
*
      CALL GUQTSZ( HHEAD,ISIZE )
      CALL GHPSET( HHEAD, 'SIZE', ISIZE )
*
 2100 CONTINUE
*
         IL   = LENB(HBUF)
         LENH = LEN(HBUF)
         IF ( LCHRN(HBUF(IL+1:IL+1)) ) THEN
*
            IC = INDEX(HBUF,':')
            IF ( IC.GT.IL .AND. IC.LT.LENH ) THEN
               ILX = LENB (HBUF(IC+1:LENH))+IC
               HXX = HBUF(ILX+1:LENH)
            ELSE
               HXX=HBUF(IL+1:LENH)
            ENDIF
            IDX = IDX + 1
            READ (HXX,*) GDATA(IDX)
*
            IF ( IDX .EQ. ISIZE ) THEN
               IEOD = 0
               RETURN
            ENDIF
            ILN  = INDEX(HXX,' ')
            LENH = LEN(HXX)
            IF ( ILN .GT. 0 .AND. ILN .LT. LENH ) THEN
               HBUF = HXX(ILN+1:LENH)
      GOTO 2100
            ENDIF
*
         ELSE
            READ ( IFILE,'(A)',END=9000 ) HBUF
      GOTO 2100
*
         ENDIF
*
 9000 CONTINUE
      IF ( IDX .NE. 0 ) THEN
         CALL MSGDMP('W','RDTXT','UNEXPECTED EOF')
      ENDIF
      IEOD = 1
      RETURN
*
      END
********************************************************************
      LOGICAL FUNCTION   LCHRN(C)
      CHARACTER  C
      LOGICAL    LCHRD
*
      LCHRN = LCHRD(C) .OR. (C.EQ.'-') .OR. (C.EQ.'.')
*
      RETURN
      END
***********************************************************************
      SUBROUTINE RDTXTL
     I         ( IFILE ,
     M           HHEAD ,
     O           GDATA, IEOD  )
*
      CHARACTER  HHEAD ( * )*(*)
      REAL       GDATA ( * )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      PARAMETER (NBUF=255)
      CHARACTER  HBUF*(NBUF), HXX*(NBUF)
      CHARACTER  HP*(NCC), HX*(NCC)
      CHARACTER  HFMT*(NCC)
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      LOGICAL    LCHRN
      SAVE
*
      PARAMETER  ( IMAXD = 1024 )
      REAL       XP( IMAXD )
      REAL       YP( IMAXD )
      REAL       ZP( IMAXD )
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
  100    CONTINUE 
         READ ( IFILE,'(A)',IOSTAT=IEOS ) HBUF
         IF ( IEOS .NE. 0 ) THEN
            IEOD = 1
            RETURN
         ENDIF
         IF ( HBUF(1:1) .EQ. '#' ) THEN
            GOTO 100
         ENDIF
      ENDIF
*
      IDX = 0
*
 1100 CONTINUE
*
         IL   = LENB(HBUF)
         LENH = LEN(HBUF)
         IF ( .NOT.LCHRN(HBUF(IL+1:IL+1)) ) THEN
*
            IC = INDEX(HBUF,':')
            IF ( IC.GT.IL .AND. IC.LT.LENH ) THEN
               HP  = HBUF(IL+1:IC-1)
               ILX = LENB(HBUF(IC+1:LENH))+IC
               HXX = HBUF(ILX+1:LENH)
               HX  = HXX
               IF ( HP .EQ. 'TITLE' ) THEN
                  CALL GHCSTS(HHEAD,'TITL',HXX)
               ELSE IF ( HP .NE. 'SIZE' ) THEN
                  CALL GHPINQ(HP,HFMT)
                  IF ( HFMT .NE. '(A)' ) THEN
                     CALL CRADJ(HX)
                  ENDIF
                  CALL GHCSET(HHEAD,HP,HX)
               ENDIF
            ENDIF
*
 1200       CONTINUE 
               READ ( IFILE,'(A)',IOSTAT=IEOS ) HBUF
               IF ( IEOS .NE. 0 ) THEN
                  IEOD = 1
                  RETURN
               ENDIF
               IF ( HBUF(1:1) .EQ. '#' ) THEN
                  GOTO 1200
               ENDIF
*
      GOTO 1100
         ENDIF
*
      CALL GUQAXQ
     I            ( HHEAD , 1     , 'LOC' ,
     O              XP    , XCYCL , IXDIM , IEODX , 
     D              IMAXD                 )
      CALL GUQAXQ
     I            ( HHEAD , 2     , 'LOC' ,
     O              YP    , YCYCL , IYDIM , IEODY , 
     D              IMAXD                 )
      CALL GUQAXQ
     I            ( HHEAD , 3     , 'LOC' ,
     O              ZP    , ZCYCL , IZDIM , IEODZ , 
     D              IMAXD                 )
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
      CALL RSET0  ( GDATA, IXDIM*IYDIM*IZDIM, 1, VMISS )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           ISTRD , IENDD , IDIMD ,
     O           JSTRD , JENDD , JDIMD ,
     O           KSTRD , KENDD , KDIMD  )
      IF ( ISTRD .EQ. 0 .AND. IENDD .EQ. 0  ) THEN
         CALL GHPSET( HHEAD, 'ASTR1', 1     )
         CALL GHPSET( HHEAD, 'AEND1', IXDIM )
      ENDIF
      IF ( JSTRD .EQ. 0 .AND. JENDD .EQ. 0  ) THEN
         CALL GHPSET( HHEAD, 'ASTR2', 1     )
         CALL GHPSET( HHEAD, 'AEND2', IYDIM )
      ENDIF
      IF ( KSTRD .EQ. 0 .AND. KENDD .EQ. 0  ) THEN
         CALL GHPSET( HHEAD, 'ASTR3', 1     )
         CALL GHPSET( HHEAD, 'AEND3', IZDIM )
      ENDIF
*
      CALL GUQTSZ( HHEAD,ISIZE )
      CALL GHPSET( HHEAD, 'SIZE', ISIZE )
*
 2100 CONTINUE
*
         IL   = LENB(HBUF)
         LENH = LEN(HBUF)
         IF ( LCHRN(HBUF(IL+1:IL+1)) ) THEN
            HXX=HBUF(IL+1:LENH)
*
            IF ( IEODX .NE. 0 ) THEN
               IF ( IEODY .NE. 0 ) THEN
                  IF ( IEODZ .NE. 0 ) THEN
                     READ (HXX,*) GDZ
                  ELSE
                     READ (HXX,*) ZPZ, GDZ
                  ENDIF
               ELSE
                  IF ( IEODZ .NE. 0 ) THEN
                     READ (HXX,*) YPZ, GDZ
                  ELSE
                     READ (HXX,*) YPZ, ZPZ, GDZ
                  ENDIF
               ENDIF
            ELSE IF ( IEODY .NE. 0 ) THEN
               IF ( IEODZ .NE. 0 ) THEN
                  READ (HXX,*) XPZ, GDZ
               ELSE
                  READ (HXX,*) XPZ, ZPZ, GDZ
               ENDIF
            ELSE IF ( IEODZ .NE. 0 ) THEN
               READ (HXX,*) XPZ, YPZ, GDZ
            ELSE
               READ (HXX,*) XPZ, YPZ, ZPZ, GDZ
            ENDIF
*
            CALL NEARST ( XPZ, XP, IXDIM, XCYCL, IX )
            CALL NEARST ( YPZ, YP, IYDIM, YCYCL, IY )
            CALL NEARST ( ZPZ, ZP, IZDIM, ZCYCL, IZ )
*
            GDATA( ((IZ-1)*IYDIM+IY-1)*IXDIM+IX ) = GDZ
*
 2200       CONTINUE 
               READ ( IFILE,'(A)',END=9000 ) HBUF
               IF ( HBUF(1:1) .EQ. '#' ) THEN
                  GOTO 2200
               ENDIF
*
      GOTO 2100
         ELSE
            IEOD = 0
            RETURN
         ENDIF
*
 9000 CONTINUE
      IEOD = 0
      HBUF = 'END_OF_FILE'
*
      RETURN
      END
****************************************************************
      SUBROUTINE NEARST
     I         ( X     , XP    , NXP   , XCYCL  ,
     O           IX                                )
*
      REAL       X
      REAL       XP  ( NXP )
      REAL       XCYCL
      INTEGER    IX
*
      IF ( NXS .EQ. 1 ) THEN
         IX = 1
         RETURN
      ENDIF
*
      DX = ABS(XP(1)-X)
      IX = 1
*
      DO 1100 IP = 1, NXP
         DXP = ABS(XP(IP)-X)
         IF ( XCYCL .NE. 0. ) THEN
            DXP = DXP-INT(DXP/ABS(XCYCL))*ABS(XCYCL)
         ENDIF
         IF ( DXP .LT. DX ) THEN
            DX = DXP 
            IX = IP
         ENDIF
 1100 CONTINUE 
*
      RETURN
      END

* PACKAGE USUBS       !" 雑ルーチン
*
*"  [HIS] 90/08/31(numaguti)
*
***********************************************************************
      SUBROUTINE RESET     !" 配列を０リセット
     O         ( DATA  ,
     D           IDIM   )
*
*   [PARAM] 
      INTEGER    IDIM
*
*   [OUTPUT]       
      REAL       DATA ( IDIM )
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATA ( I ) = 0.  
 1100 CONTINUE
*
*
      RETURN
      END
***********************************************************************
      SUBROUTINE COPY     !" 配列を複写
     O         ( DATAO  ,
     I           DATAI  ,
     D           IDIM     )
*
*   [PARAM]
      INTEGER    IDIM
*
*   [OUTPUT]       
      REAL       DATAO ( IDIM )                !" 出力データ
*
*   [INPUT] 
      REAL       DATAI ( IDIM )                !" 入力データ
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATAO ( I ) = DATAI ( I )
 1100 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE SETV   !" 配列にスカラー値をセット
     O         ( DATA  ,
     I           VALUE ,
     D           IDIM   )
*
*   [PARAM] 
      INTEGER    IDIM
*
*   [OUTPUT] 
      REAL       DATA ( IDIM )                 !" 配列
*
*   [INPUT] 
      REAL       VALUE                         !" 入力データ
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATA ( I ) = VALUE
 1100 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE FILLV  !" 配列のある範囲を値で埋める >>
     M         ( DATA  ,
     I           VALUE ,
     D           IMIN  , IMAX  , IDIM  , JMIN  , JMAX  , JDIM  ,
     D           KMIN  , KMAX                                   )
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KMAX
*
*   [MODIFY] 
      REAL       DATA ( IDIM, JDIM, KMAX )   !" 配列データ
*
*   [INPUT] 
      REAL       VALUE                       !" 入力データ
      INTEGER    IMIN                        !" 第１次元始め
      INTEGER    IMAX                        !" 第１次元終り
      INTEGER    JMIN                        !" 第２次元始め
      INTEGER    JMAX                        !" 第２次元終り
      INTEGER    KMIN                        !" 第３次元始め
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
*
      DO 1100 K = KMIN, KMAX
        DO 1100 J = JMIN, JMAX
          DO 1100 I = IMIN, IMAX
            DATA ( I, J, K ) = VALUE
 1100 CONTINUE
*
*
      RETURN
      END
************************************************************************
      SUBROUTINE MAXMIN      !"  配列の最小値最大値を出力 
     I         ( DATA, IDIM, JDIM, KMAX, IMAX, JMAX, HITEM )
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KMAX
*
*   [INPUT] 
      REAL       DATA( IDIM, JDIM, KMAX )
      INTEGER    IMAX
      INTEGER    JMAX
      CHARACTER  HITEM*(*)                     !" 表題
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IPMIN, JPMIN, KPMIN
      INTEGER    IPMAX, JPMAX, KPMAX
      REAL       DMIN, DMAX
*
      DMIN =  1.E36
      DMAX = -1.E36
*
      DO 1100 K=1,KMAX
        DO 1100 J=1,JMAX
          DO 1100 I=1,IMAX
*
            IF ( DATA( I,J,K ) .LT. DMIN ) THEN
              DMIN = DATA( I,J,K )
              IPMIN = I
              JPMIN = J
              KPMIN = K
            ENDIF
*
            IF ( DATA( I,J,K ) .GT. DMAX ) THEN
              DMAX = DATA( I,J,K )
              IPMAX = I
              JPMAX = J
              KPMAX = K
            ENDIF
*
 1100 CONTINUE
*
      WRITE (6,*) HITEM, ': min = ', DMIN,' at ', IPMIN,JPMIN,KPMIN
      WRITE (6,*) HITEM, ': max = ', DMAX,' at ', IPMAX,JPMAX,KPMAX
*
      RETURN
      END
*********************************************************************
      INTEGER FUNCTION IUNITM  !" 時間単位の変換
     I        ( KT    , HUNIT  , IDELT  )
*
*   [INPUT] 
      INTEGER     KT                          !" 時間(単位HUNIT)
      CHARACTER   HUNIT*(*)                   !" 時間単位
      INTEGER     IDELT                       !" Δｔ
*
*   [INTERNAL WORK] 
      INTEGER    IT
*
      IF      (    ( HUNIT       .EQ. 'STEP' )
     &         .OR.( HUNIT       .EQ. 'step' )  ) THEN
*
*"         < 1. step のとき Δｔを単位 >
*
        IT = KT * IDELT
*
*"         < 2. sec, min, hour, day >
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'S' )
     &         .OR.( HUNIT (1:1) .EQ. 's' )  ) THEN
        IT = KT
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'M' )
     &         .OR.( HUNIT (1:1) .EQ. 'm' )  ) THEN
        IT = KT*60
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'H' )
     &         .OR.( HUNIT (1:1) .EQ. 'h' )  ) THEN
        IT = KT*60*60
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'D' )
     &         .OR.( HUNIT (1:1) .EQ. 'd' )  ) THEN
        IT = KT*60*60*24
*
      ELSE
*
*"         < 3. それ以外 : 分 >
*
        IT = KT*60
        WRITE (6,*) 'UNIT = ',HUNIT , 'KT = ',KT
        WRITE (6,*) '単位が正しくありません。Ｍ（分）を仮定しました'
      ENDIF
*
      IUNITM = IT
*
      RETURN
      END
***********************************************************************
      INTEGER FUNCTION MALLOC  !" ワーク領域ポインター割り当て
     I        ( LENGTH, IPMAX  )
*
*   [INPUT] 
      INTEGER LENGTH                         !" 割当て長さ
      INTEGER IPMAX                          !" 最大領域
*
*   [INTERNAL SAVE] 
      INTEGER IP                             !" 割当てるポインタ
      INTEGER IPP                            !" 次に割当てるポインタ
      DATA    IPP / 1 /
      SAVE    IPP
*
*   [ENTRY FUNC] 
      INTEGER    MFREE
*
      IF ( LENGTH .LE. 0 ) THEN
         CALL MSGDMP( 'E','MALLOC','ASSIGN LENGTH IS NEGATIVE.')
*
      ELSE
         IP  = IPP
         IPP = IP + LENGTH
         IF ( (IPP-1) .GT. IPMAX ) THEN
            WRITE ( 6,* ) ' **** FURTHER ',  IPP-IPMAX-1,
     &                    ' BYTES AT MINIMUM'
            CALL MSGDMP( 'E','MALLOC','WORK AREA IS NOT ENOUGH.')
         ENDIF
*
C        WRITE ( 6,* ) ' POINTER OK ...', IP
         MALLOC = IP
      ENDIF
*
      RETURN
*======================================================================
      ENTRY MFREE()       !" ワーク領域ポインターリセット
*
      IPP   = 1
      MFREE = 1
*
      RETURN
      END

*"表題 ファイルのオープン GTOOL3(GFOPEN)
*
*"履歴 90/08/31 沼口  敦
*"     90/09/06 沼口  敦
*"     92/09/19 沼口  敦   環境変数対応
*"     96/06/22 竹広真一   IBM AIX fortran open 文への対応
*"                         FUJITSU SUN fortran open 文への対応
*
*
************************************************************************
*"      << ファイルのオープン >>
************************************************************************
      SUBROUTINE GFOPEN
     O         ( IFILE , IERR  ,
     I           HFILX , IFILED, HACT  , HFORM   )
*
      INTEGER    IFILE                       !" 装置番号
      INTEGER    IERR                        !" エラー≠０
      CHARACTER  HFILX *(*)                  !" ファイル名
      INTEGER    IFILED                      !" デフォルト装置番号
      CHARACTER  HACT  *(*)                  !" 読み／書き
      CHARACTER  HFORM *(*)                  !" フォーマット
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      LOGICAL    OEXIST, OPEND, OPENDX
      CHARACTER  HMSG   *50
      CHARACTER  HFILE  *(NFILN)
*
      HFILE = HFILX
      CALL GUNENV( HFILE, '.', .FALSE. )
*
      IF      ( HFILE .EQ. ' ' ) THEN
         IERR  = 0
         IFILE = 0
         RETURN
*
      ELSE IF  ( HFILE .EQ. '.' ) THEN
         CALL MSGDMP ( 'W', 'GFOPEN', 
     &                'INVALID FILE NAME: POSSIBLY ENV.VAR. MISMATCH' )
         IERR  = 0
         IFILE = 0
         RETURN
*
      ELSE IF ( ( HFILE(1:1).GE.'1' ).AND.( HFILE(1:1).LE.'9' ) ) THEN
         IERR  = 0
         IF ( LENC(HFILE) .EQ. 1 ) THEN
            READ ( HFILE(1:1), '(I1)' ) IFILE
         ELSE
            READ ( HFILE(1:2), '(I2)' ) IFILE
         ENDIF
         RETURN
*
      ELSE IF ( HFILE .EQ. 'CON' ) THEN
         IERR  = 0
         IF ( HACT .EQ. 'READ' ) THEN
            IFILE = 5
         ELSE
            IFILE = 6
         ENDIF
         RETURN
      ENDIF
*
      INQUIRE ( FILE=HFILE  , IOSTAT=IERR, EXIST=OEXIST,
     &          OPENED=OPEND, NUMBER=IFILE               )
*
      IF ( ( .NOT. OEXIST ).AND.( HACT.EQ.'READ' ) ) THEN
         HMSG = 'FILE '//HFILE//' NOT FOUND'
         CALL MSGDMP( 'W', 'GFOPEN', HMSG )
         IERR  = 1
         IFILE = 0
         RETURN
      ENDIF
*
      IF ( .NOT. OPEND ) THEN
         IFILE  = IFILED
         ICOUNT = 0
 2100    CONTINUE
            ICOUNT = ICOUNT + 1
*
            INQUIRE ( UNIT=IFILE, OPENED=OPENDX )
            IF ( OPENDX ) THEN
               IFILE = IFILE+1
               IF ( IFILE .GE. 100 ) IFILE=IFILE-90
               IF ( ICOUNT .GT. 90 ) THEN
                  HMSG = 'I/O UNIT FULL'
                  CALL MSGDMP( 'W', 'GFOPEN', HMSG )
                  IERR = 1
                  RETURN
*
               ENDIF
               GOTO 2100
            ENDIF
*
#ifdef SYS_IBMS
#define NOAPPEND
#endif
*
#ifdef SYS_IBMAIX
#define NOAPPEND
#endif
*
#ifdef SYS_FSun
#define NOAPPEND
#endif
*
#ifdef NOAPPEND
            OPEN ( UNIT=IFILE , FILE=HFILE, IOSTAT=IERR,
     &                ACTION=HACT, FORM=HFORM,
     &                ACCESS='SEQUENTIAL'                 )
#else
            IF ( HACT .EQ. 'APPEND' ) THEN
               OPEN ( UNIT=IFILE , FILE=HFILE, IOSTAT=IERR,
     &                FORM=HFORM,
     &                ACCESS='APPEND'                     )
            ELSE
               OPEN ( UNIT=IFILE , FILE=HFILE, IOSTAT=IERR,
     &                FORM=HFORM,
     &                ACCESS='SEQUENTIAL'                 )
            ENDIF
#endif      
*
         IF ( IERR .NE. 0 ) THEN
            HMSG = 'FILE OPEN ERROR'
            WRITE( HMSG(17:21), '(I5)' ) IERR
            CALL MSGDMP( 'W', 'GFOPEN', HMSG )
         ENDIF
*
      ELSE
         IERR = 0
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << ファイルクローズ >>
*********************************************************************
      SUBROUTINE GFCLSE
     M         ( IFILE  )
*
      LOGICAL    OPENDX
*
      INTEGER    IFILE                    !" 装置番号
*
      IF (  ( IFILE.LT.1 ).OR.( IFILE.GT.99 )  ) THEN
        RETURN
      ELSE
        INQUIRE ( UNIT=IFILE, OPENED=OPENDX )
        IF ( OPENDX ) CLOSE ( IFILE )
      ENDIF
*
      RETURN
      END

*"表題 第１次元の拡大 GTOOL3(GPYEXT)
*
*"履歴 91/01/19 沼口  敦
*
*
*********************************************************************
*"         << 第１次元の拡大 >>
*********************************************************************
      SUBROUTINE GPYEXT
     I         ( HHEAD , GDATA ,
     I           HAITMY, IYSTR , IYEND ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HAITMY      *(*)        !" 拡大する第2次元の軸名
      INTEGER    IYSTR                   !" 第2次元の軸の格子始め
      INTEGER    IYEND                   !" 第2次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
*
*"         < 1. 結合準備 >
*
      CALL GPYCMI
     I         ( HHEAD , HAITMY, IYSTR , IYEND ,
     I           'NUL' , ' '   ,
     O           HHEADO, GDATAO )
*
*"         < 2. 大きさの取得 >
*
      CALL GUSMIS ( HHEADO )
*
      CALL GUQSIZ
     I         ( HHEADO,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR1, IYEND1, IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
*"         < 3. データ詰め替え >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
*
      DO 2100 IY = IYSTR1, IYEND1
         DO 2110 IZ = 1, IZDIM
            CALL VRSET
     I         ( GDATA ( IXDIM*(IZ-1) +1 ),
     O           GDATAO( IXDIM*IYDIM*(IZ-1) + IXDIM*(IY-IYSTR1)+1 ),
     I           IXDIM , 1     , 1                                   )
 2110    CONTINUE
 2100 CONTINUE
*
*"         < 3. ヘッダー変更 >
*
      IF ( ( IYSTR1 .EQ. 1 ).AND.( IYEND1 .EQ. 1 ) ) RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAITMY, 'YE'   , '-extend',
     I                 IYSTR1, IYEND1 ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第３次元の拡大 >>
*********************************************************************
      SUBROUTINE GMYEXT
     I         ( HHEAD , GDATA ,
     I           HAITMY, IYSTR , IYEND ,
     I           HEDIT , HETTL           )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HAITMY      *(*)        !" 拡大する第2次元の軸名
      INTEGER    IYSTR                   !" 第2次元の軸の格子始め
      INTEGER    IYEND                   !" 第2次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPYEXT
     I         ( HHEAD , GDATA ,
     I           HAITMY, IYSTR , IYEND ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*PACKAGE GTVECT !" ベクトル図                           A.Numaguti
*"                                             95/05/26 S.Takehiro
*"                                             97/12/12 S.Takehiro
******************************************************************
      PROGRAM GTVECT
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEADU( NDC )*(NCC)
      REAL       GDATAU( IJKDIM )
      CHARACTER  HHEADV( NDC )*(NCC)
      REAL       GDATAV( IJKDIM )
      CHARACTER  HWRK1 *(NCC)
      CHARACTER  HWRK2 *(NCC)
*
      PARAMETER  ( NTMX=20 )
      DATA       IFILEU / 50 /
      DATA       IFILEV / 51 /
      CHARACTER  HFILE( 2 )  *(NFILN)
      DATA       HFILE / 2*'$GTTMPDIR/gtool.out' /
*
*" [オプション]
*
      INTEGER    X, Y, Z
        DATA       X, Y, Z / 3*-1 /
      INTEGER    INTV ( 2 )
        DATA       INTV / 2*1 /
      REAL       FACT
        DATA       FACT    / 1.0 /
      LOGICAL    EQRAT   
        DATA       EQRAT   / .TRUE. /
      LOGICAL    LUNIT   
        DATA       LUNIT   / .TRUE. /
      INTEGER    MAP , MAPIDX
        DATA       MAP , MAPIDX / 0, 1 /
      CHARACTER  MFILE * (NFILN)
        DATA     MFILE  /'coast_world'/
      INTEGER    WSN
        DATA       WSN / 0 /
      LOGICAL    MONO, PRINT
        DATA       MONO, PRINT / 2*.FALSE. /
      CHARACTER  PS   *(NFILN)
        DATA       PS     / '$GTTMPDIR/sgks.ps' /
      INTEGER    LAY
        DATA       LAY / 1 /
      INTEGER    STR, END, STEP
        DATA       STR, END, STEP / 1, 999999, 1 / 
      REAL       RANGE ( 2 )
        DATA       RANGE / 2*-999. /
      INTEGER    IDX
        DATA       IDX / 1 /
      LOGICAL    EXCH
        DATA       EXCH  /.FALSE./
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
        DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
        DATA       GRESET / .FALSE. /
      LOGICAL    HELP
        DATA       HELP   / .FALSE. /
*
      NAMELIST /OPTION/  X, Y, Z,
     &                   INTV, FACT, LUNIT, EQRAT, RANGE,
     &                   MAP, MAPIDX, MFILE, 
     &                   LAY, WSN, MONO, PRINT, PS,
     &                   STR, END, STEP, EXCH,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
*" < 1. コマンドライン解析 >
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEADU, IJKDIM )
      CALL GTSIZE ( HHEADV, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      IF ( WSN .LE. 0 ) THEN
         IF ( PRINT ) THEN
            WSN = 2
            IF ( PS .NE. ' ' ) THEN
               CALL GUNENV( PS, '.', .FALSE. )
               CALL SWCSET( 'PSFILE', PS     )
               IP=LENC(PS)
               WRITE (6,*) 'ps='//PS(1:IP)
            ENDIF
         ELSE
            WSN = 1
         ENDIF
      ENDIF
*
      CALL GGOPEN ( WSN )
      CALL GFROPN ( IFILEU, HFILE( 1 ) )
      IF ( HFILE(2) .EQ. HFILE(1) ) THEN
         IFILEV = IFILEU
      ELSE
         CALL GFROPN ( IFILEV, HFILE( 2 ) )
      ENDIF
*
      IF ( X.LT.0 .AND. Y.LT.0 .AND. Z.LT.0 ) Z = 0
      IF ( STEP .LE. 1 ) STEP = 1
*
*"  < 2. データ読み込み, 加工 >
*
      II = 0
 1100 CONTINUE
         CALL GFREAD
     O            ( HHEADU, GDATAU, IEODU ,
     I              IFILEU, 1               )
         CALL GFREAD
     O            ( HHEADV, GDATAV, IEODV ,
     I              IFILEV, 1               )
*
         IF ( MAX(IEODU,IEODV) .EQ. 0 ) THEN
*
            II = II + 1
            IF ( ( II.GE.STR ).AND.( II.LE.END ).AND.
     &           ( MOD( II-STR,STEP ).EQ.0 )          ) THEN         

*
               IF      ( X .EQ. 0 ) THEN
                  CALL GMXAVG
     I            ( HHEADU, GDATAU,
     I              'XM'  , 'zonal mean'  )
                  CALL GMXAVG
     I            ( HHEADV, GDATAV,
     I              'XM'  , 'zonal mean'  )
               ELSE IF ( X .GT. 0 ) THEN
                  CALL GMXSEL
     I            ( HHEADU, GDATAU, X   ,
     I              '  '  , ' '           )
                  CALL GMXSEL
     I            ( HHEADV, GDATAV, X   ,
     I              '  '  , ' '           )
               ELSE IF ( Y .EQ. 0 ) THEN
                  CALL GMYAVG
     I            ( HHEADU, GDATAU,
     I              'YM'  , 'merid mean'  )
                  CALL GMYAVG
     I            ( HHEADV, GDATAV,
     I              'YM'  , 'merid mean'  )
               ELSE IF ( Y .GT. 0 ) THEN
                  CALL GMYSEL
     I            ( HHEADU, GDATAU, Y   ,
     I              '  '  , '  '          )
                  CALL GMYSEL
     I            ( HHEADV, GDATAV, Y   ,
     I              '  '  , '  '          )
               ELSE IF ( Z .EQ. 0 ) THEN
                  CALL GMZAVG
     I            ( HHEADU, GDATAU,
     I              'ZM'  , 'vert mean'   )
                  CALL GMZAVG
     I            ( HHEADV, GDATAV,
     I              'ZM'  , 'vert mean'   )
               ELSE IF ( Z .GT. 0 ) THEN
                  CALL GMZSEL
     I            ( HHEADU, GDATAU, Z  ,
     I              ' '   , ' '           )
                  CALL GMZSEL
     I            ( HHEADV, GDATAV, Z  ,
     I              ' '   , ' '           )
               ENDIF
*
               CALL GMXCYC
     I            ( HHEADU, GDATAU )
               CALL GMXCYC
     I            ( HHEADV, GDATAV )
*
               IF ( EXCH ) THEN
                  CALL GMEYXZ
     I            ( HHEADU, GDATAU,
     I              '  ' , '  '  )
                  CALL GMEYXZ
     I            ( HHEADV, GDATAV,
     I              '  ' , '  '  )
               ENDIF
*
               IF ( ITEM .NE. ' ' ) THEN
                  CALL GHCSET( HHEADU, 'ITEM', ITEM )
               ELSE
                  CALL GHCGET( HHEADU, 'ITEM', HWRK1 )
                  CALL GHCGET( HHEADV, 'ITEM', HWRK2 )
                  IF ( HWRK1 .NE. HWRK2 ) THEN
                     I1 = LENC(HWRK1)
                     I2 = LENC(HWRK1)
                     CALL GHCSET( HHEADU, 'ITEM', 
     &                            HWRK1(1:I1)//'-'//HWRK2(1:I2) )
                  ENDIF
               ENDIF
               IF ( UNIT .NE. ' ' ) THEN
                  CALL GHCSET( HHEADU, 'UNIT', UNIT )
               ELSE
                  CALL GHCGET( HHEADU, 'UNIT', HWRK1 )
                  CALL GHCGET( HHEADV, 'UNIT', HWRK2 )
                  IF ( HWRK1 .NE. HWRK2 ) THEN
                     I1 = LENC(HWRK1)
                     I2 = LENC(HWRK1)
                     CALL GHCSET( HHEADU, 'UNIT', 
     &                            HWRK1(1:I1)//'-'//HWRK2(1:I2) )
                  ENDIF
               ENDIF
               IF ( TITLE .NE. ' ' ) THEN
                  CALL GHCSTS( HHEADU, 'TITL', TITLE )
               ELSE
                  CALL GHCGET( HHEADU, 'TITL1', HWRK1 )
                  CALL GHCGET( HHEADV, 'TITL1', HWRK2 )
                  IF ( HWRK1 .NE. HWRK2 ) THEN
                     I1 = LENC(HWRK1)
                     I2 = LENC(HWRK1)
                     CALL GHCSTS( HHEADU, 'TITL', 
     &                            HWRK1(1:I1)//'-'//HWRK2(1:I2) )
                  ENDIF
               ENDIF
               IF ( DSET .NE. ' ' ) THEN
                  CALL GHCSET( HHEADU, 'DSET', DSET )
               ELSE
                  CALL GHCGET( HHEADU, 'DSET', HWRK1 )
                  CALL GHCGET( HHEADV, 'DSET', HWRK2 )
                  IF ( HWRK1 .NE. HWRK2 ) THEN
                     I1 = LENC(HWRK1)
                     I2 = LENC(HWRK1)
                     CALL GHCSET( HHEADU, 'DSET', 
     &                            HWRK1(1:I1)//'-'//HWRK2(1:I2) )
                  ENDIF
               ENDIF
*
               IF ( GRESET ) THEN
                  CALL GHRSGP( HHEADU  )
                  CALL GHRSGP( HHEADV  )
               ENDIF
*
               IF ( RANGE(1) .NE. -999. ) THEN
                  CALL GHPSET( HHEADU, 'DMIN', 0.       )
                  CALL GHPSET( HHEADU, 'DMAX', RANGE(1) )
               ENDIF
               IF ( RANGE(2) .NE. -999. ) THEN
                  CALL GHPSET( HHEADV, 'DMIN', 0.       )
                  CALL GHPSET( HHEADV, 'DMAX', RANGE(2) )
               ENDIF
*
*"  < 3. 表題 >
*
               IF      ( LAY .EQ. 2 ) THEN
                  CALL GGLAY2  ( HHEADU )
               ELSE IF ( LAY .EQ. 3 ) THEN
                  CALL GGLAY3  ( HHEADU )
               ELSE
                  CALL GGLAY1  ( HHEADU )
               ENDIF
*
*"  < 5. ベクトル >
*
               CALL GGAXES  ( HHEADU )
*
               CALL GGPSET ( 'VXINT',  INTV(1) )
               CALL GGPSET ( 'VYINT',  INTV(2) )
               CALL GGPSET ( 'VECFCT', FACT )
               CALL GGPSET ( 'LEQRAT', EQRAT )
               CALL GGPSET ( 'LUNIT',  LUNIT )
               CALL SGSLNI ( IDX )
*
               CALL GGVECT
     I               ( HHEADU, GDATAU,
     I                 HHEADV, GDATAV )
*
*"  < 6. 地図, 緯度経度線 > 
*
               IF ( MAP .GE.1  ) THEN
                  CALL GGMAPS( MFILE )
               ENDIF
*
            ENDIF
            IF ( II .LT. END ) GOTO 1100
         ENDIF
*
      CALL GFCLSE ( IFILE )
*
      CALL GGCLSE
*
      STOP
      END

*"表題 折れ線描画 GTOOL3(GGCURV)
*
*"履歴 90/08/17 沼口  敦
*
*
*********************************************************************
*"         << 折れ線描画 >>
*********************************************************************
      SUBROUTINE GGCURV
     I         ( HHEAD , GDATA , HPOS  )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       GDATA ( * )             !" データ
      CHARACTER  HPOS       *(*)         !" データ軸 ('X' or 'Y')
*
#ifdef SYS_IBMS
      INCLUDE    (GZIWRK)                !" NW: 軸ワークの大きさ
#else
#include         "gziwrk.F"              !" NW: 軸ワークの大きさ
#endif
      REAL       ZDATA ( NW )
      LOGICAL    OLINT                   !" 線種コメントを描く？
*
      CALL GUSMIS ( HHEAD )
*
*"         < 1. 軸描画, 座標設定 >
*
      CALL GGAXSZ
     I     ( HHEAD , GDATA , HPOS   )
*
*"         < 2. 範囲 >
*
      CALL GHPGET ( HHEAD, 'ASTR1', IZSTR )
      CALL GHPGET ( HHEAD, 'AEND1', IZEND )
      IZDIM = IZEND-IZSTR+1
      CALL GUSZCZ ( NW   , IZDIM )
*
*"         < 3. 折れ線描画 >
*
      CALL UWQGXA ( ZDATA, IZDIMZ )
      IF ( IZDIM .NE. IZDIMZ ) THEN
         CALL MSGDMP( 'W', 'GGCURV', 'ARRAY SIZE DO NOT AGREE.' )
      ENDIF
*
      IF ( HPOS(1:1) .EQ. 'X' ) THEN
         CALL SGPLU  ( IZDIM, GDATA, ZDATA )
      ELSE
         CALL SGPLU  ( IZDIM, ZDATA, GDATA )
      ENDIF
*
*"         < 4. 線種コメント >
*
      CALL GGPGET ( 'LLINT', OLINT )
      IF ( OLINT ) THEN
         CALL GGLINT ( HHEAD, 'CURV' )
      ENDIF
*
      RETURN
      END

* PACKAGE USPST   !" 球面調和関数変換の準備
*
*"  [HIS] 90/08/31(numaguti)
*
**********************************************************************
      SUBROUTINE SETPNM      !" ルジャンドル関数の計算
     O         ( PNM   , DPNM  , NMO   ,
     I           QSINLA,
     D           JMAX  , MMAX  , LMAX  , NMAX  , MINT  , 
     D           NMDIM , JMXHF ,
     W           QPNM  , QDPNM                                  )
*
*   [PARAM] 
      INTEGER    JMAX
      INTEGER    MMAX
      INTEGER    LMAX
      INTEGER    NMAX
      INTEGER    MINT
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [OUTPUT]       
      REAL       PNM   ( NMDIM, JMXHF )      !" ルジャンドル関数
      REAL       DPNM  ( NMDIM, JMXHF )      !" Ｐnm μ微分
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" スペクトルの添字順番
*
*   [INPUT] 
      REAL * 8   QSINLA( JMAX )              !" sin（緯度）：倍精度
*
*   [WORK] 
      REAL * 8   QPNM  ( 0:NMAX+1, 0:MMAX )  !" Ｐnm ルジャンドル
      REAL * 8   QDPNM ( 0:NMAX+1, 0:MMAX )  !" Ｐnm μ微分
*
*   [INTERNAL WORK] 
      INTEGER    J, L, M, LEND, MEND, NMH
*
*
      DO 3300 J = 1, JMAX/2
*"                                               ------ J loop -----
*
*"         < 1. ルジャンドル関数の計算 >
*
         CALL LGNDRE
     I         ( QSINLA(J), MMAX  , NMAX,
     O           QPNM     , QDPNM                )
*
*"         < 2. 配列の順番 l-wise >
*"                           ------  zonal mean model の場合注意！
         NMH  = 0
         DO 2200 L = 0, LMAX
            MEND = MIN( MMAX, NMAX-L )
            DO 2100 M = 0, MEND, MINT
               NMH = NMH + 1
               IF ( MMAX .EQ. 0 ) THEN
                  NMO ( 1, M, L ) = NMH
                  NMO ( 2, M, L ) = NMH
               ELSE
                  NMO ( 1, M, L ) = 2* NMH - 1
                  NMO ( 2, M, L ) = 2* NMH
               ENDIF
 2100       CONTINUE
 2200    CONTINUE
*
*"         < 3. ルジャンドル関数の詰め替え >
*
         DO 3200 M = 0, MMAX, MINT
            LEND = MIN( LMAX, NMAX-M )
            DO 3100 L = 0, LEND
               PNM  (  NMO( 1,M,L ),J  ) =   QPNM ( L+M,M )
               PNM  (  NMO( 2,M,L ),J  ) =   QPNM ( L+M,M )
               DPNM (  NMO( 1,M,L ),J  ) = - QDPNM( L+M,M )
               DPNM (  NMO( 2,M,L ),J  ) = - QDPNM( L+M,M )
 3100       CONTINUE
 3200    CONTINUE
*
*"                                               ------ J loop -----
 3300 CONTINUE
*
      RETURN
      END
**********************************************************************
      SUBROUTINE LGNDRE               !" ルジャンドル関数の計算
     I         ( CTHETA , MMAX  , NMAX,
     O           QPNM   , QDPNM                )
*
*   [PARAM] 
      INTEGER    NMAX
      INTEGER    MMAX
*
*   [INPUT] 
      REAL * 8   CTHETA                      !" μ=sin(緯度)
*
*   [OUTPUT] 
      REAL * 8   QPNM  ( 0:NMAX+1, 0:MMAX )  !" Ｐnm ルジャンドル
      REAL * 8   QDPNM ( 0:NMAX+1, 0:MMAX )  !" Ｐnm μ微分
*
*   [INTERNAL WORK] 
      INTEGER    M, N
      REAL * 8   STHETA, EPS, EPSM, EPSP
*      
*
*"         < 1. ( １−μ＾2 )^1/2  >
*
      STHETA = SQRT ( 1.D0 - CTHETA **2 )
*
*"         < 2. P_m^m P_m+1^m を求める >
*
      DO 2100 M = 0, MMAX
*
          IF ( M .EQ. 0 ) THEN
             QPNM ( 0, 0 ) = 1.  
          ELSE
             QPNM ( M ,M ) = QPNM ( M-1,M-1 )
     &                        * SQRT(  DBLE( 2*M+1 )/ DBLE( 2*M )  )
     &                        * STHETA
          ENDIF
*
          QPNM ( M+1,M ) = QPNM ( M,M )
     &                     * SQRT( DBLE( 2*M+3 ) ) * CTHETA
*
 2100 CONTINUE
*
*"         < 3. P_n^m を漸化式で求める >
*
      DO 3100 M = 0, MMAX
         DO 3100 N = M+2, NMAX+1
*
            EPS         = SQRT (   ( DBLE( N   )**2 - DBLE( M )**2 )
     &                           / ( 4.D0 * DBLE( N   )**2 - 1.D0  )  )
            EPSM        = SQRT (   ( DBLE( N-1 )**2 - DBLE( M )**2 )
     &                           / ( 4.D0 * DBLE( N-1 )**2 - 1.D0  )  )
*
            QPNM( N,M ) = (   QPNM ( N-1,M ) * CTHETA
     &                      - QPNM ( N-2,M ) * EPSM    ) / EPS
*
 3100 CONTINUE
*
*"         < 4. d/dy P_n^m  を漸化式で求める >
*
      DO 4100 M = 0, MMAX
*
         EPS           = SQRT (   ( DBLE( M+1 )**2 - DBLE( M )**2 )
     &                         / ( 4.D0 * DBLE( M+1 )**2 - 1.D0  )  )
         QDPNM ( M,M ) = QPNM ( M+1,M ) * DBLE( M ) * EPS
*
         DO 4200 N = M+1, NMAX
            EPS          = SQRT (   ( DBLE( N   )**2 - DBLE( M )**2 )
     &                            / ( 4.D0 * DBLE( N   )**2 - 1.D0  )  )
            EPSP         = SQRT (   ( DBLE( N+1 )**2 - DBLE( M )**2 )
     &                            / ( 4.D0 * DBLE( N+1 )**2 - 1.D0  )  )
*
            QDPNM( N,M ) =   QPNM ( N+1,M ) * DBLE( N   ) * EPSP
     &                     - QPNM ( N-1,M ) * DBLE( N+1 ) * EPS
*
 4200    CONTINUE
 4100 CONTINUE
*
      RETURN
      END
**********************************************************************
      SUBROUTINE GAUSS      !"  ガウス緯度・荷重の計算 
     O         ( CTHETA , GW     ,
     I           JMAX             )
*
*   [PARAM] 
      INTEGER    JMAX
*
*   [OUTPUT] 
      REAL * 8   CTHETA( JMAX )              !" sin(緯度)＝μ
      REAL * 8   GW    ( JMAX )              !" ガウス荷重
*
*   [INTERNAL PARM] 
      REAL * 8   DELTP
      REAL * 8   DELTPD
      REAL * 8   DELTPS
      DATA       DELTPD / 1.0 D-28 /         !' ４倍精度の収束条件
      DATA       DELTPS / 1.0 D-14 /         !'   倍精度の収束条件
      INTEGER    ITRMAX
      DATA       ITRMAX / 50 /               !" 繰り返し最大値
*
*   [INTERNAL WORK] 
      INTEGER    JMAXD
      PARAMETER (JMAXD=200)
      REAL * 8   QPN( 0:JMAXD+1 )            !" Ｐn (倍精度)
      INTEGER    N, J, ITER
      REAL * 8   PI, X0, DELTX, R, RP
      REAL * 8   EPS, EPSM, EPSP, QDPN
*
      IF ( JMAX .GT. JMAXD) THEN
         CALL MSGDMP( 'E','GAUSS','INSUFFICIENT WORK STRAGE.')
      ENDIF
*
*"         < 0. AUTODBL 指定チェック：ちょっとトリッキー >
*
      R  = 1.
      RP = R + DELTPD
      WRITE ( 6,* ) ' precision check .. ', RP
*
      IF ( RP .GT. R ) THEN
         WRITE ( 6,* ) ' REAL*16 is used in GAUSS'
         DELTP = DELTPD
      ELSE
         WRITE ( 6,* ) ' only REAL*8 is used in GAUSS'
         DELTP = DELTPS
      ENDIF
*
      PI = ATAN( 1.D0 ) * 4.D0
*
      DO 5100 J = 1 , JMAX/2
*
*"         < 1. 初期推定値 >
*
         X0 = COS (  ( DBLE( J ) - 0.5D0  )/ DBLE( JMAX ) * PI   )
*
         DO 4100 ITER = 1, ITRMAX
*
*"         < 2. Pn を求める >
*
            QPN   ( 0 ) = 1.D0
            QPN   ( 1 ) = SQRT( 3.D0  ) * X0
*
            DO 2100 N = 2, JMAX+1
               EPS       = SQRT (   ( DBLE( N   )**2                )
     &                            / ( 4.D0 * DBLE( N   )**2 - 1.D0  )  )
               EPSM      = SQRT (   ( DBLE( N-1 )**2                )
     &                            / ( 4.D0 * DBLE( N-1 )**2 - 1.D0  )  )
*
               QPN ( N ) = (   QPN  ( N-1 ) * X0
     &                        - QPN  ( N-2 ) * EPSM    ) / EPS
 2100       CONTINUE
*
*"         < 3. d/dμ Pn を求める >
*
            EPS       = SQRT (   ( DBLE( JMAX   )**2                  )
     &                         / ( 4.D0 * DBLE( JMAX   )**2 - 1.D0 )  )
            EPSP      = SQRT (   ( DBLE( JMAX+1 )**2                  )
     &                         / ( 4.D0 * DBLE( JMAX+1 )**2 - 1.D0 )  )
*
            QDPN      =   QPN  ( JMAX+1 ) * DBLE( JMAX   ) * EPSP
     &                  - QPN  ( JMAX-1 ) * DBLE( JMAX+1 ) * EPS
*
*"         < 4. Newton 法でゼロ点を求める >
*
            DELTX = QPN ( JMAX ) / QDPN * ( 1.0D0 - X0 **2 )
            X0    = X0 + DELTX
*
            IF ( ABS( DELTX ) .LT. DELTP ) GOTO 4200
*"                                             >---- exit ----->
 4100    CONTINUE
         WRITE ( 6,* ) ' error in GAUSS(4) ', DELTX
*
*"                                             <---- exit -----<
 4200    CONTINUE
*
         CTHETA ( J ) = X0
*
*"         < 5. ガウス荷重 >
*
         GW     ( J ) =    ( DBLE( 2*JMAX ) - 1.0D0  )
     &                   * ( 1.0D0  - X0 **2 )
     &                   / (   DBLE( JMAX ) * QPN ( JMAX-1 )  )**2
*
 5100 CONTINUE
*
      DO 6100 J = 1, JMAX/2
         GW     ( JMAX-J+1 ) =   GW     ( J )
         CTHETA ( JMAX-J+1 ) = - CTHETA ( J )
 6100 CONTINUE
*
      RETURN
      END

*"表題 地図描画 GTOOL3(GGMAPS)
*
*"履歴 95/05/29 竹広真一
*
*
*********************************************************************
*"         << 地図描画(複数ファイル名) >>
*********************************************************************
      SUBROUTINE GGMAPS( MFILES )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
*
      CHARACTER  MFILES * (NFILN)        !" 地図情報ファイル名
      CHARACTER  CSEP * 1                !" ファイル名区切り子
      DATA       CSEP/','/
*
      IS = 1
*
 10   CONTINUE 
      IF( LENZ(MFILES(IS:NFILN)) .EQ. 0 ) RETURN
*
      IL = INDXCF( MFILES(IS:NFILN), NFILN-IS+1, 1, CSEP )
      IF ( IL .GT. 1 )THEN
         IE = IS-1 + IL-1
         CALL UMPMAP( MFILES(IS:IE) )
         IS = IE+2
      ELSE IF ( IL .EQ. 0 )THEN
         CALL UMPMAP( MFILES(IS:NFILN) )
         RETURN
      ELSE IF ( IL .EQ. 1 )THEN
         IS = IS+1
      ENDIF
      GOTO 10
*
      END

*"表題 格子情報の取得  GTOOL3(GUQAXV)
*
*"履歴 90/09/14 沼口  敦
*      92/09/02 沼口  敦
*
*
*********************************************************************
*"         << 格子情報の取得 >>
*********************************************************************
      SUBROUTINE GUQAXL
     I         ( HHEAD , ID    , HKIND ,
     O           HHEADA, AXIS  , ACYCLE, IAMAX , IEOD  )
*
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      INTEGER    ID                          !" 何次元目の軸か
      CHARACTER  HKIND      *(*)             !" LOC/WGT
      CHARACTER  HHEADA( * )*(*)             !" ヘッダー
      REAL       AXIS  ( * )                 !" 位置/重み
      REAL       ACYCLE                      !" サイクリック値
      INTEGER    IAMAX                       !" 格子点数:非サイクリック
      INTEGER    IEOD                        !" データなしフラグ
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
      INCLUDE    (GZIWRK)                    !" NW:格子ワーク大きさ
#else
#include         "gzsize.F"                  !" NCC, NDC
#include         "gziwrk.F"                  !" NW:格子ワーク大きさ
#endif
      CHARACTER  HHEADZ( NDC )*(NCC)         !" ヘッダー
      REAL       AXISZ ( NW  )               !" 位置/重み
      CHARACTER  HAXIS *(NCC)                !" 格子識別名称
      CHARACTER  HP    *(NCC)                !" パラメータ名称
      LOGICAL    OCYCL                       !" サイクリックか？
      LOGICAL    OSUBCK
*
      IF ( ( ID .LT. 1 ) .OR. ( ID .GT. 3 ) ) THEN
         CALL MSGDMP( 'W', 'GUQAXV', 'IRREGAL ID' )
         IEOD = 1
         RETURN
      ENDIF
*
*"         < 1. 軸名称, 大きさ >
*
      HP      = 'AITM'
      WRITE ( HP(5:5), '(I1)' ) ID
      CALL GHCGET ( HHEAD, HP  , HAXIS )
      HP(1:4) = 'ASTR'
      CALL GHPGET ( HHEAD, HP  , IZSTR )
      HP(1:4) = 'AEND'
      CALL GHPGET ( HHEAD, HP  , IZEND )
*
      CALL GUSZCK ( HHEADA, IZEND-IZSTR+1 )
*
*"         < 2. 格子情報ファイル読み込み >
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HHEADZ  ,  NW     )
      CALL GUQAXC
     I            ( HAXIS , HKIND ,
     O              HHEADZ, AXISZ , ACYCLE, IAMAX , IEOD   )
      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
      IF ( IEOD .NE. 0 ) RETURN
      IF ( IZSTR .EQ. 0 .AND. IZEND .EQ. 0 ) THEN
         IZSTR = 1
         IZEND = IAMAX
         CALL GUSZCK ( HHEADA, IZEND-IZSTR+1 )
      ENDIF
*
*"         < 3. 詰め替え >
*
      CALL GHPGET ( HHEADZ, 'MISS' , VMISS )
*
      DO 3100 IZ = IZSTR, IZEND
         IF ( ACYCLE .NE. 0. ) THEN
            IZI  = MOD( IZ-1, IAMAX ) + 1
            AOFS = (IZ-1)/IAMAX * ACYCLE
         ELSE
            IZI  = IZ
            AOFS = 0.
         ENDIF
*
         IF ( ( 1.LE.IZI ).AND.( IZI.LE.IAMAX ) ) THEN
            AXIS ( IZ-IZSTR+1 ) = AXISZ( IZI ) + AOFS
         ELSE
            AXIS ( IZ-IZSTR+1 ) = VMISS
         ENDIF
 3100 CONTINUE
*
*"         < 4. ヘッダー書換え >
*
      CALL GHCOPY ( HHEADZ, HHEADA )
      CALL GHPSET ( HHEADA, 'ASTR1', IZSTR )
      CALL GHPSET ( HHEADA, 'AEND1', IZEND )
*
      IF ( IZSTR .NE. 1 ) THEN
         IF ( AXISZ( 1 ) .LT. AXISZ( IAMAX ) ) THEN
            CALL GHPSET ( HHEADA, 'DMIN' , VMISS )
         ELSE
            CALL GHPSET ( HHEADA, 'DMAX' , VMISS )
         ENDIF
      ENDIF
*
      IF ( .NOT. ( ( IZEND .EQ. IAMAX                ) .OR.
     &             ( OCYCL .AND.( IZEND.EQ.IAMAX+1 ) )
     &    )      )                                          THEN
*
         IF ( AXISZ( 1 ) .LT. AXISZ( IAMAX ) ) THEN
            CALL GHPSET ( HHEADA, 'DMAX' , VMISS )
         ELSE
            CALL GHPSET ( HHEADA, 'DMIN' , VMISS )
         ENDIF
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 格子情報の取得 >>
*********************************************************************
      SUBROUTINE GUQAXQ
     I         ( HHEAD , ID    , HKIND ,
     O           AXIS  , ACYCLE, IAMAX , IEOD  ,
     D           IZDIM                           )
*
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      INTEGER    ID                          !" 何次元目の軸か
      CHARACTER  HKIND      *(*)             !" LOC/WGT
      REAL       AXIS  ( IZDIM )             !" 位置/重み
      REAL       ACYCLE                      !" サイクリック値
      INTEGER    IAMAX                       !" 格子点数:非サイクリック
      INTEGER    IEOD                        !" データなしフラグ
*"    INTEGER    IZDIM                       ! AXIS領域の大きさ
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      CHARACTER  HHEADA ( NDC )*(NCC)
      LOGICAL    OSUBCK
*
      CALL       GTPGET( 'SUBCHK', OSUBCK )
      CALL       GTSIZE(  HHEADA , IZDIM  )
*
      CALL       GUQAXL
     I         ( HHEAD , ID    , HKIND ,
     O           HHEADA, AXIS  , ACYCLE, IAMAX , IEOD   )
*
      CALL       GTPSET( 'SUBCHK', OSUBCK )
*
      RETURN
      END
*********************************************************************
*"         << 格子情報の取得 >>
*********************************************************************
      SUBROUTINE GUQAXV
     I         ( HHEAD , ID    , HKIND ,
     O           HHEADA, AXIS  , IEOD  )
*
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      INTEGER    ID                          !" 何次元目の軸か
      CHARACTER  HKIND      *(*)             !" LOC/WGT
      CHARACTER  HHEADA( * )*(*)             !" ヘッダー
      REAL       AXIS  ( * )                 !" 位置/重み
      INTEGER    IEOD                        !" データなしフラグ
*
      CALL       GUQAXL
     I         ( HHEAD , ID    , HKIND ,
     O           HHEADA, AXIS  , ACYCLE, IAMAX , IEOD  )
*
      RETURN
      END
*********************************************************************
*"         << 格子情報の取得 >>
*********************************************************************
      SUBROUTINE GUQAXP
     I         ( HHEAD , ID    , HKIND ,
     O           AXIS  , IEOD  ,
     D           IZDIM                  )
*
      CHARACTER  HHEAD ( * )*(*)             !" ヘッダー
      INTEGER    ID                          !" 何次元目の軸か
      CHARACTER  HKIND      *(*)             !" LOC/WGT
      REAL       AXIS  ( IZDIM )             !" 位置/重み
      INTEGER    IEOD                        !" データなしフラグ
*"    INTEGER    IAMAX                       ! AXIS領域の大きさ
*
      CALL       GUQAXQ
     I         ( HHEAD , ID    , HKIND ,
     O           AXIS  , ACYCLE, IAMAX , IEOD  ,
     D           IZDIM                           )
*
      RETURN
      END

*"表題 時刻の参照 GTOOL3(GUQTIM)
*
*"履歴 90/09/15 沼口  敦
*"     96/03/06 竹広真一  無次元時間に対応. 
*"                        時間単位が STEP の場合は 
*"                        TDUR ステップを 1 無次元時間とする.
*
*********************************************************************
*"         << 時刻の参照 >>
*********************************************************************
      SUBROUTINE GUQTIM
     I         ( HHEAD ,
     O           RT    , HUTIM )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       RT                      !" 時刻
      CHARACTER  HUTIM      *(*)         !" 時刻単位
*
      CHARACTER  HUTIMF     *8           !" 標準時間単位
      INTEGER    ITIME                   !" 時間単位, ステップ数
      INTEGER    ITIMEF                  !" 代表時間(無次元時間)
*
      CALL GHPGET ( HHEAD, 'TIME',  ITIME  )
      CALL GHCGET ( HHEAD, 'UTIM',  HUTIMF )

      IF ( HUTIMF(1:4) .EQ. 'STEP' )THEN
         CALL GHPGET ( HHEAD, 'TDUR',  ITIMEF  ) !" 1 無次元時間のステップ数
         RT = ITIME / REAL(ITIMEF)
         HUTIM = 'NDT'
      ELSE
         CALL GTCGET ( 'UTIM', HUTIM )
         CALL GUCT2R
     I            ( ITIME , HUTIMF, HUTIM , 1      ,
     O              RT                                )
      ENDIF
*
      RETURN
      END

*"表題 データに関数を作用 GTOOL3(GPFFNA)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << データに関数を作用 >>
*********************************************************************
      SUBROUTINE GPFFNA
     I         ( HHEAD , GDATA , RFNA  ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      EXTERNAL   RFNA                    !" 関数
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 3. データ演算 >
*
      CALL VRFNA
     I     ( GDATA ,
     O       GDATAO,
     I       IXDIM*IYDIM*IZDIM, 1 , 1 , RFNA  )
*
*"         < 4. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << データに関数を作用 >>
*********************************************************************
      SUBROUTINE GMFFNA
     M         ( HHEAD , GDATA ,
     I           RFNA  ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      EXTERNAL   RFNA                    !" 関数
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPFFNA
     I         ( HHEAD , GDATA , RFNA  ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW  )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 エスケープシーケンス正規化 GTOOL3(GUCTXT)
*
*"履歴 90/08/28 沼口  敦
*
*
*******************************************************************
*"         << エスケープシーケンス正規化 >>
******************************************************************
      SUBROUTINE GUCTXT
     I         ( HEXT  ,
     O           HNORM  )
*
      CHARACTER HEXT  *(*)           !" エスケープ入り文字列
      CHARACTER HNORM *(*)           !" 正規化された文字列
*
      CHARACTER CSGI
      CHARACTER HMSG  *100
*
      NL = LEN( HNORM )
      NE = LEN( HEXT  )
*
      HNORM = ' '
*
      IL = 1
      IE = 1
 1000 CONTINUE
        IF ( HEXT(IE:IE) .EQ. '\\' ) THEN
           IF ( HEXT(IE+1:IE+1) .EQ. '\\' ) THEN
              HNORM(IL:IL) = '\\'
              IE = IE + 2
              IL = IL + 1
           ELSE IF ( IE .LE. NE-3 ) THEN
              READ ( HEXT(IE+1:IE+3), '(I3)', ERR=9000 ) INUM
              IF ( ( INUM .LT. 0 ) .OR. ( INUM .GT. 255 ) ) GOTO 9000
              HNORM(IL:IL) = CSGI(INUM)
              IE = IE + 4
              IL = IL + 1
           ELSE
              HNORM(IL:IL) = '\\'
              IE = IE + 4
              IL = IL + 1
           ENDIF
        ELSE
              HNORM(IL:IL) = HEXT(IE:IE)
              IE = IE + 1
              IL = IL + 1
        ENDIF
*
        IF ( ( IL .LT. NL ) .AND. ( IE .LT. NE-1 ) ) THEN
           GOTO 1000
        ELSE IF ( IE .EQ. NE ) THEN
              HNORM(IL:IL) = HEXT(IE:IE)
        ENDIF
*
      RETURN
*
 9000 CONTINUE
      HMSG ='IRREGAL ESCAPE(\\ddd): '//HEXT
      CALL MSGDMP( 'W', 'GUCTXT', HMSG )
*
      RETURN
      END

* PACKAGE USPHE   !"  球面調和関数変換
*
*"  [HIS] 90/08/31(numaguti)
*
*
**********************************************************************
      SUBROUTINE SPW2G   !" スペクトル→格子
     M         ( GDATA ,
     I           WDATA ,
     C           PNM   , NMO   , TRIGS , IFAX ,
     F           HGRAD , HFUNC ,
     D           IMAX  , JMAX  , KMAX  , IDIM  , JDIM  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF, 
     W           ZDATA , WORK                                   )
*
*   [PARAM] 
      INTEGER    IMAX
      INTEGER    JMAX
      INTEGER    KMAX
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    LMAX
      INTEGER    MMAX
      INTEGER    NMAX
      INTEGER    MINT
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [MODIFY]       
      REAL       GDATA ( IDIM*JDIM, KMAX )    !" 格子点データ
*
*   [INPUT]
      REAL       WDATA ( NMDIM, KMAX     )    !" スペクトルデータ
*
      REAL       PNM   ( NMDIM, JMXHF )       !" ルジャンドル関数
      INTEGER    NMO   ( 2, 0:MMAX , 0:LMAX ) !" スペクトルの添字順番
      REAL       TRIGS ( * )                  !" 三角関数表
      INTEGER    IFAX  ( * )                  !" IMAX の因数分解
*
      CHARACTER  HGRAD*4                      !" 微分フラグ
      CHARACTER  HFUNC*4                      !" 符号フラグ
*
*   [WORK] 
      REAL       ZDATA ( IDIM*JDIM, KMAX )    !" 東西スペクトル
      REAL       WORK  ( IDIM*JDIM, KMAX )    !" ワーク
*
*   [INTERNAL WORK] 
      LOGICAL    LDPNM                        !" ｙ微分フラグ
      LOGICAL    LOFFS                        !" オフセットフラグ
      INTEGER    KMAXD
      PARAMETER (KMAXD=100)
      REAL       DOFFS ( KMAXD )              !" オフセット値
      INTEGER    IJ, K
*
*"         < 1. LOFFS, LDPNM : フラグ >
*
      IF ( HFUNC(4:4) .EQ. 'O' ) THEN
         LOFFS = .TRUE.
         IF ( KMAXD .LT. KMAX ) THEN
            CALL MSGDMP( 'E','SPW2G','INSUFFICIENT WORK STRAGE')
         ENDIF
      ELSE
         LOFFS = .FALSE.
      ENDIF
*
      IF ( HGRAD(1:1) .EQ. 'Y' ) THEN
         LDPNM = .TRUE.
         LOFFS = .FALSE.
      ELSE
         LDPNM = .FALSE.
      ENDIF
*
*"         < 2. スペクトル → zonal wave >
*
      IF ( LOFFS ) THEN
         DO 2000 K = 1, KMAX
            DOFFS( K ) = WDATA( NMO(1,0,0), K )
            WDATA( NMO(1,0,0), K ) = 0.  
 2000    CONTINUE
      ENDIF
*
      CALL SPW2Z
     O         ( ZDATA ,
     I           WDATA ,
     C           PNM   , NMO   ,
     F           LDPNM ,
     D           JMAX  , KMAX  , IDIM  , JDIM  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           WORK                                           )
*
      IF ( LOFFS ) THEN
         DO 2100 K = 1, KMAX
            WDATA( NMO(1,0,0), K ) = DOFFS( K )
 2100    CONTINUE
      ENDIF
*
      IF ( HGRAD(1:1) .EQ. 'X' ) THEN
*
*"         < 3. ｘ微分 >
*
         CALL GRADX
     M         ( ZDATA,
     D           IDIM , JDIM , KMAX  , MMAX , MINT ,
     W           WORK                                 )
         LOFFS = .FALSE.
      ENDIF
*
*"         < 4. zonal wave → 格子点 >
*
      CALL FFT99X
     O         ( WORK  ,
     M           ZDATA ,
     C           TRIGS , IFAX  ,
     C           1     , IDIM  , IMAX  , JDIM*KMAX , 1    )
*
      IF ( LOFFS ) THEN
         DO 4100 K = 1, KMAX
#ifdef SYS_SX3
*vdir noloopchg
#endif
            DO 4100 IJ = 1, IDIM*JDIM
               WORK ( IJ,K ) = WORK ( IJ,K ) + DOFFS( K )
 4100    CONTINUE
      ENDIF
*
*"         < 5. 出力データ >
*
      IF      ( HFUNC(1:1) .EQ. 'A' ) THEN
*
*"                               ( add )
        DO 5000 K = 1, KMAX
           DO 5000 IJ = 1, IDIM*JDIM
              GDATA( IJ,K ) = GDATA( IJ,K ) + WORK( IJ,K )
 5000   CONTINUE
*
      ELSE IF ( HFUNC(1:1) .EQ. 'S' ) THEN
*
*"                               ( sub )
        DO 5100 K = 1, KMAX
           DO 5100 IJ = 1, IDIM*JDIM
              GDATA( IJ,K ) = GDATA( IJ,K ) - WORK( IJ,K )
 5100   CONTINUE
*
      ELSE IF ( HFUNC(1:1) .EQ. 'N' ) THEN
*
*"                               ( negative )
        DO 5200 K = 1, KMAX
           DO 5200 IJ = 1, IDIM*JDIM
              GDATA( IJ,K ) = - WORK( IJ,K )
 5200   CONTINUE
*
      ELSE
*"                               ( positive )
        DO 5300 K = 1, KMAX
           DO 5300 IJ = 1, IDIM*JDIM
              GDATA( IJ,K ) = WORK( IJ,K )
 5300   CONTINUE
      ENDIF
*
      RETURN
      END
**********************************************************************
*"      << 球面調和関数変換 (格子→スペクトル) >>
**********************************************************************
      SUBROUTINE SPG2W
     M         ( WDATA ,
     I           GDATA ,
     C           PNM   , NMO   , TRIGS , IFAX , GW   ,
     F           HGRAD , HFUNC ,
     D           IMAX  , JMAX  , KMAX  , IDIM  , JDIM  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , WORK                                    )
*
*   [PARAM] 
      INTEGER    IMAX
      INTEGER    JMAX
      INTEGER    KMAX
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    LMAX
      INTEGER    MMAX
      INTEGER    NMAX
      INTEGER    MINT
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [MODIFY] 
      REAL       WDATA ( NMDIM, KMAX     )    !" スペクトルデータ
*
*   [INPUT] 
      REAL       GDATA ( IDIM*JDIM, KMAX )    !" 格子点データ
*
      REAL       PNM   ( NMDIM, JMXHF )       !" ルジャンドル関数
      INTEGER    NMO   ( 2, 0:MMAX , 0:LMAX ) !" スペクトルの添字順番
      REAL       GW    ( JDIM )               !" ガウス荷重
      REAL       TRIGS ( * )                  !" 三角関数表
      INTEGER    IFAX  ( * )                  !" IMAX の因数分解
*
      CHARACTER  HGRAD*4                      !" 微分フラグ
      CHARACTER  HFUNC*4                      !" 符号フラグ
*
*   [WORK] 
      REAL       ZDATA ( IDIM*JDIM, KMAX )    !" 東西スペクトル
      REAL       WORK  ( IDIM*JDIM, KMAX )    !" ワーク
*
*   [INTERNAL WORK] 
      LOGICAL    LDPNM                        !" ｙ微分フラグ
      LOGICAL    LOFFS                        !" オフセットフラグ
      INTEGER    KMAXD
      PARAMETER (KMAXD=100)
      REAL       DOFFS ( KMAXD )              !" オフセット値
      INTEGER    IJ, K
*
*"         < 1. LOFFS, LDPNM : フラグ >
*
      IF ( HFUNC(4:4) .EQ. 'O' ) THEN
         LOFFS = .TRUE.
         IF ( KMAXD .LT. KMAX ) THEN
            CALL MSGDMP( 'E','SPG2W','INSUFFICIENT WORK STRAGE')
         ENDIF
      ELSE
         LOFFS = .FALSE.
      ENDIF
*
      IF ( HGRAD(1:1) .EQ. 'Y' ) THEN
         LDPNM = .TRUE.
         LOFFS = .FALSE.
      ELSE
         LDPNM = .FALSE.
      ENDIF
*
*"         < 2. 入力複製 >
*
      IF ( LOFFS ) THEN
         DO 2000 K = 1, KMAX
            DOFFS ( K ) = GDATA( 1,K )
#ifdef SYS_SX3
*vdir noloopchg
#endif
            DO 2010 IJ = 1, IDIM*JDIM
               WORK ( IJ,K ) = GDATA( IJ,K ) - DOFFS( K )
 2010       CONTINUE
 2000    CONTINUE
      ELSE
         CALL COPY  ( WORK , GDATA , IDIM*JDIM*KMAX )
      ENDIF
*
*"         < 3. 格子 → zonal wave >
*
      CALL FFT99X
     M         ( WORK  ,
     O           ZDATA ,
     C           TRIGS , IFAX  ,
     C           1     , IDIM  , IMAX  , JDIM*KMAX , 0    )
*
      IF ( HGRAD(1:1) .EQ. 'X' ) THEN
*
*"                 < 4. ｘ微分 >
*
         CALL GRADX
     M         ( ZDATA,
     D           IDIM , JDIM , KMAX , MMAX , MINT  ,
     W           WORK )
*
         LOFFS = .FALSE.
      ENDIF
*
*"         < 5. zonal wave → スペクトル >
*
      CALL SPZ2W
     M         ( WDATA ,
     I           ZDATA ,
     C           PNM   , NMO   , GW    ,
     F           LDPNM , HFUNC ,
     D           JMAX  , KMAX  , IDIM  , JDIM  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           WORK                                           )
*
      IF ( LOFFS ) THEN
         IF (      ( HFUNC(1:1) .EQ. 'N' )
     &        .OR. ( HFUNC(1:1) .EQ. 'S' )    ) THEN
            DO 5100 K = 1, KMAX
               WDATA( NMO(1,0,0),K ) = WDATA( NMO(1,0,0),K )
     &                               - DOFFS( K )
 5100       CONTINUE
         ELSE
            DO 5200 K = 1, KMAX
               WDATA( NMO(1,0,0),K ) = WDATA( NMO(1,0,0),K )
     &                               + DOFFS( K )
 5200       CONTINUE
         ENDIF
      ENDIF
*
      RETURN
      END
**********************************************************************
      SUBROUTINE SPW2Z  !" ルジャンドル変換 (スペクトル→格子)
     O         ( ZDATA   ,
     I           WDATA ,
     C           PNM   , NMO   ,
     F           LDPNM ,
     D           JMAX  , KMAX  , IDIM  , JDIM  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDW                                            )
*
*   [PARAM] 
      INTEGER    JMAX
      INTEGER    KMAX
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    LMAX
      INTEGER    MMAX
      INTEGER    NMAX
      INTEGER    MINT
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [OUTPUT] 
      REAL       ZDATA ( IDIM, JDIM, KMAX )   !" 東西スペクトル
*
*   [INPUT] 
      REAL       WDATA ( NMDIM, KMAX      )   !" スペクトル
*
      REAL       PNM   ( NMDIM, JMXHF )       !" ルジャンドル関数
      INTEGER    NMO   ( 2, 0:MMAX , 0:LMAX ) !" スペクトルの添字順番
*
      LOGICAL    LDPNM                        !" ｙ微分フラグ
*
*   [WORK] 
      REAL       ZDW   ( IDIM, JDIM, KMAX )   !" ワーク
*
*   [INTERNAL ONCE] 
      INTEGER    NMDIMD
      PARAMETER (NMDIMD=12000)
      INTEGER    MLIST ( NMDIMD )             !" リストベクトル
      INTEGER    JLIST ( NMDIMD )             !" リストベクトル
      LOGICAL    OLSET
      DATA       OLSET / .FALSE. /
      SAVE       MLIST, JLIST, OLSET
*
*   [INTERNAL WORK] 
      INTEGER    L, M, NM, K
      INTEGER    LEND, MM, IM
      INTEGER    J, JP, JE, JO, JN, JS
*
*
*"         < 0. リストベクトル作成 >
*
*   [ONCE] 
      IF ( .NOT. OLSET ) THEN
         OLSET = .TRUE.
*
         IF ( NMDIMD .LT. NMDIM ) THEN
            CALL MSGDMP( 'E','SPW2Z','INSUFFICIENT WORK STRAGE')
         ENDIF
*
         DO 200 M = 0, MMAX, MINT
            LEND = MIN ( LMAX, NMAX-M )
            MM = M / MINT
*
            DO 100 L = 0, LEND
               MLIST (  NMO ( 1,M,L )  ) = 2 * MM + 1
               MLIST (  NMO ( 2,M,L )  ) = 2 * MM + 2
*
               IF ( MOD( L,2 ) .EQ. 0 ) THEN
                  JLIST (  NMO ( 1,M,L )  ) = 0
                  JLIST (  NMO ( 2,M,L )  ) = 0
               ELSE
                  JLIST (  NMO ( 1,M,L )  ) = JMAX / 2
                  JLIST (  NMO ( 2,M,L )  ) = JMAX / 2
               ENDIF
*
  100       CONTINUE
  200    CONTINUE
*
      ENDIF
*
*"         < 1. 作業領域リセット >
*
      CALL RESET ( ZDW  , IDIM*JDIM*KMAX )
      CALL RESET ( ZDATA, IDIM*JDIM*KMAX )
*
*"         < 2.  ルジャンドル変換 >
*
      DO 2300 NM = 1 , NMDIM
         IM = MLIST( NM )
*
         DO 2200 K = 1 , KMAX
#ifdef SYS_HITAC
*VOPTION INDEP(ZDW)
#endif
#ifdef SYS_SX3
*vdir nodep(ZDW)
#endif
            DO 2100 J = 1 , JMAX/2
               JP = JLIST( NM ) + J
*
               ZDW( IM,JP,K   ) = ZDW( IM,JP,K   )
     &                        +  PNM  ( NM,J ) * WDATA( NM,K   )
 2100       CONTINUE
 2200    CONTINUE
*
 2300 CONTINUE
*
*"         < 3. 対称・反対称成分 → 通常の並び >
*
      DO 3200 J = 1 , JMAX/2
         JN = J
         JS = JMAX+1 - J
         IF ( .NOT. LDPNM ) THEN
*"                                (  PNM を用いる場合 )
            JE = J
            JO = JMAX/2 + J
         ELSE
*"                                ( DPNM を用いる場合 )
            JE = JMAX/2 + J
            JO = JN
         ENDIF
*
         DO 3100 K = 1 , KMAX
            DO 3100 IM = 1 , IDIM
               ZDATA( IM,JN,K ) = ZDW( IM,JE,K ) + ZDW( IM,JO,K )
               ZDATA( IM,JS,K ) = ZDW( IM,JE,K ) - ZDW( IM,JO,K )
 3100    CONTINUE
*
 3200 CONTINUE
*
*
      RETURN
      END
**********************************************************************
      SUBROUTINE SPZ2W     !" ルジャンドル変換 (格子→スペクトル)
     M         ( WDATA ,
     I           ZDATA   ,
     C           PNM   , NMO   , GW    ,
     F           LDPNM , HFUNC ,
     D           JMAX  , KMAX  , IDIM  , JDIM  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDW                                            )
*
*   [PARAM] 
      INTEGER    JMAX
      INTEGER    KMAX
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    LMAX
      INTEGER    MMAX
      INTEGER    NMAX
      INTEGER    MINT
      INTEGER    NMDIM
      INTEGER    JMXHF
*
*   [MODIFY] 
      REAL       WDATA ( NMDIM, KMAX      )   !" スペクトル
*
*   [INPUT] 
      REAL       ZDATA ( IDIM, JDIM, KMAX )   !" 東西スペクトル
*
      REAL       PNM   ( NMDIM, JMXHF )       !" ルジャンドル関数
      INTEGER    NMO   ( 2, 0:MMAX , 0:LMAX ) !" スペクトルの添字順番
      REAL       GW    ( JDIM )               !" ガウス荷重
*
      LOGICAL    LDPNM                        !" ｙ微分フラグ
      CHARACTER  HFUNC*4                      !" 符号フラグ
*
*   [WORK] 
      REAL       ZDW   ( IDIM, JDIM, KMAX )   !" ワーク
*
*   [INTERNAL ONCE] 
      INTEGER    NMDIMD
      PARAMETER (NMDIMD=12000)
      INTEGER    MLIST ( NMDIMD )             !" リストベクトル
      INTEGER    JLIST ( NMDIMD )             !" リストベクトル
      LOGICAL    OLSET
      DATA       OLSET / .FALSE. /
      SAVE       MLIST, JLIST, OLSET
*
*   [INTERNAL WORK] 
      INTEGER    L, M, NM, K
      INTEGER    LEND, MM, IM
      INTEGER    J, JP, JE, JO, JN, JS
*
*
*"         < 0. リストベクトル作成 >
*
*   [ONCE] 
      IF ( .NOT. OLSET ) THEN
         OLSET = .TRUE.
*
         IF ( NMDIMD .LT. NMDIM ) THEN
            CALL MSGDMP( 'E','SPZ2W','INSUFFICIENT WORK STRAGE')
         ENDIF
*
         DO 200 M = 0, MMAX, MINT
            LEND = MIN ( LMAX, NMAX-M )
            MM   = M / MINT
            DO 100 L = 0, LEND
               MLIST (  NMO ( 1,M,L )  ) = 2* MM + 1
               MLIST (  NMO ( 2,M,L )  ) = 2* MM + 2
*
               IF ( MOD( L,2 ) .EQ. 0 ) THEN
                  JLIST (  NMO ( 1,M,L )  ) = 0
                  JLIST (  NMO ( 2,M,L )  ) = 0
               ELSE
                  JLIST (  NMO ( 1,M,L )  ) = JMAX / 2
                  JLIST (  NMO ( 2,M,L )  ) = JMAX / 2
               ENDIF
*
  100       CONTINUE
  200    CONTINUE
*
      ENDIF
*
*
      IF (      ( HFUNC(1:1) .NE. 'A' )
     &     .AND.( HFUNC(1:1) .NE. 'S' )    ) THEN
*
*"                 < 1. 和差をとらないときリセット >
*
         CALL RESET ( WDATA, NMDIM*KMAX )
      ENDIF
*
*"         < 2. ガウス荷重をかける >
*"              ( 通常の並び → 対称・反対称成分 )
*
      DO 2200 J = 1 , JMAX/2
*
         JN = J
         JS = JMAX+1 - J
         IF ( .NOT. LDPNM ) THEN
*"                                (  PNM を用いる場合 )
            JE = J
            JO = JMAX/2 + J
         ELSE
*"                                ( DPNM を用いる場合 )
            JE = JMAX/2 + J
            JO = JN
         ENDIF
*
         DO 2100 K = 1 , KMAX
            DO 2100 IM = 1 , IDIM
               ZDW( IM,JE,K ) = GW ( J ) *
     &                      ( ZDATA( IM,JN,K ) + ZDATA( IM,JS,K ) )
               ZDW( IM,JO,K ) = GW ( J ) *
     &                      ( ZDATA( IM,JN,K ) - ZDATA( IM,JS,K ) )
 2100    CONTINUE
*
 2200 CONTINUE
*
*
      IF (      ( HFUNC(1:1) .EQ. 'N' )
     &     .OR. ( HFUNC(1:1) .EQ. 'S' )    ) THEN
*
*"         < 3. ルジャンドル変換−負のとき   >
*
         DO 3300 J = 1 , JMAX/2
*
            DO 3200 K = 1 , KMAX
               DO 3100 NM = 1 , NMDIM
*
                  IM = MLIST( NM )
                  JP = JLIST( NM ) + J
*
                  WDATA( NM,K   )  = WDATA( NM,K   )
     &                             -  PNM ( NM,J ) * ZDW( IM,JP,K   )
 3100          CONTINUE
 3200       CONTINUE
*
 3300    CONTINUE
*
      ELSE
*
*"         < 4. ルジャンドル変換−正のとき   >
*
         DO 4300 J = 1 , JMAX/2
*
            DO 4200 K = 1 , KMAX
               DO 4100 NM = 1 , NMDIM
*
                  IM = MLIST( NM )
                  JP = JLIST( NM ) + J
*
                  WDATA( NM,K   )  = WDATA( NM,K   )
     &                             +  PNM ( NM,J ) * ZDW( IM,JP,K   )
 4100          CONTINUE
 4200       CONTINUE
*
 4300    CONTINUE
*
      ENDIF
*
      RETURN
      END
************************************************************************
      SUBROUTINE GRADX      !" ｘ微分のスペクトル成分
     M         ( ZDATA ,
     D           IDIM  , JDIM  , KMAX  , MMAX  , MINT ,
     W           ZDW    )
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KMAX
      INTEGER    MMAX
      INTEGER    MINT
*
*   [MODIFY] 
      REAL       ZDATA ( IDIM, JDIM, KMAX ) !" データ
*
*   [WORK] 
      REAL       ZDW   ( IDIM, JDIM, KMAX ) !" ワーク
*
*   [INTERNAL WORK] 
      INTEGER    M, MR, MI, MM
      INTEGER    J, K
*
*
*"         < 1. 作業領域 >
*
      CALL COPY ( ZDW , ZDATA , IDIM*JDIM*KMAX )
*
*"         < 2. ｉｍ をかける >
*
      DO 2100 M = 0, MMAX, MINT
         MM = M / MINT
         MR = 2*MM + 1
         MI = 2*MM + 2
         DO 2110 K = 1, KMAX
            DO 2110 J = 1, JDIM
               ZDATA( MR, J, K ) = - REAL( M ) * ZDW  ( MI, J, K )
               ZDATA( MI, J, K ) =   REAL( M ) * ZDW  ( MR, J, K )
 2110    CONTINUE      
 2100 CONTINUE
*
      RETURN
      END

*"表題 サイズの取得 GTOOL3(GUQSIZ)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << データサイズの取得 >>
*********************************************************************
      SUBROUTINE GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      INTEGER    IXSTR , IXEND , IXDIM   !" 軸1の始め 終り 寸法
      INTEGER    IYSTR , IYEND , IYDIM   !" 軸2の始め 終り 寸法
      INTEGER    IZSTR , IZEND , IZDIM   !" 軸3の始め 終り 寸法
*
      CALL GHPGET ( HHEAD , 'ASTR1', IXSTR )
      CALL GHPGET ( HHEAD , 'AEND1', IXEND )
      CALL GHPGET ( HHEAD , 'ASTR2', IYSTR )
      CALL GHPGET ( HHEAD , 'AEND2', IYEND )
      CALL GHPGET ( HHEAD , 'ASTR3', IZSTR )
      CALL GHPGET ( HHEAD , 'AEND3', IZEND )
*
      IXDIM = IXEND - IXSTR + 1
      IYDIM = IYEND - IYSTR + 1
      IZDIM = IZEND - IZSTR + 1
*
      RETURN
      END
*********************************************************************
*"         << 全データサイズの取得 >>
*********************************************************************
      SUBROUTINE GUQTSZ
     I         ( HHEAD ,
     O           ISIZE   )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      INTEGER    ISIZE                   !" 全寸法
*
      CALL       GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      ISIZE = IXDIM*IYDIM*IZDIM
*
      RETURN
      END

* PACKAGE GTSEQ   !" 系列をまとめたデータの作成
*********************************************************************
      PROGRAM GTSEQ
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
      CHARACTER  HHEADT( NDC )*(NCC)
      REAL       GDATAT( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  AXNAME *(NCC)
      CHARACTER  AXITEM *(NCC)
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       AXNAME, AXITEM / 2*' ' /
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ OUT, APND, AXNAME, AXITEM,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GTSIZE ( HHEADT, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      IF ( AXITEM .NE. ' ' ) THEN
         CALL GTCSET ( 'ITEMSEQ', AXITEM )
      ENDIF
      IF ( AXNAME .NE. ' ' ) THEN
         CALL GTCSET ( 'AXISSEQ', AXNAME )
      ENDIF
      CALL GPTSQR ( HHEADT )
*
      II = 0
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD.EQ.0 ) THEN
            II = II + 1
*
            CALL GPTSEQ
     I         ( HHEAD , GDATA ,
     I           ' '   , ' '   ,
     M           HHEADT, GDATAT )
*
      GOTO 1100
         ENDIF
*
      IF ( II .GT. 0 ) THEN
*
         IF ( ITEM .NE. ' ' ) THEN
            CALL GHCSET( HHEADT, 'ITEM', ITEM )
         ENDIF
         IF ( UNIT .NE. ' ' ) THEN
            CALL GHCSET( HHEADT, 'UNIT', UNIT )
         ENDIF
         IF ( TITLE .NE. ' ' ) THEN
            CALL GHCSTS( HHEADT, 'TITL', TITLE )
         ENDIF
         IF ( DSET .NE. ' ' ) THEN
            CALL GHCSET( HHEADT, 'DSET', DSET )
         ENDIF
*
         IF ( GRESET ) THEN
            CALL GHRSGP( HHEADT  )
         ENDIF
*
         CALL  GFOOPN ( JFILE,  OUT , APND )
*
         CALL  GFWRIT
     I               ( HHEADT, GDATAT,
     I                 JFILE , 1     , 0       )
*
         CALL  GUWIAX
     I               ( HHEADT )
      ENDIF
*
      STOP
      END

* PACKAGE GUNENV              " パス名を環境変数で置換
*
*"  [HIS] 92/09/20(numaguti)
*"        95/05/29(takepiro) by dcl-5.0
*
***********************************************************************
      SUBROUTINE GUNENV                      !" パス名環境変数置換
     M         ( HFILE ,
     I           HDEFEV, OMESG  )
*
*   [MODIFY] 
      CHARACTER  HFILE  *(*)          !" パス名
      CHARACTER  HDEFEV *(*)          !" 環境変数デフォルト
      LOGICAL    OMESG                !" メッセージフラグ
*
*   [INTERNAL WORK] 
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HFILX  *(NFILN)
*
      NFILE = LEN( HFILE )
      IF ( HFILE(1:2) .EQ. '‾/' ) THEN
         HFILX = '$HOME/'//HFILE(3:NFILE)
      ELSE
         HFILX = HFILE
      ENDIF
*
      CALL GURENV
     M   ( HFILX ,
     I     HDEFEV, OMESG  )
*
      IF ( HFILX(1:2) .EQ. './' ) THEN
         HFILE = HFILX(3:NFILN)
      ELSE
         HFILE = HFILX
      ENDIF
*
      RETURN
      END
***********************************************************************
      SUBROUTINE GURENV                      !" 環境変数置換
     M         ( HFILE ,
     I           HDEFEV, OMESG  )
*
*   [MODIFY] 
      CHARACTER  HFILE  *(*)          !" パス名
      CHARACTER  HDEFEV *(*)          !" 環境変数デフォルト
      LOGICAL    OMESG                !" メッセージフラグ
*
*   [INTERNAL WORK] 
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HFILX  *(NFILN)
      INTEGER    NFNAM, NFILE, I, II, IE, NENV, IEN
      CHARACTER  HCQUO, HCENV
      DATA       HCQUO, HCENV / '"', '$' /
      CHARACTER  HENVN  *(NCC)
      CHARACTER  HENVV  *(NFILN)
      CHARACTER  HMSG   *100
*
*   [EXTERNAL FUNC] 
      INTEGER    LENC
*
      NFILE = LEN ( HFILE )
      HFILX = HFILE
      HFILE = ' '
      NFNAM = LENC( HFILX )
      I     = 1
      II    = 1
*
 1100 CONTINUE 
         IF      ( HFILX(I:I) .EQ. HCQUO ) THEN
            I = I + 1
         ELSE IF ( HFILX(I:I) .EQ. HCENV ) THEN
            HENVN = ' '
            DO 1200 IE = I+1, NFNAM
               IF ( ((HFILX(IE:IE) .LT. 'A') .OR.
     &               (HFILX(IE:IE) .GT. 'Z')) .AND.
     &               (HFILX(IE:IE) .NE. '_')       ) THEN
                  IF ( IE .GT. I+1 ) THEN
                     HENVN = HFILX(I+1:IE-1)
                  ENDIF
                  I = IE
                  GOTO 1300
               ENDIF
 1200       CONTINUE 
            HENVN = HFILX(I+1:NFNAM)
            I = NFNAM+1
*
 1300       CONTINUE 
            CALL GUGENV ( HENVN, HENVV )
            IF ( HENVV .NE. ' ' ) THEN
               NENV = LENC( HENVV )
               IEN  = MIN( II+NENV-1, NFILE )
               HFILE(II:IEN) = HENVV
               II = IEN+1
            ELSE 
               IF ( OMESG ) THEN
                  NENV = LENC( HENVN )
                  HMSG = 'ENVIRONMENT VARIABLE '//
     &                       HENVN(1:NENV)//' IS NOT DEFINED'
                  CALL MSGDMP( 'W','MKFILN',HMSG )
               ENDIF 
               IF ( HDEFEV .NE. ' ' ) THEN
                  NENV = LENC( HDEFEV )
                  IEN  = MIN( II+NENV-1, NFILE )
                  HFILE(II:IEN) = HDEFEV
                  II = IEN+1
               ENDIF
            ENDIF
         ELSE
            HFILE(II:II) = HFILX(I:I)
            I  = I + 1
            II = II + 1
         ENDIF
      IF ( (I. LE. NFNAM) .AND. (II .LE. NFILE) ) GOTO 1100
*
      RETURN
      END
***********************************************************************
      SUBROUTINE GUGENV                      !" 環境変数取得
     I         ( HENAME ,
     O           HEVAL    )
*
      CHARACTER  HENAME *(*)
      CHARACTER  HEVAL  *(*)
*
#ifdef SYS_IBMS
      CALL SGPGET('IUNIT',IUNIT)
      OPEN (IUNIT,FILE=HENAME,ACCESS='READ',IOSTAT=IOS)
      IF ( IOS .EQ. 0 ) THEN
         READ (IUNIT,'(A)') HEVAL
         CLOSE (IUNIT)
      ELSE
         HEVAL = ' '
      ENDIF
#else
      CALL OSGENV ( HENAME, HEVAL )
#endif
*
      RETURN
      END

* PACKAGE GTSHOW   !" 最大/最小キャラクタ表示
************************************************************************
      PROGRAM GTMXMN
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
      CHARACTER  HHFLD       *(NCC)
      CHARACTER  HH          *51
*
      CHARACTER  HFILE( 1 )        *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
*
      INTEGER    XSTR, XEND, XSTEP, X
      INTEGER    YSTR, YEND, YSTEP, Y
      INTEGER    ZSTR, ZEND, ZSTEP, Z
      INTEGER    TSTR, TEND, TSTEP, T
      DATA       XSTR, XEND, XSTEP, X / 1, 999999, 1, -999 /
      DATA       YSTR, YEND, YSTEP, Y / 1, 999999, 1, -999 /
      DATA       ZSTR, ZEND, ZSTEP, Z / 1, 999999, 1, -999 /
      DATA       TSTR, TEND, TSTEP, T / 1, 999999, 1, -999 /
      LOGICAL    HEAD
      DATA       HEAD   / .FALSE. /
      LOGICAL    NOHEAD
      DATA       NOHEAD / .FALSE. /
      LOGICAL    POINTS
      DATA       POINTS / .FALSE. /
      LOGICAL    ALL
      DATA       ALL  / .FALSE. /
      LOGICAL    HELP
      DATA       HELP / .FALSE. /
      LOGICAL    LOC
      DATA       LOC  / .FALSE. /
*
      NAMELIST  /OPTION/ XSTR, XEND, XSTEP, X,
     &                   YSTR, YEND, YSTEP, Y,
     &                   ZSTR, ZEND, ZSTEP, Z,
     &                   TSTR, TEND, TSTEP, T,
     &                   HEAD, NOHEAD, POINTS, 
     &                   ALL, LOC, HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GTOPEN
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
*
      II = 0
 1100 CONTINUE
         II = II + 1
*
         CALL GFREAD
     O            ( HHEAD , GDATA , IEOD  ,
     I              IFILE , 0               )
*
         IF ( IEOD .EQ. 0 ) THEN
            IF ( II .GT. TEND ) GOTO 1900
*
            IF ( ((T.GT.0).AND.(T.EQ.II))   .OR.
     &           ((T.LT.0).AND.(II.GE.TSTR).AND.
     &            (II.LE.TEND).AND.(MOD(II-TSTR,TSTEP).EQ.0)) ) THEN
*
               HH = '###### Data No.      ##############'
*                    12345678901234567890123456789012345
*
               WRITE ( HH(17:20), '(I4)' ) II
               WRITE ( 6,* ) HH
*
               CALL GUQSIZ
     I              ( HHEAD,
     O                IXSTR, IXEND, IXDIM,
     O                IYSTR, IYEND, IYDIM,
     O                IZSTR, IZEND, IZDIM )
*
               CALL GHPGET(  HHEAD, 'MISS',  RMISS )
               CALL GLRSTX( 'RMISS', RMISS )
               CALL GLLSTX( 'LMISS', .TRUE. )  !" デフォルトは欠損値処理ON
*
               CALL MAXMIN( GDATA, IXDIM, IYDIM, IZDIM, 
     &                      IXDIM, IYDIM, HHEAD(3) )
            ENDIF
      GOTO 1100            
         ENDIF
*
 1900 CONTINUE
*
      STOP
      END
************************************************************************
      SUBROUTINE MAXMIN      !"  配列の最小値最大値を出力 
     I         ( DATA, IDIM, JDIM, KMAX, IMAX, JMAX, HITEM )
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KMAX
*
*   [INPUT] 
      REAL       DATA( IDIM, JDIM, KMAX )
      INTEGER    IMAX
      INTEGER    JMAX
      CHARACTER  HITEM*(*)                     !" 表題
*
*   [INTERNAL WORK] 
      INTEGER    IPMIN, JPMIN, KPMIN
      INTEGER    IPMAX, JPMAX, KPMAX
      REAL       DMIN, DMAX
*
      CALL RVMXMN
     O     ( DMAX  , DMIN  , 
     O       IPMAX , JPMAX , KPMAX , 
     O       IPMIN , JPMIN , KPMIN , 
     I       DATA  , IDIM  , JDIM  , KMAX , 
     I          1  , IMAX  ,    1  , JMAX ,  1 , KMAX  )
*
      WRITE (6,*) HITEM, ': min = ', DMIN,' at ', IPMIN,JPMIN,KPMIN
      WRITE (6,*) HITEM, ': max = ', DMAX,' at ', IPMAX,JPMAX,KPMAX
*
      RETURN
      END
*********************************************************************
      SUBROUTINE RVMXMN
     O            ( DMAX  , DMIN  , 
     O              IPMAX , JPMAX , KPMAX , 
     O              IPMIN , JPMIN , KPMIN , 
     I              DATA  , IDIM  , JDIM  , KDIM , 
     I              ISTR  , IEND  , JSTR  , JEND , KSTR , KEND  )
*
*   [INPUT
      REAL       DMAX , DMIN             !" 最大・最小値
      INTEGER    IPMAX, JPMAX, KPMAX       !" 最大値をとる要素
      INTEGER    IPMIN, JPMIN, KPMIN       !" 最小値をとる要素
      INTEGER    IDIM, JDIM, KDIM
      REAL       DATA( IDIM, JDIM, KDIM )  !" 調べる配列
      INTEGER    ISTR, IEND                !" 調べる範囲
      INTEGER    JSTR, JEND
      INTEGER    KSTR, KEND
*
      REAL       RMISS                     !" 欠損値
      LOGICAL    LMISS                     !" 欠損値処理スイッチ
      LOGICAL    OSETMN, OSETMX            !" 最大最小設定スイッチ
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
*
      CALL GLLGET( 'LMISS', LMISS )
      CALL GLRGET( 'RMISS', RMISS )
*
      OSETMN = .FALSE.
      OSETMX = .FALSE.
*
      DO 1100 K=KSTR,KEND
        DO 1100 J=JSTR,JEND
          DO 1100 I=ISTR,IEND
*
             IF ( LMISS ) THEN
                IF ( DATA( I,J,K ) .NE. RMISS ) THEN
                   IF ( DATA( I,J,K ) .LT. DMIN .OR. .NOT. OSETMN ) THEN
                      DMIN = DATA( I,J,K )
                      IPMIN = I
                      JPMIN = J
                      KPMIN = K
                      OSETMN = .TRUE. 
                   ENDIF
*
                   IF ( DATA( I,J,K ) .GT. DMAX .OR. .NOT.OSETMX ) THEN
                      DMAX = DATA( I,J,K )
                      IPMAX = I
                      JPMAX = J
                      KPMAX = K
                      OSETMX = .TRUE. 
                   ENDIF
                ENDIF
             ELSE
                IF ( DATA( I,J,K ) .LT. DMIN .OR. .NOT. OSETMN ) THEN
                   DMIN = DATA( I,J,K )
                   IPMIN = I
                   JPMIN = J
                   KPMIN = K
                   OSETMN = .TRUE. 
                ENDIF
*
                IF ( DATA( I,J,K ) .GT. DMAX .OR. .NOT. OSETMX ) THEN
                   DMAX = DATA( I,J,K )
                   IPMAX = I
                   JPMAX = J
                   KPMAX = K
                   OSETMX = .TRUE. 
                ENDIF
             ENDIF
*
 1100 CONTINUE
*
      IF ( .NOT. OSETMN ) 
     &     CALL MSGDMP('W','RVMXMN','MIN. VALUE NOT FOUND')
      IF ( .NOT. OSETMX ) 
     &     CALL MSGDMP('W','RVMXMN','MAX. VALUE NOT FOUND')
*
      RETURN
      END

*"表題 編集記述子セット GTOOL3(GHESET)
*
*"履歴 90/09/08 沼口  敦
*
*
********************************************************************
*"         << 編集記述子のセット >>
********************************************************************
      SUBROUTINE GHESET
     M         ( HHEAD ,
     I           HEDIT , HETTL, IENUM  )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      CHARACTER  HEDIT *(*)              !" 編集略記号
      CHARACTER  HETTL *(*)              !" 編集タイトル
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HP    *8                !" ヘッダーの欄指定
*
      IF ( ( IENUM .LT. 1 ).OR.( IENUM .GT. NED ) ) THEN
         CALL MSGDMP( 'W', 'GHESET', 'IRREGAL NUMBER EDIT FIELD.' )
         RETURN
      ENDIF
*
      HP = 'EDIT'
      WRITE ( HP(5:5),'(I1)' ) IENUM
      CALL GHCSET( HHEAD , HP  , HEDIT )
      HP(1:4) = 'ETTL'
      CALL GHCSET( HHEAD , HP  , HETTL )
*
      RETURN
      END
*********************************************************************
*"         << 編集記述子の追加セット >>
*********************************************************************
      SUBROUTINE GHEADD
     M         ( HHEAD ,
     I           HEDIT , HETTL )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      CHARACTER  HEDIT *(*)              !" 編集略記号
      CHARACTER  HETTL *(*)              !" 編集タイトル
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
*
      CALL GHQENM ( HHEAD, IENUM )
*
      IF ( IENUM .GE. NED ) THEN
         CALL MSGDMP('W', 'GHEADD', 'NO MORE EDIT FIELD.' )
         RETURN
      ENDIF
*
      CALL       GHESET
     M         ( HHEAD ,
     I           HEDIT , HETTL, IENUM+1 )
*
      RETURN
*===================================================================
*"         << 編集記述子の再セット >>
*===================================================================
      ENTRY      GHERST
     M         ( HHEAD ,
     I           HEDIT , HETTL )
*
      CALL GHQENM ( HHEAD, IENUM )
*
      CALL       GHESET
     M         ( HHEAD ,
     I           HEDIT , HETTL, IENUM  )
*
      RETURN
      END

* PACKAGE  GTTHETAE  !" ΑκΕφ²Ή°Μ
***********************************************************************
      PROGRAM GTTHTE
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEADT( NDC )*(NCC)
      REAL       GDATAT( IJKDIM )
      CHARACTER  HHEADQ( NDC )*(NCC)
      REAL       GDATAQ( IJKDIM )
      CHARACTER  HHEADP( NDC )*(NCC)
      REAL       GDATAP( IJKDIM )
*
      DATA       IFILT / 50 /
      DATA       IFILQ / 51 /
      DATA       IFILP / 52 /
      DATA       JFILE / 60 /
*
      CHARACTER  T      *(NFILN)
      DATA       T      / 'T' /
      CHARACTER  Q      *(NFILN)
      DATA       Q      / 'q' /
      CHARACTER  PS     *(NFILN)
      DATA       PS     / 'Ps' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM   / 'THETAE' /
      DATA       UNIT   / ' ' /
      DATA       TITLE  / 'Equiv. Pot. Temp.' /
      DATA       DSET, EDIT, ETTL /3*' '/
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   THETAE
*     
      NAMELIST  /OPTION/ T, Q, PS, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEADT, IJKDIM )
      CALL GTSIZE ( HHEADQ, IJKDIM )
      CALL GTSIZE ( HHEADP, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( T , OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( Q , OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( PS, OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILET, T     )
      CALL GFROPN ( IFILEQ, Q     )
      CALL GFROPN ( IFILEP, PS    )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEADT, GDATAT, IEODT  ,
     I          IFILET , 1               )
         CALL   GFREAD
     O        ( HHEADQ, GDATAQ, IEODQ  ,
     I          IFILEQ, 1               )
         CALL   GFREAD
     O        ( HHEADP, GDATAP, IEODP ,
     I          IFILEP, 1               )
*
         IF ( MAX(IEODQ,IEODT,IEODP) .EQ.0 ) THEN
            CALL GMCAL3
     I         ( THETAE,
     M           HHEADT, GDATAT,
     I           HHEADQ, GDATAQ,
     I           HHEADP, GDATAP,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEADT, 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEADT, 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEADT  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEADT, GDATAT,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE THETAE
     I         ( HHEADT, T     ,
     I           HHEADQ, Q     ,
     I           HHEADP, PS    ,
     O           HHEADE, THE   ,
     D           IXDIM , IYDIM , IZDIM ,
     D           IXDIM2, IYDIM2, IZDIM2,
     D           IXDIM3, IYDIM3, IZDIM3 )
*
      CHARACTER  HHEADT ( * ) *(*)
      CHARACTER  HHEADQ ( * ) *(*)
      CHARACTER  HHEADP ( * ) *(*)
      CHARACTER  HHEADE ( * ) *(*)
      REAL       T  ( IXDIM , IYDIM , IZDIM  )
      REAL       Q  ( IXDIM2, IYDIM2, IZDIM2 )
      REAL       PS ( IXDIM3, IYDIM3         )
      REAL       THE( IXDIM , IYDIM , IZDIM  )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      PARAMETER  ( KDIMD = 100 )
      REAL       SIG ( KDIMD )
* 
      DATA       P00  / 1000. /
      DATA       RAIR / 287.04 /
      DATA       CP   / 1004.6 /
      DATA       EL   / 2.5E6  /
*
      IF ( IZDIM .GT. KDIMD ) THEN
         CALL MSGDMP( 'E','THETAE','WORK AREA TOO SMALL' )
      ENDIF
*
      CALL GUQAXP
     I         ( HHEADT, 3     , 'LOC',
     O           SIG   , IEOD  , KDIMD  )
*
      AKAPPA = RAIR / CP
*
      DO 1100 K = 1, IZDIM
         DO 1100 J = 1, IYDIM
            DO 1100 I = 1, IXDIM
                  THE( I,J,K ) = ( T ( I,J,K ) + EL/CP * Q ( I,J,K ) )
     &                         / ( PS( I,J )*SIG( K )/ P00 )** AKAPPA
 1100 CONTINUE
*
      RETURN
      END

*"表題 編集記述を作成 GTOOL3(GUEAXN)
*
*"履歴 90/09/20 沼口  敦
*
*
*********************************************************************
*"         << 編集記述を作成  >>
*********************************************************************
      SUBROUTINE GUEAXN
     I         ( HAXIS , HED   , HET   ,
     I           ISTR  , IEND  ,
     O           HEDIT , HETTL           )
*
      CHARACTER  HAXIS         *(*)          !" 軸名称
      CHARACTER  HED           *(*)          !" 編集記述子接頭
      CHARACTER  HET           *(*)          !" 編集タイトル接尾
      INTEGER    ISTR                        !" 格子番号始め
      INTEGER    IEND                        !" 格子番号終り
      CHARACTER  HEDIT         *(*)          !" 編集記述子
      CHARACTER  HETTL         *(*)          !" 編集タイトル
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
      CHARACTER  HNUM1         *(NCC)
      CHARACTER  HNUM2         *(NCC)
#ifdef SYS_IBMS
      INCLUDE   (GZIWRK)                     !" NW: 軸ワークの大きさ
#else
#include        "gziwrk.F"                   !" NW: 軸ワークの大きさ
#endif
      CHARACTER  HHEADZ ( NDC )*(NCC)
      CHARACTER  HHEADA ( NDC )*(NCC)
      REAL       AXISZ  ( NW )
      LOGICAL    OSUBCK
*
*"         < 1. 編集略記号 >
*
      NHE  = LENC ( HED   )
      WRITE ( HNUM1, '(I5)' ) ISTR
      CALL CLADJ  ( HNUM1 )
      NH1  = LENC ( HNUM1 )
      IF ( ISTR .NE. IEND ) THEN
         WRITE ( HNUM2, '(I5)' ) IEND
         CALL CLADJ  ( HNUM2 )
         HEDIT = HED(1:NHE)//HNUM1(1:NH1)//'-'//HNUM2
      ELSE
         HEDIT = HED(1:NHE)//HNUM1
      ENDIF
*
*"         < 2. 編集タイトル >
*
      CALL GHPSET ( HHEADZ, 'IDFM' , 0     )
      CALL GHCSET ( HHEADZ, 'AITM1', HAXIS )
      CALL GHPSET ( HHEADZ, 'ASTR1', ISTR  )
      CALL GHPSET ( HHEADZ, 'AEND1', IEND  )
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HHEADA  ,  NW     )
      CALL GUQAXV
     I            ( HHEADZ, 1     , 'LOC' ,
     O              HHEADA, AXISZ , IEOD  )
      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
      NHA    = LENC( HAXIS )
*
      IF ( IEOD .EQ. 0 ) THEN
*
         CALL CHVAL  ( 'D', AXISZ(1), HNUM1 )
         NH1 = LENC( HNUM1 )
*
         IF ( ISTR .NE. IEND ) THEN
            CALL CHVAL  ( 'D', AXISZ(IEND-ISTR+1), HNUM2 )
            HETTL = HAXIS(1:NHA)//'='//HNUM1(1:NH1)//'-'//HNUM2
         ELSE
            HETTL = HAXIS(1:NHA)//'='//HNUM1
         ENDIF
*
      ELSE
         HETTL = HAXIS(1:NHA)//' '//HET
      ENDIF
*
      RETURN
      END

*"表題 文字記述子の参照/設定 GTOOL3(GHCGTS)
*
*"履歴 90/08/21 沼口  敦
*
*
*********************************************************************
*"         << 文字記述子の参照 >>
**********************************************************************
      SUBROUTINE GHCGTS
     I         ( HHEAD, HP    ,
     O           HX            )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      CHARACTER  HP         *(*)         !" ヘッダーの欄指定
      CHARACTER  HX         *(*)         !" 記述子の内容：文字
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HPN        *(NCC)
      CHARACTER  HNUM       *(NCC)
      CHARACTER  HFM        *(NCC)
      INTEGER    NHT
*
      NHT = LEN ( HX )
      NHP = LENC( HP )
      HX  = ' '
*
      CALL GHPINQ ( HP  , HFM  )
      IF ( HFM .NE. ' ' ) THEN
         CALL GHCGET
     I      ( HHEAD   , HP    ,
     O        HX               )
*
      ELSE
         DO 1100 I = 1, ( NHT+NCC-1 )/NCC
            WRITE ( HNUM, '(I2)' ) I
            CALL CLADJ( HNUM )
            HPN = HP(1:NHP)//HNUM
*
            IHS = (I-1)*NCC+1
            IHE = MIN( I*NCC, NHT )
*
            CALL GHPINQ ( HPN   , HFM   )
            IF ( ( I.EQ.1 ).OR.( HFM.NE.' ' ) ) THEN
               CALL GHCGET
     I            ( HHEAD   , HPN   ,
     O              HX(IHS:IHE)      )
            ENDIF
 1100    CONTINUE
      ENDIF
*
      RETURN
*=====================================================================
*"         << 文字記述子の設定 >>
*=====================================================================
      ENTRY      GHCSTS
     I         ( HHEAD, HP    ,
     I           HX            )
*
      NHT = LENC( HX )
      NHP = LENC( HP )
*
      CALL GHPINQ ( HP   , HFM   )
      IF ( HFM .NE. ' ' ) THEN
         CALL GHCSET
     I      ( HHEAD   , HP    ,
     I        HX               )
*
      ELSE
         DO 2100 I = 1, NDC
            WRITE ( HNUM, '(I2)' ) I
            CALL CLADJ( HNUM )
            HPN = HP(1:NHP)//HNUM
*
            IHS = (I-1)*NCC+1
            IHE = MIN( I*NCC, NHT )
*
            CALL GHPINQ ( HPN   , HFM   )
            IF      ( ( I.EQ.1 ).OR.
     &                ((HFM.NE.' ').AND.(IHS.LE.IHE))  ) THEN
               CALL GHCSET
     I            ( HHEAD   , HPN   ,
     I              HX(IHS:IHE)      )
            ELSE IF ( HFM .NE. ' ' ) THEN
               CALL GHCSET
     I            ( HHEAD   , HPN   ,
     I              ' '              )
            ENDIF
 2100    CONTINUE
      ENDIF
*
      RETURN
      END

*"表題 GTOOL 開始 GTOOL3(GTOPEN)
*
*"履歴 92/06/20 沼口  敦
*"     92/07/06 沼口  敦
*
*********************************************************************
*"         << GTOOL 開始 >>
*********************************************************************
      SUBROUTINE GTOPEN
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
*
      CHARACTER  HSIGN       *(NCC)        !" 名前
      CHARACTER  HAXDIR      *(NFILN)      !" 軸ファイル置き場
      CHARACTER  HAXLOC      *(NFILN)      !" 軸ファイル置き場
      CHARACTER  HAXWGT      *(NFILN)      !" 軸ファイル置き場
*
      INTEGER    LENC
*
      CALL GUGENV ( 'USER', HSIGN )
      IF ( HSIGN .EQ. ' ' ) THEN
         CALL GUGENV ( 'USERNAME', HSIGN )          
         IF ( HSIGN .EQ. ' ' ) THEN
            CALL MSGDMP( 'W','GTOPEN','YOU MUST SPECIFY "USER" ! ')
            HSIGN = 'GTOOL3'
         ENDIF
      ENDIF
*
      CALL GTSIGN ( HSIGN )                !" 作業者名の設定
*
      CALL GUGENV ( 'GTAXDIR', HAXDIR )
      IF ( HAXDIR .NE. ' ' ) THEN
         IC = LENC(HAXDIR)
         HAXLOC = HAXDIR(1:IC)//'/GTAXLOC.'
         HAXWGT = HAXDIR(1:IC)//'/GTAXWGT.'
         CALL GTCSET ( 'FAXLOC', HAXLOC )
         CALL GTCSET ( 'FAXWGT', HAXWGT )
      ENDIF
*
      RETURN
      END

*"表題 時刻をパック/アンパック GTOOL3(GHHGET)
*
*"履歴 90/08/21 沼口  敦
*
*
***********************************************************************
*"         << 時刻をパック >>
*********************************************************************
      SUBROUTINE GUTPAC
     I         ( IYEAR , IMONTH, IDAY  ,
     I           IHOUR , IMIN  , ISEC  ,
     O           HDATE                  )
*
      INTEGER    IYEAR                        !" 年
      INTEGER    IMONTH                       !" 月
      INTEGER    IDAY                         !" 日
      INTEGER    IHOUR                        !" 時
      INTEGER    IMIN                         !" 分
      INTEGER    ISEC                         !" 秒
      CHARACTER  HDATE *(*)                   !" 時刻(yyyymmddhhmmss)
*
      IF ( LEN( HDATE ) .LT. 14  ) THEN
         CALL MSGDMP( 'W', 'GUTPAC', 'SIZE OF HDATE IS TOO SMALL.' )
         RETURN
      ENDIF
*
      HDATE = ' '
      WRITE ( HDATE(1:4)  , '(I4)'   ) IYEAR
      WRITE ( HDATE(5:6)  , '(I2.2)' ) IMONTH
      WRITE ( HDATE(7:8)  , '(I2.2)' ) IDAY
      WRITE ( HDATE(9:10) , '(I2.2)' ) IHOUR
      WRITE ( HDATE(11:12), '(I2.2)' ) IMIN
      WRITE ( HDATE(13:14), '(I2.2)' ) ISEC
*
      RETURN
*======================================================================
*"         << 時刻をアンパック >>
*======================================================================
      ENTRY      GUTUPC
     O         ( IYEAR , IMONTH, IDAY  ,
     O           IHOUR , IMIN  , ISEC  ,
     I           HDATE                  )
*
      IF ( LEN( HDATE ) .LT. 14  ) THEN
         CALL MSGDMP( 'W', 'GUTUPC', 'SIZE OF HDATE IS TOO SMALL.' )
         RETURN
      ENDIF
*
      READ  ( HDATE(1:4)  , '(I4)', ERR=2900 ) IYEAR
      READ  ( HDATE(5:6)  , '(I2)', ERR=2900 ) IMONTH
      READ  ( HDATE(7:8)  , '(I2)', ERR=2900 ) IDAY
      READ  ( HDATE(9:10) , '(I2)', ERR=2900 ) IHOUR
      READ  ( HDATE(11:12), '(I2)', ERR=2900 ) IMIN
      READ  ( HDATE(13:14), '(I2)', ERR=2900 ) ISEC
*
      RETURN
*
 2900 CONTINUE
      CALL MSGDMP( 'W', 'GUTUPC', ' IRREGAL CONTENTS OF HDATE.' )
*
      RETURN
      END

*"表題 第１次元の拡大 GTOOL3(GPXEXT)
*
*"履歴 91/01/19 沼口  敦
*
*
*********************************************************************
*"         << 第１次元の拡大 >>
*********************************************************************
      SUBROUTINE GPXEXT
     I         ( HHEAD , GDATA ,
     I           HAITMX, IXSTR , IXEND ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HAITMX      *(*)        !" 拡大する第1次元の軸名
      INTEGER    IXSTR                   !" 第1次元の軸の格子始め
      INTEGER    IXEND                   !" 第1次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
*
*"         < 1. 結合準備 >
*
      CALL GPXCMI
     I         ( HHEAD , HAITMX, IXSTR , IXEND ,
     I           'NUL' , ' '   ,
     O           HHEADO, GDATAO )
*
*"         < 2. 大きさの取得 >
*
      CALL GUSMIS ( HHEADO )
*
      CALL GUQSIZ
     I         ( HHEADO,
     O           IXSTR1, IXEND1, IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
*"         < 3. データ詰め替え >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
*
      DO 2100 IX = IXSTR1, IXEND1
            CALL VRSET
     I         ( GDATA                ,
     O           GDATAO( IX-IXSTR1+1 ),
     I           IYDIM*IZDIM, 1     , IXDIM  )
 2100 CONTINUE
*
*"         < 3. ヘッダー変更 >
*
      IF ( ( IXSTR1 .EQ. 1 ).AND.( IXEND1 .EQ. 1 ) ) RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAITMX, 'XE'   , '-extend',
     I                 IXSTR1, IXEND1 ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第３次元の拡大 >>
*********************************************************************
      SUBROUTINE GMXEXT
     I         ( HHEAD , GDATA ,
     I           HAITMX, IXSTR , IXEND ,
     I           HEDIT , HETTL           )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HAITMX      *(*)        !" 拡大する第1次元の軸名
      INTEGER    IXSTR                   !" 第1次元の軸の格子始め
      INTEGER    IXEND                   !" 第1次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPXEXT
     I         ( HHEAD , GDATA ,
     I           HAITMX, IXSTR , IXEND ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

* PACKAGE  GTSLP !" ³¤ÌÌ¹¹Àµµ¤°µ
***********************************************************************
      PROGRAM GTSLP
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEADP( NDC )*(NCC)
      REAL       GDATAP( IJKDIM )
      CHARACTER  HHEADT( NDC )*(NCC)
      REAL       GDATAT( IJKDIM )
      CHARACTER  HHEADZ( NDC )*(NCC)
      REAL       GDATAZ( IJKDIM )
      CHARACTER  HITEZ  *(NCC)
*
      DATA       IFILP / 50 /
      DATA       IFILT / 51 /
      DATA       IFILZ / 52 /
      DATA       JFILE / 60 /
*
      DATA       GRAV  /  9.8 /
*
      CHARACTER  PS     *(NFILN)
      DATA       PS     / 'Ps' /
      CHARACTER  T      *(NFILN)
      DATA       T      / 'T' /
      CHARACTER  ZS     *(NFILN)
      DATA       ZS     / 'ZS' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM  / 'SLP' /
      DATA       TITLE / 'Sea Level Pressure' /
      DATA       UNIT, DSET, EDIT, ETTL / 4*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   CALSLP
*     
      NAMELIST  /OPTION/ PS  , T   , ZS   , OUT,  APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEADP, IJKDIM )
      CALL GTSIZE ( HHEADT, IJKDIM )
      CALL GTSIZE ( HHEADZ, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( PS, OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( T , OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( ZS, OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILEP, PS   )
      CALL GFROPN ( IFILET, T    )
      CALL GFROPN ( IFILEZ, ZS   )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      CALL   GFREAD
     O        ( HHEADZ, GDATAZ, IEODZ ,
     I          IFILEZ, 1               )
*
      IF ( IEODZ .NE. 0 ) THEN
         CALL MSGDMP('E','GTSLP','ZS FILE NOT FOUND' )
      ENDIF
*
      CALL GHCGET( HHEADZ, 'ITEM', HITEZ )
      IF ( HITEZ .EQ. 'GPHIS' ) THEN
         CALL GMFFCT
     I        ( HHEADZ, GDATAZ, 1./GRAV ,
     I          '  '  , '  '              )
      ENDIF
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEADP, GDATAP, IEODP ,
     I          IFILEP, 1               )
         CALL   GFREAD
     O        ( HHEADT, GDATAT, IEODT ,
     I          IFILET, 1               )
*
         IF ( MAX(IEODP,IEODT) .EQ.0 ) THEN
            CALL GMCAL3
     I         ( CALSLP,
     M           HHEADP, GDATAP,
     I           HHEADT, GDATAT,
     I           HHEADZ, GDATAZ,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEADP, 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEADP, 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEADP, 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEADP, 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEADP )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEADP, GDATAP,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE CALSLP
     I         ( HPS   , PS    ,
     I           HT    , T     ,
     I           HZS   , ZS    ,
     O           HSLP  , SLP   ,
     D           IMAX  , JMAX  , KMAX ,
     D           IMAX2 , JMAX2 , KMAX2,
     D           IMAX3 , JMAX3 , KMAX3  )
*
      CHARACTER  HPS ( * )*(*)
      REAL       PS  ( IMAX, JMAX )
      CHARACTER  HT  ( * )*(*)
      REAL       T   ( IMAX2, JMAX2, KMAX2 )
      CHARACTER  HZS ( * )*(*)
      REAL       ZS  ( IMAX3, JMAX3 )
      CHARACTER  HSLP( * )*(*)
      REAL       SLP ( IMAX, JMAX )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      CHARACTER  HHS ( NDC )*(NCC)
      PARAMETER  ( KMAXD = 100 )
      REAL       SIG  ( KMAXD )
*
      IF ( KMAX .GT. KMAXD ) THEN
         CALL MSGDMP( 'E','SLP','WORK AREA TOO SMALL' )
      ENDIF
      CALL GTSIZE ( HHS  ,  KMAXD   )
      CALL GUQAXV
     I            ( HT    , 3     , 'LOC',
     O              HHS   , SIG   , IEOD  )
*
      CALL PS2SLP
     I           ( ZS  , T   , PS  , SIG ,
     I             IMAX, JMAX,
     O             SLP                     )
*
      RETURN
      END
******************************************************************
      SUBROUTINE PS2SLP
     I           ( Z     , T     , PS    , SIG   ,
     I             IMAX  , JMAX  ,
     O             RSLP                            )
* ---------------------------------------
*  CALCULATE SEA LEVEL PRESSURE
*
* [INPUT]
*   Z    : SURFACE ALTITUDE
*   T    : TEMPERATURE AT SIGMA LEVEL 1
*   PS   : SURFACE AIR PRESSURE
*   SIG  : SIGMA LEVEL AT EACH LAYER
* [OUTPUT]
*   RSLP : SEA LEVEL PRESSURE
* [INTERNAL]
*   RZ   : ALTITUDE AT SIGMA LEVEL 1
*   P    : AIR PRESSURE AT SIGMA LEVEL 1
* ---------------------------------------
      REAL       Z     ( IMAX*JMAX )
      REAL       T     ( IMAX*JMAX )
      REAL       PS    ( IMAX*JMAX )
      REAL       SIG   ( 1 )
      REAL       RSLP  ( IMAX*JMAX )
*
      DATA       RAIR  /287.04/
      DATA       GRAV  /  9.8 /
*
* EVALUATE Z(LEVEL1) USING HYDROSTATIC RELATION
*
      DO 100 IJ = 1, IMAX*JMAX
         RZ = Z(IJ) - LOG( SIG(1) ) * RAIR * T(IJ) / GRAV
*
* SEA LEVEL PRESSURE
*
         RSLP(IJ) = PS(IJ) + DELTAP( RZ, T(IJ), PS(IJ)*SIG(1) )
  100 CONTINUE 
*
      RETURN
      END
**********************************************************************
      REAL FUNCTION DELTAP
     I              ( Z, T, P )
* ---------------------------------------------------------------
*  ( SEA LEVEL PRESSURE ) - ( SURFACE PRESSURE )
*
*  THIS METHOD HAVE USED BY THE OBSERVATION SECTION
*                        IN THE JAPANESE METEOROLOGICAL AGENCY.
* [INPUT]
*   Z   : ALTITUDE
*   T   : TEMPERATURE
*   P   : AIR PRESSURE
* [INTERNAL]
*   TM  : MEAN TEMPERATURE IN THE DESTINATION AIR COLUMN
*   EM  : EFFECT ON AIR MOISTURE
*   TVM : MEAN VIRTUAL TEMPERATURE IN THE DESTINATION AIR COLUMN
* ---------------------------------------------------------------
      DATA T00    /273.15 /
      DATA GRAV   /  9.8  /
      DATA RAIR   /287.05 /
      DATA TLAPS  /  0.005/
*
      TM  = ( T -T00 ) + TLAPS / 2. * Z
      EM  = EPSM( TM )
      TVM = T00 + TM + EM
*
      DELTAP = P * ( EXP( GRAV * Z / ( RAIR * TVM ) ) - 1. )
*
      RETURN
      END
*********************************************************************
      REAL FUNCTION EPSM(TM)
* ---------------------------------------
*  EFFECT ON AIR MOISTURE
*   (MEAN STATE OF LOWER LAYER IN JAPAN)
* ---------------------------------------
      IF(TM.LT.-30.) THEN
         EPSM = 0.09
         RETURN
       ELSE IF((-30..LE.TM).AND.(TM.LT.0.)) THEN
         A = 0.000489
         B = 0.0300
         C = 0.550
       ELSE IF((0..LE.TM).AND.(TM.LT.20.)) THEN
         A = 0.002850
         B = 0.0165
         C = 0.550
       ELSE IF((20..LE.TM).AND.(TM.LT.33.8)) THEN
         A =-0.006933
         B = 0.4687
         C =-4.580
       ELSE
         EPSM = 3.34
         RETURN
      ENDIF
*
      EPSM = ( A * TM + B ) * TM + C
*
      RETURN
      END

*"表題 時間単位の変換 GTOOL3(GUCT2R)
*
*"履歴 90/08/18 沼口  敦
*
*
*********************************************************************
*"          << 時間単位の変換 HUNIT → HUNITY: 実数 >>
*"         ( 秒・分・時・日・ステップ 相互間 )
*********************************************************************
      SUBROUTINE GUCT2R
     I         ( KT    , HUNIT  , HUNITY, IDELT  ,
     O           RT                                )
*
      INTEGER    KT                !" 入力時刻：単位 HUNIT
      CHARACTER  HUNIT *(*)        !" 入力 KT の単位
      CHARACTER  HUNITY*(*)        !" 変換すべき単位
      INTEGER    IDELT             !" １ステップの秒数
      REAL       RT                !" 出力時刻：単位 HUNITY
      INTEGER    IT                !" 出力時刻：単位 HUNITY
*
      REAL*8     WS                !" 時刻：単位 秒
      REAL*8     WT                !" 時刻：単位 HUNITY
*
      CALL  GUCT2S
     I         ( KT    , HUNIT  , IDELT  ,
     O           WS                       )
*
      CALL  GUCS2T
     I         ( WS    , HUNITY , IDELT  ,
     O           WT                       )
*
      RT = WT
*
      RETURN
*====================================================================
*"          << 時間単位の変換 HUNIT → HUNITY: 整数 >>
*"         ( 秒・分・時・日・ステップ 相互間 )
*====================================================================
      ENTRY      GUCT2I
     I         ( KT    , HUNIT  , HUNITY, IDELT  ,
     O           IT                                )
*
      CALL  GUCT2S
     I         ( KT    , HUNIT  , IDELT  ,
     O           WS                       )
*
      CALL  GUCS2T
     I         ( WS    , HUNITY , IDELT  ,
     O           WT                       )
*
      IT = NINT( WT )
*
      RETURN
      END
*********************************************************************
*"          << 時間単位の変換 HUNIT → 秒(倍精度) >>
*"         ( 秒・分・時・日・ステップ )
*********************************************************************
      SUBROUTINE GUCT2S
     I         ( KT    , HUNIT  , IDELT  ,
     O           WS                       )
*
      INTEGER    KT                !" 入力時刻：単位 HUNIT
      CHARACTER  HUNIT *(*)        !" 入力 KT の単位
      INTEGER    IDELT             !" １ステップの秒数
      REAL*8     WS                !" 時刻：単位 秒
*
      CHARACTER  HMSG*80
*
*"         < 1. 秒に換算 >
*
      IF      (    ( HUNIT       .EQ. 'STEP' )
     &         .OR.( HUNIT       .EQ. 'step' )  ) THEN
*
*"         < 1.1 step のとき Δｔを単位とする >
*
        WS = DBLE(KT) * DBLE(IDELT)
*
*"         < 1.2 sec, min, hour, dayとして換算 >
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'S' )
     &         .OR.( HUNIT (1:1) .EQ. 's' )  ) THEN
        WS = KT
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'M' )
     &         .OR.( HUNIT (1:1) .EQ. 'm' )  ) THEN
        WS = DBLE(KT) *60.D0
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'H' )
     &         .OR.( HUNIT (1:1) .EQ. 'h' )  ) THEN
        WS = DBLE(KT) *60.D0*60.D0
*
      ELSE IF (    ( HUNIT (1:1) .EQ. 'D' )
     &         .OR.( HUNIT (1:1) .EQ. 'd' )  ) THEN
        WS = DBLE(KT) *60.D0*60.D0*24.D0
*
      ELSE
*"         < 1.3 それ以外は時とする >
*
        WS = DBLE(KT)*60.D0*60.D0
*
        NHU = LENC( HUNIT )
        HMSG = 'IRREGAL INPUT TIME UNIT '//HUNIT(1:NHU)//
     &         ', <HOUR> ASSUMED.'
        CALL MSGDMP( 'W', 'GUCT2S', HMSG )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"          << 時間単位の変換 秒倍精度 → HUNITY 倍精度 >>
*"         ( 秒・分・時・日・ステップ 相互間 )
*********************************************************************
      SUBROUTINE GUCS2T
     I         ( WS    , HUNITY, IDELT  ,
     O           WT                       )
*
      REAL*8     WS                !" 入力時刻：単位 HUNIT
      CHARACTER  HUNITY*(*)        !" 変換すべき単位
      INTEGER    IDELT             !" １ステップの秒数
      REAL*8     WT                !" 出力時刻：単位 HUNITY
*
      CHARACTER  HMSG*80
*
*"         < 2. 求める単位に換算 >
*
      IF      (    ( HUNITY      .EQ. 'STEP' )
     &         .OR.( HUNITY      .EQ. 'step' )  ) THEN
*
*"         < 2.1 step のとき Δｔを単位とする >
*
        WT = WS / DBLE( IDELT )
*
*"         < 2.2 sec, min, hour, dayへ換算 >
*
      ELSE IF (    ( HUNITY (1:1) .EQ. 'S' )
     &         .OR.( HUNITY (1:1) .EQ. 's' )  ) THEN
        WT = WS
*
      ELSE IF (    ( HUNITY (1:1) .EQ. 'M' )
     &         .OR.( HUNITY (1:1) .EQ. 'm' )  ) THEN
        WT = WS / 60.D0
*
      ELSE IF (    ( HUNITY (1:1) .EQ. 'H' )
     &         .OR.( HUNITY (1:1) .EQ. 'h' )  ) THEN
        WT = WS / ( 60.D0*60.D0 )
*
      ELSE IF (    ( HUNITY (1:1) .EQ. 'D' )
     &         .OR.( HUNITY (1:1) .EQ. 'd' )  ) THEN
        WT = WS / ( 60.D0*60.D0*24.D0 )
*
      ELSE
*"         < 2.3 それ以外は時へ換算 >
*
        WT = WS / ( 60.D0*60.D0 )
*
        NHU = LENC( HUNITY )
        HMSG = 'IRREGAL OUTPUT TIME UNIT '//HUNITY(1:NHU)//
     &         ', <HOUR> ASSUMED.'
        CALL MSGDMP( 'W', 'GUCS2T', HMSG )
*
      ENDIF
*
      RETURN
      END

*"表題 内部設定格子の参照/設定 GTOOL3(GUQIAX)
*
*"履歴 90/09/14 沼口  敦
*
*
*********************************************************************
*"         << 内部設定格子の参照 >>
*********************************************************************
      SUBROUTINE GUQIAX
     I         ( HAXIS , HKIND ,
     O           HHEAD , AXIS  , IEOD   )
*
      CHARACTER  HAXIS      *(*)         !" 格子識別名称
      CHARACTER  HKIND *(*)              !" LOC/WGT
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       AXIS  ( * )             !" 位置/重み
      INTEGER    IEOD                    !" データなしフラグ
*
      REAL       AXLOC ( * )             !" 位置
      REAL       AXWGT ( * )             !" 重み
      INTEGER    INUM                    !" 内部設定格子番号
      REAL       AXLOC1                  !" 位置
      REAL       AXWGT1                  !" 重み
      INTEGER    IZ                      !" 格子番号
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
#ifdef SYS_IBMS
      INCLUDE   (GZIWRK)                 !" NW: 格子ワーク大きさ
#else
#include        "gziwrk.F"               !" NW: 格子ワーク大きさ
#endif
      CHARACTER  HAXISA(      NAXIS )*(NCC)
      DATA       HAXISA / NAXIS*' ' /
      CHARACTER  HHEADA( NDC, NAXIS )*(NCC)
      REAL       AXLOCA( NW , NAXIS )
      REAL       AXWGTA( NW , NAXIS )
      SAVE       HAXISA, HHEADA, AXLOCA, AXWGTA
      CHARACTER  HDS   *(NCC)
      CHARACTER  HAITM *(NCC)
      CHARACTER  HAXF  *(NFILN)
      CHARACTER  HFILE *(NFILN)
      CHARACTER  HMSG  * 100
*
      DO 1100 IA = 1, NAXIS
         IF ( HAXIS .EQ. HAXISA( IA ) ) THEN
*
            CALL GHCOPY ( HHEADA( 1,IA ), HHEAD )
            CALL GHPGET ( HHEAD , 'ASTR1', IZSTR )
            CALL GHPGET ( HHEAD , 'AEND1', IZEND )
            CALL GUSZCK ( HHEAD , IZEND-IZSTR+1  )
*
            CALL GHCGET ( HHEAD , 'DSET', HDS    )
            IF ( HDS(1:1) .EQ. 'C' ) THEN
               IDS = 2
            ELSE
               IDS = 1
            ENDIF
*
            IF      ( HKIND(1:1).EQ.'L' ) THEN
               CALL VRSET( AXLOCA(1,IA), AXIS, IZEND-IZSTR+1, 1, 1 )
               HDS(IDS:NCC) = 'IAXLOC'
            ELSE IF ( HKIND(1:1).EQ.'W' ) THEN
               CALL VRSET( AXWGTA(1,IA), AXIS, IZEND-IZSTR+1, 1, 1 )
               HDS(IDS:NCC) = 'IAXWGT'
            ELSE
               CALL MSGDMP( 'W','GUQIAX',
     I                      'IRREGAL HKIND: <LOC> ASSUMED.' )
               CALL VRSET( AXLOCA(1,IA), AXIS, IZEND-IZSTR+1, 1, 1 )
               HDS(IDS:NCC) = 'IAXLOC'
            ENDIF
            CALL GHCSET ( HHEAD , 'DSET', HDS    )
            IEOD = 0
*
            RETURN
         END IF
 1100 CONTINUE
*
      IEOD = 1
*
      RETURN
*====================================================================
*"         << 内部設定格子ヘッダーの参照 >>
*====================================================================
      ENTRY      GUQIAH
     I         ( HAXIS ,
     O           HHEAD , IEOD   )
*
      DO 2100 IA = 1, NAXIS
         IF ( HAXIS .EQ. HAXISA( IA ) ) THEN
            CALL GHCOPY ( HHEADA( 1,IA ), HHEAD )
            IEOD = 0
            RETURN
         END IF
 2100 CONTINUE
*
      IEOD = 1
*
      RETURN
*=======================================================================
*"         << 内部設定格子の設定 >>
*=======================================================================
      ENTRY      GUSIAX
     I         ( HHEAD , AXLOC , AXWGT ,
     I           INUM                   )
*
      IF ( ( INUM .LE. 0 ) .OR. ( INUM .GT. NAXIS ) ) THEN
         HMSG = 'AXIS NUM IS OVER RANGE :'
         NMSG = LENC( HMSG )
         WRITE ( HMSG(NMSG+2:NMSG+4), '(I3)' ) INUM
         CALL MSGDMP( 'W', 'GUSIAX', HMSG )
         RETURN
      ENDIF
*
      CALL GHCGET ( HHEAD , 'ITEM' , HAITM  )
*
      CALL GHPGET ( HHEAD , 'ASTR1', IZSTR  )
      CALL GHPGET ( HHEAD , 'AEND1', IZEND  )
      CALL GUSZCZ ( NW    , IZEND-IZSTR+1   )
*
      HAXISA( INUM ) = HAITM
      CALL GHCOPY ( HHEAD, HHEADA( 1,INUM ) )
      CALL VRSET  ( AXLOC, AXLOCA( 1,INUM ), IZEND-IZSTR+1, 1, 1 )
      CALL VRSET  ( AXWGT, AXWGTA( 1,INUM ), IZEND-IZSTR+1, 1, 1 )
*
      RETURN
*=======================================================================
*"         << 内部設定格子座標の付加設定 >>
*=======================================================================
      ENTRY      GUAIAX
     I         ( HAXIS , AXLOC1, AXWGT1,
     I           IZ                      )
*
      DO 4100 IA = 1, NAXIS
         IF ( HAXIS .EQ. HAXISA( IA ) ) THEN
*
            CALL GHPGET ( HHEADA(1,IA), 'ASTR1', IZSTR  )
            CALL GHPGET ( HHEADA(1,IA), 'AEND1', IZEND  )
            CALL GHPGET ( HHEADA(1,IA), 'MISS' , VMISS  )
            IF ( IZ .EQ. 0 ) THEN
               IZ1 = IZEND + 1
            ELSE
               IZ1 = IZ
            ENDIF
*
            CALL GUSZCZ ( NW    , IZ1-IZSTR+1   )
            AXLOCA( IZ1-IZSTR+1, IA ) = AXLOC1
            AXWGTA( IZ1-IZSTR+1, IA ) = AXWGT1
            IF ( IZ1 .GT. IZEND ) THEN
               CALL GHPSET ( HHEADA( 1,IA ), 'AEND1', IZ1 )
               CALL RSET ( AXLOCA( IZEND-IZSTR+2,IA ),
     I                     IZ1-IZEND-1, 1, VMISS      )
               CALL RSET ( AXWGTA( IZEND-IZSTR+2,IA ),
     I                     IZ1-IZEND-1, 1, VMISS      )
            ENDIF
*
            RETURN
         END IF
 4100 CONTINUE
*
      NHP  = LENC(HAXIS)
      HMSG = 'AXIS '''//HAXIS(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP( 'W', 'GUAIAX', HMSG )
*
      RETURN
*=======================================================================
*"         << 内部設定格子の設定参照 >>
*====================================================================== 
      ENTRY GUQIAN
     O    ( IAMAX )
*
      IAMAX = 0
      DO 5100 IA = NAXIS, 1, -1
         IF ( HAXISA( IA ) .NE. ' ' ) THEN
            IAMAX = IA
            RETURN
         ENDIF
 5100 CONTINUE
*
      RETURN
*=======================================================================
*"         << 内部設定格子の出力 >>
*====================================================================== 
      ENTRY GUWIAX
     I         ( HHEAD )
*
      DO 6100 IA = 1, NAXIS
         CALL GHCGET( HHEAD, 'AITM1', HAITM )
         IF ( HAITM .NE. HAXISA( IA ) ) THEN
            CALL GHCGET( HHEAD, 'AITM2', HAITM )
            IF ( HAITM .NE. HAXISA( IA ) ) THEN
               CALL GHCGET( HHEAD, 'AITM3', HAITM )
               IF ( HAITM .NE. HAXISA( IA ) ) THEN
                  GOTO 6100
               ENDIF
            ENDIF
         ENDIF
         IF ( HAXISA( IA ) .EQ. ' ' ) GOTO 6100
*
         CALL GTPGET( 'WFILE', IFILW )
         CALL GTCGET( 'FAXLOC1', HAXF  )
         NHF   = LENC( HAXF )
         HFILE = HAXF(1:NHF)//HAXISA( IA )
*
         CALL GFWOPN
     M         ( IFILW ,
     I           HFILE   )
         CALL GFWRIT
     O         ( HHEADA(1,IA), AXLOCA(1,IA),
     I           IFILW , 1   , 0             )
         CALL GFCLSE ( IFILW )
*
         CALL GTCGET( 'FAXWGT1', HAXF  )
         NHF   = LENC( HAXF )
         HFILE = HAXF(1:NHF)//HAXISA( IA )
*
         CALL GFWOPN
     M         ( IFILW ,
     I           HFILE   )
         CALL GFWRIT
     O         ( HHEADA(1,IA), AXWGTA(1,IA),
     I           IFILW , 1   , 0             )
         CALL GFCLSE ( IFILW )
*
 6100 CONTINUE
*
      RETURN
      END
************************************************************************
*"         << 内部設定格子座標の付加設定(2) >>
************************************************************************
      SUBROUTINE GUAIAH
     I         ( HHEAD , ID    ,
     I           AXLOC1, AXWGT1,
     I           IZ                      )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      INTEGER    ID                      !" 何次元目の軸か
      REAL       AXLOC1                  !" 位置
      REAL       AXWGT1                  !" 重み
      INTEGER    IZ                      !" 格子番号
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HAXIS *(NCC)            !" 格子識別名称
      CHARACTER  HP    *(NCC)            !" パラメータ名称
*
      IF ( ( ID .LT. 1 ) .OR. ( ID .GT. 3 ) ) THEN
         CALL MSGDMP( 'W', 'GUAIAH', 'IRREGAL ID' )
         RETURN
      ENDIF
*
      HP      = 'AITM'
      WRITE ( HP(5:5), '(I1)' ) ID
      CALL GHCGET ( HHEAD, HP  , HAXIS )
*
      CALL       GUAIAX
     I         ( HAXIS , AXLOC1, AXWGT1,
     I           IZ                      )
*
      RETURN
      END

* PACKAGE GTCRAX   !" 書式つき->gtool3軸ファイル
************************************************************************
      PROGRAM GTCRAX
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
*
      PARAMETER  ( IMISS = -999 )
      PARAMETER  ( IMAXD = 1025 )
      REAL       XP( IMAXD )
      REAL       YP( IMAXD )
      REAL       ZP( IMAXD )
      REAL       XW( IMAXD )
*
      CHARACTER  X    *(NFILN)
      CHARACTER  Y    *(NFILN)
      CHARACTER  Z    *(NFILN)
      DATA       X,Y,Z / 3*' ' /
      CHARACTER  TX   *(NCC)
      CHARACTER  TY   *(NCC)
      CHARACTER  TZ   *(NCC)
      DATA       TX,TY,TZ / 3*' ' /
      LOGICAL    INVX
      LOGICAL    INVY
      LOGICAL    INVZ
      DATA       INVX, INVY, INVZ / 3*.FALSE. /
      REAL       XCYCL
      REAL       YCYCL
      REAL       ZCYCL
      DATA       XCYCL, YCYCL, ZCYCL / 3*0. /
      CHARACTER  HFILE( 1 )        *(NFILN)
      DATA       HFILE / '-' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ X, Y, Z, TX, TY, TZ, INVX, INVY, INVZ,
     &                   XCYCL, YCYCL, ZCYCL, HFILE, HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
*
      IF ( HFILE(1) .EQ. '-' ) THEN
         IFILE = 5
      ELSE
         OPEN ( IFILE, FILE=HFILE(1), 
     &          ACCESS='SEQUENTIAL',FORM='FORMATTED' )
      ENDIF
*
      CALL GTPGET ( 'MISS', VMISS )
      CALL RSET0  ( XP, IMAXD, 1, VMISS )
      CALL RSET0  ( YP, IMAXD, 1, VMISS )
      CALL RSET0  ( ZP, IMAXD, 1, VMISS )
*
      IXSTR = IMISS
      IYSTR = IMISS
      IZSTR = IMISS
      IXEND = IMISS
      IYEND = IMISS
      IZEND = IMISS
      IXDIM = 0
      IYDIM = 0
      IZDIM = 0
*
      II = 0
 2100 CONTINUE
         II = II + 1
*
         CALL RDTXTL
     I            ( IFILE ,
     M              X     , Y     , Z     ,
     M              IXSTR , IYSTR , IZSTR ,
     M              IXEND , IYEND , IZEND ,
     M              IXDIM , IYDIM , IZDIM ,
     M              XP    , YP    , ZP    , IMAXD-1, 
     O              IEOD                             )
*
         IF ( IEOD .EQ. 0 ) THEN
      GOTO 2100            
         ENDIF
*

      IF ( X .NE. ' ' ) THEN
         CALL    WRTAXS
     I         ( X     , TX    , XCYCL  , INVX   , 
     M           IXSTR , IXEND , IXDIM  , XP     , XW     )
      ENDIF
      IF ( Y .NE. ' ' ) THEN
         CALL    WRTAXS
     I         ( Y     , TY    , YCYCL  , INVY   , 
     M           IYSTR , IYEND , IYDIM  , YP     , XW     )
      ENDIF
      IF ( Z .NE. ' ' ) THEN
         CALL    WRTAXS
     I         ( Z     , TZ    , ZCYCL  , INVZ   , 
     M           IZSTR , IZEND , IZDIM  , ZP     , XW     )
      ENDIF
*
      STOP
      END
***********************************************************************
      SUBROUTINE WRTAXS
     I         ( HX    , HTX   , XCYCL  , OINVX  ,
     M           IXSTR , IXEND , IXDIM  , XP     , XW      )
*
      CHARACTER  HX  *(*)
      CHARACTER  HTX *(*)
      REAL       XCYCL
      LOGICAL    OINVX
      INTEGER    IXSTR, IXEND
      REAL       XP ( * )
      REAL       XW ( * )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
*
      PARAMETER  ( IMISS = -999 )
      CHARACTER  HHEAD ( NDC )*(NCC)
      CHARACTER  HTYPE  *(NCC)
      CHARACTER  HTYPW  *(NCC)
      CHARACTER  HFILE  *(NFILN)
      CHARACTER  HAXF   *(NFILN)
*
      IF ( IXSTR .EQ. IMISS ) THEN
         IF ( IXEND .EQ. IMISS ) THEN
            IXSTR = 1
            IXEND = IXDIM
         ELSE
            IXSTR = IXEND-IXDIM+1
         ENDIF
      ELSE IF ( IXEND .EQ. IMISS ) THEN
         IXEND = IXSTR+IXDIM-1
      ENDIF
      IF ( IXEND-IXSTR+1 .NE. IXDIM ) THEN
         CALL MSGDMP('W','GTCRAX','MISMATCH IXDIM' )
      ENDIF
*
      IF ( OINVX ) THEN
         DO 1100 I = 1, IXDIM
            XW(I) = XP(IXDIM+1-I)
 1100    CONTINUE 
         DO 1110 I = 1, IXDIM
            XP(I) = XW(I)
 1110    CONTINUE 
      ENDIF
*
      DO 2100 I = 2, IXDIM-1
         XW(I) = ABS(XP(I+1)-XP(I-1))/2.
 2100 CONTINUE 
*
      IF ( XCYCL .NE. 0. ) THEN
         HTYPE = 'CAXLOC'
         HTYPW = 'CAXWGT'
         IXDIM = IXDIM + 1
         IXEND = IXEND + 1
         XP(IXDIM)   = XP(1)+XCYCL
         XW(1)       = ABS(XP(2)+XCYCL-XP(IXDIM-1))/2.
         XW(IXDIM-1) = ABS(XP(IXDIM)-XP(IXDIM-2))/2.
         XW(IXDIM)   = XW(1)
      ELSE
         HTYPE = 'AXLOC'
         HTYPW = 'AXWGT'
         XW(1)       = ABS(XP(2)-XP(1))/2.
         XW(IXDIM)   = ABS(XP(IXDIM)-XP(IXDIM-1))/2.
      ENDIF
*
      CALL GTPGET ( 'MISS', VMISS )
      CALL GTSIZE ( HHEAD , IMAXD )
      CALL    GHPACA
     O      ( HHEAD   ,
     I        HTYPE   , HX    ,
     I        HTX     , HTX   ,
     I        0       ,
     I        'UR4'   , VMISS ,
     I        VMISS   , VMISS , VMISS , VMISS , 1    )
      CALL    GHPSET( HHEAD, 'ASTR1', IXSTR )
      CALL    GHPSET( HHEAD, 'AEND1', IXEND )
*
      CALL GTPGET( 'WFILE', IFILW )
      CALL GTCGET( 'FAXLOC1', HAXF  )
      NHF   = LENC( HAXF )
      HFILE = HAXF(1:NHF)//HX
*
      CALL GFWOPN
     M      ( IFILW ,
     I        HFILE   )
      CALL GFWRIT
     O      ( HHEAD , XP  ,
     I        IFILW , 1   , 0             )
      CALL GFCLSE ( IFILW )
* 
      CALL GTCGET( 'FAXWGT1', HAXF  )
      NHF   = LENC( HAXF )
      HFILE = HAXF(1:NHF)//HX
      CALL GHCSET( HHEAD,'DSET', HTYPW )
* 
      CALL GFWOPN
     M      ( IFILW ,
     I        HFILE   )
      CALL GFWRIT
     O      ( HHEAD , XW  ,
     I        IFILW , 0   , 0             )
      CALL GFCLSE ( IFILW )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE RDTXTL
     I         ( IFILE ,
     M           HX    , HY    , HZ     ,
     M           IXSTR , IYSTR , IZSTR ,
     M           IXEND , IYEND , IZEND ,
     M           IXDIM , IYDIM , IZDIM ,
     M           XP    , YP    , ZP    , IMAXD , 
     O           IEOD                            )
*
      INTEGER    IFILE
      CHARACTER  HX *(*)
      CHARACTER  HY *(*)
      CHARACTER  HZ *(*)
      REAL       XP ( * ), YP ( * ), ZP ( * )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      PARAMETER (NBUF=255)
      CHARACTER  HBUF*(NBUF), HXX*(NBUF)
      CHARACTER  HP*(NCC), HV*(NCC)
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      LOGICAL    LCHRN
      SAVE
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
  100    CONTINUE 
         READ ( IFILE,'(A)',IOSTAT=IEOS ) HBUF
         IF ( IEOS .NE. 0 ) THEN
            IEOD = 1
            RETURN
         ENDIF
         IF ( HBUF(1:1) .EQ. '#' ) THEN
            GOTO 100
         ENDIF
      ENDIF
*
      IDX = 0
*
 1100 CONTINUE
*
         IL   = LENB(HBUF)
         LENH = LEN(HBUF)
         IF ( .NOT.LCHRN(HBUF(IL+1:IL+1)) ) THEN
*
            IC = INDEX(HBUF,':')
            IF ( IC.GT.IL .AND. IC.LT.LENH ) THEN
               HP  = HBUF(IL+1:IC-1)
               ILX = LENB(HBUF(IC+1:LENH))+IC
               HV  = HBUF(ILX+1:LENH)
               IF      ( HP .EQ. 'AITM1' ) THEN
                  HX = HV
               ELSE IF ( HP .EQ. 'AITM2' ) THEN
                  HY = HV
               ELSE IF ( HP .EQ. 'AITM3' ) THEN
                  HZ = HV
               ELSE IF ( HP .EQ. 'ASTR1' ) THEN
                  CALL CRADJ(HV)
                  IF (HV.NE.' ') READ(HV,'(I16)') IXSTR
               ELSE IF ( HP .EQ. 'ASTR2' ) THEN
                  CALL CRADJ(HV)
                  IF (HV.NE.' ') READ(HV,'(I16)') IYSTR
               ELSE IF ( HP .EQ. 'ASTR3' ) THEN
                  CALL CRADJ(HV)
                  IF (HV.NE.' ') READ(HV,'(I16)') IZSTR
               ELSE IF ( HP .EQ. 'AEND1' ) THEN
                  CALL CRADJ(HV)
                  IF (HV.NE.' ') READ(HV,'(I16)') IXEND
               ELSE IF ( HP .EQ. 'AEND2' ) THEN
                  CALL CRADJ(HV)
                  IF (HV.NE.' ') READ(HV,'(I16)') IYEND
               ELSE IF ( HP .EQ. 'AEND3' ) THEN
                  CALL CRADJ(HV)
                  IF (HV.NE.' ') READ(HV,'(I16)') IZEND
               ENDIF
            ENDIF
*
 1200       CONTINUE 
               READ ( IFILE,'(A)',IOSTAT=IEOS ) HBUF
               IF ( IEOS .NE. 0 ) THEN
                  IEOD = 1
                  RETURN
               ENDIF
               IF ( HBUF(1:1) .EQ. '#' ) THEN
                  GOTO 1200
               ENDIF
*
      GOTO 1100
         ENDIF
*
 2100 CONTINUE
*
         IL   = LENB(HBUF)
         LENH = LEN(HBUF)
         IF ( LCHRN(HBUF(IL+1:IL+1)) ) THEN
            HXX=HBUF(IL+1:LENH)
*
            IF ( HX .EQ. ' ' ) THEN
               IF ( HY .EQ. ' ' ) THEN
                  IF ( IEODZ .NE. 0 ) THEN
                     ZPZ = 1.
                  ELSE
                     READ (HXX,*) ZPZ
                  ENDIF
               ELSE
                  IF ( HZ .EQ. ' ' ) THEN
                     READ (HXX,*) YPZ
                  ELSE
                     READ (HXX,*) YPZ, ZPZ
                  ENDIF
               ENDIF
            ELSE IF ( HY .EQ. ' ' ) THEN
               IF ( HZ .EQ. ' ' ) THEN
                  READ (HXX,*) XPZ
               ELSE
                  READ (HXX,*) XPZ, ZPZ
               ENDIF
            ELSE IF ( HZ .EQ. ' ' ) THEN
               READ (HXX,*) XPZ, YPZ
            ELSE
               READ (HXX,*) XPZ, YPZ, ZPZ
            ENDIF
*
            IF ( HX .NE. ' ' ) THEN
               CALL SETVAL( XPZ, IMAXD, XP, IXDIM )
            ENDIF
            IF ( HY .NE. ' ' ) THEN
               CALL SETVAL( YPZ, IMAXD, YP, IYDIM )
            ENDIF
            IF ( HZ .NE. ' ' ) THEN
               CALL SETVAL( ZPZ, IMAXD, ZP, IZDIM )
            ENDIF
*
 2200       CONTINUE 
               READ ( IFILE,'(A)',END=9000 ) HBUF
               IF ( HBUF(1:1) .EQ. '#' ) THEN
                  GOTO 2200
               ENDIF
*
      GOTO 2100
         ELSE
            IEOD = 0
            RETURN
         ENDIF
*
 9000 CONTINUE
      HBUF  = 'END_OF_FILE' 
      IEOD  = 0
*
      RETURN
      END
****************************************************************
      SUBROUTINE SETVAL
     I         ( X     , IMAXD  ,
     M           XP    , IXDIM    )
*
      REAL       X
      REAL       XP  ( IMAXD )
      INTEGER    IXDIM
*
      IX = INDXRF(XP,IXDIM,1,X)
      IF ( IX .EQ. 0 ) THEN
         IF ( IXDIM .EQ. 0 ) THEN
            IX = 1
         ELSE
            IX = IBLKLE(XP,IXDIM,X)
         ENDIF
         DO 2310 IXX = MIN(IXDIM,IMAXD-1), IX, -1
            XP(IXX+1) = XP(IXX)
 2310    CONTINUE 
         XP(IX) = X
         IF ( IXDIM .GE. IMAXD ) THEN
            CALL MSGDMP('W','SETVAL','TOO LARGE IXDIM' )
         ENDIF
         IXDIM = MIN(IXDIM+1,IMAXD)
      ENDIF
*
      RETURN
      END
********************************************************************
      LOGICAL FUNCTION   LCHRN(C)
      CHARACTER  C
      LOGICAL    LCHRD
*
      LCHRN = LCHRD(C) .OR. (C.EQ.'-') .OR. (C.EQ.'.')
*
      RETURN
      END

*"表題 ファイル書き込み GTOOL3(GFWRIT)
*
*"履歴 90/08/15 沼口  敦
*"     92/06/18 沼口  敦  倍精度対応
*"     97/02/14 竹広真一  GFWRTZ を単/倍精度に分割
*"     99/12/02 竹広真一  メッセージ出力番号を DCL より取得
*
**********************************************************************
*"      <<  GTOOL3標準フォーマットデータ書き込み >>
**********************************************************************
      SUBROUTINE GFWRIT
     I         ( HHEAD , GDATA ,
     I           JFILE , MODE  , NOEND  )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      REAL       GDATA ( * )             !" データ
      INTEGER    JFILE                   !" 装置番号
      INTEGER    MODE                    !" モード(1なら表示ON)
      INTEGER    NOEND                   !" ENDFILEの間隔
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HSIGN *(NCC)
      CHARACTER  HITEM *(NCC)
      CHARACTER  HSIZE *(NCC)
      CHARACTER  HFMT  *(NCC)
      CHARACTER  HDFMT *(NCC)
      CHARACTER  HSIGN0*(NCC)
      DATA       HSIGN0 / 'GTOOL3' /
      INTEGER    ITIME
      INTEGER    ISTR  , IEND  , JSTR  , JEND  , KSTR  , KEND
*
*"         < 1.  NOUT : 出力した回数を記録 >
*
      INTEGER   IUNIT
      INTEGER   NOUT ( 99 )
      INTEGER   NFOU ( 99 )
      LOGICAL   OFIRST
      DATA      OFIRST /.TRUE./
      SAVE      NOUT, NFOU, OFIRST, IUNIT
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         DO 1100 J = 1, 99
            NOUT( J ) = 0
            NFOU( J ) = 1
 1100    CONTINUE
         CALL GTCGET( 'MYSIGN', HSIGN )
         IF ( HSIGN .EQ. HSIGN0 ) THEN
            CALL MSGDMP( 'W', 'GFWRIT',
     &                   'PLEASE SPECIFY YOUR SIGN BY <GTSIGN>.' )
         ENDIF
         CALL GLIGET( 'MSGUNIT', IUNIT )
      ENDIF
*
*"         < 2. ファイル番号チェック >
*
      IF (  ( JFILE.LT.1 ).OR.( JFILE.GT.99 )  ) THEN
        RETURN
      ENDIF
*
*"         < 3. メッセージを書く >
*
      IF ( MODE.EQ.1 )   THEN
         CALL GHCGET ( HHEAD, 'ITEM', HITEM )
         CALL GHPGET ( HHEAD, 'TIME', ITIME )
         WRITE (IUNIT,*) '** WRITE ', HITEM, ' T = ', ITIME
      ENDIF
*
      CALL GUSNOW ( HHEAD, 'MDATE'  )
      CALL GTCGET ( 'MYSIGN', HSIGN )
      CALL GHCSET ( HHEAD, 'MSIGN', HSIGN )
*
*"         < 4. データの大きさ >
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           ISTR  , IEND  , IDIM ,
     O           JSTR  , JEND  , JDIM ,
     O           KSTR  , KEND  , KDIM   )
*
      CALL GHPINQ ( 'SIZE', HFMT  )
      WRITE ( HSIZE, HFMT ) IDIM*JDIM*KDIM
*
*"         < 5. ヘッダー付データ出力 >
*
      WRITE ( JFILE ) ( HHEAD( II ), II=1, NDC-1 ), HSIZE
*
      CALL GHCGET ( HHEAD, 'DFMT', HDFMT )
      IF ( HDFMT .EQ. 'UR8' ) THEN
         CALL GFWRZD            !" 倍精度書き込み
     O        ( GDATA ,
     I          JFILE , IDIM*JDIM*KDIM )
      ELSE
         CALL GFWRZR            !" 単精度書き込み
     O        ( GDATA ,
     I          JFILE , IDIM*JDIM*KDIM )
      ENDIF
*
*"         < 6. ENDFILE 処理 >
*
      NOUT( JFILE ) = NOUT( JFILE ) + 1
*
      IF ( NOEND .GE. 1 ) THEN
*
         IF ( NOUT( JFILE ) .GE. NOEND ) THEN
            ENDFILE JFILE
*
            WRITE (IUNIT,6100) JFILE, NFOU( JFILE )
 6100       FORMAT (' === END OF OUTPUT FILE FT', I2.2, 'F', I3.3 )
            NOUT( JFILE ) = 0
            NFOU( JFILE ) = NFOU( JFILE ) + 1
         ENDIF
*
      ENDIF
*
      RETURN
      END
************************************************************************
*"         << データ書き込み >>
************************************************************************
      SUBROUTINE GFWRZR
     I         ( GDATA ,
     I           JFILE , IJKDIM )
*
      REAL       GDATA ( IJKDIM )              !" データ
      INTEGER    JFILE                         !" ファイル番号
*
      WRITE ( JFILE ) GDATA
*
      RETURN
      END
************************************************************************
      SUBROUTINE GFWRZD
     I         ( GDATA ,
     I           JFILE , IJKDIM )
*
      REAL*8     GDATA ( IJKDIM )              !" データ
      INTEGER    JFILE                         !" ファイル番号
*
      WRITE ( JFILE ) GDATA
*
      RETURN
      END

*"表題 編集記述子の設定数の参照 GTOOL3(GHQENM)
*
*"履歴 90/09/06 沼口  敦
*
*
*********************************************************************
*"         << 編集記述子の設定数の参照 >>
*********************************************************************
      SUBROUTINE GHQENM
     I         ( HHEAD ,
     O           IENUM )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      INTEGER    IENUM                   !" 設定済の編集記述子の数
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HEDIT *(NCC)            !" 編集略記号
      CHARACTER  HP    *8                !" ヘッダーの欄指定
*
      HP = 'EDIT'
      DO 1100 II = 1, NED
         WRITE ( HP(5:5),'(I1)' ) II
         CALL GHCGET( HHEAD , HP  , HEDIT )
         IF ( HEDIT .EQ. ' ' ) THEN
            IENUM = II-1
            RETURN
         ENDIF
 1100 CONTINUE
      IENUM = NED
*
      RETURN
      END

*"表題 第３次元の拡大 GTOOL3(GPZEXT)
*
*"履歴 91/01/19 沼口  敦
*
*
*********************************************************************
*"         << 第３次元の拡大 >>
*********************************************************************
      SUBROUTINE GPZEXT
     I         ( HHEAD , GDATA ,
     I           HAITMZ, IZSTR , IZEND ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HAITMZ      *(*)        !" 拡大する第3次元の軸名
      INTEGER    IZSTR                   !" 第3次元の軸の格子始め
      INTEGER    IZEND                   !" 第3次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
*
*"         < 1. 結合準備 >
*
      CALL GPZCMI
     I         ( HHEAD , HAITMZ, IZSTR , IZEND ,
     I           'NUL' , ' '   ,
     O           HHEADO, GDATAO )
*
*"         < 2. 大きさの取得 >
*
      CALL GUSMIS ( HHEADO )
*
      CALL GUQSIZ
     I         ( HHEADO,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR1, IZEND1, IZDIM  )
*
*"         < 3. データ詰め替え >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
*
      DO 2100 IZ = IZSTR1, IZEND1
         CALL VRSET
     I         ( GDATA                              ,
     O           GDATAO( IXDIM*IYDIM*(IZ-IZSTR1)+1 ),
     I           IXDIM*IYDIM, 1     , 1                )
 2100 CONTINUE
*
*"         < 3. ヘッダー変更 >
*
      IF ( ( IZSTR1 .EQ. 1 ).AND.( IZEND1 .EQ. 1 ) ) RETURN
*
      IF      ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAITMZ, 'ZE'   , '-extend',
     I                 IZSTR1, IZEND1 ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 第３次元の拡大 >>
*********************************************************************
      SUBROUTINE GMZEXT
     I         ( HHEAD , GDATA ,
     I           HAITMZ, IZSTR , IZEND ,
     I           HEDIT , HETTL           )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HAITMZ      *(*)        !" 拡大する第3次元の軸名
      INTEGER    IZSTR                   !" 第3次元の軸の格子始め
      INTEGER    IZEND                   !" 第3次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPZEXT
     I         ( HHEAD , GDATA ,
     I           HAITMZ, IZSTR , IZEND ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 現在の時刻の参照 GTOOL3(GHHGET)
*
*"履歴 90/08/21 沼口  敦
*
*
***********************************************************************
*"         << 現在の日付・時刻 yyyymmddhhmmss >>
*********************************************************************
      SUBROUTINE GUQNOW
     O         ( HTIME )
*
      CHARACTER  HTIME  *(*)             !" 時刻(yyyymmddhhmmss)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HTIMZ  *(NCC)
*
      CALL DATEQ1 ( IDATE )
      CALL TIMEQ1 ( ITIME )
*
      HTIMZ = ' '
      WRITE ( HTIMZ( 1: 8), '(I8)' ) IDATE 
      WRITE ( HTIMZ(10:15), '(I6)' ) ITIME
      HTIME = HTIMZ
*
      RETURN
      END

*"表題 データへのスカラー代入 GTOOL3(GPFCON)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << データへのスカラー代入 >>
*********************************************************************
      SUBROUTINE GPFCON
     I         ( HHEAD , GDATA , VAL   ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      REAL       VAL                     !" スカラー値
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 3. データ代入 >
*
      CALL VRCON
     I     ( GDATA ,
     O       GDATAO,
     I       IXDIM*IYDIM*IZDIM, 1 , 1 , VAL  )
*
*"         < 4. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << データへのスカラー代入 >>
*********************************************************************
      SUBROUTINE GMFCON
     M         ( HHEAD , GDATA ,
     I           VAL   ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      REAL       VAL                     !" スカラー値
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEAD, IXDIM*IYDIM*IZDIM )
*
*"         < 2. データ代入 >
*
      CALL RSET
     O     ( GDATA ,
     I       IXDIM*IYDIM*IZDIM, 1 , VAL  )
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHEADD ( HHEAD, HEDIT, HETTL )
      ENDIF
*
      RETURN
      END

*"表題 現在の時刻を作成時刻等に設定  GTOOL3(GUSNOW)
*
*"履歴 90/09/21 沼口  敦
*
*
*********************************************************************
*"         << 現在の時刻を作成時刻等に設定 >>
*********************************************************************
      SUBROUTINE GUSNOW
     M         ( HHEAD ,
     I           HP     )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー
      CHARACTER  HP          *(*)        !" 記述子名
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HTIME       *(NCC)      !" 時刻(yyyymmddhhmmss)
*
      CALL GUQNOW ( HTIME )
      CALL GHCSET ( HHEAD, HP    , HTIME )
*
      RETURN
      END

*"表題 数を左よせで文字列化 GTOOL3(GULCHR)
*
*"履歴 90/10/15 沼口  敦
*      92/06/23 沼口  敦      REAL -> INTEGER 基本
*
***********************************************************************
*"         << 数を左よせで文字列化 >>
*********************************************************************
      SUBROUTINE GULCHR
     I         ( HFMT  , IVAL  ,
     O           HCHR  , NCHR   )
*
      CHARACTER  HFMT   *(*)             !" フォーマット
*    (INTEGER)   IVAL                    !" 数データ
      CHARACTER  HCHR   *(*)             !" 文字列
      INTEGER    NCHR                    !" 文字列長
*
      IF ( HFMT(2:2) .EQ. 'I' ) THEN
         WRITE ( HCHR, HFMT ) IVAL
      ELSE
         CALL CHVAL ( HFMT, IVAL, HCHR )
      ENDIF
*
      CALL CLADJ ( HCHR )
      NCHR = LENC( HCHR )
*
      RETURN
      END

* PACKAGE  GTIMIS !" ท็ยปรอสไดึ
***********************************************************************
      PROGRAM GTIMIS
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE   / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      REAL       WX
      REAL       WY
      REAL       WZ
      DATA       WX,WY,WZ  / 3* 1.0 /
      CHARACTER  OUT     *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL / 6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   INTERP
*     
      NAMELIST  /OPTION/ WX, WY, WZ, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      CALL  SETWGT ( WX, WY, WZ )
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( MAX(IEOD,IEODP) .EQ.0 ) THEN
            CALL GMCAL1
     I         ( INTERP,
     M           HHEAD , GDATA ,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEAD , 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEAD  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE INTERP
     I         ( HDS   , DS     ,
     O           HDP   , DP    ,
     D           IMAX  , JMAX  , KMAX  )
*
      CHARACTER  HDS ( * )*(*)
      REAL       DS ( * )
      CHARACTER  HDP ( * )*(*)
      REAL       DP ( * )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      PARAMETER  ( IMAXD = 1024 )
      REAL       XS ( IMAXD )
      REAL       YS ( IMAXD )
      REAL       ZS ( IMAXD )
      REAL       XCYCL, YCYCL, ZCYCL
*
      IF ( MAX(IMAX,JMAX,KMAX) .GT. IMAXD ) THEN
         CALL MSGDMP( 'E','INTERP','WORK AREA TOO SMALL' )
      ENDIF
*
      CALL GUSMIS( HDS )
* 
      CALL GUQAXQ
     I            ( HDS   , 1     , 'LOC' ,
     O              XS    , XCYCL , IXDIM , IEOD  , 
     D              IMAXD                 )
*
      CALL GUQAXQ
     I            ( HDS   , 2     , 'LOC' ,
     O              YS    , YCYCL , IYDIM , IEOD  , 
     D              IMAXD                 )
*
      CALL GUQAXQ
     I            ( HDS   , 3     , 'LOC' ,
     O              ZS    , ZCYCL , IZDIM , IEOD  , 
     D              IMAXD                 )
*
      CALL INTR3
     I           ( DS  , XS   , YS   , ZS   ,
     I                   IMAX , JMAX , KMAX ,
     I                   XCYCL, YCYCL, ZCYCL,
     I                   WX   , WY   , WZ   ,
     O             DP                          )
*
      RETURN
*===============================================================
      ENTRY      SETWGT
     I         ( WX1, WY1, WZ1 )
      WX = WX1
      WY = WY1
      WZ = WZ1
      END
****************************************************************
      SUBROUTINE INTR3
     I         ( DS  , XS   , YS   , ZS   ,
     I                 NXS  , NYS  , NZS  ,
     I                 XCYCL, YCYCL, ZCYCL,
     I                 WX   , WY   , WZ   ,
     O           DP                          )
*
      REAL       DS  ( NXS, NYS, NZS )
      REAL       XS  ( NXS )
      REAL       YS  ( NYS )
      REAL       ZS  ( NZS )
      REAL       DP  ( NXS, NYS, NZS )
      EXTERNAL   IMOD
*
      CALL       GLPGET( 'RMISS', VMISS )
      ICOUNT = 0
*
      DO 4100 K = 1, NZS
         DO 4100 J = 1, NYS
            DO 4100 I = 1, NXS
*
               IF ( DS(I,J,K) .EQ. VMISS ) THEN
*
                  S = 0.
                  W = 0.
*
                  IF ( WX .NE. 0. ) THEN
                     IF ( XCYCL .NE. 0. ) THEN
                        IME = I-NXS
                        IPE = I+NXS
                     ELSE
                        IME = 1
                        IPE = NXS
                     ENDIF
                     DO 5100 II = I-1, IME, -1
                        III = IMOD(II-1,NXS)+1
                        IF ( DS(III,J,K) .NE. VMISS ) THEN
                           IF ( II .LE. 0 ) THEN
                              WXM = 1./(XS(I)-XS(III)+XCYCL)**2
                           ELSE
                              WXM = 1./(XS(I)-XS(III))**2
                           ENDIF
                           S = S + WX*WXM*DS(III,J,K)
                           W = W + WX*WXM
                           GOTO 5110
                        ENDIF
 5100                CONTINUE 
 5110                CONTINUE 
                     DO 5200 II = I+1, IPE
                        III = IMOD(II-1,NXS)+1
                        IF ( DS(III,J,K) .NE. VMISS ) THEN
                           IF ( II .GT. NXS ) THEN
                              WXP = 1./(XS(III)-XS(I)+XCYCL)**2
                           ELSE
                              WXP = 1./(XS(III)-XS(I))**2
                           ENDIF
                           S = S + WX*WXP*DS(III,J,K)
                           W = W + WX*WXP
                           GOTO 5210
                        ENDIF
 5200                CONTINUE 
 5210                CONTINUE 
                  ENDIF
*
                  IF ( WY .NE. 0. ) THEN
                     IF ( YCYCL .NE. 0. ) THEN
                        JME = J-NYS
                        JPE = J+NYS
                     ELSE
                        JME = 1
                        JPE = NYS
                     ENDIF
                     DO 6100 JJ = J-1, JME, -1
                        JJJ = IMOD(JJ-1,NYS)+1
                        IF ( DS(I,JJJ,K) .NE. VMISS ) THEN
                           IF ( JJ .LE. 0 ) THEN
                              WYM = 1./(YS(J)-YS(JJJ)+YCYCL)**2
                           ELSE
                              WYM = 1./(YS(J)-YS(JJJ))**2
                           ENDIF
                           S = S + WY*WYM*DS(I,JJJ,K)
                           W = W + WY*WYM
                           GOTO 6110
                        ENDIF
 6100                CONTINUE 
 6110                CONTINUE 
                     DO 6200 JJ = J+1, JPE
                        JJJ = IMOD(JJ-1,NYS)+1
                        IF ( DS(I,JJJ,K) .NE. VMISS ) THEN
                           IF ( JJ .GT. NYS ) THEN
                              WYP = 1./(YS(JJJ)-YS(J)+YCYCL)**2
                           ELSE
                              WYP = 1./(YS(JJJ)-YS(J))**2
                           ENDIF
                           S = S + WY*WYP*DS(I,JJJ,K)
                           W = W + WY*WYP
                           GOTO 6210
                        ENDIF
 6200                CONTINUE 
 6210                CONTINUE 
                  ENDIF
*
                  IF ( WZ .NE. 0. ) THEN
                     IF ( ZCYCL .NE. 0. ) THEN
                        KME = K-NZS
                        KPE = K+NZS
                     ELSE
                        KME = 1
                        KPE = NZS
                     ENDIF
                     DO 7100 KK = K-1, KME, -1
                        KKK = IMOD(KK-1,NZS)+1
                        IF ( DS(I,J,KKK) .NE. VMISS ) THEN
                           IF ( KK .LE. 0 ) THEN
                              WZM = 1./(ZS(K)-ZS(KKK)+ZCYCL)**2
                           ELSE
                              WZM = 1./(ZS(K)-ZS(KKK))**2
                           ENDIF
                           S = S + WZ*WZM*DS(I,J,KKK)
                           W = W + WZ*WZM
                           GOTO 7110
                        ENDIF
 7100                CONTINUE 
 7110                CONTINUE 
                     DO 7200 KK = K+1, KPE
                        KKK = IMOD(KK-1,NZS)+1
                        IF ( DS(I,J,KKK) .NE. VMISS ) THEN
                           IF ( KK .GT. NZS ) THEN
                              WZP = 1./(ZS(KKK)-ZS(K)+ZCYCL)**2
                           ELSE
                              WZP = 1./(ZS(KKK)-ZS(K))**2
                           ENDIF
                           S = S + WZ*WZP*DS(I,J,KKK)
                           W = W + WZ*WZP
                           GOTO 7210
                        ENDIF
 7200                CONTINUE 
 7210                CONTINUE 
                  ENDIF
*
                  IF ( W .GT. 0. ) THEN
                     DP(I,J,K) = S/W
                  ELSE
                     DP(I,J,K) = VMISS
                     ICOUNT = ICOUNT + 1
                  ENDIF
*
               ELSE
                  DP(I,J,K) = DS(I,J,K)
               ENDIF
*
 4100 CONTINUE 
*
      IF ( ICOUNT .NE. 0 ) THEN
         CALL MSGDMP( 'W','GTIMIS','STILL MISSING VALUE' )
         WRITE (6,*) ICOUNT
      ENDIF
*
      RETURN
      END

*"表題 ヘッダー記述子入力 GTOOL3(GHCSQ2)
*
*"履歴 91/01/25 沼口  敦
*"     99/12/02 竹広真一  メッセージ出力番号を DCL より取得
*
**********************************************************************
*"         << 記述子を書き出しコンソール入力 >>
**********************************************************************
      SUBROUTINE GHCSQ2
     I         ( HH1   , HH2   , HP    , IC    ,
     M           HHO                            )
*
      CHARACTER  HH1  ( * )*(*)
      CHARACTER  HH2  ( * )*(*)
      CHARACTER  HHO  ( * )*(*)
      CHARACTER  HP        *(*)
      INTEGER    IC                      !" 記憶番号
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      PARAMETER  (NCON=10)               !" 記憶の数
      CHARACTER  HH1S ( NDC,NCON )*(NCC)
      CHARACTER  HH2S ( NDC,NCON )*(NCC)
      CHARACTER  HHOS ( NDC,NCON )*(NCC)
      CHARACTER  HHCS ( NDC,NCON )*(NCC)
      CHARACTER  HX1         *(NCC*2)
      CHARACTER  HX2         *(NCC*2)
      CHARACTER  HXO         *(NCC*2)
      CHARACTER  HX1S        *(NCC*2)
      CHARACTER  HX2S        *(NCC*2)
      CHARACTER  HC          *(NCC*2)
*
      INTEGER    IUNIT
      LOGICAL    OFIRST
      DATA       OFIRST /.TRUE./
      SAVE
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         DO 100 ICC = 1, NCON
            CALL GHPCLR ( HH1S( 1,ICC ) )
            CALL GHPCLR ( HH2S( 1,ICC ) )
            CALL GHPCLR ( HHOS( 1,ICC ) )
            CALL GHPCLR ( HHCS( 1,ICC ) )
            DO 110 IP = 2, NDC
               HHCS( IP,ICC ) = ' '
  110       CONTINUE
  100    CONTINUE
         CALL GLIGET( 'MSGUNIT', IUNIT )
      ENDIF
*
      CALL GHCGTS( HH1 , HP , HX1  )
      CALL GHCGTS( HH2 , HP , HX2  )
*
      ICCC = 0
      ICCE = 1
      DO 1100 ICC = 1, NCON
         CALL GHCGTS( HH1S( 1,ICC ), HP, HX1S )
         CALL GHCGTS( HH2S( 1,ICC ), HP, HX2S )
         CALL GHCGTS( HHCS( 1,ICC ), HP, HC   )
         IF ( HC .NE. ' ' ) THEN
            READ ( HC, '(I5)' ) ICS
         ELSE
            ICS = 0
         ENDIF
         IF ( ICS .NE. 0 ) THEN
            ICCE = ICC+1
         ENDIF
         IF ( ( HX1S .EQ. HX1 ).AND.( HX2S .EQ. HX2 )
     &                         .AND.( ICS  .EQ. IC ) ) THEN
            ICCC = ICC
         ENDIF
 1100 CONTINUE
*
      IF ( ICCC .NE. 0 ) THEN
         CALL GHCGTS( HHOS(1,ICCC), HP , HXO  )
*
      ELSE
*
         WRITE ( IUNIT, * ) HP, ':IN1 = ', HX1
         WRITE ( IUNIT, * ) HP, ':IN2 = ', HX2
         WRITE ( IUNIT, * ) ' OUT = ?'
         READ  ( 5, '(A)') HXO
*
         IF      ( HXO .EQ. '#1' ) THEN
            WRITE ( IUNIT,* ) ' default 1 assumed.'
            HXO = HX1
         ELSE IF ( HXO .EQ. '#2' ) THEN
            WRITE ( IUNIT,* ) ' default 2 assumed.'
            HXO = HX2
         ENDIF
*
         IF ( IC .NE. 0 ) THEN
            CALL GHCSTS( HH1S(1,ICCE), HP , HX1 )
            CALL GHCSTS( HH2S(1,ICCE), HP , HX2 )
            CALL GHCSTS( HHOS(1,ICCE), HP , HXO )
            WRITE ( HC, '(I5)' ) IC
            CALL GHCSTS( HHCS(1,ICCE), HP , HC  )
         ENDIF
      ENDIF
*
      CALL GHCSTS ( HHO , HP, HXO )
*
      RETURN
      END

*"表題 レイアウト GTOOL3(GGLAY2)
*
*"履歴 90/08/21 沼口  敦
*"履歴 95/05/29 竹広真一 for dcl-5.0
*"     97/12/01 竹広真一 SET -> STX
*
*********************************************************************
*"         << レイアウト, 題名表示 >>
*********************************************************************
      SUBROUTINE GGLAY2
     I         ( HHEAD )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#endif
      CHARACTER  HTITL   *(NCC*2)
      CHARACTER  HDSET   *(NCC)
      CHARACTER  HUNIT   *(NCC)
      CHARACTER  HITEM   *(NCC)
      CHARACTER  HUTIM   *4
      CHARACTER  HTIME   *(NCC)
      CHARACTER  HEDIT( NED )*(NCC)
      INTEGER    NHE  ( NED )
      CHARACTER  HFNUM   *(NCC)
      CHARACTER  HDNUM   *(NCC)
      CHARACTER  HAITM   *(NCC)
      CHARACTER  HS      *(NCC)
      CHARACTER  HE      *(NCC)
      CHARACTER  HRAN    *(NCC)
      CHARACTER  HEDS    *(100)
      CHARACTER  HP      *8
      DATA       NDESC / 24 /
      DATA       STITL  / 0.022 /
      DATA       SAXSL  / 0.02 / 
      DATA       SAXST  / 0.02 / 
      DATA       SREMK  / 0.01 / 
      DATA       SCONL  / 0.01 / 
*
*"         < 1. 初期化 >
*
      CALL GRFRM
      CALL GGAXRS
      CALL GGLTRS
*
      CALL GGPSET ( 'STITL'  , STITL  )
      CALL GGPSET ( 'SAXSL'  , SAXSL  )
      CALL GGPSET ( 'SAXST'  , SAXST  )
      CALL GGPSET ( 'SREMK'  , SREMK  )
      CALL GGPSET ( 'SCONL'  , SCONL  )
*
      CALL UZPGET( 'RSIZET2', RSIZT2 )
      CALL UZPGET( 'ROFFXT' , ROFFXT )
      IF ( ROFFXT .LT. RSIZT2 ) CALL UZPSTX( 'ROFFXT', RSIZT2 )
*
*"         < 2. ビューポート(仮座標)設定 >
*
      CALL GGPGET ( 'VRATIO' , VRATIO )
      CALL GGPGET ( 'VXMIN'  , VXMIN  )
      CALL GGPGET ( 'VXMAX'  , VXMAX  )
      CALL GGPGET ( 'VYMIN'  , VYMIN  )
      CALL GGPGET ( 'VYMAX'  , VYMAX  )
*
      CALL SGSVPT ( VXMIN, VXMAX , VYMIN , VYMAX )
      CALL SGSWND ( 0.   , 1.    , 0.    , 1.  )
      CALL SGSTRN (1)
      CALL SGSTRF
*
*"         < 3. 編集タイトル >
*
      CALL SGPSTX ( 'IFONT', 2 )
*
      CALL GHCGTS ( HHEAD, 'TITL',  HTITL  )
      CALL GGPGET ( 'STITL'  , STITL )
      CALL UZPSTX ( 'RSIZEC2', STITL )
*
      CALL UXMTTL ( 'T', HTITL , -1. )
*
      CALL UZPSTX ( 'ROFFXT' , 0. )

      RETURN
      END

* PACKAGE     !" 等値線図, トーン                      A.Numaguti
*"                              for dcl-5.0 : 95/05/26 S.Takehiro
*"                         clipping changes : 96/06/21 S.Takehiro
******************************************************************
      PROGRAM GTCONT
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
*
      PARAMETER  ( NTMX=20 )
      DATA       IFILE / 50 /
      CHARACTER  HFILE( 1 )  *(NFILN)
      DATA       HFILE / 'gtool.out' /
*
      REAL      XMIN, XMAX, YMIN, YMAX         !" 地図投影の描画位置
        DATA   XMIN, XMAX  / 0.2,  0.8 /
        DATA   YMIN, YMAX  / 0.10, 0.55 /
      REAL      TXLOC, TYLOC, TXWDH, TYWDH     !" トーンスケール位置, 幅
        DATA   TXLOC, TYLOC  / 0.05, 0.05  /
        DATA   TXWDH, TYWDH  / 0.25, 0.025 /
*
      REAL      ALAT, ALON                     !" 投影中心緯度経度
*
*" [オプション]
*
      INTEGER    PRJ                       !" 投影法
        DATA       PRJ / 0 /
      REAL       POSI(2), ROTA , MAG       !" 投影中心経度緯度,回転,拡大率
        DATA       POSI, ROTA, MAG/ 180.,0., 0., 1./
      INTEGER    X, Y, Z
        DATA       X, Y, Z / 3*-1 /
      REAL       CONT  ( 2 )
        DATA       CONT  / -999.,-999. /
      INTEGER    CCYCLE
        DATA       CCYCLE / 5 /
      REAL       RANGE ( 2 )
        DATA       RANGE / -999.,-999. /
      INTEGER    CIDX ( 2 )
        DATA       CIDX  / 1, 3 /
      LOGICAL    CLABEL
        DATA       CLABEL / .TRUE. /
      REAL       TONE ( NTMX+1 )
        DATA       TONE / -999.,NTMX*-999. /
      INTEGER    PAT  ( NTMX )
        DATA       PAT  / NTMX*-1 /
      INTEGER    MAP , MAPIDX
        DATA       MAP , MAPIDX / 0, 1 /
      CHARACTER  MFILE * (NFILN)
        DATA     MFILE  /'coast_world'/
      INTEGER    WSN
        DATA       WSN / 0 /
      LOGICAL    MONO, PRINT
        DATA       MONO, PRINT / 2*.FALSE. /
      INTEGER    LAY
        DATA       LAY / 1 /
      INTEGER    STR, END, STEP
        DATA       STR, END, STEP / 1, 999999, 1 /
      LOGICAL    EXCH
        DATA       EXCH  /.FALSE./
      INTEGER    COLOR
        DATA       COLOR / 0 /
      INTEGER    CPAT ( 2 )
        DATA       CPAT / 18999, -99999 /
      LOGICAL    NOCONT
        DATA       NOCONT /.FALSE./
      LOGICAL    SOFTF
        DATA       SOFTF /.FALSE./
      INTEGER    TLNUM
        DATA       TLNUM / 6 /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
        DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
        DATA       GRESET / .FALSE. /
      LOGICAL    HELP
        DATA       HELP   / .FALSE. /
*
      NAMELIST /OPTION/  PRJ, POSI, ROTA, MAG, 
     &                   X, Y, Z,
     &                   CONT, CCYCLE, RANGE, CIDX, CLABEL, 
     &                   TONE, PAT, MAP, MAPIDX, MFILE, 
     &                   LAY, WSN, MONO, PRINT,
     &                   STR, END, STEP, EXCH, TLNUM, NOCONT, SOFTF,
     &                   COLOR, CPAT,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
*" < 1. コマンドライン解析 >
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      IF ( WSN .LE. 0 ) THEN
         IF ( PRINT ) THEN
            WSN = 2
         ELSE
            WSN = 1
         ENDIF
      ENDIF
*
      CALL GGOPEN ( WSN )
*
*" 描画位置設定
*
      CALL GGPSET( 'TXSLOC', TXLOC )
      CALL GGPSET( 'TYSLOC', TYLOC )
      CALL GGPSET( 'TXSWDH', TXWDH )
      CALL GGPSET( 'TYSWDH', TYWDH )
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
*
      DO 80 ITN = 1, NTMX
         IF ( PAT(ITN) .LT. 0 ) THEN
            NTON = ITN-1
            GOTO 90
         ENDIF
 80   CONTINUE
      NTON = NTMX
 90   CONTINUE
*
      IF ( X.LT.0 .AND. Y.LT.0 .AND. Z.LT.0 ) Z = 0
      IF ( STEP .LE. 1 ) STEP = 1
* 
      IF ( COLOR .GT.1 ) THEN
         CALL GGPSET ( 'NTONE',   COLOR   )
         IF ( CPAT(1) .GT. 0 ) THEN
            CALL GGPSET ( 'TONEPAT', CPAT(1) )
         ENDIF
         IF ( CPAT(2) .GT. 0 ) THEN
            CALL GGPSET ( 'TONEINC', CPAT(2) )
         ELSE IF ( CPAT(2) .LT. 0 ) THEN
            CALL GGPGET ( 'TONEPAT', IPAT1 )
            IF ( -CPAT(2) .GT. 1000 ) THEN
               IPINC = INT((-CPAT(2)-IPAT1)/COLOR/1000) * 1000
            ELSE
               IPINC = INT((-CPAT(2)-IPAT1)/COLOR)
            ENDIF
            CALL GGPSET ( 'TONEINC', IPINC )
         ENDIF
      ENDIF
*
      ALON = POSI(1)               !" 地図投影中心位置
      ALAT = POSI(2)
*
*
*"  < 2. データ読み込み, 加工 >
*
      II = 0
 1100 CONTINUE
         CALL GFREAD
     O            ( HHEAD , GDATA , IEOD  ,
     I              IFILE , 1               )
*
         IF ( IEOD .EQ. 0 ) THEN
*
            II = II + 1
            IF ( ( II.GE.STR ).AND.( II.LE.END ).AND.
     &           ( MOD( II-STR,STEP ).EQ.0 )          ) THEN         
*
               IF      ( X .EQ. 0 ) THEN
                  CALL GMXAVG
     I            ( HHEAD , GDATA ,
     I              'XM'  , 'zonal mean'  )
               ELSE IF ( X .GT. 0 ) THEN
                  CALL GMXSEL
     I            ( HHEAD , GDATA , X   ,
     I              '  '  , ' '           )
               ELSE IF ( Y .EQ. 0 ) THEN
                  CALL GMYAVG
     I            ( HHEAD , GDATA ,
     I              'YM'  , 'merid mean'  )
               ELSE IF ( Y .GT. 0 ) THEN
                  CALL GMYSEL
     I            ( HHEAD , GDATA , Y   ,
     I              '  '  , '  '          )
               ELSE IF ( Z .EQ. 0 ) THEN
                  CALL GMZAVG
     I            ( HHEAD , GDATA ,
     I              'ZM'  , 'vert mean'   )
               ELSE IF ( Z .GT. 0 ) THEN
                  CALL GMZSEL
     I            ( HHEAD , GDATA , Z  ,
     I              ' '   , ' '           )
               ENDIF
*
               CALL GMXCYC
     I            ( HHEAD , GDATA )
*
               IF ( EXCH ) THEN
                  CALL GMEYXZ
     I            ( HHEAD , GDATA ,
     I              '  ' , '  '  )
               ENDIF
*
               IF ( ITEM .NE. ' ' ) THEN
                  CALL GHCSET( HHEAD , 'ITEM', ITEM )
               ENDIF
               IF ( UNIT .NE. ' ' ) THEN
                  CALL GHCSET( HHEAD , 'UNIT', UNIT )
               ENDIF
               IF ( TITLE .NE. ' ' ) THEN
                  CALL GHCSTS( HHEAD , 'TITL', TITLE )
               ENDIF
               IF ( DSET .NE. ' ' ) THEN
                  CALL GHCSET( HHEAD , 'DSET', DSET )
               ENDIF
               IF ( GRESET ) THEN
                  CALL GHRSGP( HHEAD  )
               ENDIF
*
               CALL GGPSET( 'ICYCLE', CCYCLE )
               IF ( CONT(1) .GT. 0. ) THEN
                  CALL GHPSET( HHEAD, 'DIVS', CONT(1) )
               ENDIF
               IF ( CONT(2) .GT. 0. ) THEN
                  CALL GHPSET( HHEAD, 'DIVL', CONT(2) )
               ENDIF
               IF ( RANGE(1) .NE. -999. ) THEN
                  CALL GHPSET( HHEAD, 'DMIN', RANGE(1) )
               ENDIF
               IF ( RANGE(2) .NE. -999. ) THEN
                  CALL GHPSET( HHEAD, 'DMAX', RANGE(2) )
               ENDIF
*
*"  < 3. 表題 >
*
               IF(     (PRJ .GE.  5 .AND. PRJ .LE.  7) 
     &             .OR.(PRJ .GE. 10 .AND. PRJ .LE. 13) 
     &             .OR.(PRJ .GE. 20 .AND. PRJ .LE. 23)
     &             .OR.(PRJ .GE. 30 .AND. PRJ .LE. 33) )THEN
                   CALL GGPSET( 'VXMIN', XMIN )
                   CALL GGPSET( 'VXMAX', XMAX )
                   CALL GGPSET( 'VYMIN', YMIN )
                   CALL GGPSET( 'VYMAX', YMAX )
               ENDIF
*
               IF      ( LAY .EQ. 2 ) THEN
                  CALL GGLAY2  ( HHEAD )
               ELSE IF ( LAY .EQ. 3 ) THEN
                  CALL GGLAY3  ( HHEAD )
               ELSE
                  CALL GGLAY1  ( HHEAD )
               ENDIF
*
*"  < 4. 地図投影 >
*
               CALL GGPSET( 'MAPPRJ', PRJ  )
               CALL GGPSET( 'MAPLAT', ALAT )
               CALL GGPSET( 'MAPLON', ALON )
               CALL GGPSET( 'MAPROT', ROTA )
               CALL GGPSET( 'MAPFAC', MAG )
*
               CALL GGAXES  ( HHEAD )
*
*"  < 5. トーン >
*
               IF ( SOFTF ) THEN
                  CALL  SGPSET( 'LSOFTF', .TRUE. )
               ENDIF
               IF ( TLNUM .GE. 0 ) THEN
                  CALL GGPSET  ( 'TLNUM', TLNUM )
               ENDIF
               IF ( COLOR .GT.1 ) THEN
                  CALL GGSTON ( HHEAD, GDATA )
               ENDIF
               IF ( COLOR .GT. 1 .OR. NTON .GE. 1 ) THEN
                  CALL GGTONE  ( HHEAD , GDATA ,
     I                           TONE  , PAT   , NTON  )
               ENDIF
*
*"  < 6. コンター > 
*
               CALL UDPSET  ( 'LABEL',  CLABEL )
               CALL UDPSET  ( 'INDXMJ', CIDX(2) )
               CALL UDPSET  ( 'INDXMN', CIDX(1) )
*
               CALL SGPSET( 'LCLIP', .TRUE. )
               IF ( .NOT. NOCONT .AND. (CIDX(1) .GT. 0) ) THEN
                  CALL GGCNTR  ( HHEAD , GDATA )
               ENDIF
*
*"  < 7. 地図, 緯度経度線 > 
*
               IF ( MAP .GE.1  ) THEN
                  CALL GGMAPS( MFILE )
               ENDIF
               IF(     (PRJ .GE. 10 .AND. PRJ .LE. 13) 
     &             .OR.(PRJ .GE. 20 .AND. PRJ .LE. 23)
     &             .OR.(PRJ .GE. 30 .AND. PRJ .LE. 33) )THEN
                  CALL UMPGRD
               ENDIF
               CALL SGPSET( 'LCLIP', .FALSE. )
*
            ENDIF
      GOTO 1100
         ENDIF
*
      CALL GFCLSE ( IFILE )
*
      CALL GGCLSE
*
      STOP
      END

* PACKAGE  GTTHET  !" ²¹°Ì<->²¹ÅÙ
***********************************************************************
      PROGRAM GTTHET
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
      CHARACTER  HHEADP( NDC )*(NCC)
      REAL       GDATAP( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE   / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       IFILEP / 51 /
      DATA       JFILE / 60 /
*
      CHARACTER  PS     *(NFILN)
      DATA       PS     / 'Ps' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      LOGICAL    INV    
      DATA       INV   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM   / 'THETA' /
      DATA       UNIT   / 'K' /
      DATA       TITLE  / 'potentital temp.' /
      DATA       DSET, EDIT, ETTL /3*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   T2THET
*     
      NAMELIST  /OPTION/ PS, OUT, APND, INV ,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      IF ( INV ) THEN
         IF ( ITEM  .EQ. 'THETA'            ) ITEM = 'T'
         IF ( TITLE .EQ. 'potentital temp.' ) TITLE = 'temprerature'
         CALL STH2T
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GTSIZE ( HHEADP, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( PS        , OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFROPN ( IFILEP, PS    )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
         CALL   GFREAD
     O        ( HHEADP, GDATAP, IEODP ,
     I          IFILEP, 1               )
*
         IF ( MAX(IEOD,IEODP) .EQ.0 ) THEN
            CALL GMCAL2
     I         ( T2THET,
     M           HHEAD , GDATA ,
     I           HHEADP, GDATAP,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEAD , 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEAD  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE T2THET
     I         ( HT    , T     ,
     I           HPS   , PS    ,
     O           HTH   , TH    ,
     D           IDIM  , JDIM  , KDIM ,
     D           IDIM2 , JDIM2 , KDIM2 )
*
      CHARACTER  HT ( * )*(*)
      REAL       T  ( IDIM, JDIM, KDIM )
      CHARACTER  HPS ( * )*(*)
      REAL       PS ( IDIM2, JDIM2 )
      CHARACTER  HTH ( * )*(*)
      REAL       TH ( IDIM, JDIM, KDIM )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      CHARACTER  HHEADA ( NDC )*(NCC)
      PARAMETER  ( KDIMD = 100 )
      REAL       SIG ( KDIMD )
*
      DATA       P00  / 1000. /
      DATA       RAIR / 287.04 /
      DATA       CP   / 1004.6 /
*
      LOGICAL    OINV
      DATA       OINV / .FALSE. /
*
      IF ( KDIM .GT. KDIMD ) THEN
         CALL MSGDMP( 'E','T2THET','WORK AREA TOO SMALL' )
      ENDIF
*
      AKAPPA = RAIR / CP
* 
      CALL GTSIZE ( HHEADA  ,  KDIMD   )
      CALL GUQAXV
     I         ( HT    , 3     , 'LOC',
     O           HHEADA, SIG   , IEOD  )
*
      IF ( .NOT.OINV ) THEN
         DO 1100 K = 1, KDIM
            DO 1100 J = 1, JDIM
               DO 1100 I = 1, IDIM
                  TH ( I,J,K ) = T ( I,J,K ) 
     &                         / ( PS( I,J )*SIG( K )/ P00 )** AKAPPA
 1100    CONTINUE
      ELSE
         DO 1200 K = 1, KDIM
            DO 1200 J = 1, JDIM
               DO 1200 I = 1, IDIM
                  T  ( I,J,K ) = TH ( I,J,K ) 
     &                         * ( PS( I,J )*SIG( K )/ P00 )** AKAPPA
 1200    CONTINUE
      ENDIF
*
      RETURN
*=================================================================
      ENTRY STH2T
*
      OINV = .TRUE.
*
      RETURN
      END

*" PACKAGE GTSTSPCT 時空間フーリエフィルター
*" FFT の都合で時系列の長さは 2,3,5 で割りきれる偶数でなければならない。
*" [HIS] 95/12/14 堀之内武  (gtspspct を利用)
***********************************************************************
      PROGRAM GTSTSP
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
*
*" [PARAM] 必要な領域は約 (2*NDIM4+3*IJKDIM)*4 バイト. 確保可能か注意
      PARAMETER (NDIM4 = 30E5)   !" 読み込む全データ数の最大値
      PARAMETER (IJKDIM= 15E4)   !" 1レコードのデータ数の最大値
**      PARAMETER (NDIM4 = 7536700 )   !" 読み込む全データ数の最大値
**      PARAMETER (IJKDIM= 94300  )   !" 1レコードのデータ数の最大値
      PARAMETER (NTMAX = 1E4)    !" 時系列の個数の最大値
*
      REAL       GDAT4( NDIM4 )
      CHARACTER  HHEAD( NDC )*(NCC)
      INTEGER    ITIME(NTMAX)
      CHARACTER  HDATE(NTMAX)  *(NCC)
      INTEGER    IDNUM(NTMAX)
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      CHARACTER  OUT( 1 )    *(NFILN)
      DATA       OUT / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
*
      LOGICAL    EWD  !" T/F: pass only eastward/westward components
      DATA       EWD/.TRUE./
      INTEGER    MMIN,MMAX !"pass wavemumber M s.t. (0<) MIN<=M<=MAX
      DATA       MMIN,MMAX /1,-999/ !" negative MAX doesn't allow high cut
      INTEGER    FMIN,FMAX !"pass freq F(ineger) s.t. (0<) FMIN<=F<=FMAX
      DATA       FMIN,FMAX /1,-999/ !" negative MAX doesn't allow high cut
*
      INTEGER    M4(4),F4(4) !" 波数振動数の範囲を4辺形で設定する.
*"               (M4(i),F4(i)),i=1,..,4 は反時計回りになっていることを
*"               仮定する. すべての値に負でない値を与えたときのみ有効.
*"               MMIN,MMAX,FMIN,FMAXは有効のまま(だから最大で8角形切断).
      DATA       M4,F4/ 4*-999,4*-999/
*
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET /4*' '/
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       EDIT   / ' ' /
      DATA       ETTL   / ' ' /
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
      INTEGER    SDIM       !" Fourier変換される空間次元は何次元目か
      DATA       SDIM   / 1 /
**      LOGICAL    RSTRD  !"  T -> 空間フーリエの前にリニアトレンドを引く
**      DATA       RSTRD  / .FALSE. /
**      LOGICAL    RTTRD  !"  T -> 時間フーリエの前にリニアトレンドを引く
**      DATA       RTTRD  / .FALSE. /
*
      NAMELIST  /OPTION/ HFILE, OUT, APND,  SDIM, EWD, MMIN, MMAX,
     &                   FMIN, FMAX, M4,  F4,
     &                   GRESET, ITEM, UNIT,  TITLE, DSET, EDIT, ETTL,
     &                   HELP
**     &                   ,RSTRD, RTTRD
*
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      CHARACTER  HHEADS( NDC )*(NCC)
*
      CHARACTER  EDITP  *(NCC)
      CHARACTER  ETTLP  *(NCC)
      DATA       EDITP  / 'STPH' /
      DATA       ETTLP  / 's-t phase' /
*
      CHARACTER  AITMF  *(NCC)  !" 時間軸ファイル名
      DATA       AITMF  / '@FREQ' /  !" その頭の部分
      CHARACTER  AITMS  *(NCC)  !" 空間軸ファイル名
      DATA       AITMS  / '@WVNWE' /  !" その頭の部分
      LOGICAL    LFIRST
      DATA       LFIRST  /.TRUE./
      LOGICAL    LINIT
      DATA       LINIT  /.TRUE./
      CHARACTER  HAITM1*(NCC),HAITM2*(NCC),HAITM3*(NCC)
      INTEGER    IXDIM,IYDIM,IZDIM,IWDIM !" ４次元データの各要素数
      INTEGER    IRDIM,ITDIM     !" 変換に使われる空間、時間の要素数
      INTEGER    IQDIM,ISDIM !" 時系列は(IQ,IR,IS,IT)DIM の４次元として扱われる
*
*  [WORK]
      REAL       WX(IJKDIM),WT(IJKDIM)      !" work(consts) for FFT
      REAL       WY(NDIM4)                  !" work for FFT
      REAL       SP(NDIM4/2),PH(NDIM4/2)    !" power spectrum, phase
      EQUIVALENCE (WY(1),SP)
      EQUIVALENCE (WY(NDIM4/2+1),PH)
*
      INTEGER    IWT(5),IWX(5)
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( HELP ) THEN
         WRITE(6,OPTION)
         WRITE(6,*) 'Filter for Eastward or Westward moving component'
         WRITE(6,*) '  on the basis of space-time Fourier transf.'
         WRITE(6,*) 'Input data has to be a time sequence.'
         WRITE(6,*) 'Options:'
         WRITE(6,*) ' sdim: assume sdim-th axis to be the "space" axis'
         WRITE(6,*) ' ewd: T/F pass eastward/westward moving component'
         WRITE(6,*) ' mmax,mmin: select wavenumber M s.t. min<=M<=max'
         WRITE(6,*) 
     +          ' fmax,fmin: select freq F(integer) s.t. fmin<=F<=fmax'
         WRITE(6,*) 'If all of M4(4),F4(4) are .le. 0,'
         WRITE(6,*) '  select (M,F)s within a quadrilateral ',
     +              '(M4(i),F4(i)),i=1,..,4 (assume anti-clockwise)'
         WRITE(6,*) 
         STOP
      ELSE IF ( IOS.NE.0 ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
*
      CALL GURNTF ( HFILE( 1 ), OUT(1)  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFOOPN ( JFILE ,  OUT(1) , APND )
      CALL GUNENV( OUT(1),'.',.FALSE. )
      IL=LENC(OUT(1))
      WRITE (6,*) 'output='//OUT(1)(1:IL)
*
*  < read data >
*
      IANUM = 0
      NGDAT=0
 1100 CONTINUE
        IF ( (IANUM+1)*NGDAT .GT. NDIM4 )
     &         CALL MSGDMP('E',' MAIN ','"NDIM4" INSUFFICIENT')
        CALL   GFREAD
     O        ( HHEAD , GDAT4(1+IANUM*NGDAT) , IEOD  ,
     I          IFILE , 1               )
*
        IF ( IEOD .EQ.0 ) THEN
          IANUM = IANUM + 1
          IF (LFIRST) THEN
            LFIRST = .FALSE.
            CALL   GHCOPY( HHEAD,HHEADS)
            CALL GHCGET( HHEAD, 'AITM1', HAITM1 )
            CALL GHCGET( HHEAD, 'AITM2', HAITM2 )
            CALL GHCGET( HHEAD, 'AITM3', HAITM3 )
            IF  ( HAITM1 .EQ. ' ' ) 
     &          CALL MSGDMP( 'E',' MAIN ','ZERO SPACE DIMENSION' )
            CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
            NGDAT=IXDIM*IYDIM*IZDIM
          ENDIF
          CALL GHPGET( HHEAD, 'TIME' , ITIME(IANUM) )
          CALL GHCGET( HHEAD, 'DATE' , HDATE(IANUM) )
          CALL GHPGET( HHEAD, 'DNUM' , IDNUM(IANUM) )
      GOTO 1100
        ENDIF
        CALL   GHCOPY( HHEADS,HHEAD)
*
*  < set dimension >
*
      IWDIM = IANUM
      ITDIM = IWDIM
*
      ITDIM = 2*(ITDIM/2)      !" 偶数に限る.
*
      IF (SDIM.EQ.1) THEN
        IQDIM = 1
        IRDIM = IXDIM
        ISDIM = IYDIM*IZDIM
      ELSE IF (SDIM.EQ.2) THEN
        IQDIM = IXDIM
        IRDIM = IYDIM
        ISDIM = IZDIM
      ELSE IF (SDIM.EQ.3) THEN
        IQDIM = IXDIM*IYDIM
        IRDIM = IZDIM
        ISDIM = 1
      ELSE
        CALL MSGDMP('E',' MAIN ','INVALID SPACE DIM.NUMBER' )
      ENDIF
*
*  < Fourier tranf. > 
*
      ISN = 1
*
      WRITE(6,*) IXDIM,IYDIM,IZDIM,IWDIM
      WRITE(6,*) IQDIM,IRDIM,ISDIM,ITDIM
*
**      IF (RSTRD) THEN   !" 空間リニアトレンドを引く
**        CALL SUBTRD
**     M      ( GDAT4,
**     I        IQDIM, IRDIM, IRDIM, ISDIM*ITDIM )
**      ENDIF
      CALL  AFFTRU      !" 空間 Fourier
     M      ( GDAT4, 
     W        WY,
     C        WX, IWX, 
     I        IQDIM, IRDIM, IRDIM, ISDIM*ITDIM,  ISN, LINIT )
*
**      IF (RTTRD) THEN   !" 時間リニアトレンドを引く
**        CALL SUBTRD
**     M      ( GDAT4,
**     I        IQDIM*IRDIM*ISDIM, ITDIM, ITDIM, 1 )
**      ENDIF
      CALL  AFFTRU      !" 時間 Fourier
     M      ( GDAT4, 
     W        WY,
     C        WT, IWT, 
     I        IQDIM*IRDIM*ISDIM, ITDIM, ITDIM, 1,  ISN, LINIT )
      LINIT = .FALSE.
*
*  < Filtering >
*
      CALL STFILT  !" 時空間フィルター(東進or西進のみ通す)
     M      ( GDAT4,
     I        IQDIM, IRDIM, ISDIM, ITDIM,
     I        EWD,
     M        MMIN,  MMAX,  FMIN,  FMAX,
     M        M4,    F4  )
*
*  < Fourier inverse tranf. > 
*
      ISN = -1
      CALL  AFFTRU      !" 空間逆Fourier
     M      ( GDAT4, 
     W        WY,
     C        WX, IWX, 
     I        IQDIM, IRDIM, IRDIM, ISDIM*ITDIM,  ISN, LINIT )
*
      CALL  AFFTRU      !" 時間逆Fourier
     M      ( GDAT4, 
     W        WY,
     C        WT, IWT, 
     I        IQDIM*IRDIM*ISDIM, ITDIM, ITDIM, 1,  ISN, LINIT )
*
*  < output >
*
      IF ( ITEM .NE. ' ' ) THEN
        CALL GHCSET( HHEAD , 'ITEM', ITEM )
      ENDIF
      IF ( UNIT .NE. ' ' ) THEN
        CALL GHCSET( HHEAD , 'UNIT', UNIT )
      ENDIF
      IF ( TITLE .NE. ' ' ) THEN
        CALL GHCSTS( HHEAD , 'TITL', TITLE )
      ENDIF
      IF ( DSET .NE. ' ' ) THEN
        CALL GHCSET( HHEAD , 'DSET', DSET )
      ENDIF
      IF ( GRESET ) THEN
        CALL GHRSGP( HHEAD  )
      ENDIF
*
      DO 100 ISEQ = 1,ITDIM
        CALL GHPSET( HHEAD, 'TIME' , ITIME(ISEQ) )
        CALL GHCSET( HHEAD, 'DATE' , HDATE(ISEQ) )
        CALL GHPSET( HHEAD, 'DNUM' , IDNUM(ISEQ) )
*
        CALL GFWRIT
     I         ( HHEAD , GDAT4(1+(ISEQ-1)*NGDAT) ,
     I           JFILE , 1     , 0      )
  100 CONTINUE
*
      STOP
      END
*********************************************************************
      SUBROUTINE COPY(X,Y,N)
      REAL    X(N),Y(N)
      DO 10 I=1,N
        X(I) = Y(I) 
   10 CONTINUE
      RETURN
      END
*********************************************************************
      SUBROUTINE STFILT  !" 時空間フィルター(東進or西進のみ通す)
     M      ( GDAT4,
     I        IDIM, JDIM, KDIM, LDIM,
     I        LEWD,
     M        JWMIN,JWMAX,LFMIN,LFMAX,
     M        JW4,  LF4  )
*
      REAL    GDAT4(IDIM,JDIM,KDIM,LDIM) !"JDIM:wn,LDIM:freq
      LOGICAL LEWD !" T/F: pass only eastward/westward components
      INTEGER JWMIN,JWMAX !"pass wavemumber J s.t. JWMIN<=J<=JWMAX
      INTEGER LFMIN,LFMAX !"pass freq L s.t. LFMIN<=L<=LFMAX
      INTEGER JW4(4),LF4(4) !"波数振動数の範囲を反時計回りの4辺形で設定
*
      IF(JWMIN.LE.0) THEN
        JWMIN=1         !" No low wavenum cut filtering (except for J=0)
      ENDIF
      IF(JWMAX.LT.0) THEN
        JWMAX=JDIM/2-1  !" No high wavenum cut filtering
      ENDIF
*
      IF(LFMIN.LE.0) THEN
        LFMIN=1         !" No low freq cut filtering (except for L=0)
      ENDIF
      IF(LFMAX.LT.0) THEN
        LFMAX=LDIM/2-1  !" No high freq cut filtering
      ENDIF
*
      DO 1000 L=1,LDIM
      DO 1000 I=1,IDIM  !" IDIM=1がほとんどだろう
      DO 1000 K=1,KDIM
      DO 1000 J=1,MIN(2*JWMIN,JDIM) !" WN=0,..,JWMIN-1, and JDIM/2  -> ZERO
        GDAT4(I,J,K,L)=0
 1000 CONTINUE
*
      DO 1100 L=1,LDIM
      DO 1100 I=1,IDIM
      DO 1100 K=1,KDIM
      DO 1100 J=MAX(2*JWMAX+3,3),JDIM !" WN=JWMAX+1,..,JDIM/2-1  -> ZERO
          GDAT4(I,J,K,L)=0
 1100 CONTINUE
*
      DO 1200 L=1,MIN(2*LFMIN,LDIM) !" FREQ=0,..,LFMIN-1 and LDIM/2 -> ZERO
      DO 1200 I=1,IDIM
      DO 1200 K=1,KDIM
      DO 1200 J=1,JDIM
        GDAT4(I,J,K,L)=0
 1200 CONTINUE
*
      DO 1300 L=MAX(2*LFMAX+3,3),LDIM !" FREQ=LFMAX,..,LDIM/2-1 -> ZERO
      DO 1300 I=1,IDIM
      DO 1300 K=1,KDIM
      DO 1300 J=1,JDIM
        GDAT4(I,J,K,L)=0
 1300 CONTINUE
*
      IF( JW4(1).GE.0 .AND. JW4(2).GE.0 .AND.
     &    JW4(3).GE.0 .AND. JW4(4).GE.0 .AND.
     &    LF4(1).GE.1 .AND. LF4(2).GE.1 .AND.
     &    LF4(3).GE.1 .AND. LF4(4).GE.1      ) THEN !" 全部正の場合
        DO 1500 L=3,LDIM
        DO 1500 J=3,JDIM
          LW=(L-1)/2
          JW=(J-1)/2
          IF( (JW4(2)-JW4(1))*(LW-LF4(1)).LT.(LF4(2)-LF4(1))*(JW-JW4(1))
     &    .OR.(JW4(3)-JW4(2))*(LW-LF4(2)).LT.(LF4(3)-LF4(2))*(JW-JW4(2))
     &    .OR.(JW4(4)-JW4(3))*(LW-LF4(3)).LT.(LF4(4)-LF4(3))*(JW-JW4(3))
     &    .OR.(JW4(1)-JW4(4))*(LW-LF4(4)).LT.(LF4(1)-LF4(4))*(JW-JW4(4))
     &      ) THEN     !" (J,L)平面で反時計回りの4辺形の外にある条件
            DO 1600 I=1,IDIM
            DO 1600 K=1,KDIM
              GDAT4(I,J,K,L)=0
 1600       CONTINUE
          ENDIF
 1500   CONTINUE
      ENDIF
*
      IF(LEWD) THEN
        DO 2000 LW=1,LDIM/2-1 !" =FREQ; COS:L=2*LW+1 , -SIN:L=2*LN+2
        DO 2000 K=1,KDIM
        DO 2000 JW=JWMIN,JWMAX !" =WN;   COS:J=2*JW+1 , -SIN:J=2*JN+2
        DO 2000 I=1,IDIM
          GDAT4(I,2*JW+1,K,2*LW+1) = ( GDAT4(I,2*JW+1,K,2*LW+1)
     &                                +GDAT4(I,2*JW+2,K,2*LW+2) )/2
          GDAT4(I,2*JW+1,K,2*LW+2) = ( GDAT4(I,2*JW+1,K,2*LW+2)
     &                                -GDAT4(I,2*JW+2,K,2*LW+1) )/2
          GDAT4(I,2*JW+2,K,2*LW+1) = -GDAT4(I,2*JW+1,K,2*LW+2)
          GDAT4(I,2*JW+2,K,2*LW+2) =  GDAT4(I,2*JW+1,K,2*LW+1)
 2000   CONTINUE
      ELSE
        DO 3000 LW=1,LDIM/2-1 !" =FREQ; COS:L=2*LW+1 , -SIN:L=2*LN+2
        DO 3000 K=1,KDIM
        DO 3000 JW=JWMIN,JWMAX !" =WN; COS:J=2*JW+1 , -SIN:J=2*JN+2
        DO 3000 I=1,IDIM
          GDAT4(I,2*JW+1,K,2*LW+1) = ( GDAT4(I,2*JW+1,K,2*LW+1)
     &                                -GDAT4(I,2*JW+2,K,2*LW+2) )/2
          GDAT4(I,2*JW+1,K,2*LW+2) = ( GDAT4(I,2*JW+1,K,2*LW+2)
     &                                +GDAT4(I,2*JW+2,K,2*LW+1) )/2
          GDAT4(I,2*JW+2,K,2*LW+1) =  GDAT4(I,2*JW+1,K,2*LW+2)
          GDAT4(I,2*JW+2,K,2*LW+2) = -GDAT4(I,2*JW+1,K,2*LW+1)
 3000   CONTINUE
      ENDIF
*
      RETURN
      END

*"表題 GMTOOLパラメーター管理 GTOOL3(GMPGET)
*
*"履歴 90/01/10 沼口  敦
*
*
*********************************************************************
*"         << GMTOOLパラメータ（数）を参照 >>
*********************************************************************
      SUBROUTINE GMPGET
     I         ( HP,
     O           IPARA )
*
      CHARACTER HP   *(*)                !" パラメーターの名前
*"   (INTEGER)  IPARA                    ! パラメーターの内容：数字
*
      PARAMETER ( NPP=1 )
*
      REAL      RX( NPP )
      INTEGER   IX( NPP )
      LOGICAL   LX( NPP )
      EQUIVALENCE ( RX,IX,LX )
*
      CHARACTER HPP  ( NPP )*8
      CHARACTER CMSG*80
*
      SAVE
*
      DATA      HPP( 1)/'SIZE    '/, IX( 1)/ 1 /  !" 作業配列サイズ
*
      DO 1100 N = 1, NPP
        IF ( HP .EQ. HPP  (N) ) THEN
          IPARA = IX(N)
          RETURN
        END IF
 1100 CONTINUE
*
      NHP  = LENC(HP)
      CMSG = 'PARAMETER '''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP( 'E', 'GMPGET', CMSG )
*
      RETURN
*=======================================================================
*"         << GMTOOLパラメータ（数）を設定 >>
*=======================================================================
      ENTRY GMPSET
     I         ( HP, IPARA )
*
      DO 2100 N = 1, NPP
        IF ( HP .EQ. HPP  (N) ) THEN
          IX( N ) = IPARA
          RETURN
        END IF
 2100 CONTINUE
*
      NHP = LENC(HP)
      CMSG = 'PARAMETER '''//HP(1:NHP)//''' IS NOT DEFINED.'
      CALL MSGDMP( 'E', 'GMPSET', CMSG )
*
      RETURN
      END

*"表題 データにデータを代入 GTOOL3(GPFSET)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << データにデータを代入 >>
*********************************************************************
      SUBROUTINE GPFSET
     I         ( HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 3. データ演算 >
*
      DO 3100 I = 1, IXDIM*IYDIM*IZDIM
         GDATAO( I ) = GDATA( I )
 3100 CONTINUE
*
*"         < 4. ヘッダー複写 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHEADD ( HHEADO, HEDIT, HETTL )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << データにデータを代入 >>
*********************************************************************
      SUBROUTINE GMFSET
     M         ( HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHEADD ( HHEAD, HEDIT, HETTL )
      ENDIF
*
      RETURN
      END

* PACKAGE GTSEL   !" 選択, フィールド変更
**************************************************************************
      PROGRAM GTSEL
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      PARAMETER  ( RUNDEF=-999., IUNDEF=-999 )
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       IFILP / 51 /
      DATA       JFILE / 60 /
      CHARACTER  ITEMZ *(NCC)
*
      INTEGER    X, Y, Z
      DATA       X, Y, Z / 3*-1 /
      INTEGER    STR, END, STEP
      DATA       STR, END, STEP / 1, 9999999, 1 /
      CHARACTER  SEL *(NCC)
      DATA       SEL    / ' ' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      REAL       DIVS , DIVL
      REAL       DMIN , DMAX
      REAL       DMISS, ROPTN
      DATA       DIVS , DIVL, DMIN, DMAX, DMISS, ROPTN / 6*RUNDEF /
      INTEGER    STYP
      DATA       STYP / IUNDEF /
      INTEGER    IOPTN 
      DATA       IOPTN / IUNDEF /
      CHARACTER  COPTN  *(NCC)
      DATA       COPTN / ' ' /
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ X, Y, Z, STR, END, STEP, SEL, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, 
     &                   DIVS, DIVL, DMIN, DMAX, DMISS, STYP,
     &                   ROPTN, IOPTN, COPTN, GRESET, HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
      CALL GFOOPN ( JFILE,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      IF ( STEP .LE. 1 ) STEP = 1
*
      II = 0
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD.EQ.0 ) THEN
*
            CALL GHCGET( HHEAD, 'ITEM', ITEMZ )
            IF (  ( SEL .EQ. ' '   )  .OR.
     &            ( SEL .EQ. ITEMZ )        ) THEN
*
               II = II + 1
               IF ( ( II.GE.STR ).AND.( II.LE.END ).AND.
     &              ( MOD( II-STR,STEP ).EQ.0 )          ) THEN         
*
                  IF ( Z .EQ. 0 ) THEN
                     CALL GMZAVG
     M               ( HHEAD , GDATA ,
     I                 'ZM'  , 'vert mean'  )
                  ELSE IF ( Z .GT. 0 ) THEN 
                     CALL GMZSEL
     M               ( HHEAD , GDATA , Z ,
     I                 '  '  , '  '        )
                  ENDIF
                  IF ( Y .EQ. 0 ) THEN
                     CALL GMYAVG
     M               ( HHEAD , GDATA ,
     I                 'YM'  , 'merid mean' )
                  ELSE IF ( Y .GT. 0 ) THEN 
                     CALL GMYSEL
     M               ( HHEAD , GDATA , Y ,
     I                 '  '  , '  '         )
                  ENDIF
                  IF ( X .EQ. 0 ) THEN
                     CALL GMXAVG
     I               ( HHEAD , GDATA ,
     I                 'XM'  , 'zonal mean' )
                  ELSE IF ( X .GT. 0 ) THEN 
                     CALL GMXSEL
     I               ( HHEAD , GDATA , X ,
     I                 '  '  , '  '        )
                  ENDIF
*
                  IF ( ITEM .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'ITEM', ITEM )
                  ENDIF
                  IF ( UNIT .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'UNIT', UNIT )
                  ENDIF
                  IF ( TITLE .NE. ' ' ) THEN
                     CALL GHCSTS( HHEAD , 'TITL', TITLE )
                  ENDIF
                  IF ( DSET .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD , 'DSET', DSET )
                  ENDIF
                  IF ( GRESET ) THEN
                     CALL GHRSGP( HHEAD  )
                  ENDIF
                  IF ( DIVS .NE. RUNDEF ) THEN
                     CALL GHPSET( HHEAD, 'DIVS', DIVS )
                  ENDIF
                  IF ( DIVL .NE. RUNDEF ) THEN
                     CALL GHPSET( HHEAD, 'DIVL', DIVL )
                  ENDIF
                  IF ( DMIN .NE. RUNDEF ) THEN
                     CALL GHPSET( HHEAD, 'DMIN', DMIN )
                  ENDIF
                  IF ( DMAX .NE. RUNDEF ) THEN
                     CALL GHPSET( HHEAD, 'DMAX', DMAX )
                  ENDIF
                  IF ( DMISS .NE. RUNDEF ) THEN
                     CALL GHPSET( HHEAD, 'MISS', DMISS )
                  ENDIF
                  IF ( ROPTN .NE. RUNDEF ) THEN
                     CALL GHPSET( HHEAD, 'ROPTN', ROPTN )
                  ENDIF
                  IF ( STYP .NE. IUNDEF ) THEN
                     CALL GHPSET( HHEAD, 'STYP', STYP )
                  ENDIF
                  IF ( IOPTN .NE. IUNDEF ) THEN
                     CALL GHPSET( HHEAD, 'IOPTN', IOPTN )
                  ENDIF
                  IF ( COPTN .NE. ' ' ) THEN
                     CALL GHCSET( HHEAD, 'COPTN', COPTN )
                  ENDIF

*
                  CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
               ENDIF
            ENDIF
*
            IF ( II .LT. END ) GOTO 1100
         ENDIF
*
      STOP
      END

* PACKAGE GURNTF              " 同じパス名を変更
*
*"  [HIS] 920/09/10(numaguti)
*
***********************************************************************
      SUBROUTINE GURNTF
     M         ( HFNAME ,
     I           HFNREF , HFNCHG  )
*
      CHARACTER  HFNAME *(*)
      CHARACTER  HFNREF *(*)
      CHARACTER  HFNCHG *(*)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                    !" NCC, NDC
#else
#include         "gzsize.F"                  !" NCC, NDC
#endif
*
      CHARACTER  HFNEXP *(NFILN)
      CHARACTER  HFREXP *(NFILN)
      CHARACTER  HFCEXP *(NFILN)
      CHARACTER  HMESG  *100
      LOGICAL    OEXIST
*
      HFNEXP = HFNAME
      HFREXP = HFNREF
      HFCEXP = HFNCHG
*
      CALL GUNENV( HFNEXP, '.', .FALSE. )
      CALL GUNENV( HFREXP, '.', .FALSE. )
      CALL GUNENV( HFCEXP, '.', .FALSE. )
*
      IF ( HFNEXP .EQ. HFREXP ) THEN
         INQUIRE ( FILE=HFNEXP, EXIST=OEXIST )
         IF ( OEXIST ) THEN
#ifdef SYS_IBMS
            CALL MSGDMP('E','GURNTF','COLLISION IN FILE NAME.')
            STOP
#else
            NN = LENC(HFNAME)
            NC = LENC(HFNCHG)
            HMESG = 'RENAMED:'//HFNAME(1:NN)//'->'//HFNCHG(1:NC)
            CALL MSGDMP( 'W','GURTNF',HMESG )
            CALL SYSTEM( 'mv -f '//HFNEXP//HFCEXP )
#endif
         ENDIF
         HFNAME = HFNCHG
      ENDIF
*
      RETURN
      END

* PACKAGE GTAVR     !"  系列平均
*******************************************************************
      PROGRAM GTAVR
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
*
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GDATA ( IJKDIM )
      CHARACTER  HHEAD1( NDC )*(NCC)
      REAL       GDATA1( IJKDIM )
      CHARACTER  HHEADW( NDC )*(NCC)
      REAL       GDATAW( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      LOGICAL    WEIGHT
      DATA       WEIGHT / .FALSE. /
      INTEGER    STR, END, STEP
      DATA       STR, END, STEP / 1, 9999999, 1 /
      INTEGER    OSTEP
      DATA       OSTEP  / 0 /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      NAMELIST  /OPTION/ WEIGHT, STR, END, STEP, OSTEP, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
 
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GTSIZE ( HHEAD1, IJKDIM )
      CALL GTSIZE ( HHEADW, IJKDIM )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE, HFILE( 1 ) )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      CALL GPTAVR ( HHEAD1 )
*
      II = 0
      III = 0
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD.EQ.0 ) THEN
            II = II + 1
*
            IF ( ( II.GE.STR ).AND.( II.LE.END ).AND.
     &           ( MOD( II-STR,STEP ).EQ.0 )          ) THEN         
*
               III = III + 1
               IF ( .NOT. WEIGHT ) THEN
                  CALL GHPSET( HHEAD, 'TDUR', 1  )
               ENDIF
               CALL GPTAVG
     I         ( HHEAD , GDATA ,
     I           EDIT  , ETTL  ,
     M           HHEADW, GDATAW,
     O           HHEAD1, GDATA1 )
*
               IF ( OSTEP .GT. 0 ) THEN
                  IF ( III .EQ. OSTEP ) THEN
                     GOTO 2100
                  ENDIF
               ENDIF
*
            ENDIF
*
            IF ( II .LT. END ) THEN
               GOTO 1100
            ENDIF
         ENDIF
*
 2100    CONTINUE 
*
         IF ( III .GT. 0 ) THEN
            CALL GPTAVO
     M         ( HHEADW, GDATAW ,
     M           HHEAD1, GDATA1  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEAD1, 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEAD1, 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEAD1, 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEAD1, 'DSET', DSET )
            ENDIF
*
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEAD1  )
            ENDIF
*
            CALL  GFOOPN ( JFILE,  OUT , APND )
*
            CALL  GFWRIT
     I               ( HHEAD1, GDATA1,
     I                 JFILE , 1     , 0       )
*
            CALL GPTAVR ( HHEAD1 )
            III = 0
*
         ENDIF
         IF ( (IEOD .EQ. 0) .AND. (II .LT. END) ) THEN
            GOTO 1100
         ENDIF
*
      STOP
      END

* PACKAGE  GTINTERP !" ³Ê»ÒÊÑ´¹
***********************************************************************
      PROGRAM GTINTRP
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE   / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       IFILP / 51 /
      DATA       JFILE / 60 /
*
      CHARACTER  X *(NCC)
      CHARACTER  Y *(NCC)
      CHARACTER  Z *(NCC)
      DATA       X,Y,Z  / 3*' ' /
      CHARACTER  OUT     *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      LOGICAL    MISOUT
      DATA       MISOUT / .TRUE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL / 6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   INTERP
*     
      NAMELIST  /OPTION/ X, Y, Z, OUT, APND, MISOUT,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      CALL  SETCOR ( X, Y, Z )
      CALL  SETMIS ( MISOUT  )
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( MAX(IEOD,IEODP) .EQ.0 ) THEN
            CALL GMCAL1
     I         ( INTERP,
     M           HHEAD , GDATA ,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEAD , 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEAD  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE INTERP
     I         ( HDS   , DS     ,
     O           HDP   , DP    ,
     D           IMAX  , JMAX  , KMAX  )
*
      CHARACTER  HDS ( * )*(*)
      REAL       DS ( * )
      CHARACTER  HDP ( * )*(*)
      REAL       DP ( * )
*
      CHARACTER  HCORX1 *(*)
      CHARACTER  HCORY1 *(*)
      CHARACTER  HCORZ1 *(*)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      CHARACTER  HXP ( NDC )*(NCC)
      CHARACTER  HYP ( NDC )*(NCC)
      CHARACTER  HZP ( NDC )*(NCC)
      PARAMETER  ( IMAXD = 1024 )
      REAL       XS ( IMAXD ), XP( IMAXD )
      REAL       YS ( IMAXD ), YP( IMAXD )
      REAL       ZS ( IMAXD ), ZP( IMAXD )
      CHARACTER  HCORDX *(NCC)
      CHARACTER  HCORDY *(NCC)
      CHARACTER  HCORDZ *(NCC)
      REAL       XCYCL, YCYCL, ZCYCL
*
      IF ( MAX(IMAX,JMAX,KMAX) .GT. IMAXD ) THEN
         CALL MSGDMP( 'E','INTERP','WORK AREA TOO SMALL' )
      ENDIF
*
      CALL GUSMIS( HDS )
* 
      CALL GUQAXQ
     I            ( HDS   , 1     , 'LOC' ,
     O              XS    , XCYCL , IXDIM , IEOD  , 
     D              IMAXD                 )
      CALL GTSIZE ( HXP , IMAXD   )
      CALL GUQAXC
     I            ( HCORDX, 'LOC',
     O              HXP   , XP   , CYCLE , IMAXP , IEOD  )
*
      CALL GUQAXQ
     I            ( HDS   , 2     , 'LOC' ,
     O              YS    , YCYCL , IYDIM , IEOD  , 
     D              IMAXD                 )
      CALL GTSIZE ( HYP , IMAXD   )
      CALL GUQAXC
     I            ( HCORDY, 'LOC',
     O              HYP   , YP   , CYCLE , JMAXP , IEOD  )
*
      CALL GUQAXQ
     I            ( HDS   , 3     , 'LOC' ,
     O              ZS    , ZCYCL , IZDIM , IEOD  , 
     D              IMAXD                 )
      CALL GTSIZE ( HZP , IMAXD   )
      CALL GUQAXC
     I            ( HCORDZ, 'LOC',
     O              HZP   , ZP   , CYCLE , KMAXP , IEOD  )
*
      CALL INTR3
     I           ( DS  , XS   , YS   , ZS   ,
     I                   IMAX , JMAX , KMAX ,
     I                   XCYCL, YCYCL, ZCYCL,
     I                   XP   , YP   , ZP   ,
     I                   IMAXP, JMAXP, KMAXP,
     O             DP                          )
*
      CALL GHCSET( HDP, 'AITM1', HCORDX )
      CALL GHPSET( HDP, 'ASTR1', 1      )
      CALL GHPSET( HDP, 'AEND1', IMAXP  )
*
      CALL GHCSET( HDP, 'AITM2', HCORDY )
      CALL GHPSET( HDP, 'ASTR2', 1      )
      CALL GHPSET( HDP, 'AEND2', JMAXP  )
*
      CALL GHCSET( HDP, 'AITM3', HCORDZ )
      CALL GHPSET( HDP, 'ASTR3', 1      )
      CALL GHPSET( HDP, 'AEND3', KMAXP  )
*
      RETURN
*=====================================================================
      ENTRY      SETCOR
     I         ( HCORX1, HCORY1, HCORZ1 )
      HCORDX = HCORX1 
      HCORDY = HCORY1 
      HCORDZ = HCORZ1 
      RETURN
      END
***********************************************************************
      SUBROUTINE INTR3
     I         ( DS  , XS   , YS   , ZS   ,
     I                 NXS  , NYS  , NZS  ,
     I                 XCYCL, YCYCL, ZCYCL,
     I                 XP   , YP   , ZP   ,
     I                 NXP  , NYP  , NZP  ,
     O           DP                          )
*
      REAL       DS  ( NXS, NYS, NZS )
      REAL       XS  ( NXS )
      REAL       YS  ( NYS )
      REAL       ZS  ( NZS )
      REAL       XP  ( NXP )
      REAL       YP  ( NYP )
      REAL       ZP  ( NZP )
      REAL       DP  ( NXP, NYP, NZP )
*
      LOGICAL    OMISOZ
      LOGICAL    OMISOU
      DATA       OMISOU / .TRUE. /
      PARAMETER  ( NDIM = 1025 )
      INTEGER    I0  ( NDIM ), I1  ( NDIM )
      INTEGER    J0  ( NDIM ), J1  ( NDIM )
      INTEGER    K0  ( NDIM ), K1  ( NDIM )
      REAL       DI  ( NDIM )
      REAL       DJ  ( NDIM )
      REAL       DK  ( NDIM )
*
      IF ( MAX( NXP, NYP, NZP ) .GT. NDIM ) THEN
         CALL MSGDMP( 'E','INTR3', ' TOO SMALL WORK AREA: NDIM' )
      ENDIF
*
      CALL       GLPGET( 'RMISS', VMISS )
*
      CALL       GETRNG
     I         ( XS    , NXS   , XCYCL  ,
     I           XP    , NXP   ,
     O           I0    , I1    , DI      )
*
      CALL       GETRNG
     I         ( YS    , NYS   , YCYCL  ,
     I           YP    , NYP   ,
     O           J0    , J1    , DJ      )
*
      CALL       GETRNG
     I         ( ZS    , NZS   , ZCYCL  ,
     I           ZP    , NZP   ,
     O           K0    , K1    , DK      )
*
      DO 4100 KP = 1, NZP
         DO 4100 JP = 1, NYP
            DO 4100 IP = 1, NXP
*
               DX  = DI(IP)
               DY  = DJ(JP)
               DZ  = DK(KP)
*
               DX1 = 1.-DX
               DY1 = 1.-DY
               DZ1 = 1.-DZ
*
               IF ( OMISOU ) THEN
                  IF (     (DX .GT. 1.).OR.(DY .GT. 1.)
     &                 .OR.(DZ .GT. 1.)                 ) THEN
                     DP(IP,JP,KP) = VMISS
                     GOTO 4100
                  ENDIF
               ENDIF
*
               SP = 0.
               SD = 0.
               IF ( DS(I0(IP),J0(JP),K0(KP)) .NE. VMISS ) THEN
                  SP = SP + DS(I0(IP),J0(JP),K0(KP))* DX1*DY1*DZ1
                  SD = SD + DX1*DY1*DZ1
               ENDIF
               IF ( DS(I1(IP),J0(JP),K0(KP)) .NE. VMISS ) THEN
                  SP = SP + DS(I1(IP),J0(JP),K0(KP))* DX *DY1*DZ1
                  SD = SD + DX *DY1*DZ1
               ENDIF
               IF ( DS(I0(IP),J1(JP),K0(KP)) .NE. VMISS ) THEN
                  SP = SP + DS(I0(IP),J1(JP),K0(KP))* DX1*DY *DZ1
                  SD = SD + DX1*DY *DZ1
               ENDIF
               IF ( DS(I1(IP),J1(JP),K0(KP)) .NE. VMISS ) THEN
                  SP = SP + DS(I1(IP),J1(JP),K0(KP))* DX *DY *DZ1
                  SD = SD + DX *DY *DZ1
               ENDIF
               IF ( DS(I0(IP),J0(JP),K1(KP)) .NE. VMISS ) THEN
                  SP = SP + DS(I0(IP),J0(JP),K1(KP))* DX1*DY1*DZ
                  SD = SD + DX1*DY1*DZ
               ENDIF
               IF ( DS(I1(IP),J0(JP),K1(KP)) .NE. VMISS ) THEN
                  SP = SP + DS(I1(IP),J0(JP),K1(KP))* DX *DY1*DZ
                  SD = SD + DX *DY1*DZ
               ENDIF
               IF ( DS(I0(IP),J1(JP),K1(KP)) .NE. VMISS ) THEN
                  SP = SP + DS(I0(IP),J1(JP),K1(KP))* DX1*DY *DZ
                  SD = SD + DX1*DY *DZ
               ENDIF
               IF ( DS(I1(IP),J1(JP),K1(KP)) .NE. VMISS ) THEN
                  SP = SP + DS(I1(IP),J1(JP),K1(KP))* DX *DY *DZ
                  SD = SD + DX *DY *DZ
               ENDIF
               IF ( SD .GT. 0. ) THEN
                  DP(IP,JP,KP) = SP/SD
               ELSE
                  DP(IP,JP,KP) = VMISS
               ENDIF
*
 4100 CONTINUE 
*
      RETURN
*===============================================================
      ENTRY      SETMIS
     I         ( OMISOZ )
      OMISOU = OMISOZ
      RETURN
      END
****************************************************************
      SUBROUTINE GETRNG
     I         ( XS    , NXS   , XCYCL  ,
     I           XP    , NXP   ,
     O           I0    , I1    , DX      )
*
      REAL       XS  ( NXS )
      REAL       XCYCL
      REAL       XP  ( NXP )
      INTEGER    I0  ( NXP )
      INTEGER    I1  ( NXP )
      REAL       DX  ( NXP )
*
      IF ( XCYCL .NE. 0. ) THEN
         NCY = 1
      ELSE
         NCY = 0
      ENDIF
*
      IF ( NXS .EQ. 1 ) THEN
         DO 100 IP = 1, NXP
            I0(IP) = 1
            I1(IP) = 1
            DX(IP) = 0.
  100    CONTINUE 
*
         RETURN
      ENDIF

      DO 1100 IP = 1, NXP
         I0 ( IP ) = 0
         DO 1110 IX = 1, NXS
            DO 1110 ICY = -NCY, NCY
*
               IF      ( IX .NE. NXS ) THEN
                  IXP = IX + 1
                  DA  = XS(IXP) - XS(IX)
                  DD  = ( XP(IP) - ( XS(IX) + ICY*XCYCL ) ) / DA
               ELSE IF ( XCYCL .NE. 0. ) THEN
                  IXP = 1
                  DA  = XS(1)+XCYCL - XS(IX)
                  DD  = ( XP(IP) - ( XS(IX) + ICY*XCYCL ) ) / DA
               ELSE
                  GOTO 1110
               ENDIF
*
               IF ( DD .GE. 0. .AND. DD .LE. 1. ) THEN
                  I0(IP) = IX
                  I1(IP) = IXP
                  DX(IP) = DD
               ELSE IF ( (IX .EQ. 1) .AND. (ICY .EQ. -NCY )
     &                               .AND. (DD  .LT. 0.   ) ) THEN
                  I0(IP) = 1
                  I1(IP) = 1
                  DX(IP) = 2.
               ELSE IF ( (IX .EQ. NXS-1) .AND. (ICY .EQ. NCY )
     &                                   .AND. (DD  .GT. 1.  ) ) THEN
                  I0(IP) = NXS
                  I1(IP) = NXS
                  DX(IP) = 2.
               ENDIF
 1110    CONTINUE 
         IF ( I0(IP) .EQ. 0 ) WRITE (6,*) 'ERROR I0', IP
*
 1100 CONTINUE 
*
      RETURN
      END

* PACKAGE GTDUMP   !" 球面調和関数フィルタ
*********************************************************************
      PROGRAM GTDUMP
*
#include         "gtsinc.F"
#include         "gzsize.F"
#include         "gpainc.F"              !" /GPAWRK/
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE / 'gtool.out' /
      DATA       IFILE / 50 /
      DATA       JFILE / 60 /
*
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / 'gtool.out' /
      LOGICAL    POSI
      DATA       POSI  / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL /6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   FILT
*     
      NAMELIST  /OPTION/ OUT, POSI,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFWOPN ( JFILE ,  OUT )
*
      IL=LENC(OUT)
      WRITE (0,*) 'output='//OUT(1:IL)
*
      IF ( POSI ) CALL SETPOS
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
*
         IF ( IEOD .EQ.0 ) THEN
*
            CALL GMCAL1
     I         ( FILT  ,
     M           HHEAD , GDATA ,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEAD , 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEAD  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
*********************************************************************
      SUBROUTINE FILT
     I         ( HH    , GDATA , 
     O           HHF   , GDATAF,
     I           IMAX  , JMAX  , KMAX  )
*
      CHARACTER  HH     ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HHF    ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAF ( * )            !" データ(出力)
*
      LOGICAL    OPOSI
      DATA       OPOSI / .FALSE. /
      SAVE       OPOSI
*
      PARAMETER  ( IDIM=3, JDIM=2, KDIM=1 )
#include         "gpainc.F"              !" /GPAWRK/
*"    COMMON /GPAWK?/ WDATA , ZDATA , ZWORK ,
*"                    PNM   , DPNM  , TRIGS , IFAX  ,
*"                    NMO   , GW    , COSLAT,
*"                    QPNM  , QDPNM , QGW   , QSINLA
*"    REAL ER / 6370.E3 /
*
      IF ( OPOSI ) THEN
         DO 1000 IJK = 1, IMAX*JMAX*KMAX
            GDATA( IJK ) = MAX( GDATA(IJK), 0. )
 1000    CONTINUE 
      ENDIF
*
*"         < 球関数の準備 >
*
      CALL GPASPS
     I         ( IMAX  , JMAX  , KMAX  , ER    ,
     O           PNM   , DPNM  , TRIGS , IFAX  ,
     O           NMO   , GW    , COSLAT,
     O           LMAX  , MMAX  , NMAX  , MINT  ,
     O           NMDIM , JMXHF ,
     W           QPNM  , QDPNM , QGW   , QSINLA         )
*
*"         < スペクトルに >
*
      CALL SPG2W
     M         ( WDATA ,
     I           GDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  , GW    ,
     F           '    ', 'POS' ,
     D           IMAX  , JMAX  , KMAX  , IMAX  , JMAX  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF ,
     W           ZDATA , ZWORK                                   )
*
      DO 1100 K = 1, KMAX
         DO 1100 N = 0, NMAX
            POW = 0.
            DO 1200 M = 0, MIN(MMAX,N)
               FF = FILTF(N,NMAX)
               NMI = (N-M)*(MMAX+1)*2 + M*2 
               WDATA(NMO(1+NMI)+(K-1)*NMDIM) 
     &       = WDATA(NMO(1+NMI)+(K-1)*NMDIM) * FF
               WDATA(NMO(2+NMI)+(K-1)*NMDIM)
     &       = WDATA(NMO(2+NMI)+(K-1)*NMDIM) * FF
 1200       CONTINUE 
 1100 CONTINUE 
*
*"         < 格子点値に戻す >
*
      CALL SPW2G
     M         ( GDATAF,
     I           WDATA ,
     C           PNM   , NMO   , TRIGS , IFAX  ,
     F           '    ', 'POS' ,
     D           IMAX  , JMAX  , KMAX  , IMAX  , JMAX  ,
     D           LMAX  , MMAX  , NMAX  , MINT  , NMDIM , JMXHF , 
     W           ZDATA , ZWORK                                   )
*
      RETURN
*======================================================================
      ENTRY      SETPOS
      OPOSI = .TRUE.
      RETURN
      END
*======================================================================
      REAL FUNCTION FILTF ( N, NMAX )
*
      INTEGER    N, NMAX
*
      FILTF = 1. - ( REAL(N)/REAL(NMAX) )**2
*
      RETURN
      END

* PACKAGE  GTS2P  !" ¦Ò-> p
***********************************************************************
      PROGRAM GTS2P
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEAD( NDC )*(NCC)
      REAL       GDATA( IJKDIM )
      CHARACTER  HHEADP( NDC )*(NCC)
      REAL       GDATAP( IJKDIM )
*
      CHARACTER  HFILE( 1 ) *(NFILN)
      DATA       HFILE   / '$GTTMPDIR/gtool.out' /
      DATA       IFILE / 50 /
      DATA       IFILP / 51 /
      DATA       JFILE / 60 /
*
      CHARACTER  PLEV   *(NCC)
      DATA       PLEV   / 'STDPLEV' /
      CHARACTER  PS     *(NFILN)
      DATA       PS     / 'Ps' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM, UNIT, TITLE, DSET, EDIT, ETTL / 6*' '/
      LOGICAL    GRESET
      DATA       GRESET / .FALSE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   S2P
*     
      NAMELIST  /OPTION/ PLEV, PS, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP, HFILE
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEAD, IJKDIM )
      CALL GTSIZE ( HHEADP, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( HFILE( 1 ), OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( PS        , OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILE , HFILE( 1 ) )
      CALL GFROPN ( IFILEP, PS    )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
      CALL  SETPLV ( PLEV )
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEAD , GDATA , IEOD  ,
     I          IFILE , 1               )
         CALL   GFREAD
     O        ( HHEADP, GDATAP, IEODP ,
     I          IFILEP, 1               )
*
         IF ( MAX(IEOD,IEODP) .EQ.0 ) THEN
            CALL GMCAL2
     I         ( S2P,
     M           HHEAD , GDATA ,
     I           HHEADP, GDATAP,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEAD , 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEAD , 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEAD  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEAD , GDATA ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE S2P
     I         ( HDS   , DS     ,
     I           HPS   , PS    ,
     O           HDP   , DP    ,
     D           IMAX  , JMAX  , KMAX ,
     D           IMAX2 , JMAX2 , KMAX2 )
*
      CHARACTER  HDS ( * )*(*)
      REAL       DS ( IMAX, JMAX, KMAX )
      CHARACTER  HPS ( * )*(*)
      REAL       PS ( IMAX2, JMAX2 )
      CHARACTER  HDP ( * )*(*)
      REAL       DP ( IMAX, JMAX, KMAX )
*
      CHARACTER  HPLEVZ *(*)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
      CHARACTER  HHS ( NDC )*(NCC)
      CHARACTER  HHP ( NDC )*(NCC)
      PARAMETER  ( KMAXD = 100 )
      REAL       SIG  ( KMAXD )
      REAL       PLEVS( KMAXD )
      CHARACTER  HPLEV *(NCC)
*
      DATA       P00  / 1000. /
      DATA       RAIR / 287.04 /
      DATA       CP   / 1004.6 /
*
      IF ( KMAX .GT. KMAXD ) THEN
         CALL MSGDMP( 'E','S2P','WORK AREA TOO SMALL' )
      ENDIF
*
      AKAPPA = RAIR / CP
      CALL GHPGET( HDS,'MISS',VMISS )
* 
      CALL GTSIZE ( HHP  ,  KMAXD   )
      CALL GTSIZE ( HHS  ,  KMAXD   )
      CALL GUQAXV
     I            ( HDS   , 3     , 'LOC',
     O              HHS   , SIG   , IEOD  )
      CALL GUQAXS
     I            ( HPLEV , 'LOC',
     O              HHP   , PLEVS, IEOD  )
      CALL GUQTSZ ( HHP, LMAX )
*
      CALL SINTRP
     I           ( PS  , SIG , DS  , PLEVS,
     I             IMAX, JMAX, KMAX, LMAX, VMISS,
     O             DP                            )
*
      CALL GHCSET( HDP, 'AITM3', HPLEV  )
      CALL GHPSET( HDP, 'ASTR3', 1      )
      CALL GHPSET( HDP, 'AEND3', LMAX   )
*
      RETURN
*=====================================================================
      ENTRY      SETPLV
     I         ( HPLEVZ )
      HPLEV = HPLEVZ
      RETURN
      END
***********************************************************************
      SUBROUTINE SINTRP
     I           ( PS  , SIG, XSIG,  PLEV,
     I             IMAX, JMAX, KMAX, LMAX, VMISS,
     O             XPRES                                 )
*
* INTERPOLATION FROM SIGMA LEVEL TO STD-PRESSURE LEVEL
*
*     created  by kuma 
*     modified by numaguti 92/07/06
*
      REAL     PS    (IMAX*JMAX)      ! PRESSURE
      REAL     SIG   (KMAX)           ! SIG
      REAL     XSIG  (IMAX*JMAX,KMAX) ! DATA OF SIGMA-CORDINATE
      REAL     XPRES (IMAX*JMAX,LMAX) ! DATA OF PRESSURE-CORDINATE
      REAL     PLEV  (LMAX)           ! INTERPOLATE IN THESE PRESSURE LEVELS
*
      PARAMETER  ( KMAXD = 100 )
      REAL     PLN   (KMAXD)
      REAL     Z     (KMAXD)
      REAL     PILN  (KMAXD)
      REAL     ZI    (KMAXD)
*
      DO 50 K = 1, LMAX
         PILN(K) = LOG(PLEV(K))
   50 CONTINUE 
*
      DO 100 IJ=1,IMAX*JMAX
         DO 110 K=1,KMAX
            PLN (K) = LOG(PS(IJ)*SIG(K))
            Z(K)=XSIG(IJ,K)
  110    CONTINUE
         CALL SPLINE(ZI,PILN,LMAX,Z,PLN,KMAX,VMISS)
         DO 120 L=1,LMAX
            XPRES(IJ,L)=ZI(L)
  120    CONTINUE
  100 CONTINUE
*
      RETURN
      END
* ---------------------------------------------------------------------
C     INTERPOLATION USING A CUBIC NONPERIODIC SPLINE
C     ZI(I)........INTERPOLATED VALUE AT PILN(I)
C     PILN(I)......LN(P) COORDINATE IN DECREASING ORDER
C     LMAX.........NUMBER OF INTERPOLATION POINTS
C     Z(I).........DATA AT PLN(I)
C     PLN(I).......LN(P) COORDINATE  IN DECREASING ORDER
C     IMAX.........NUMBER OF DATA POINTS
C     SM(I)........SECOND DERIVATIVES AT DATA POINTS
* ---------------------------------------------------------------------
* LAST MODIFIED ON 1992/07/06
*   PRESSURE-CORDINATE DATA UNDER THE GROUND ARE BLACKOUTED.
*   (THE BLACKOUTED AREAS ARE FILLED WITH BLKOUT)
*     created  by kuma 
*     modified by numaguti 92/07/06
*
      SUBROUTINE SPLINE
     O           (ZI,
     I            PILN,LMAX,Z,PLN,KMAX,BLKOUT)
*
      PARAMETER  ( KMAXD = 100 )
      REAL      ZI  (LMAX)
      REAL      PILN(LMAX)
      REAL      Z   (KMAX)
      REAL      PLN (KMAX)
      REAL      SM  (KMAXD)
      REAL      H   (KMAXD)
      REAL      AL  (KMAXD)
      REAL      AM  (KMAXD)
      REAL      AP  (KMAXD)
      REAL      C   (KMAXD)
*
      DO 110 K=2,KMAX
         H(K) = PLN(K)-PLN(K-1)
  110 CONTINUE
      DO 120 K=2, KMAX-1
         AL(K) = 0.5*H(K+1) / ( H(K)+H(K+1) )
         AM(K) = 0.5 - AL(K)
  120 CONTINUE
      AL(1)    = 0.
      AM(KMAX) = 0.
      AL(KMAX) = 0.
      DO 130 K=2, KMAX
         AP(K) = 1.0/( 1.0-AL(K-1)*AM(K) )
         AL(K) = AL(K)*AP(K)
  130 CONTINUE
*
      C(1)    = 0.
      C(KMAX) = 0.
      DO 160 K=2, KMAX-1
         C(K) = 3.0*( (Z(K+1)-Z(K))/H(K+1) - (Z(K)-Z(K-1))/H(K) )
     &            / ( H(K)+H(K+1) )
  160 CONTINUE
*
* FORWARD SUBSTITUTION
*
      DO 200 K=2,KMAX
         C(K)=( C(K)-C(K-1)*AM(K) )*AP(K)
  200 CONTINUE
      SM(KMAX)=C(KMAX)
*
*     BACKWARD SUBSTUTUTION
*
      DO 220 K=KMAX-1,K,-1
         SM(K) = C(K)-AL(K)*SM(K+1)
  220 CONTINUE
*
*     INTERPOLATION
*
      KU = 1
      DO 500 L=1,LMAX
         P=PILN(L)
*
         DO 300 K=KU, KMAX-1
            IF( P .GE. PLN(K) ) THEN
               KU = K
               GOTO 310
            ENDIF
  300    CONTINUE
         KU = KMAX
  310    CONTINUE
*
         IF( KU .EQ. 1 ) THEN
            ZI(L)=BLKOUT
         ELSE
            ZI(L)=( PLN(KU)-P    )/H(KU)
     &              *( Z(KU-1) - SM(KU-1)/6.
     &                        * ( P-PLN(KU-1) )*( H(KU)+PLN(KU)-P   ) )
     &            +( P-PLN(KU-1) )/H(KU)
     &              *( Z(KU)   - SM(KU)/6.
     &                        * ( PLN(KU)-P   )*( H(KU)+P-PLN(KU-1) ) )
         ENDIF
  500 CONTINUE
*
      RETURN
      END

*"表題 外部手続き呼びだし GTOOL3(GPCAL1)
*
*"履歴   90/08/18 沼口  敦
*"     2002/06/20 竹広真一
*
*
*********************************************************************
*"         << 外部手続き呼びだし >>
*********************************************************************
      SUBROUTINE GPCAL1
     I         ( GESUBR,
     I           HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      EXTERNAL   GESUBR                  ! 外部手続き名
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEAD )
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
*"         < 2. ヘッダーコピー >
*
      CALL GHCOPY ( HHEAD , HHEADO )
      CALL GHQENM ( HHEADO, IENUM  )
*
*"         < 3. 外部手続き呼びだし >
*
      CALL GESUBR
     I         ( HHEAD , GDATA ,
     M           HHEADO, GDATAO,
     D           IXDIM , IYDIM , IZDIM )
*
*"         < 4. ヘッダー変更 >
*
      IF (  ( HEDIT .NE. ' ' ).AND.( HEDIT .NE.'NUL' )  ) THEN
         CALL GHESET ( HHEADO, HEDIT  , HETTL , IENUM+1 )
      ENDIF
*
      RETURN
      END
*********************************************************************
*"         << 外部手続き呼びだし >>
*********************************************************************
      SUBROUTINE GMCAL1
     I         ( GESUBR,
     M           HHEAD , GDATA ,
     I           HEDIT , HETTL  )
*
      EXTERNAL   GESUBR                  ! 外部手続き名
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
*
      COMMON     /GMWORK/ GDATAW
      REAL       GDATAW ( 1 )            !" データ(ワーク)
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      CHARACTER  HHEADW ( NDC )*(NCC)    !" ヘッダー(ワーク)
*
      CALL       GMCSIZ ( HHEADW )
      CALL       GPCAL1
     I         ( GESUBR,
     I           HHEAD , GDATA ,
     I           HEDIT , HETTL ,
     O           HHEADW, GDATAW )
*
      CALL       GPFSET
     I         ( HHEADW, GDATAW,
     I           ' '   , ' '   ,
     O           HHEAD , GDATA   )
*
      RETURN
      END

*"表題 軸の描画(X) GTOOL3(GGAXIS)
*
*"履歴 90/08/16 沼口  敦
*
*
*********************************************************************
*"         << 軸のセット X or Y 軸のみ >>
*********************************************************************
      SUBROUTINE GGAXIS
     I         ( HHEAD , HPOS   )
*
      CHARACTER  HHEAD ( * )*(*)         !" ヘッダー
      CHARACTER  HPOS *(*)               !" セットする軸 ('X' or 'Y')
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
      INCLUDE    (GZIWRK)                !" NW: 軸ワークの大きさ
#else
#include         "gzsize.F"              !" NCC, NDC
#include         "gziwrk.F"              !" NW: 軸ワークの大きさ
#endif
      CHARACTER  HHEADZ( NDC )*(NCC)
      REAL       AXISZ ( NW )
      LOGICAL    OSUBCK
*
*"         < 1. 軸ファイルの読み込み >
*
      CALL GTPGET ( 'SUBCHK', OSUBCK )
      CALL GTSIZE ( HHEADZ  ,  NW     )
      CALL GUQAXV
     I            ( HHEAD , 1     , 'LOC' ,
     O              HHEADZ, AXISZ , IEOD   )
      CALL GTPSET ( 'SUBCHK', OSUBCK )
*
*"         < 2. 範囲 >
*
      CALL GHPGET ( HHEAD , 'ASTR1', IZSTR )
      CALL GHPGET ( HHEAD , 'AEND1', IZEND )
*
*"         < 3. 軸描画 >
*
      CALL GGAXSZ
     I     ( HHEADZ, AXISZ , HPOS   )
*
*"         < 4. 座標の設定 >
*
      CALL UWSGXA ( AXISZ, IZEND-IZSTR+1 )
*
      RETURN
      END

*"  96/09/24
*"  gtonpv を改良
*********************************************************************
      PROGRAM GTONTH2
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      PARAMETER  ( NFILE=9, NIDX=24 )
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*"[入出力データの領域確保]
      CHARACTER  HTHETA   ( NDC )*(NCC)
      CHARACTER  HHEAD ( NDC )*(NCC)
      REAL       GTHETA   ( IJKDIM )
      REAL       GDATA ( IJKDIM )
*"[途中の計算に必要なワーク領域]
      CHARACTER  HWORK ( NDC )*(NCC)
      REAL       GWORK ( IJKDIM )
*"[データに初期値を与える]
      DATA       ITHETA / 50 /
      INTEGER    IFILE( NFILE )
      DATA       IFILE / 51,52,53,54,55,56,57,58,59 /
      INTEGER    JFILE( NFILE )
      DATA       JFILE / 61,62,63,64,65,66,67,68,69 /
      DATA       JSIGTH  / 70 /
*
      CHARACTER  THT    *(NFILN)
      DATA       THT    / '$GTTMPDIR/THETA' /
      PARAMETER  (NFM1=NFILE-1)
      CHARACTER  HFILE(NFILE)*(NFILN)
      DATA       HFILE / '$GTTMPDIR/gtool.out',NFM1*' ' /
      CHARACTER  HFILEW(NFILE)*(NFILN)
      CHARACTER  SIGTH  *(NFILN)
      DATA       SIGTH  / '$GTTMPDIR/SIGTH' /
*
      CHARACTER  ITEM   *(NCC)
      DATA       ITEM   / ' ' /
      CHARACTER  UNIT   *(NCC)
      DATA       UNIT   / ' ' /
      CHARACTER  TITLE  *(NCC*2)
      DATA       TITLE  / ' ' /
      CHARACTER  DSET   *(NCC)
      DATA       DSET   / ' ' /
      CHARACTER  EDIT   *(NCC)
      DATA       EDIT   / ' ' /
      CHARACTER  ETTL   *(NCC)
      DATA       ETTL   / ' ' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      CHARACTER  HAXTH*(NCC)
      INTEGER    KTHETA
      DATA       KTHETA / 4 /
      REAL       VALTH(20)
      DATA      (VALTH(I),I=1,4) / 350., 330., 310., 290. /
      LOGICAL    OSIG
      DATA       OSIG  / .FALSE. /
*
      EXTERNAL   GSPLIN1, GSPLIN2
*
      NAMELIST  /OPTION/
     &     THT, HFILE,              !" 入力ファイル名
     &     SIGTH,                  !" 出力ファイル名
     &     ITEM, UNIT, TITLE, DSET, EDIT, ETTL, 
     &     APND ,GRESET, HELP,
     &     KTHETA, VALTH,             !" THETA 軸
     &     OSIG                    !" データ出力の有無
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILES )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HTHETA   , IJKDIM )
      CALL GTSIZE ( HHEAD , IJKDIM )
      CALL GTSIZE ( HWORK , IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GFROPN ( ITHETA   , THT )
      IF ( OSIG ) CALL GFWOPN ( JSIGTH  , SIGTH  )
      NFL = 1
      DO 300 IFL = 1, NFILES
         IF ( HFILE(IFL) .NE. ' ' ) THEN
            CALL GFROPN ( IFILE(IFL), HFILE(IFL) )
            LH=LENC(HFILE(IFL))
            HFILEW(IFL)=HFILE(IFL)(1:LENC(HFILE(IFL)))//'TH'
            WRITE(6,*) 'HFILEW=',HFILEW(IFL)
            CALL GFWOPN ( JFILE(IFL), HFILEW(IFL) )
            NFL = IFL
         ENDIF
 300  CONTINUE
*
      CALL GHPGET ( HTHETA , 'MISS' , VMISS )
*
      CALL MKAX                       !" θ 軸をつくる
     &     ( VALTH , KTHETA , VMISS , HAXTH )
*
      IAX=3                    !" 3 番目の軸を補間
      CALL SETPAR1 ( IAX , VALTH , KTHETA , HAXTH )
      CALL SETPAR2 ( IAX )
*
 1100 CONTINUE
        CALL   GFREAD                   !" THETA データ入力
     O        ( HTHETA    , GTHETA   , IEOTHETA  ,
     I          ITHETA    , 1               )
*
        IF (IEOTHETA.EQ.0) THEN
*
          CALL GMCAL1           !" σ on THETA を求める
     I         ( GSPLIN1,
     M           HTHETA    , GTHETA   ,
     I           '   '  , '   '  )
          CALL GHCSET ( HTHETA   , 'ITEM' , 'SIG' )
          CALL GHCSET ( HTHETA   , 'UNIT' , ' ' )
          CALL GHCSTS ( HTHETA   , 'TITL', 'sigma on THETA' )
*
          IF ( OSIG ) THEN
            CALL  GFWRIT        !" σ on THETA を出力
     I             ( HTHETA  , GTHETA   ,
     I             JSIGTH , 1     , 0       )
          ENDIF
*
          IJ  = 0
 1200       CONTINUE
            IJ = IJ + 1
            IF ( IJ.LE.NFL ) THEN
              IFILEX = IFILE( IJ )
              JFILEX = JFILE( IJ )
              CALL GFREAD       !" DATA on σ の入力
     O            ( HHEAD , GDATA , IEOD  ,
     I              IFILEX, 1               )
*
              CALL GPFSET       !" HWORK に σ on THETA を代入
     I           ( HTHETA  , GTHETA   ,
     I           '   '  , '  '  ,
     O            HWORK, GWORK  )
*
              NDIF=0            !" 補間
              CALL SETDIF ( NDIF )
              CALL GMCAL2       !" DATA on THETA を求める
     I             ( GSPLIN2,
     M             HWORK, GWORK,
     I             HHEAD, GDATA,
     I             '   ', '   ' )
*
              IF ( ITEM .NE. ' ' ) THEN
                CALL GHCSET ( HWORK, 'ITEM', ITEM ) 
              ELSE
                CALL GHCSET ( HWORK, 'ITEM' ,
     +                 HFILEW(IJ)(1:LENC(HFILEW(IJ)))  )
              ENDIF
              IF ( UNIT .NE. ' ' ) THEN
                CALL GHCSET ( HWORK, 'UNIT' , UNIT )
              ELSE
                CALL GHCGET ( HHEAD, 'UNIT' , UNIT )
                CALL GHCSET ( HWORK, 'UNIT' , UNIT )
              ENDIF
              IF ( TITLE .NE. ' ' ) THEN 
                CALL GHCSTS ( HWORK, 'TITL' , TITLE )
              ELSE
                CALL GHCSTS ( HWORK, 'TITL', 
     +                 HFILE(IJ)(1:LENC(HFILE(IJ)))//' on THETA' )
              ENDIF
              IF ( DSET .NE. ' ' ) THEN
                CALL GHCSET ( HWORK, 'DSET', DSET )
              ELSE
                CALL GHCGET ( HHEAD, 'DSET' , DSET )
                CALL GHCSET ( HWORK, 'DSET' , DSET )
              ENDIF
              IF ( GRESET ) THEN
                CALL GHRSGP ( HWORK )
              ENDIF
*
              CALL  GFWRIT      !" DATA on THETA を出力
     I             ( HWORK , GWORK ,
     I               JFILEX, 1     , 0       )
*
              GOTO 1200
            ENDIF
*
          GOTO 1100
        ENDIF
* commented out by toyoda
*     CALL GTCLSE
*
      STOP
      END


*****************************************************
*" θ 軸を作成する
******************************************************
      SUBROUTINE MKAX
     I      ( VAL, LEVEL , VMISS, HAITM )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC, NED
      INCLUDE    (GZIWK)                 !" NW, NAXIS
#else
#include         "gzsize.F"              !" NCC, NDC, NED
#include         "gziwrk.F"              !" NW, NAXIS
#endif
*
      INTEGER    LEVEL                  !" 与える θ 軸の格子数
      REAL       VAL(20)               !" 与える θ の値
*
      CHARACTER  HAITM   *(NCC)          !" 軸の名称 (例:CTHETA10 )
      REAL       AX  ( NAXIS )           !" 格子位置
      REAL       DAX ( NAXIS )           !" 軸の重み
      CHARACTER  HAX (NDC)*(NCC)         !" 軸ファイルのヘッダ
*
      HAITM = 'CTHETA'
      LH = LENC(HAITM)
      IF(LEVEL.LT.10) THEN
        WRITE( HAITM(LH+1:LH+1),'(I1)') LEVEL
      ELSE IF(LEVEL.LT.100) THEN
        WRITE( HAITM(LH+1:LH+2),'(I2)') LEVEL
      ELSE
        CALL MSGDMP ( 'E', 'MKAX', 'GRID NUMBER IS TOO MUCH!!')
      ENDIF
*
      DO 10 I = 1, LEVEL
        AX(I) = VAL(LEVEL+1-I)      !" 逆の順番で代入
        DAX(I)=1.                      !" 注意！この重みはいいかげん
   10 CONTINUE
*
      CALL    GHPACA                   !" 格子情報を与える
     O         ( HAX,
     I           'IAXLOC', HAITM,
     I           'theta', ' ',
     I           LEVEL,
     I           'UR4' , VMISS ,
     I           VMISS , VMISS , VMISS , VMISS , 1 )
*
      CALL    GUSIAX                   !" 内部設定格子の設定
     I         ( HAX , AX , DAX ,
     I           1                )
*
      CALL  GUWIAX                     !" 内部設定格子の出力
     I         ( HAX )
*
      RETURN
      END





********************************************************************
*" (旧 95/01/16 horinout  CUBIC SPLINE INTERPOLATIO)
*" 改良している
*" 補間か微分かを決める NDIF は ENTRY 文で代入
*===================================================================
      SUBROUTINE GSPLIN2
     I         ( HHEAD1, GDATA1,
     I           HHEAD2, GDATA2,
     O           HHEADO, GDATAO,
     D           IDIM1 , JDIM1 , KDIM1,
     D           IDIM2 , JDIM2 , KDIM2 )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
*
      CHARACTER  HHEAD1 ( * )*(*)
      REAL       GDATA1 ( IDIM1,JDIM1,KDIM1 )
      CHARACTER  HHEAD2 ( * )*(*)
      REAL       GDATA2 ( IDIM2,JDIM2,KDIM2 )
      CHARACTER  HHEADO ( * )*(*)
      REAL       GDATAO ( * )
* internal work
      CHARACTER  HAX1 ( NDC )*(NCC)
      CHARACTER  HAX2 ( NDC )*(NCC)
      PARAMETER  (NAXD=2048)
      REAL       AX2(NAXD)
      REAL       X(NAXD),Y(NAXD),Y2(NAXD)
*
      INTEGER   IAX
      SAVE  IAX, NDIF
*
* / read axis /
*
      CALL GTSIZE(HAX1,NAXD)
      CALL GTSIZE(HAX2,NAXD)

      CALL GUQAXV   !" original axis
     I       ( HHEAD2, IAX, 'LOC' ,
     O         HAX2, AX2 , IEOD2 )      
*
*  / header /
*
      CALL GHPGET( HHEAD1,'MISS',VMISS )
*
      IJKDO=IDIM1*JDIM1*KDIM1
      CALL GTSIZE( HHEADO,IJKDO )
*
* / cubic spline interpolation /
*
        DO 1300 J=1,JDIM2
        DO 1300 I=1,IDIM2
          N=0
          DO 1310 K=1,KDIM2
            IF(GDATA2(I,J,K).NE.VMISS) THEN
              N=N+1
              X(N)=AX2(K)
              Y(N)=GDATA2(I,J,K)
            ENDIF
 1310     CONTINUE
          CALL SPLINE(X,Y,N,1E31,1E31,Y2)
          DO 1320 K=1,KDIM1
            IJK=I+IDIM2*(J-1)+IDIM2*JDIM2*(K-1)
            AX1=GDATA1(I,J,K)
            IF (AX1.NE.VMISS) THEN
              CALL SPLINT(X,Y,Y2,N,AX1,NDIF,YB)
              GDATAO(IJK)=YB
            ELSE
              GDATAO(IJK)=VMISS
            ENDIF
 1320     CONTINUE
 1300   CONTINUE
*
      RETURN
*===========
      ENTRY SETPAR2(IAXE)
      IAX  = IAXE
      RETURN
*===========
      ENTRY SETDIF (NDIFE)
      NDIF=NDIFE
      RETURN
      END


********************************************************************
*" (旧: 95/01/16 horinout  CUBIC SPLINE INTERPOLATION)
*" 適当な θ 面における σ の値を求める
*" θ 軸の情報は ENTRY 文から入手
*===================================================================
      SUBROUTINE GSPLIN1
     I         ( HDT   , DT    ,
     O           HPW   , PW    ,
     D           IDIM  , JDIM  , KDIM  )
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)
#else
#include         "gzsize.F"
#endif
*
      CHARACTER  HDT ( * )*(*)
      REAL       DT  ( IDIM, JDIM, KDIM )
      CHARACTER  HPW ( * )*(*)
      REAL       PW  ( * )
* internal work
      CHARACTER  HAITM*(NCC)
      CHARACTER  HAITM2*(NCC)
      CHARACTER  HAX ( NDC )*(NCC)
      PARAMETER  (NAXD=2048)
      REAL       AXA(NAXD),AXB(NAXD)
      LOGICAL    OCYCL
      REAL       X(NAXD),Y(NAXD),Y2(NAXD)
*
      SAVE  IAX
*
      REAL  SIGLVL(557056)   !" include/gtsinc.F の IJKDIM の大きさ
      CHARACTER  HAITMX*(NCC), HAXTH*(NCC)
      REAL  VALPV(20), VALPVX(20)   !" 求める PV のレベル
      SAVE  KPV,VALPV,HAXTH

      LOGICAL OFIRST
      DATA    OFIRST / .TRUE. /
      SAVE    OFIRST
*     
      LMAX=30                !" 鉛直にアバウトに攻めていく回数
      EPS=0.0001             !" PV の収束判定値(PVU)
      NDIF=0                 !" 補間
*
* / read axis /
*
      CALL GTSIZE(HAX,NAXD)
      CALL GUQAXV   !" original axis
     I       ( HDT, IAX, 'LOC' ,
     O         HAX, AXA , IEOD )
*
      CALL GHCGET(HDT,'AITM3',HAITM) !" original の軸の情報を得る
      CALL GHCGET(HDT,'AITM2',HAITM2) !" original の軸の情報を得る
      CALL GUQAXS
     I       ( HAITM, 'LOC',
     O         HAX  , AXB  , IEOD )
      CALL GUQAXD
     I       ( HAITM,
     O         NADIM, OCYCL )
*
*  / header /
*
      CALL GHPGET( HDT,'MISS',VMISS )
*
      CALL GHCOPY(HDT,HPW)           !" PV 軸の情報を与える
        CALL GHCSET(HPW,'AITM3',HAXTH)
        CALL GHPSET(HPW,'AEND3',KPV)
        IJKDO=IDIM*JDIM*KPV
      CALL GTSIZE( HPW,IJKDO )
*
* / cubic spline interpolation /
*
      SIGMAX=AXB(1)
      SIGMIN=AXB(NADIM)

      IF(SIGMIN.GT.SIGMAX) THEN   !" SIGMA の与え方の妥当性チェック
        CALL MSGDMP( 'E','GSPLIN','SIGMIN IS GREATER THAN SIGMAX')
      ENDIF

      DO 1300 J=1,JDIM
      DO 1300 I=1,IDIM
        N=0
        DO 1310 K=1,KDIM
          IF(DT(I,J,K).NE.VMISS) THEN
            N=N+1
            X(N)=AXA(K)
            Y(N)=DT(I,J,K)
          ENDIF
 1310   CONTINUE
        CALL SPLINE(X,Y,N,1E31,1E31,Y2)

        AXB2=0.
        LMIN=1
        DO 1320 K=1,KPV
          DO 4000 L=LMIN,LMAX
            IJK=I+IDIM*(J-1)+IDIM*JDIM*(K-1)
            AXB1=(SIGMAX-SIGMIN)*(L-1)/(LMAX-1)+SIGMIN
            CALL SPLINT(X,Y,Y2,N,AXB1,NDIF,YB)

            IF((YB-VALPV(K)).LT.0) THEN   !" 目的のレベルを越えたら
              IF (L.EQ.1) THEN    !" VALPV の与え方チェック
                CALL MSGDMP('W','GSPLIN','VALPV IS TOO HIGH')
                WRITE(6,*) '(I,J)=',I,J
                SIGLVL(IJK)=VMISS
                GOTO 1320
              ENDIF
 3000         CONTINUE                         !" 2 分法で正確に求める
              AXBMID = (AXB1+AXB2)/2
                CALL SPLINT(X,Y,Y2,N,AXBMID,NDIF,YB)
                IF((YB-VALPV(K)).LT.0.) THEN
                  AXB1=AXBMID
                ELSE
                  AXB2=AXBMID
                ENDIF
                IF(ABS(YB-VALPV(K)).GE.EPS) THEN !" 収束判定
                  GOTO 3000
                ENDIF
              SIGLVL(IJK)=AXBMID               !" SIGMA LEVEL を代入
              LMIN=L-2       !" 次のレベルはそこより下から探す。
              GOTO 1320
            ENDIF

            AXB2=AXB1
 4000     CONTINUE
          SIGLVL(IJK)=VMISS !" SIGMA LEVEL が見つからないときは欠損値を代入
          LMIN=LMAX         !" 次は一番下のレベルから探す
 1320   CONTINUE
 1300 CONTINUE

      DO 6100 I=1,IDIM
        DO 6100 J=1,JDIM
          DO 6100 K=1,KPV
            IJK=I+IDIM*(J-1)+IDIM*JDIM*(K-1)
            IJKR=I+IDIM*(J-1)+IDIM*JDIM*(KPV-K)
            PW(IJK)=SIGLVL(IJKR)  !" 鉛直の順番並べ替え
 6100 CONTINUE
*
      RETURN
*===========
      ENTRY SETPAR1(IAXE,VALPVX,KPVX,HAITMX)
      IAX  = IAXE
      KPV=KPVX
      HAXTH=HAITMX
      DO 5000 I=1,KPV
        VALPV(I)=VALPVX(I)
 5000 CONTINUE
      RETURN
      END


************************************************************************
*(Original Source Location: /home/horinout/src/numrecipes/splin.f)
*
* NUMERICAL  RECIPES
*
*" 3.3  3次スプライン補間
*" subroutines  SPLINE  準備 ( Y2 = y" )
*"              SPLINT  補間  仮定: X(1)<X(2)<..<X(N) or X(1)>X(2)>..>X(N)
*" 95/02/01  Ver.3 一、二階微分値の計算ができる(NDIF で指定)。
*" [注意]  SPLINT の引数は Ver.1, Ver.2 と違う. (入力 NDIF を追加)
************************************************************************
      SUBROUTINE SPLINE
     I            ( X,Y,N,YP1,YPN,
     O              Y2 )
      IMPLICIT  REAL  (A-H,O-Z)
      PARAMETER (NMAX=200)
      DIMENSION X(N),Y(N), Y2(N), U(NMAX)
*
      IF(N.GT.NMAX) THEN
        WRITE(6,*) '***(SPLINE)*** NOT ENOUGH WORKING AREA SIZE NMAX'
        STOP
      ENDIF
*
      IF (YP1 .GT. .99E30) THEN !" the lower b.c. is set either to be "natural"
        Y2(1)=0.
        U(1)=0.
      ELSE
        Y2(1)=-0.5
        U(1)=(3./(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
      ENDIF
      DO 11 I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.
        Y2(I)=(SIG-1.)/P
        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     &       /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
   11 CONTINUE
      IF (YPN .GT. .99E30) THEN !" the upper b.c. is set either to be "natural"
        QN=0.
        UN=0.
      ELSE
        QN=0.5
        UN=(3./(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      ENDIF
      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)
      DO 12 K=N-1,1,-1
        Y2(K)=Y2(K)*Y2(K+1)+U(K)
   12 CONTINUE
      RETURN
      END
************************************************************************
* NDIF=0:simple interpolation, NDIF=1,2:d(YA)/d(XA),d^2(YA)/d(XA)^2
*
      SUBROUTINE SPLINT
     I            ( XA,YA,Y2A,N,X, NDIF,
     O              Y )
      IMPLICIT  REAL  (A-H,O-Z)
      DIMENSION XA(N),YA(N),Y2A(N)
*
      KLO=1
      KHI=N
    1  IF (KHI-KLO.GT.1) THEN
         K=(KHI+KLO)/2
         IF((XA(N).GT.XA(1)).EQV.(XA(K).GT.X)) THEN
           KHI=K
         ELSE
           KLO=K
         ENDIF
      GOTO 1
       ENDIF
      H=XA(KHI)-XA(KLO)
      IF (H.EQ.0.) THEN
        WRITE(6,*) '***(SPLINT)*** Bad XA input.'
        STOP
      ENDIF
      A=(XA(KHI)-X)/H
      B=(X-XA(KLO))/H
      IF (NDIF.NE.1 .AND. NDIF.NE.2) THEN
        Y=A*YA(KLO)+B*YA(KHI)+
     &     ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.
      ELSE IF (NDIF.EQ.1) THEN  !" 1st derivative
        Y=(YA(KHI)-YA(KLO))/H 
     &      - (3.*A*A-1.)/6.*H*Y2A(KLO) + (3.*B*B-1.)/6.*H*Y2A(KHI)
      ELSE IF (NDIF.EQ.2) THEN  !" 2nd derivative
        Y=A*Y2A(KLO)+B*Y2A(KHI)
      ENDIF
      RETURN
      END

*"表題 第３次元の結合 GTOOL3(GPZCOM)
*
*"履歴 90/08/19 沼口  敦
*
*
*********************************************************************
*"         << 第３次元の結合 >>
*********************************************************************
      SUBROUTINE GPZCOM
     I         ( HHEAD , GDATA , IZ    ,
     M           HHEADO, GDATAO         )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      REAL       GDATA  ( * )            !" データ(入力)
      INTEGER    IZ                      !" 入れるべき第3次元の格
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
*"         < 1. 大きさの取得 >
*
      CALL GUSMIS ( HHEADO )
*
      CALL GUQSIZ
     I         ( HHEADO,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IZSTR , IZEND , IZDIM  )
*
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
      IF ( ( IZ .LT. IZSTR ) .OR. ( IZ .GT. IZEND ) ) THEN
         CALL MSGDMP( 'E', 'GPZCOM', 'IZ IS OUT OF RANGE.' )
      ENDIF
*
*"         < 2. データ詰め替え >
*
      CALL VRSET
     I     ( GDATA,
     O       GDATAO( IXDIM*IYDIM*(IZ-IZSTR) + 1 ),
     I       IXDIM*IYDIM  , 1     , 1          )
*
      RETURN
      END
*********************************************************************
*"         << 第３次元の結合の準備 >>
*********************************************************************
      SUBROUTINE GPZCMI
     I         ( HHEAD , HAITMZ, IZSTR , IZEND ,
     I           HEDIT , HETTL ,
     O           HHEADO, GDATAO )
*
      CHARACTER  HHEAD  ( * )*(*)        !" ヘッダー(入力)
      CHARACTER  HAITMZ      *(*)        !" 結合する第3次元の軸の
      INTEGER    IZSTR                   !" 第3次元の軸の格子始め
      INTEGER    IZEND                   !" 第3次元の軸の格子終り
      CHARACTER  HEDIT       *(*)        !" 編集略記号
      CHARACTER  HETTL       *(*)        !" 編集タイトル
      CHARACTER  HHEADO ( * )*(*)        !" ヘッダー(出力)
      REAL       GDATAO ( * )            !" データ(出力)
*
#ifdef SYS_IBMS
      INCLUDE    (GZSIZE)                !" NCC, NDC
#else
#include         "gzsize.F"              !" NCC, NDC
#endif
      LOGICAL    OCYCL                   !" サイクリックか？
      CHARACTER  HEDITD      *(NCC)      !" 編集略記号
      CHARACTER  HETTLD      *(NCC)      !" 編集タイトル
*
*"         < 1. 大きさの取得 >
*
      CALL GUQSIZ
     I         ( HHEAD ,
     O           IXSTR , IXEND , IXDIM ,
     O           IYSTR , IYEND , IYDIM ,
     O           IDUMY1, IDUMY2, IDUMY3 )
*
      IF ( ( IZSTR .EQ. 0 ) .AND. ( IZEND .EQ. 0 ) ) THEN
         CALL GUQAXD
     I         ( HAITMZ,
     O           IADIM , OCYCL  )
         IZSTRZ = 1
         IZENDZ = IADIM
      ELSE
         IZSTRZ = IZSTR
         IZENDZ = IZEND
      ENDIF
*
      IZDIM = IZENDZ - IZSTRZ + 1
      CALL GUSZCK ( HHEADO, IXDIM*IYDIM*IZDIM )
*
*"         < 2. 欠損値を詰める >
*
      CALL GHPGET ( HHEAD, 'MISS', VMISS )
      CALL RSET   ( GDATAO, IXDIM*IYDIM*IZDIM, 1 , VMISS )
*
*"         < 3. ヘッダー変更 >
*
      CALL GHCOPY ( HHEAD, HHEADO )
      CALL GHCSET ( HHEADO, 'AITM3', HAITMZ )
      CALL GHPSET ( HHEADO, 'ASTR3', IZSTRZ )
      CALL GHPSET ( HHEADO, 'AEND3', IZENDZ )
*
      IF ( HEDIT .EQ. ' ' ) THEN
         CALL GUEAXN
     I               ( HAITMZ, 'ZC'   , '-combine',
     I                 IZSTRZ, IZENDZ ,
     O                 HEDITD, HETTLD          )
         CALL GHEADD ( HHEADO, HEDITD, HETTLD )
      ELSE IF ( HEDIT .NE. 'NUL' ) THEN
         CALL GHEADD ( HHEADO, HEDIT  , HETTL   )
      ENDIF
*
      RETURN
      END

* PACKAGE  GTRELH  !" 相対湿度                         A.Numaguti
*"                                            95/05/31 S.Takehiro
***********************************************************************
      PROGRAM GTRELH
*
#ifdef SYS_IBMS
      INCLUDE    (GTSINC)
      INCLUDE    (GZSIZE)
#else
#include         "gtsinc.F"
#include         "gzsize.F"
#endif
      COMMON     /GMWORK/ MWORK
      REAL       MWORK  ( IJKDIM )
*
      CHARACTER  HHEADQ( NDC )*(NCC)
      REAL       GDATAQ( IJKDIM )
      CHARACTER  HHEADT( NDC )*(NCC)
      REAL       GDATAT( IJKDIM )
      CHARACTER  HHEADP( NDC )*(NCC)
      REAL       GDATAP( IJKDIM )
*
      DATA       IFILEQ / 50 /
      DATA       IFILET / 51 /
      DATA       IFILEP / 52 /
      DATA       JFILE / 60 /
*
      CHARACTER  Q      *(NFILN)
      DATA       Q      / 'q' /
      CHARACTER  T      *(NFILN)
      DATA       T      / 'T' /
      CHARACTER  PS     *(NFILN)
      DATA       PS     / 'Ps' /
      CHARACTER  OUT    *(NFILN)
      DATA       OUT    / '$GTTMPDIR/gtool.out' /
      LOGICAL    APND
      DATA       APND   / .FALSE. /
      CHARACTER  ITEM   *(NCC)
      CHARACTER  UNIT   *(NCC)
      CHARACTER  TITLE  *(NCC*2)
      CHARACTER  DSET   *(NCC)
      CHARACTER  EDIT   *(NCC)
      CHARACTER  ETTL   *(NCC)
      DATA       ITEM   / 'RH' /
      DATA       UNIT   / ' ' /
      DATA       TITLE  / 'relative humidity' /
      DATA       DSET, EDIT, ETTL /3*' '/
      LOGICAL    GRESET
      DATA       GRESET / .TRUE. /
      LOGICAL    HELP
      DATA       HELP   / .FALSE. /
*
      EXTERNAL   RELHUM
*     
      NAMELIST  /OPTION/ Q, T, PS, OUT, APND,
     &                   ITEM, UNIT, TITLE, DSET, EDIT, ETTL, GRESET,
     &                   HELP
*
      CALL OPTARG ( 91, 'OPTION', 'HFILE', NOPT, NFILE )
      READ (91,OPTION,IOSTAT=IOS)
      CLOSE(91)
      IF ( IOS.NE.0 .OR. HELP ) THEN
         WRITE(6,OPTION)
         STOP
      ENDIF
*
      CALL GTOPEN
      CALL GTSIZE ( HHEADQ, IJKDIM )
      CALL GTSIZE ( HHEADT, IJKDIM )
      CALL GTSIZE ( HHEADP, IJKDIM )
      CALL GMSIZE ( IJKDIM  )
*
      CALL GURNTF ( Q,  OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( T,  OUT  , '$GTTMPDIR/gtool.in' )
      CALL GURNTF ( PS, OUT  , '$GTTMPDIR/gtool.in' )
*
      CALL GFROPN ( IFILEQ, Q     )
      CALL GFROPN ( IFILET, T     )
      CALL GFROPN ( IFILEP, PS    )
      CALL GFOOPN ( JFILE ,  OUT , APND )
*
      CALL GUNENV( OUT,'.',.FALSE. )
      IL=LENC(OUT)
      WRITE (6,*) 'output='//OUT(1:IL)
*
 1100 CONTINUE
         CALL   GFREAD
     O        ( HHEADQ, GDATAQ, IEODQ  ,
     I          IFILEQ, 1               )
         CALL   GFREAD
     O        ( HHEADT, GDATAT, IEODT  ,
     I          IFILET , 1               )
         CALL   GFREAD
     O        ( HHEADP, GDATAP, IEODP ,
     I          IFILEP, 1               )
*
         IF ( MAX(IEODQ,IEODT,IEODP) .EQ.0 ) THEN
            CALL GMCAL3
     I         ( RELHUM,
     M           HHEADQ, GDATAQ,
     I           HHEADT, GDATAT,
     I           HHEADP, GDATAP,
     I           EDIT  , ETTL  )
*
            IF ( ITEM .NE. ' ' ) THEN
               CALL GHCSET( HHEADQ, 'ITEM', ITEM )
            ENDIF
            IF ( UNIT .NE. ' ' ) THEN
               CALL GHCSET( HHEADQ, 'UNIT', UNIT )
            ENDIF
            IF ( TITLE .NE. ' ' ) THEN
               CALL GHCSTS( HHEADQ, 'TITL', TITLE )
            ENDIF
            IF ( DSET .NE. ' ' ) THEN
               CALL GHCSET( HHEADQ, 'DSET', DSET )
            ENDIF
            IF ( GRESET ) THEN
               CALL GHRSGP( HHEADQ  )
            ENDIF
*
            CALL  GFWRIT
     I                 ( HHEADQ, GDATAQ,
     I                   JFILE , 1     , 0       )
*
      GOTO 1100
         ENDIF
*
      STOP
      END
********************************************************************
      SUBROUTINE RELHUM
     I         ( HHEADQ, QQ    ,
     I           HHEADT, TT    ,
     I           HHEADP, PS    ,
     O           HHEADR, RH    ,
     D           IXDIM , IYDIM , IZDIM ,
     D           IXDIM2, IYDIM2, IZDIM2,
     D           IXDIM3, IYDIM3, IZDIM3 )
*
      CHARACTER  HHEADT ( * ) *(*)
      CHARACTER  HHEADQ ( * ) *(*)
      CHARACTER  HHEADP ( * ) *(*)
      CHARACTER  HHEADR ( * ) *(*)
      REAL       TT ( IXDIM , IYDIM , IZDIM  )
      REAL       QQ ( IXDIM2, IYDIM2, IZDIM2 )
      REAL       PS ( IXDIM3, IYDIM3         )
      REAL       RH ( IXDIM , IYDIM , IZDIM  )
*
      PARAMETER  ( NCC=16, NDC=64 )
      PARAMETER  ( KDIMD=20 )
      CHARACTER  HHEADS ( NDC ) *(NCC)
      REAL       SIG ( KDIMD )
*
* PACKAGE ZQSAT     !" Clausis-Clapeyron の式(文関数)
*
*"    QSAT:  saturation water vapour mixing ratio
*"    DQSAT: d(QSAT)/d(T)
*
      REAL       FQSAT
      REAL       FDQSAT
      REAL       T, P, QS
*
      FQSAT ( T,P )    = EPSV * ES0
     &                   * EXP( EL/RVAP *( 1./273. - 1./T ) )
     &                   / P
      FDQSAT( T,QS )   = EL * QS / ( RVAP * T*T )
*
      EL   = 2.5E6
      RVAP = 461.
      EPSV = 0.622
      ES0  = 6.11
      CALL GTSIZE ( HHEADS, KDIMD )
*
      CALL GUQAXV
     I         ( HHEADR, 3     , 'LOC' ,
     O           HHEADS, SIG   , IEOD   )
*
      DO 1100 IZ = 1, IZDIM
         DO 1110 IY = 1, IYDIM
            DO 1120 IX = 1, IXDIM
               RH ( IX,IY,IZ ) = QQ( IX,IY,IZ )
     &                         / FQSAT( TT(IX,IY,IZ),PS(IX,IY)*SIG(IZ) )
 1120       CONTINUE
 1110    CONTINUE
 1100 CONTINUE
*
      RETURN
      END

*"    三次元配列、第二次元のフーリエ変換 ISN=+1, 逆変換 ISN=-1
*"    FTPACK (石岡ルーチン) 利用. 
*"    初期化をするときは、LINIT=.TRUE. 
***********************************************************************
      SUBROUTINE AFFTRU
     M      ( X, 
     W        Y,
     C        T, IT, 
     I        N1, N2, L2, N3, ISN, LINIT )

      IMPLICIT  REAL   ( A-H,O-Z )
*  [MODIFY]
      DIMENSION  X(N1,N2,N3)
*  [WORK]
      DIMENSION  Y(N1*N2)
*  [CONST]
      DIMENSION  T(2*N2)  !" このルーチンの外でみだりに使ってはならない
      INTEGER    IT(5)    !" このルーチンの外でみだりに使ってはならない
*  [INPUT]
      LOGICAL    LINIT  
      INTEGER    N1, N2, L2, N3, ISN

      N = N2 / 2
      L = L2 / 2
      IF (MOD(L2,2).NE.0) CALL MSGDMP('E','AFFTRU','L2 MUST BE EVEN')
 
      IF( LINIT ) THEN
        CALL FTRUPR( N ,IT , T )
      ENDIF

      DO 10 J=1,N3
        CALL FTRUMN( X(1,1,J) , Y , N1 , N , L , IT , T , ISN )
   10 CONTINUE

      RETURN
      END
***********************************************************************
*"    三次元配列、第二次元：フーリエ係数 --> スペクトル
*"    X(?,J,?) の J=1,L2/2 にスペクトルを格納.
*"    定数部分は X(?,L2/2+1,?）に移動
*
      SUBROUTINE F2SPRU
     M       ( X, 
     W         Y, 
     I         N1, N2, L2, N3 )
*
      IMPLICIT  REAL ( A-H,O-Z )
*  [MODIFY]
      DIMENSION  X(N1,N2,N3)
*  [WORK]
      DIMENSION  Y(N1,N2/1+1)
*  [INPUT]
      INTEGER    N1, N2, L2, N3
*
      DO 100 K=1,N3
      DO 100 I=1,N1
        DO 20 J=1,L2/2-1
          Y(I,J) = SQRT( X(I, 2*J+1, K)**2 + X(I, 2*J+2, K)**2 )
   20   CONTINUE
        J=L2/2
        IF(L2.EQ.N2)  THEN
          Y(I,J) = ABS( X(I,2,K) )
        ELSE
          Y(I,J) = SQRT( X(I, 2*J+1, K)**2 + X(I, 2*J+2, K)**2 )
        ENDIF          
        Y(I,L2/2+1) = X(I,1,K)
        DO 70 J=1,L2/2+1
          X(I,J,K) = Y(I,J)
   70   CONTINUE
  100 CONTINUE
*
      RETURN
      END
